C////////////////////////////////////////////////////////////////////////
C
C     SUBROUTINE TO PRODUCE COLOUR MAP
c         the image nfr1 and nfr2 are assumed to be aligned.  
c     ipar=0  Global sky values are determined for each frame.
c     ipar=1  local sky determined in grids are determined
c   The color is formed by   1000*(X1-sky1)/(X2-sky2) and stored
c    in frame nres 
C
C
	SUBROUTINE MKCMAP(*,NFR1,NFR2,NRES,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),icarray(200000)
	INTEGER IX(NU,NV,KF),icarray(200000)
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	equivalence (icarray(1),iscr(1))
	CALL QUERYNFR(NFR1,KF,1,*999,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*999,*20002)
20002	CALL QUERYNFR(NRES,KF,4,*999,*20003)
20003	ni1=nii(nfr1)
	nj1=njj(nfr1)
	ni2=nii(nfr2)
	nj2=njj(nfr2)
	scale=1000.
c  compute average sky values for the 2 frames using spaced rows
	call stripsky(nfr1,int(.1*ni1),int(.1*nj1),int(.9*ni1), 
     *          int(.9*nj1),40,sky1,sig1,0,ix,nu,nv,kf)
	call stripsky(nfr2,int(.1*ni2),int(.1*nj2),int(.9*ni2), 
     *          int(.9*nj2),40,sky2,sig2,0,ix,nu,nv,kf)
	write(6,1) nfr1,sky1,sig1,nfr2,sky2,sig2
 1	format(2('  Frame ',i2,': sky=',f8.2,'  sig=',f8.3))
 601	WRITE(6,2) cut
 2	format('  Enter cutoff limit for computing colors in sig',
     *    ' [dflt:',f5.2,']: ',$)
	call read1r(cut,*999,*601)
	NII(NRES)=ni1
	NJJ(NRES)=nj1
	nfl(6,nres)=1
	clim1=cut*sig1
	clim2=cut*sig2
	ab1=clim1*2.
	ab2=clim2*2.
	DO 100 J=1,nj1
	  DO 100 I=1,ni1
	    pix1=float(ix(i,j,nfr1))-sky1
	    pix2=float(ix(i,j,nfr2))-sky2
	    if (pix1.lt.clim1.or.pix2.lt.clim2) then
	      ix(i,j,nres)=0.
	    else
	      ix(i,j,nres)=intlimr(scale*pix1/pix2)
	   end if
 100	CONTINUE
 999	return1
	end
c////////////////////////////////////////////////////////////
c
c  driving subroutine to display color-intensity map
C
	SUBROUTINE discmap(*,NFR1,NFR2,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),icarray(500000)
	INTEGER IX(NU,NV,KF),icarray(500000)
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	include 'ppparm.inc'
	equivalence (icarray(1),iscr(1))
	CALL QUERYNFR(NFR1,KF,1,*999,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*999,*20002)
20002	ni1=nii(nfr1)
	nj1=njj(nfr1)
	nca=0
	scale=1000.
	call stripsky(nfr1,int(.1*ni1),int(.1*nj1),int(.9*ni1), 
     *          int(.9*nj1),40,sky,sig,0,ix,nu,nv,kf)
c	down=amax1(0.,down)
 601	write(6,1) down,up
 1	format('   Enter lower and upper intensity range in sigma [',
     *       2f6.1,']: ',$)	
	call read2r(down,up,*999,*601)
c  compute average and sigma of color ratio
	j1=nj1/4
	j2=3*nj1/4
	i1=ni1/4
	i2=3*ni1/4
	do 100 j=j1,j2
	  do 100 i=i1,i2
	      if (ix(i,j,nfr2).gt.0) then
c  store color in array for determining color scale
		nca=min0(500000,nca+1)
		icarray(nca)=ix(i,j,nfr2)
	      end if
 100	continue
	call avsig(icarray,cave,csig,maxc,minc,nca)
 602	write(6,11) scale,cave,csig,maxc,minc,siglow,sighigh
 11	format('  color ratio stats *',f6.1,': ave=',f8.2,'  sig=',f8.2,
     *         '  max=',i6,'  min=',i6
     *   /'  enter upper and lower range in sigma [dflt:',2f5.1,']: ',$)
	call read2r(siglow,sighigh,*999,*602)
	crange1=cave+siglow*csig
	crange2=cave+sighigh*csig
	frange1=sky+down*sig
	frange2=sky+up*sig
	call mapclr(ix(1,1,nfr1),ix(1,1,nfr2),ni1,nj1,
     *        crange1,crange2,frange1,frange2,icflag,ifflag,1,0,1,
     *	      nu,nv,ibflag)
 999	RETURN1
	END	
c  dummy
C	subroutine mapclr(ix1,ix2,ni1,nj1,crange1,crange2,
C     *    frange1,frange2,icflat,iiflat,idum1,idum2,idum3)
C	integer*2 ix1(ni1,nj1),ix2(ni1,nj1)
C	write(6,*) '  ++++ color-intensity display not available ++'
C	return
C	end
