C////////////////////////////////////////////////////////////////
c    Subroutine to create outputs to run GALFIT
C\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
c  driving routine
c
	SUBROUTINE galfitdri(*,NFR,ipar,IX,NU,NV,KF)
c maximum number of objects allowed
c     nmax=objects for galfitting
c     nsts= max size of psf image stamp
c         actual size set by parameter nupsf 
c     ngs= max size of galaxy stamp image
c     maxpsf= max number of psf
	parameter(nmax=10000,nsts=101,maxpsf=200,ngs=1000)
	INTEGER IX(NU,NV,KF),ICL(nmax),NNG(200),
     *    NMASK(500,500),NNEI(nmax),IDBR(nmax)
	real pix(ngs,ngs),x0,y0,cntrt,asymt,rsky,rskyrms,
     *      rmask(ngs,ngs),areat,ctt,sbrt,rnsigma,rii(nmax),rjj(nmax)
     *      ,psfpix(nsts,nsts,maxpsf),psfpx(maxpsf),psfpy(maxpsf)
	integer nx,ny,ids(nmax),nmrefst(maxpsf)
	DIMENSION  RMAG(nmax),cntr(nmax),asym(nmax),
     *    area(nmax),cts(nmax),sbr(nmax),
     *   sky(nmax),ZSIG(nmax),err(nmax),rad(nmax),SKARAY(50000)
c    *     index(nfmax),distpsf(nfmax),xline(250),dlograd(29)
	CHARACTER*1 IANS,IANS2,secstr,outname*24,tempcom*20
	CHARACTER COMMENT*60,fdate*24,filout*20,filroot*18
     *    ,filroot2*18,tempname*20,tempname2*20,psfname*24,
     *     feedmename*24,galfitcomm*60,dummyname*8
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
        include 'galfitparm.inc'
        include 'galfitres.inc'
	include 'imagepar.inc'
	include 'apert.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=6 FOR POSITION FILE'
	  RETURN1
	END IF
c  read object information from .phm file
	call mordaper2(nfr,rad,rmag,rii,rjj,err,sky,zsig,icl,ids,
     *     nmax,nmrefst,nref,comment,filroot,*999)
c create psf''s
	call mkpsf(nfr,nref,nmrefst,ix(1,1,nfr),nu,nv,psfpix,nsts,
     *            maxpsf,psfpx,psfpy,sky)
	write(6,*) '  ..... ',nref,' psf"s from ref stars stored'
	write(6,*) (nmrefst(k),k=1,nref)
c result output file: filroot.mph, filroot is read in from .phm file
	write(6,*) filroot
	filout=filroot(1:lnblnk(filroot))//'.mph'
	write(6,2) filout
 2	format('  ...Output file name: ',a20)
c make name without ^ for image (so that ppp can read it),
c and move the chip number to the end of the name
	len1=index(filroot,'^')
	filroot2=filroot(1:len1-1)//filroot(len1+2:
     *       lnblnk(filroot))//filroot(len1+1:len1+1)
c search for date string on phm file comment to create comment
	do 161 i=1,60
	  if (comment(i:i).eq.':') goto 162
 161	continue
 162    comment=comment(1:i-14)//'(.phm file: '//comment(i-9:i-4)//
     *     comment(i+6:i+10)//') '
 601	WRITE(6,'(a60)') COMMENT
c
c  Go through each object to do galfit
c
	maxu=201
	ni=nii(nfr)
	nj=njj(nfr)
	ngftot=0
	write(6,*) ' Galfit file generation begins, S/N cut ',snlim
c before running galfit, check for existing result file and copy it to *.B*
c  this is done by opening a dummy fit.log file, and then deleting it
c   leaving the previous fit.log to have .B* suffix.
        dummyname='fit.log'
        call opennew(33,1,8,dummyname,*999)
        close (unit=33,status='delete')
	do 100 i=1,nob(nfr)
c  for testing, just do a few objects
 	if (i.le.noo1.or.i.gt.noo2) goto 100
	  iob=ijoi(i,nfr)
	  job=ijoj(i,nfr)
c  check if object has sufficient S/N  or star/saturated
c    snlim set from common block, 
	  if (icl(i).ge.3.or.icl(i).eq.0) goto 100
	  if (err(i).lt.snlim) goto 100
c   object passed criteria
 	write(6,*) ' object ppp# ',i,rii(i),rjj(i),rad(i),err(i)
c  Should there be a magnitude cut?
c        any objects with center less than 2 rad from edge are not  done
	  rad2=1.5*rad(i)
	  if (float(iob-ilpos(nfr)+1).lt.rad2) goto 100
	  if (float(iupos(nfr)-iob-1).lt.rad2) goto 100
	  if (float(job-jlpos(nfr)+1).lt.rad2) goto 100
	  if (float(jupos(nfr)-job-1).lt.rad2) goto 100
C  cut out object and place in input array pix
c    the size of the array is gstsXrad, with a max of maxu 
c    Should there be a minimum?
c
c    Need to deal with objects at edges:
	  nx=min(2*(iob-ilpos(nfr)),min(maxu,nint(2.*gsts*rad(i))))
	  nx=min(nx,2*(iupos(nfr)-iob))
	  ny=min(nx,2*(job-jlpos(nfr)))
	  ny=min(ny,2*(jupos(nfr)-job))
c make sure both arrays are odd in size
	  if (mod(nx,2).eq.0) nx=nx+1
	  if (mod(ny,2).eq.0) ny=ny+1
c  need to figure out what x0 and y0 are when not in center 
	  nxh=nx/2
	  nyh=ny/2
	  x0=nxh+1
	  y0=nyh+1
c temp: use x0 and Y0 as guess of centroid
          gfx=x0
          gfy=y0
	  rsky=sky(i)
          rskyrms=zsig(i)
	  ITT=IOB-nxh 
	  JTT=JOB-nyh
c  object accepted, store the ppp# in nppg
          ngftot=ngftot+1
          npppg(ngftot)=i
c fill the image array for output
	  do 103 jm=1,ny
	    jjp=job-nyh-1+jm
	    do 104 im=1,nx
 	      pix(im,jm)=IX(itt-1+im,jjp,nfr)
 104	    continue
 103	  continue
 	    WRITE(6,24) I,iob,job,rmag(i),5*rad(i),nx,ny,x0,y0,
     *             rsky,rskyrms 
 24	FORMAT(' ppp#',i5,2i5,f8.3,f7.1,2i4,1x,2f7.1,f10.2,f7.2)
c write out the stamp
          tempcom='object stamp image'
          istatus=encode(tempname,float(i),1,0,dum)
	  outname=filroot2(1:lnblnk(filroot2))//'_'//
     *            tempname(1:lnblnk(tempname))//'.fits'
	write(6,*) ' Galaxy stamp name ',outname
          call outstamp(pix,ngs,ngs,nx,ny,exptime(nfr),ccdgn(nfr),
     *        readnoise(nfr),ncombine(nfr),outname,tempcom)
c create psf for the object
c	write(6,*) ' making summed psf '
	  dismaxsq=rrefmax*rrefmax*nj*nj
	  call crpsf(iob,job,nmrefst,psfpix,nsts,maxpsf,psfpx,psfpy,
     *           dismaxsq,nref,psfname,outname)
c  determine initial values for Re, a/b, and PA
c	write(6,*) ' initializing galfit fitting parameters'
	  call gfinit
c  make galfit feedme file
c	write(6,*) ' making galfit feedme file'
	  call mkfeedme(i,feedmename,outname,psfname,nx,ny 
     *       ,gfx,gfy,rmag(i),sky(i))
c spawn galfit
	  galfitcomm=galfitpath(1:lnblnk(galfitpath))//' '
     *        //feedmename(1:lnblnk(feedmename))
	write(6,*) galfitcomm
 	  call system(galfitcomm)
c  for objects with no galfit run, fill in parameters with dummy
c110	  call galfitdummy(i)
 100	CONTINUE
c
c  read in results and store 
 	call rdgfitres(35)
C  output results
	write(6,*)' Total of ',ngftot,' galaxies fitted...'
	call opennew(28,1,20,filout,*999)
	call gfresout(28,ngftype,comment)
C
 	close(unit=28)
 999	RETURN1
	END
c////////////////////////////////////////////////////////////////////
c  subroutine to output GALFIT results
c     output file contains only objects that have been fitted,
c    identified by the ordinal ppp numbers.
c    Each objects have 2 lines, containing the fits using deV+exp
c                 or   2 lines, containing the fits using sersic
c                               plus the 2nd line with chisq
c      the x-y positions are reconstructed to the original pixel
c       co-ordinate
c
	subroutine gfresout(idev,ngftype,comment)
	character comment*60
	include 'galfitres.inc'
c   header
	comment=COMMENT(1:lnblnk(comment))//':: '//fdate()//':morp'
 	write(idev,'(1x,a60)') comment 
	write(idev,10)
 10	format(' ppp#   Type     Xc   +/-     Yc    +/-  mag  +/-' 
     *         ,'    rad   +/-  b/a  +/-     PA   +/-')
	do 100 i=1,ngftot
	  if (fgtype(1,i).eq.'fail') then
	    write(idev,5) npppg(i)
 5	format(i5,1x,'failed')
	    if (ngftype.eq.2) write(idev,6)
 6	format('    no fit')
	    goto 100
	  end if
c write the first fit
c  make everything no bigger than the max need to fit the format
	  call gfitform(i)
	  if (fgtype(1,i).ne.'Ser') then
	    write(idev,1) npppg(i),fgtype(1,i)(1:3),gfcx(1,i),gfcxe(1,i),
     *       gfcy(1,i),gfcye(1,i),gfmag(1,i),gfmage(1,i),gfr(1,i),
     *       gfre(1,i),gfab(1,i),gfabe(1,i),gfpa(1,i),gfpae(1,i)
 1	format(i5,3x,a3,2(f9.2,f5.2),f6.2,f5.2,f7.2,f6.2,2f5.2,f8.2,
     *         f5.2,f6.2,f5.2)
	  else
	    write(idev,1) npppg(i),fgtype(1,i)(1:3),gfcx(1,i),gfcxe(1,i),
     *       gfcy(1,i),gfcye(1,i),gfmag(1,i),gfmage(1,i),gfr(1,i),
     *       gfre(1,i),gfab(1,i),gfabe(1,i),gfpa(1,i),gfpae(1,i),
     *       gfpwr(1,i),gfpwre(1,i)
	  end if
	  if (fgtype(2,k).eq.' ') then
	    write(idev,2) chi_nu(i)
	  else 
	    if (fgtype(2,k).ne.'Ser') then
	      write(idev,2) chi_nu(i),fgtype(2,i)(1:3),gfcx(2,i),
     *          gfcxe(2,i),gfcy(2,i),gfcye(2,i),gfmag(2,i),gfmage(2,i),
     *      gfr(2,i),gfre(2,i),gfab(2,i),gfabe(2,i),gfpa(2,i),gfpae(2,i)
 2	format(2x,f5.2,1x,a3,2(f9.2,f5.2),f6.2,f5.2,f7.2,f6.2,2f5.2,f8.2,
     *         f5.2,f6.2,f5.2)
	    else
	      write(idev,2) chi_nu(i),fgtype(2,i)(1:3),gfcx(2,i),
     *          gfcxe(2,i),gfcy(2,i),gfcye(2,i),gfmag(2,i),gfmage(2,i),
     *          gfr(2,i),gfre(2,i),gfab(2,i),gfabe(2,i),gfpa(2,i),
     *          gfpae(2,i),gfpwr(1,i),gfpwre(1,i)
	    end if
	  end if
 100	continue
c     
	return
	end
c////////////////////////////////////////////
c   make numbers = 99.99 etc. to make the numbers fit into output format
c
	subroutine gfitform(i)
	include 'galfitres.inc'
	do 100 k=1,2
	  gfcxe(k,i)=amin1(9.99,gfcxe(k,i))
	  gfcye(k,i)=amin1(9.99,gfcye(k,i))
	  gfmage(k,i)=amin1(9.99,gfmage(k,i))
	  gfr(k,i)=amin1(999.99,gfr(k,i))
	  gfre(k,i)=amin1(99.99,gfre(k,i))
	  gfabe(k,i)=amin1(9.99,gfabe(k,i)) 
	  gfpae(k,i)=amin1(9.99,gfpae(k,i)) 
 100	continue
	return
	end
c//////////////////////////////////////////////////////
c  determine initial values for Re, a/b, and PA
c
        subroutine gfinit
        include 'galfitparm.inc'
c temporary: return fixed numbers
c
c b/a ratio
	gfbarati=1.
c position angle
	gfpai=0.
c  radius (r_e for dev and serics, r_s for exp
	gfrad=2.
c  exponent for sersic
	sersicexp=2.
c  eccentricity
c       gfeccen=1.
        return
        end
c//////////////////////////////////////////////////////
c  make galfit feedme file
c
	subroutine mkfeedme(numppp,feedmename,gfitname,psfname,
     *            igals,jgals,gfx,gfy,rmag,sky)
        character gfitname*24,inimage*20,outimage*20,galstr*6,
     *            psfname*24,feedmename*24
        include 'galfitparm.inc'
	include 'imagepar.inc'
c open galfit input file 
        inimage='galaxy_in.fits'
        if (igfitsave.eq.1) then
c make individual names for saved residual image
 	write(6,*) ' making galfit feedme file for ppp# ',numppp
          istatus=encode(galstr,float(numppp),1,0,dum)
          outimage='gal_out'//galstr(1:lnblnk(galstr))//'.fits'
        else
          outimage='gal_out.fits'
        end if
	feedmename=gfitname(1:lnblnk(gfitname)-5)//'.gfitin'
	call opennew(29,1,24,feedmename,*999)
c output image parameters
        write(29,1)
 1      format('# IMAGE PARMATERS')
        write(29,2) gfitname
 2      format('A) ',a20,' # Input Data Image (FITS file)')
        write(29,3) outimage
 3      format('B) ',a20,' # Output Data Image (FITS file)')
        write(29,4)
 4      format('C) none                 # Noise image name ',
     *      '(made from data if blank or "none")') 
        write(29,5) psfname
 5      format('D) ',a20,
     *         ' # Input PSF image for convolution (FITS file)')
        write(29,6)
 6      format('E) 1                   # PSF oversampling factor',
     *    ' relative to data') 
        write(29,7)
 7      format('F) none                ',
     *     ' # Bad pixel mask (FITS image or ASCII coord list)')
        write(29,8)
 8      format('G) none                ',
     *     ' # File with parameter constraints (ASCII file)')
	imin=1
	jmin=1
        write(29,9) imin,igals,jmin,jgals
 9      format('H) ',4i5,' # Image region to fit (xmin xmax ymin ymax)')
c convolution size should not be bigger than 0.6 image size
	igsjt=min0(igsj,nint(0.6*nupsf))
	jgsjt=min0(jgsj,nint(0.6*nupsf))
	write(6,*) ' conv box ',igsjt,igsj,nupsf
        write(29,10) igsjt,jgsjt
 10     format('I) ',2i5,10x,' # Size of the convolution box (x y)')
        write(29,11) gzpt
 11     format('J) ',f7.3,13x,' # Magnitude photometric zeropoint')
c  always assume image in nfr=1
        write(29,12) pixscale(1),pixscale(1)
 12     format('K) ',2f8.5,4x,' # Plate scale (dx dy)')
        write(29,13)
 13     format('O)   regular            #',
     *     ' Display type (regular, curses, both)')
	igfit=0
        write(29,14)  igfit
 14     format('P) ',i1,19x,' # Create output only?(1=yes;0=optimize)') 
        write(29,15)
 15     format('S) 0                   ',
     *       ' # Modify/create objects interactively?')
c  temporarily set center of object to be center of the stamp,
c     need to compute the centroid here and feed in
	ixt=nint(0.5*igals+0.5)
	ixy=nint(0.5*jgals+0.5)
        write(29,16)
 16     format('# INITIAL FITTING PARAMETERS'/'#'/
     *    '#  object type allowed functions: psf, sersic, nuker,'/
     *    '#                       expdisk, devauc, moffat, gaussian.'/
     *    '# Objtype:      Fit?         Parameters ')
c initial parameters for target object 
c
c  compute the xy position and mag

c  number of components to fit, each requiring its own fitting parm
c    the 3rd column integer specify if the paramter is to be fitted (1),
c      or fixed (0)
c  
	do 100 i=1,ngftype
	  write(29,17) i
 17     format('# Object number: ',i2)
	  write(29,18) gftype(i)
 18     format(' 0) ' ,a19,'#    Object type')
	  write(29,19) gfx,gfy
c  the integer(s) after the parameter indicates: 1=to be fitted,
c                                                0= fixed
 19     format(' 1) ',f7.2,f8.2,' 1 1 #   position x, y')
        write(29,20)  rmag+gzpt
 20     format(' 3) ',f7.3,'      1     #  total magnitude')
c  for different fit types, different initial parameters are needed
c  (1) devauc
	if (gftype(i).eq.'devauc'.or.gftype(i).eq.'sersic') then
          write(29,21)  gfrad
 21     format(' 4) ',f7.3,'      1     #      R_e')
c (2) sersic
          if (gftype(i).eq.'sersic') then
	    write(29,22) sersicexp
 22     format(' 5) ',f7.3,'      1     # ',
     *      ' exponent (de Vaucouleurs = 4)')
	  else
	    write(29,23)
	  end if
	  write(29,24)
	  write(29,25)
 23     format(' 5) 0.000        0     #     ----- ')
 24     format(' 6) 0.000        0     #     ----- ')
 25     format(' 7) 0.000        0     #     ----- ')
c exponential disk
	else if (gftype(i).eq.'expdisk') then
	  write(29,26) gfrad 
 26     format(' 4) ',f7.3,'      1     #      Rs ')
c 3) blanks for expdisj
	  write(29,23)
          write(29,24)
          write(29,25)
c 4) nuker  (to be completed)
	else if (gftype(i).eq.'nuker') then
c need to write item 4,5,6,7
	  write(29,27)
	  write(29,28)
          write(29,29)
          write(29,30)
 27	format(' 4) ','    1     # Rb ')
 28	format(' 5) ','    1     # alpha ')
 29	format(' 6) ','    1     # beta ')
 30	format(' 7) ','    1     # gamma ')
c  psf
	else if (gftype(i).eq.'psf') then
	  goto 520
	end if 
        write(29,31) gfbarati
 31     format(' 8) ',f7.3,'      1     #  axis ratio (b/a)')
        write(29,32) gfpai
 32     format(' 9) ',f7.2,'      1     #  position angle (PA) ')
        write(29,33) 
c  temporarily fixed to no fit for this
 33     format('10) 0.000        0     #  diskiness(-)/boxiness(+)')
 520	write(29,34) igfout
 34     format(' Z) ',i2,17x,'#  Output option (0 = residual,',
     *        ' 1 = Don''t subtract') 
	write(29,*)
 100	continue
c  enter sky value
	write(29,17) i
	write(29,35) 
 35     format(' 0)    sky          #    Object type')
	write(29,36) sky
 36	format(' 1) ',f8.2,12x,'# sky background'/
     *   ' Z) 0                  #  Output option ',
     *       '(0 = residual, 1 = Don''t subtract)')
 999    close(unit=29)
	return
        end
c////////////////////////////////////////////////////////////////
c  subroutine to read aperture information for morphology (GALFIT)
c     include info on reference psfs
c
	subroutine mordaper2(nfr,rad,rmag,ri,rj,err,sky,zsig,icl,ids,
     *        nmax,nmrefst,nref,comstr,filroot,*)
	INTEGER icl(*)
	dimension rad(*),rmag(*),err(*),ids(*),sky(*),zsig(*),ri(*)
     *           ,rj(*),nmrefst(200)
	character phmname*20,nfrstr*3,refstr*4
     *      ,comstr*60,secstr*1,filroot*18
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
c request .phm file and read position and compute diameter
 600	write(6,20)
 20	format('  Enter .phm name (++posfil array will',
     *         ' be over-written++): ',$)
	read(5,'(a20)',end=999) phmname
c add .phm if it does not end in ".B"
	if (phmname(lnblnk(phmname)-1:lnblnk(phmname)).ne.'.B') 
     *     phmname=phmname(1:lnblnk(phmname))//'.phm'
c add section number if needed
	if (nsct(nfr).gt.0) then
	  istatus=encode(secstr,float(nsct(nfr)),1,0,dum)
          phmname=phmname(1:lnblnk(phmname))//'.'//secstr
	end if
	do 160 i=1,20
	  if (phmname(i:i).eq.'.') goto 161
 160	continue
 161	filroot=phmname(1:i-1)
	open(unit=34,file=phmname,status='old',err=601)
	go to 150
 601	  write(6,1) phmname
 1	format('  +++ ',a20,' does not exist ++++')
	  go to 600
 150    call readrad3(34,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),ri,rj,
     *       ids,rad,rmag,err,icl,sky,zsig,nmrefst,nref,comstr,
     *       nmax,icflag)
	close(unit=34)
	return
 999	return1
	end
c///////////////////////////////////////////
c  subroutine to read .phm file
c     ipar=1: normal read, rad() is the radius in pixels
c     ipar=0: rad() is used to store scaled magnitude values
c                     for plot size
c
	subroutine readrad3(idev,nob,ii,jj,ri,rj,ids,rad,rmag,err,
     *         icl,sky,zsig,iref,nref,comment,nmax,icflag)
	character teststr*2,teststr2*3,comment*60,string*80
	integer ii(*),jj(*),icl(*),iref(200)
	dimension ids(*),rad(*),rmag(*),err(*),sky(*),zsig(*),
     *            ri(*),rj(*)
c   read first line, including ref star numbers
	read(idev,1) comment,(iref(k),k=1,7)
 1	format(a60,8x,7i4)
	nref=0
	do 130 k=1,7
	  if (iref(k).le.0) goto 131
	  nref=nref+1
 130	continue
c read aperture info
 131	READ(idev,9,ERR=998) IAP1,IAP2,ideld,SIZ1,SIZ2
 9	FORMAT(27X,I2,13X,I3,1x,i1,7X,F4.0,1X,F4.0)
 	if (ideld.eq.0)  then
	  write(6,*) ' ++ ideld=0, ideld from ppparm.dat used ++ '
	  ideld=ideldt
	end if
        NAP=(IAP2-IAP1)/ideld+1
	nline=(nap-1)/10+1
c determine how many lines there are in the growth curve
	write(6,10) IAP1,IAP2,ideld, NAP,nline
 10	format(' 1st aper ',i3,'; last aper ',i3,', deld:',i2,
     *     '; max aperture number:',i3, ' #line:',i2)
c read additional reference stars if there are any
 199    read(idev,'(1x,3a)',end=998) teststr2
        backspace idev
c  test if it is a Ref star line, if not proceed to reading section info
        if (teststr2.eq.'Ref') then
c read up to 10 reference stars
	  k1=nref+1
	  read(idev,2,err=198,end=198) (iref(kr),kr=k1,k1+9)
 2	format(36x,10i5)
 198	  nref=kr-1
	  go to 199
        end if
c  remove zeros from reference stars\
	nreft=nref
	do 141 kr=nreft,1,-1
	  if (iref(kr).le.0) then
	   nref=nref-1
	  else
	   goto 142
	  end if
 141	continue
 142	write(6,*) '  Total number of reference star read: ',nref
c read section info
	do 200 i=1,5
	  read(idev,'(a80)') string
	  if (string(1:1).eq.'#') then
c	     write(6,'(a10)') string(1:10)
c  it is an additional header line
c    *** need to read the section info
	  else
            backspace idev
	    goto 201
	  end if
 200	continue
 201	continue 
c read data, need I and J, and ids
	do 100 i=1,nmax  
          READ(idev,11,END=999,ERR=981) RI(i),RJ(i),rmag(i),err(i),
     *            sky(i),zsig(i),icl(i) 
 11     FORMAT(5X,2(F6.2,1X),7x,f7.2,7x,f7.2,29x,f10.3,f8.3,9x,6x,i2)
	  ii(i)=nint(ri(i))
	  jj(i)=nint(rj(i))
c  check if it is a long format growth curve
	  if (icflag.eq.0) then
            READ(idev,12,END=999,ERR=982) ids(i)
 12	FORMAT(23X,83x,I2)
	  else
	    read(idev,112,end=999,err=982) ids(i)
 112	format(23x,93x,i2)
	  end if
c check if it is a big galaxy
	  read(idev,13,end=999,err=983) teststr,idum
 13	format(10x,a2,1x,i3)
 	  if (teststr.eq.'BG') then
c  read aperture number
 	    rad(i)=idum*.5
 	  else
c compute size (radius)
	    rad(i)=(iap1+ideld*(ids(i)-1))*.5
 	  end if
c  read one more line
          if (nline.eq.3) read(idev,'(1x)',end=999)
	  goto 100
 981	write(6,*) '  ** read error headerline, obj#',i,' obj skipped'
          read(idev,'(1x)',end=999)
          read(idev,'(1x)',end=999)
          if (nline.eq.3) read(idev,'(1x)',end=999)
	  goto 100
 982	write(6,*) '  ** read error ids, obj#',i,' obj skipped'
          read(idev,'(1x)',end=999)
          if (nline.eq.3) read(idev,'(1x)',end=999)
	  goto 100
 983	write(6,*) '  ** read error BG, obj#',i,' obj skipped'
          if (nline.eq.3) read(idev,'(1x)',end=999)
 100	continue
c..................................................
 999	nob=i-1
	write(6,*) '  ... total number of objs read: ',nob
	return
 998	write(6,*) ' ** .phm file read error, reading aborted at obj'
     *      ,i
	nob=i-1
	return
	end
c/////////////////////////////////////////////////////////////////
c  subroutine to create a bank of centered psfs
c        the set of nref PSFs are already read in from the .phm file,
c           with ppp number stored in nmrefst
c
	subroutine mkpsf(nfr,nref,nmrefst,ix,nu,nv,psfpix,nsts,maxpsf,
     *         psfpx,psfpy,sky)
	integer ix(nu,nv),nmrefst(*),ixtemp(111,111)
	dimension psfpix(nsts,nsts,maxpsf),psfpx(maxpsf),psfpy(maxpsf)
     *        ,sky(*)
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'galfitparm.inc'
c size of the psf images, set by gset nupsf
	ijpsf=nupsf
	mhalf=ijpsf/2
	ipsff=mhalf+1
	jpsff=mhalf+1
	idev=6
	do 100 i=1,min0(maxpsf,nref)
	  kk=nmrefst(i)
c fill temp array with psf
	  i0=ijoi(kk,nfr)
	  j0=ijoj(kk,nfr)
          psfpx(i)=float(i0)
          psfpy(i)=float(j0)
c	write(6,*) '  +++ filling psf storage ',i,' ppp# ',kk,
c    *    ' @ ',psfpx(i),psfpy(i)
	  do 101 jj=1,ijpsf
	    jjp=j0-mhalf-1+jj
	    do 102 ii=1,ijpsf
	      ixtemp(ii,jj)=ix(i0-mhalf-1+ii,jjp)
 102	    continue
 101	  continue
c determine shift using sinc shift interations
c	  call psfcen3(ixtemp,ijpsf,ijpsf,ipsff,jpsff,cdiam,irobj,
c     *           cenox,cenoy,txsh,tysh,sky(kk),is2,itercen,idev)
c shift the psf to the array center 
c  (*** need attention to some parameters still)
c	  call psfcen3(ixtemp,ijpsf,ijpsf,ipsff,jpsff,cdiam,irobj,
c     *      cenox,cenoy,TXSH,TYSH,sky(kk),is2,itercen,6)
c  copy to psfpix (storage for the shifted psf)
c
c   TEMP: no shifting of psf
	  do 105 jj=1,ijpsf
	    do 106 ii=1,ijpsf
c galfit expect psf to be sky-subtracted
	      psfpix(ii,jj,i)=ixtemp(ii,jj)*1.-sky(kk)
 106	    continue
 105	  continue
c	write(6,*) i,' @ ',i0,j0,' peak pix: ',
c    *    psfpix(mhalf+1,mhalf+1,i), ix(i0,j0)
 100	continue
	return
	end
c////////////////////////////////////////////////////////////////
c subroutine to create a summed psf for a particular object
c          at (ii,jj) using
c    the set of reference stars from the .phm file
c
c      ii,jj: the position of the object in question
c      nref: number of psfs available
c      nmrefst(*): ppp number of psfs
c      psfpix: array containing the psfs'' pixel values
c      psfpx, psfpy: x and y of the psfs
c
c      npsfres: psf numbers of the chosen psfs
c      psfsum(,): arrray containing the summed psf (output as fits)
c
	subroutine crpsf(ii,jj,nmrefst,psfpix,nsts,maxpsf,
     *     psfpx,psfpy,dismaxsq,nref,psfname,galoutname)
	dimension psfpix(nsts,nsts,maxpsf),nmrefst(maxpsf),
     *               psfpx(maxpsf),psfpy(maxpsf),
     *             npsfres(16),psfsum(nsts,nsts)
        character psfname*24,galoutname*24,tempcom*20
     *           ,tempname*24
	include 'ppparm.inc'
	include 'galfitparm.inc'
c search for the nearest psfs, given ii and jj
        reali=float(ii)
        realj=float(jj)
	call pickrefs(reali,realj,psfpx,psfpy,
     *     nref,delx,dely,dismaxsq,nvpsf,npsfp,npsfres)
c writing out a test psf
c       tempcom='psf #2'
c       tempname='testpsf.fits'
c	call outstamp(psfpix(1,1,2),nsts,nsts,nupsf,nupsf,tempname,tempcom)
c weighted sum of the psf, 
        call sumpsf(psfpix,psfsum,nsts,nupsf,maxpsf,npsfp,npsfres)
c write out fits file
        tempcom='psf stamp'
	len1=lnblnk(galoutname)
	psfname=galoutname(1:lnblnk(galoutname)-5)//'pf.fits'
	write(6,*) ' ... writing out summed psf: ',psfname
c use dummy arguements for key words for psf stamp.
	exptime=1.
	ccdgn=2.
	readnoise=5.
	ncombine=1
        call outstamp(psfsum,nsts,nsts,nupsf,nupsf,exptime,
     *             ccdgn,readnoise,ncombine,psfname,tempcom) 
	return
	end
c///////////////////////////////////////////////////////////////
c  subroutine to locate nearest  psfs curve from a set of PSFs,
c   uses the closest refstars in each quadrant 
c
c   the integer positions of the ref stars are good enough
c  
c         nrefres: array storing the psf number of the selected psfs
c
	subroutine pickrefs(reali,realj,psfpx,psfpy,
     *     nref,delx,dely,dismaxsq,nvpsf,npsfp,nrefres)
	dimension psfpx(*),psfpy(*)
     *  ,tdis(nref,4),t(16),l(16),index(16),nkk(4)
	integer lpsf(nref,4),indx(nref),nrefres(*)
 	dsq=dismaxsq
	dsmallest=10000000.
	ksmall=0
	itry=1
	iclose=0
	nmax=nvpsf*4
	if (nvpsf.eq.1) nmax=5
 120	continue
c setting initial values, t=distance of ith star, l=
	do 105 i=1,nmax
	  t(i)=10000000.
	  l(i)=0 
 105	continue
c nkk()=number of obj in quadrant i
	do 106 i=1,4
	  nkk(i)=0
 106	continue
c sort objects into quardants
	do 100 i=1,nref
c first check that there is no screw up on the psf postion
	  if (psfpx(i).lt.0.0) then
	    write(6,*) '  *** psf position error, psf# ',i,psfpx(i),
     *                 psfpy(i)
	    go to 100
	  end if
c compute distance to object
	  dist=(reali-psfpx(i))**2+(realj-psfpy(i))**2
c  do not use if it is too far away
	  if (dist.gt.dsq) go to 100
c separate them into quadrants, note that if the object is itself a
c  psf, it will be stored in kk=1
	  if (psfpx(i).le.reali.and.psfpy(i).le.realj) then
c kk is the quadrant number
c  (1) upper right (smaller i and j)
	    kk=1
	  else if (psfpx(i).ge.reali.and.psfpy(i).le.realj) then
c  (2) upper right (larger i, smaller j)
	    kk=2
	  else if (psfpx(i).le.reali.and.psfpy(i).ge.realj) then
c  (3) upper left  (smaller i, larger j)
	    kk=3
	  else if (psfpx(i).ge.reali.and.psfpy(i).ge.realj) then
c  (4) lower left  (larger i and j)
	    kk=4
	  else 
c  this should not happen, but just in case
	    goto 100
	  end if
c  store the ref star number (lpsf) and distance (tdis) in the correct bin
	  nkk(kk)=nkk(kk)+1
	  lpsf(nkk(kk),kk)=i
	  tdis(nkk(kk),kk)=dist
 100	continue
c sort the distance and the corresponding psf number array lpsf
	ntot=0 
	do 101 m=1,4
	  if (nkk(m).gt.1) then    
	    call indexx(nkk(m),tdis(1,m),indx)
	  else if (nkk(m).eq.1) then
	    indx(1)=1
	  else 
c no psf in the quadrant
	    goto 101
	  end if
c now pick the smallest nvpsf and store it in the final array,
c    first check to see that it is not very close to zero
	  if (tdis(indx(1),m).lt.delx) then
c  for the case of 1 psf per quadrand, this object should be used
	    if (nvpsf.eq.1) iclose=lpsf(indx(1),m)
	  end if
c  now save the nearest nvpsf psfs; l() is the psf number, t is the dist
	  do 102 i=1,min0(nkk(m),nvpsf)
	    ntot=ntot+1
	    l(ntot)=lpsf(indx(i),m)
	    t(kk)=tdis(indx(i),m)
 102	  continue
 101	continue
c if nvpsf=1, and if there is a really close psf (ie iclose=1)
	if (nvpsf.eq.1.and.iclose.gt.0) then
	    ntot=ntot+1
c	  if (idsm(1).gt.0) then
c  fudge t(new) to be 1/2 X the smallest t's (note that t is distance sq'ed)
c	    t(ntot)=0.25*t(1)
c	  else
c	    t(ntot)=1.
c	  end if
	  l(ntot)=iclose
	end if
c  now check if there are any psf''s, (at least 1 if nvpsf=1, or
c   2 if nvpsf>1) if not, expend the search radius
	if (ntot.le.min0(nvpsf,2).and.itry.eq.1) then
	  itry=2
	  dsq=2.*dismaxsq 
	  iclose=0
	  goto 120
	else if (itry.eq.2) then
	  if (ntot.eq.0) then
c still no star, use the whole set (up to 16)
	    ndel=nref/16+1
	    write(6,*) ' +++ no close psf available, using whole set ++'
	    do 125 i=ndel,nref,ndel
	      ntot=ntot+1
	      if (ntot.gt.16) goto 132
	      l(ntot)=i
	      t(ntot)=1.
 125	    continue
 132        continue
	  end if
	end if
	npsfp=ntot
	do 139 i=1,ntot
	  nrefres(i)=l(i)
 139	continue
	return
	end
c/////////////////////////////////////////////////////////////
c  subroutine to sum the individual psfs.  This assumes that the psfs
c    are already recentroided
c
        subroutine sumpsf(psfpix,psfsum,nsts,ijs,maxpsf,npsfp,npsfres)
        dimension psfpix(nsts,nsts,maxpsf),psfsum(nsts,nsts),
     *                 npsfres(16)
	write(6,1) (npsfres(i),i=1,npsfp)
 1	format('  summing the psf stars #: ',16i4)
        do 100 j=1,ijs
          do 101 i=1,ijs
c initialize
            psfsum(i,j)=0.0
c sum
            do 102 k=1,npsfp
	      kk=npsfres(k) 
              psfsum(i,j)=psfsum(i,j)+psfpix(i,j,kk)
 102        continue
c average
            psfsum(i,j)=psfsum(i,j)/float(npsfp)
 101      continue
 100    continue
        return
        end
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CENTER OBJECT (PSFCEN modified to run quietly and from
c   an input small array)
C
c  ixk= array containing sectioned imagea (must be 201X201 array)
c  niik= I size
c  njjk= J size
c  ipsff, jpsff: integer centroid of object in I,J
c  cdiam= diameter in pixels for determining intensity (first guess) centroid
c  cenox, cenoy: fractional centroid (final) in I,J
c  txsh, tysh: total shifts from input integer centroid
c  sky= sky value (must be input)
c  is2=
c  itercen= number of iterations
c  idev=output device number
	SUBROUTINE PSFCEN3(ixk,niik,njjk,IPSFF,JPSFF,CDIAM,IROBJ,
     *      cenox,cenoy,TXSH,TYSH,sky,is2,itercen,idev)
c	real*8 txsh,tysh
	INTEGER ixk(201,201),ixt(201,201)
	DIMENSION YY(5,5),DERI(5),DERJ(5),DERDUM(5),YT(5)
	INCLUDE 'picdir.inc'
	TXSH=IPSFF-CENOX
	TYSH=JPSFF-CENOY
	ITER=0
	pxsh=0.
	pysh=0.
c	WRITE(idev,30) TXSH,TYSH
 30	FORMAT( ' ... Sinc shift initial guess (dx,dy):',2F8.4)
C make a working copy of the unshifted PSF
	DO 101 J=1,NJJK
	  DO 101 I=1,NIIK
            IXK(i,j)=10*IXK(I,J)
            IXT(i,j)=IXK(I,J)
 101	continue
c....................
c start of iteration loop
c
c shift the central 5X5 pixels of ixk by txsh and tysh (nps=2
 555	CALL PSINCSH3(ixt,niik,njjk,TXSH,TYSH,IPSFF,JPSFF,2,is2,sky)
c check if the matched condition is achieved, if so, skip the rest
	if (ixt(ipsff-1,jpsff).eq.ixt(ipsff+1,jpsff).and.
     *       ixt(ipsff,jpsff-1).eq.ixt(ipsff,jpsff+1)) then
	  xsh=0.
	  ysh=0.
	  iter=iter+1
c	  WRITE(idev,19) iter,TXSH,TYSH,XSH,YSH
	  return1
	end if
C   fill  5x5 sky subtracted array for TESTING
c    note: this can use only single 1X5 array, currently 2-D for
c                   printing out intermediate results
 130	DO 104 J=1,5
	  K=JPSFF-3+J
	  DO 104 I=1,5
 104	    YY(I,J)=FLOAT(IXT(IPSFF-3+I,K))-SKY
	DO 115 J=1,5
 115	  YT(J)=YY(3,J)
c determine derivatives in x and y direction 
	CALL deriva(YY(1,3),DERI,5)
	CALL deriva(YT,DERJ,5)
c checking y direction
	IF (DERJ(2).NE.DERJ(3)) THEN
	  YSH=0.5*(YY(3,2)-YY(3,4))/(DERJ(2)-DERJ(3))
	  ysh=0.8*SIGN(AMIN1(ABS(YSH),1.),YSH)
	ELSE
	  YSH=0.
	END IF
c 	write(idev,*)' Y',YSH,DERJ(2),DERJ(3)
c  the shift must smaller than 1 pixel (is this necessary? it should never
c      happen?...
c	YSH=SIGN(AMIN1(ABS(YSH),1.),YSH)
c  fudge the shift to smaller value
c	IF (ABS(YSH).GT..15) THEN
c	  YSH=YSH*.8
c	ELSE 
c	  YSH=YSH*.75
c	END IF
c  checking x direction
	IF (DERI(2).NE.DERI(3)) THEN
	  XSH=0.5*(YY(2,3)-YY(4,3))/(DERI(2)-DERI(3))
	  xsh=0.8*SIGN(AMIN1(ABS(XSH),1.),XSH)
	ELSE
	  XSH=0.
	END IF
c 	write(idev,*)' X',XSH,DERI(2),DERI(3)
c	XSH=SIGN(AMIN1(ABS(XSH),1.),XSH)
c	IF (ABS(XSH).GT..15) THEN
c	  XSH=XSH*.8
c	ELSE 
c	  XSH=XSH*.75
c	END IF
	ITER=ITER+1
c	WRITE(idev,17) ITER
c17	FORMAT(/'  ..Iteration #',I3)
c	DO 108 I=1,5
c108	  WRITE(idev,18) (YY(I,J),J=5,1,-1)
 18	FORMAT(3X,5F7.0)
c	WRITE(idev,19) iter,TXSH,TYSH,XSH,YSH
 19	FORMAT(' iter ',i3,'  Tot shift:',2F8.4,',  new del:',2F8.4)
 	if (((iter.lt.5).or.(ABS(XSH).GT.0.005.OR.ABS(YSH).GT.0.005))
     *          .and.(iter.lt.itercen)) then
c	if ((ABS(XSH).GT.0.005.OR.ABS(YSH).GT.0.005)
c     *          .and.(iter.lt.itercen)) then
c   
c  check for oscillating solutions
	  TXSH=TXSH+XSH
	  TYSH=TYSH+YSH
	  if (abs(xsh+pxsh).lt.0.0001.and.abs(ysh+pysh).lt.0.0001) then
	     write(idev,20)  txsh,tysh
 20	format('  ...oscillating solution, stopping, final net shift:'
     *              ,2f8.4)
	     return
	  end if
C  get the new shift and do the test shift again
	  pxsh=xsh
	  pysh=ysh
C reset PSF
	  DO 111 J=1,NJJK
	    DO 111 I=1,NIIK
 111          IXT(I,J)=IXK(I,J)
	  GO TO 555
	END IF
 999	RETURN
	END
C/////////////////////////////////////////////////////////////////////
C
C  SINC FUNCTION INTERPOLATION FOR SHIFTING: SINC FILTER SIZE=ISINCF FROM PPPARM
C       SINC FNC IS TAPERED WITH A HAMMING FILTER, EDGES ARE SET TO MEAN VALUES
C       DOING IT ONE DIMENSION AT A TIME
C
c  this shifts the whole picture. This is done before photometry
c
	SUBROUTINE SINCSHIF3(XSH,YSH,niik,njjk,sky,is2,IXK,nu,nv)
	INTEGER IXK(NU,NV),ixt(nu,nv)
c	REAL*8 SINC(151),xsh,ysh
	REAL*8 SINC(151)
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
C shifting X and Y axis separately
C first check if the shift in X is zero
c  !  central index of filter = size of filter+1
c	IS2=(ISINCF+2)/2    
	IF (ABS(XSH).LT.0.00001) THEN
C must move the frame to the scartch
C don''t bother with shift, copy the frame to the scratch
	  do 100 j=1,njjk
	    do 100 i=1,niik
	      ixt(i,j)=ixk(i,j)
 100	  continue
	ELSE
C shifting in X (I) directiion, the temp frame is stored in scratch
c	  if (isinctab.eq.0) then
	    CALL MAKESINC3(-XSH,ISINCS,ISINCF,IS2,ISH,SINC)
c	  else
c	    call findsinc(-xsh,sinc)
c	  end if
c
c edges are replaced by the overall sky value to save cpu
c
C  first determine means of edges I=1 I=NII
c	    CALL PSTAT(*220,NFR,1,0,0,0,ED1,DUM,NDUM,-7,IX,NU,NV,KF)
c220	    CALL PSTAT(*221,NFR,NII(NFR),0,0,0,ED2,DUM,NDUM,
c    *                  -7,IX,NU,NV,KF)
 221	    DO 200 J=1,NJJK
	      DO 205 I=1,NIIK
	        KK=I-IS2+ISH
	        SUMT=0.
	        DO 206 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.niik) THEN
	            SUMT=SUMT+SINC(K)*sky
	          ELSE
	            SUMT=SUMT+SINC(K)*IXK(KKK,J)
	          END IF
 206	        CONTINUE
 205 	      IXT(I,J)=NINT(SUMT)
 200 	    CONTINUE
	END IF
C shifting in Y (J) directiion, here ixt is the original array
c    and ixk is the final array 
C check if the y shift if zero
	IF (ABS(YSH).LT.0.00001) THEN
	  do 101 j=1,njjk
	    do 101 i=1,niik
	      ixk(i,j)=ixt(i,j)
 101	  continue
	ELSE
C the array is moved back to NFR during the shift
c	  if (isinctab.eq.0) then
	    CALL MAKESINC3(-YSH,JSINCS,ISINCF,IS2,ISH,SINC)
c	  else
c	    call findsinc(-ysh,sinc)
c	  end if
 231	    DO 300 J=1,NJJK
	      KK=J-IS2+ISH
	      DO 305 I=1,NIIK
	        SUMT=0.
	        DO 306 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.njjk) THEN
	            SUMT=SUMT+SINC(K)*sky
	          ELSE
	            SUMT=SUMT+SINC(K)*IXT(I,KKK)
	          END IF
 306	        CONTINUE
 305 	      IXK(I,J)=nint(SUMT)
 300 	    CONTINUE
	END IF
c check image
	write(6,*) ' After final shift'
	do 444 j=44,48
 444	  write(6,'(5i6)') (ixk(i,j),i=44,48)
 999	RETURN 
	END
C////////////////////////////////////////////////////////////
C
C  subroutine MAKESINC creates the sinc funtion for SINCSHIFT
c
c  is2=isincf/2+1
c  bis2=float(is2-1)
C
	SUBROUTINE MAKESINC3(SHIFT,NSCALE,ISINCF,IS2,ISH,SINC)
c	real*8 SINC(*),shift,psc,sumfil
	real*8 SINC(*),psc,sumfil
c some of these constant calculations should be moved out of subroutine
	SCALE=FLOAT(NSCALE)
	bis2=float(is2-1)
	PSC=3.14159/SCALE
C  calculate sinc function (ISH = integer part of shift)
 	  ISH=NSCALE*NINT(SHIFT/SCALE)
	  X=ISH-SHIFT
	  SUMFIL=0.0000000000
	  DO 201 K=1,ISINCF
	    XT=PSC*(X+FLOAT(K-IS2))
	    IF (ABS(XT).GT.0.001) THEN
 	      SINC(K)=SIN(XT)/XT
	    ELSE
 	      SINC(K)=1.
	    END IF
C  taper by Hamming filter (see Digital Filter by R.W. Hamming)
 	    SINC(K)=SINC(K)*(.46*COS(XT/BIS2)+.55)
	    SUMFIL=SUMFIL+SINC(K)
 201	  CONTINUE
C  Normalize the filter
	  DO 207 K=1,ISINCF
 207	    SINC(K)=SINC(K)/SUMFIL
	RETURN
	END
C/////////////////////////////////////////////////////////////////////
C
C  Subroutine to sinc shift part of a picture, for use in CENPSF
C    size of shift = 2*NPS+1 centered around I0 and J0
c     this minimze the shift only to the pixels necessary
C
c    the scratch frame is need to store the result of each pixel
c     as the shift is being performed.
c      shift in x is store in ixt, then ixt is shifted in y and
c       stored back in ixk to minimize moving.
c
	SUBROUTINE PSINCSH3(ixk,niik,njjk,XSH,YSH,I0,J0,NPS,is2,sky)
	INTEGER IXK(201,201),ixt(201,201)
c	REAL*8 SINC(151),xsh,ysh,sumt
	REAL*8 SINC(151),sumt
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
C shifting X and Y axis separately
C first check if the shift in X is zero
	IF (ABS(XSH).LT.0.00001) THEN
C don''t bother with shift, copy the frame to the scartch
	  do 100 j=1,njjk
	    do 100 i=1,niik
	      ixt(i,j)=ixk(i,j)
 100	  continue
	ELSE
C shifting in X (I) directiion, the temp frame is stored in scratch
c	  if (isinctab.eq.0) then
	    CALL MAKESINC3(-XSH,ISINCS,ISINCF,IS2,ISH,SINC)
c	  else
c	    call findsinc(-xsh,sinc)
c	  end if
c
c  limits for x shift and y shift  are different.
c   this is due to shifting in y requires the extra pixels in y
c
 	    DO 200 J=MAX0(1,J0-IS2-NPS),MIN0(NJJK,J0+IS2+NPS)
	      DO 205 I=I0-NPS,I0+NPS
	        KK=I-IS2+ISH
	        SUMT=0.
c  the sum is done over -is2 and +is2 around the pixel (is2= 1/2 of
c          isincf=size of the sinc filter.)
	        DO 206 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.niik) THEN
c  this pads the edge with sky value
	            SUMT=SUMT+SINC(K)*sky
	          else
	            SUMT=SUMT+SINC(K)*IXK(KKK,J)
	          END IF
 206	        CONTINUE
 205 	      IXT(I,J)=nint(SUMT)
 200 	    CONTINUE
	END IF
C shifting in Y (J) directiion,  
C check if the y shift if zero
	IF (ABS(YSH).LT.0.00001) THEN
	  do 101 j=1,njjk
	    do 101 i=1,niik
	      ixk(i,j)=ixt(i,j)
 101	  continue
	ELSE
C the array is moved back to NFR during the shift
c	  if (isinctab.eq.0) then
	    CALL MAKESINC3(-YSH,JSINCS,ISINCF,IS2,ISH,SINC)
c	  else
c	    call findsinc(-ysh,sinc)
c	  end if
 231	    DO 300 J=J0-NPS,J0+NPS
	      KK=J-IS2+ISH
	      DO 305 I=I0-NPS,I0+NPS
	        SUMT=0.
	        DO 306 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.njjk) THEN
	            SUMT=SUMT+SINC(K)*sky
	          ELSE
	            SUMT=SUMT+SINC(K)*IXT(I,KKK)
	          END IF
 306	        CONTINUE
 305 	      IXK(I,J)=nint(SUMT)
 300 	    CONTINUE
	END IF
 999	RETURN
	END
c////////////////////////////////////////////////////////
c  short version of the DERIV subroutine for sinc shift iteration
c     delta x is always 1 pixel
	subroutine deriva(y,der1,nop)
	dimension y(*),der1(*)
c der1(1) is not needed)
c	der1(1)=-3.*y(1)+4.*(y(2)-y(3))/.5
	do 100 i=2,nop-1
	  der1(i)=(y(i+1)-y(i-1))*.5
 100	continue
c der1(5) also not needed
c	DER1(NOP)=(Y(NOP-2)-4.*Y(NOP-1)+3.*Y(NOP))/.5
	return
	end
c////////////////////////////////////////////////////////////////////
c   subroutine to compute structural parameters of object
c        based on subroutine isophot of surphot.f
c
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MAKE MAP OF CONNECTED PIXEL AREA WITH VALUE>=IXLIM
C    STARTING FROM SEEDS WITH VALUE>ISEED, WITH MIMUM SIZE OF NCON PIXELS
C      
	SUBROUTINE ISOPHOT2(ipix,mu,mv,icen,jcen,sky)
c	INTEGER*2 IX(NU,NV,KF),ITC(100000),JTC(100000)
	INTEGER ipix(mu,mv),ITC(100000),JTC(100000)
c	INTEGER ICTL(40)
c	DIMENSION XCEN(40),YCEN(40),RAD(40),ARAD(40),BRAD(40),ELL(40),
c    *         THETA(40)
c	REAL*4 SKYRAY(62500),SP(150),RR(150),TSP(3)
c    *        , TLSP(3),TRR(3),AART(2,2),ER(150),TER(3)
	CHARACTER FILEN*24,STR*8,ian*1,ian1*1,comment*60
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	EQUIVALENCE (ITC(1),iscr(1)),(JTC(1),iscr(300001))
	icen=xxxx
	jcen=xxxx
 	CALL CSKY(*60,NFR,ICEN,JCEN,SKY,SKYSIG,nsky,ipix,mu,mv,1,' ')
 60	SSKYSIG=SKYSIG*SKYSIG
        maxpix=ipix(icen,jcen)
c set the level for the contour: default: 1/3 of peak
	iclt=nint(sky)+(maxpix-nint(sky))/3
	SUM1=0.
	IPT1=0
	  SUM=0.
	  CALL SEGCON(ICEN,JCEN,ICTL,ITC,JTC,IPT,mu,mv,ipix,mu,mv)
C  make isophot map  -- **** need to figure out where to put the array
	  IF (NFISO.NE.0) THEN
	    NCT=NL-I+1
	    DO 114 N=1,IPT
c	      IF (IX(ITC(N),JTC(N),NFISO).EQ.0) 
c    *             IX(ITC(N),JTC(N),NFISO)=NCT
 114	    CONTINUE
	  END IF
C  compute profile parameters
C  1:  centroid 
	  ICX=0
	  ICY=0
	  PT=FLOAT(IPT)
	  DO 111 N=1,IPT
	    ICX=ICX+ITC(N)
 111	    ICY=ICY+JTC(N)
	  XCEN=FLOAT(ICX)/PT
	  YCEN=FLOAT(ICY)/PT
C  2:  equivalent radius
	  RAD=SQRT(PT/3.1416)
C  3:  best fitting ellipse (see Dodd and MacGillivray, 1986 A.J., 92, 706)
C    compute moments	  
	  RMXX=0.
	  RMXY=0.
	  RMYY=0.
	  DO 112 N=1,IPT
	    SUM=SUM+ipix(ITC(N),JTC(N))
	    TT=ITC(N)-XCEN
	    TT1=JTC(N)-YCEN
	    RMXX=RMXX+TT*TT
	    RMXY=RMXY+TT1*TT
 112	    RMYY=RMYY+TT1*TT1
	  RMXX=RMXX/PT
	  RMXY=RMXY/PT
	  RMYY=RMYY/PT
	  RMXSY=RMXX-RMYY
	  IF (ABS(RMXSY).LT.0.0000001) RMXSY=.0000001
	  THETA=57.2958*0.5*ATAN2(2.*RMXY,RMXSY)
	  TT=2.*(RMXX+RMYY) 
	  TT1=2.*SQRT(AMAX1(0.00001,RMXSY*RMXSY+4*RMXY*RMXY))
	  ARAD=SQRT(AMAX1(.000001,TT+TT1))
	  BRAD=SQRT(AMAX1(.000001,TT-TT1))
	  ELL=1-BRAD/AMAX1(.00001,ARAD)
	  SUM=SUM-SKY*IPT
C  compute uncertainty in flux
c	  SIGSUR=sqrt(float(IPT-IPT1))*SKYSIG/(SUM-SUM1)
c	  sigsur=sqrt((skyerr/(float(ictl(i))-sky))**2+sigsur*sigsur)
c
c  new noise calculation: uncertainty=skyerr+photon noise
c         photon noise=sqrt(sky noise^2+object noise^2)
c following values are squared already
	  skynoise=float(ipt-ipt1)*skysig*skysig
	  objnoise=(sum-sum1)/ccdgain
c skyerr, skynoise, objnoise are all in ADUs
c  skyerr gives the uncertainty in the level due to sky, the
c   sum of the noise divided by the number of pixel gives the
c   uncertainy of the level due to the noise.
c    this is done in this curious way because the level is fixed,
c   and it is the radius that is being fitted.
c
c  linear sum
c	  sigsur=skyerr+sqrt(skynoise+objnoise)/float(ipt-ipt1)
c  quadrature sum as fraction
	  sigsur=sqrt(skyerr*skyerr+(skynoise+objnoise)/
     *          float((ipt-ipt1)*(ipt-ipt1)))
c sigsur as mag error
	  sigsur=2.5*alog10(amax1(.00001,1.+sigsur/(float(ictl)-sky)))
c              
c total error^2= N*sig^2+gain*sum/(gain*sum)^2
	  SIGTOT=SQRT(IPT*SSKYSIG+sum/ccdgain)/SUM
	  IPT1=IPT
	  SUM1=SUM
C  output
	IF (FILEN.NE.'n') THEN
	  WRITE(28,23) I,ICTL-NINT(SKY),-2.5*ALOG10(AMAX1(.00001,
     *               FLOAT(ICTL)-SKY)),SIGSUR,XCEN,YCEN,
     *         RAD,THETA,ARAD,BRAD,ELL
	  WRITE(28,31) IPT,SUM,-2.5*ALOG10(AMAX1(1.,SUM)),SIGTOT
	END IF
	  WRITE(6,23) I,ICTL-nint(SKY),-2.5*ALOG10(AMAX1(.00001,
     *               FLOAT(ICTL)-SKY)),SIGSUR,XCEN,YCEN,
     *         RAD,THETA,ARAD,BRAD,ELL
	  WRITE(6,31) IPT,SUM,-2.5*ALOG10(AMAX1(1.,SUM)),SIGTOT
 31	FORMAT(5X,'# of pix:',I7,'  total net cts:',F10.1,' mag:',F8.3
     *          ,F7.3)
 23	FORMAT(1X,I2,I6,F8.3,F6.3,2F9.3,F8.3,F8.2,1X,2F7.2,F7.3)
 900	IF (FILEN.NE.'n') CLOSE(UNIT=28)
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////
C
C  SUBROUTINE FOR CONNECTED AREA USING SEGMENTS
C
C
	SUBROUTINE SEGCON2(ICEN,JCEN,ILIM,ISEG,JSEG,NPX,NI,NJ,
     *                 IX,NU,NV)
c	INTEGER*2 IX(NU,NV),ISEG(1),JSEG(1),KSEG1(5000),KSEG2(5000)
	INTEGER IX(NU,NV),ISEG(*),JSEG(*),KSEG1(5000),KSEG2(5000)
     	INTEGER NSEG(5000)
	include 'pppcore.inc'
c	equivalence (iscr(60001),kseg1(1)),(iscr(65001),kseg2(1))
c    *             , (iscr(67001),nseg(1))
c    NSEG(k) is the number of pixels in the kth segment
c    KSEG1(i) is the I pixel co-ordinate of the segment (temp storage)
c
C  search 1st segment which will be used as seeds
	do 220 i=1,1000
	 nseg(i)=0
 220	continue
	do 221 i=1,3000
	  kseg1(i)=0
	  kseg2(i)=0
 221	continue
c	NSEG(1)=0
c searching forward, fixed J, running I
	DO 100 I=ICEN,NI
	  IF (IX(I,JCEN).LT.ILIM) GO TO 200
	  NSEG(1)=NSEG(1)+1
	  KSEG1(NSEG(1))=I
 100	CONTINUE
c searching backward, fixed J, running I
 200	DO 101 I=ICEN-1,1,-1
	  IF (IX(I,JCEN).LT.ILIM) GO TO 201
	  NSEG(1)=NSEG(1)+1
	  KSEG1(NSEG(1))=I
 101	CONTINUE
C  sort the segment I co-ordinate from small to large
 201	IF (NSEG(1).GT.1) CALL N2SORT(NSEG(1),KSEG1)
C Store array
	DO 110 I=1,NSEG(1)
	  ISEG(I)=KSEG1(I)
 110	  JSEG(I)=JCEN
C
C  first search J co-ordinate less than center
C   KSEG1 contains I co-ordinate of seed segment
C   KSEG2 contains retruned new  segment
C
	K=0
	NPX=NSEG(1)
	DO 102 J=JCEN-1,1,-1
	  K=K+1
	  CALL CONSEG(KSEG1,KSEG2,NSEG(K),NSEG(K+1),ILIM,IX(1,J),NI)
C  store data 
c  ! exit search if the next segment has no pixel:
	  IF (NSEG(K+1).EQ.0) GO TO 202 
c  otherwise sort the new segment
	  IF (NSEG(K+1).GT.1) CALL N2SORT(NSEG(K+1),KSEG2)
c  store the new segment
	  DO 103 L=1,NSEG(K+1)
	    KSEG1(L)=KSEG2(L)
 	    ISEG(NPX+L)=KSEG2(L)
 103	    JSEG(NPX+L)=J
	  NPX=NPX+NSEG(K+1)
 102	CONTINUE
C
C search the other J direction
C   restore initial segment (around ICEN)
 202	DO 111 I=1,NSEG(1)
 111	  KSEG1(I)=ISEG(I)
	NSEG(K)=NSEG(1)
	K=K-1
	DO 104 J=JCEN+1,NJ
	  K=K+1
	  CALL CONSEG(KSEG1,KSEG2,NSEG(K),NSEG(K+1),ILIM,IX(1,J),NI)
C  store data 
c  ! exit search
	  IF (NSEG(K+1).EQ.0) GO TO 203 
	  IF (NSEG(K+1).GT.1) CALL N2SORT(NSEG(K+1),KSEG2)
	  DO 105 L=1,NSEG(K+1)
	    KSEG1(L)=KSEG2(L)
 	    ISEG(NPX+L)=KSEG2(L)
 105	    JSEG(NPX+L)=J
	  NPX=NPX+NSEG(K+1)
 104	CONTINUE
 203	RETURN
	END
C
C/////////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE OF CONNECTING A SINGLE SEGMENT GIVEN A SEED SEGMENT IN
C   ASCENDING I CO-ORDINATE (stored in kseg1)
c   the new segment is stored in kseg2
C
	SUBROUTINE CONSEG2(KSEG1,KSEG2,NSEG1,NSEG2,ILIM,IX,NI)
c	INTEGER*2 KSEG1(1),KSEG2(1),IX(NI)
	INTEGER KSEG1(*),KSEG2(*),IX(NI)
C  start search from the smallest i
 	NSEG2=0
	DO 100 I=KSEG1(1),1,-1
	  IF (IX(I).LT.ILIM) GO TO 200
	  NSEG2=NSEG2+1
	  KSEG2(NSEG2)=I
 100	CONTINUE
c LARGE is the previous larges I co-ordinate checked
 200	LARGE=KSEG1(1)
C comes to an end, now look for additional segments connected with seed
C  at i co-ordinate larger than I=kseg1(1), 
	L=2
c ! do while loop
 150    CONTINUE   
	  DO 102 I=L,NSEG1
	    IF (KSEG1(I).GT.LARGE) THEN
	      LBACK=LARGE
	      LARGE=KSEG1(I)
c ! new seed
	      GO TO 202 
	    END IF
 102	  CONTINUE
C  no more seed, done (ie kseg1(nseg1) is not larger than LARGE)
	  GO TO 151
C  new seed, go forward
 202	  L=I+1
 	  DO 104 I=LARGE,NI
	    IF (IX(I).LT.ILIM) GO TO 201
	    NSEG2=NSEG2+1
	    KSEG2(NSEG2)=I
 104	  CONTINUE
C  check backward to LBACK
 201	  DO 105 II=LARGE-1,LBACK,-1
	    IF (IX(II).LT.ILIM) GO TO 203
	    NSEG2=NSEG2+1
 105	    KSEG2(NSEG2)=II
 203	  LARGE=I
	GO TO 150
 151	RETURN
	END
c////////////////////////////////////////////////////
c
c     ---- Write out pix(nu,nv) where ni,nj is actual size of image
c   written by D. Gilbank
c
      subroutine outstamp(array,nu,nv,ni,nj,obstime,ccdgain,rdnoise,
     *      ncombine,outname,comment)
      integer nu,nv,ni,nj
      integer status,blocksize,unit,bitpix,naxis,naxes(2)
      integer group,fpixel,nelements
      dimension array(nu,nv)
      dimension pix(ni,nj)
      character outname*24,comment*20
      logical simple,extend

      status=0

c     ---- take out just the subarray required.  This is passed whole to CFITSIO 
c     **** prob. some smarter fortran way to pass this array ****
      do j=1,nj
         do i=1,ni
            pix(i,j)=array(i,j)
!            print *,pix(i,j)
         end do
      end do
c     ----

C  Delete the file if it already exists, so we can then recreate it.
C  The deletefile subroutine is listed at the end of this file.
      call deletefile(outname,status)
      if (status .gt. 0)call printerror(status)

C  Get an unused Logical Unit Number to use to open the FITS file.
C  This routine is not required;  programmers can choose any unused
C  unit number to open the file.
!      status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)

C  Create the new empty FITS file.  The blocksize parameter is a
C  historical artifact and the value is ignored by FITSIO.
      blocksize=1
      call ftinit(unit,outname,blocksize,status)

C  Initialize parameters about the FITS image.
C  BITPIX = 16 means that the image pixels will consist of 16-bit
C  integers.  The size of the image is given by the NAXES values. 
C  The EXTEND = TRUE parameter indicates that the FITS file
C  may contain extensions following the primary array.
      simple=.true.
      naxis=2
      naxes(1)=ni
      naxes(2)=nj
      extend=.true.

c     ---- write real data
      bitpix=32


C  Write the required header keywords to the file
c	write(6,*) ' writing fits keywords '
      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)
C  Write the array to the FITS file.
C  The last letter of the subroutine name defines the datatype of the
C  array argument; in this case the 'J' indicates that the array has an
C  integer*4 datatype. ('I' = I*2, 'E' = Real*4, 'D' = Real*8).
C  The 2D array is treated as a single 1-D array with NAXIS1 * NAXIS2
C  total number of pixels.  GROUP is seldom used parameter that should
C  almost always be set = 1.
      group=1
      fpixel=1
!!      bitpix=16
      nelements=naxes(1)*naxes(2)
!!      call ftpprj(unit,group,fpixel,nelements,pix,status)

!      print *,unit,group,fpixel,nelements
      call ftppre(unit,group,fpixel,nelements,pix,status)
c     ----

C  Write another optional keyword to the header
C  The keyword record will look like this in the FITS file:
C
!!  EXPOSURE=                 1500 / Total Exposure Time
!!
c add minimal key words expected by galfit
	   call ftpkyf(unit,'EXPTIME',obstime,2,'Total Exposure Time',status)
	   call ftpkyf(unit,'GAIN',ccdgain,3,' CCD gain ',status)
	   call ftpkyf(unit,'RDNOISE',rdnoise,2,' Read noise ',status)
 	   call ftpkyj(unit,'ncombine',ncombine,' ncombine',status)
c     ---- Put (append) a COMMENT keyword into the CHU.  
c          Multiple COMMENT keywords will be written if the input comment string 
c          is longer than 72 characters
      call ftpcom(unit,comment, status)
c     ----

C  The FITS file must always be closed before exiting the program. 
C  Any unit numbers allocated with FTGIOU must be freed with FTFIOU.
      call ftclos(unit, status)
      call ftfiou(unit, status)

C  Check for any errors, and if so print out error messages.
C  The PRINTERROR subroutine is listed near the end of this file.
      if (status .gt. 0)call printerror(status)
      end
C *************************************************************************
C *************************************************************************
      subroutine deletefile(fname,status)

C  A simple little routine to delete a FITS file

      integer status,unit,blocksize
      character*(*) fname

C  Simply return if status is greater than zero
      if (status .gt. 0)return

C  Get an unused Logical Unit Number to use to open the FITS file
      call ftgiou(unit,status)

C  Try to open the file, to see if it exists
      call ftopen(unit,fname,1,blocksize,status)

      if (status .eq. 0)then
C         file was opened;  so now delete it 
          call ftdelt(unit,status)
      else if (status .eq. 103)then
C         file doesn''t exist, so just reset status to zero and clear errors
          status=0
          call ftcmsg
      else
C         there was some other error opening the file; delete the file anyway
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

C  Free the unit number for later reuse
      call ftfiou(unit, status)
      end
c//////////////////////////////////////////////////////
c  subroutine to set galfit set parameters
c
c   ipar=0:  set default values
c   ipar=1:  set an individual parameter
c   ipar=2:  type out parameters
	subroutine setgalfit(*,str,str1,nfr,rn,ipar)
	character str*60,str1*60,var*12
	include 'galfitparm.inc'
	if (ipar.eq.0.or.str.eq.'reset'.or.str.eq.'default') then
	  snlim=30.
	  gsts=2.5
	  igfitsave=1
	  nupsf=41
	  rmlim=0.
	  igfout=0
	  ists=200
	  igsj=50
	  jgsj=50
	  ngftype=1 
	  gftype(1)='sersic'
	  iginit=0
	  gzpt=30.
	  galfitpath='~/galfit/galfit'
	  noo1=0
	  noo2=100000
	  return1
	else if (ipar.eq.2.or.str.eq.'list') then
	  write(6,1)
 1	format('  -- PPP GALFIT wrapper SET parameters (gset) --')
 	  write(6,402) snlim
	  write(6,403) gsts
 	  write(6,404) nupsf
	  write(6,405) igsj,jgsj
	  write(6,406) gzpt
	  write(6,407) ngftype
	  write(6,*) '  Component   Type'
	  do 508 k=1,ngftype
	       write(6,503) k,gftype(k)
 508	    continue
	  write(6,408) igfitsave
	  write(6,409) iginit
	  write(6,410) galfitpath
	else if (ipar.eq.1) then
	  var=str(1:lnblnk(str))
	  if (var.eq.'snlim') then
	    if (str1.eq.' ') then
	      write(6,402) snlim
 302	      write(6,400)
	      call read1r(snlim,*999,*302)
	    else
	      snlim=rn
	    end if
	    write(6,402) snlim
	  else if (var.eq.'gsts') then
	    if (str1.eq.' ') then
	      write(6,403) gsts
 303	      write(6,400)
	      call read1r(gsts,*999,*303)
	    else
	      gsts=rn
	    end if
	    write(6,403) gsts 
	  else if (var.eq.'nupsf') then
	    if (str1.eq.' ') then
	      write(6,404) nupsf
 304	      write(6,400)
	      call read1i(nupsf,*999,*304)
	    else
	      nupsf=nfr
	    end if
	    write(6,404) nupsf
	  else if (var.eq.'igsj'.or.var.eq.'jgsj') then
	    if (str1.eq.' ') then
	      write(6,405) igsj,jgsj
 305	      write(6,400)
	      call read1i(igsj,*999,*305)
	    else
	      igsj=nfr
	    end if
	    jgsj=igsj
	    write(6,405) igsj,jgsj
	  else if (var.eq.'gzpt') then
	    if (str1.eq.' ') then
	      write(6,406) gzpt
 306	      write(6,400)
	      call read1r(gzpt,*999,*306)
	    else
	      gzpt=rn
	    end if
	    write(6,406) gzpt 
	  else if (var.eq.'gftype'.or.var.eq.'ngftype') then
	    ikmax=ngftype
 610	    write(6,501) 
 501	format(' Enter fitting component# you want to change/add (<=10),'
     *      ,' 0 to end : ',$)
	    call read1i(k,*999,*610)
	    if (k.gt.ikmax+1) then
c  issue warning if increasing component number faster than 1
	      k=ikmax+1
	      write(6,521) k
 521	format(' +++ Can only increment component# by 1 over current;'
     *    ,' set to add component ',i2)
	    end if
	    if (k.gt.ikmax) ikmax=k
	    if (k.eq.0.or.k.gt.10) goto 611
	    if (ikmax.gt.ngftype) then
	      ngftype=ikmax
	      write(6,*) '  ... fitting components increased to ',
     *                     ngftype
	    end if
    	    write(6,502) k
	    read(5,'(a20)',end=999) gftype(k)
 502	format('  Enter type for fitting component ',i3,', choices: '/
     *   '   psf,seric,devauc,expdisk,nuker,moffat,guassian,sky :',$)
	    write(6,*) ' ... fitting component ',k,' changed'
	    goto 610
 611	    continue
c  out put list of components
	    write(6,*) '  ... Final components for fitting '
	    do 516 k=1,ngftype
	       write(6,503) k,gftype(k)
 503	format(5x,i3,9x,a20)
 516	    continue
	  else if (var.eq.'igfitsave') then
	    if (str1.eq.' ') then
	      write(6,408) igfitsave
 308	      write(6,400)
	      call read1i(igfitsave,*999,*308)
	    else
	      igfitsave=nfr
	    end if
	    write(6,408) igfitsave
	  else if (var.eq.'iginit') then
	    if (str1.eq.' ') then
	      write(6,409) iginit
 309	      write(6,400)
	      call read1i(iginit,*999,*309)
	    else
	      iginit=nfr
	    end if
	    write(6,409) iginit
	  else if (var.eq.'galfitpath') then
	    if (str1.eq.' ') then
	      write(6,410) galfitpath
 310	      write(6,400)
	      read(6,'(a48)',end=999) galfitpath
	    else
	      galfitpath=str1
	    end if
	    write(6,410) galfitpath
	  else if (var.eq.'noo1') then
	    if (str1.eq.' ') then
	      write(6,490) noo1
 390	      write(6,400)
	      call read1i(noo1,*999,*390)
	    else
	      noo1=nfr
	    end if
	    write(6,490) noo1
	  else if (var.eq.'noo2') then
	    if (str1.eq.' ') then
	      write(6,491) noo2
 391	      write(6,400)
	      call read1i(noo2,*999,*391)
	    else
	      noo2=nfr
	    end if
	    write(6,491) noo2
          end if
	end if
 400	format(' Enter new value: ',$)
 402	format(' snlim:',f7.2,' -  if positive, S/N ratio limit ',
     *  'for inclusion'/17x,' if negative: intrumental mag limit')
 403	format(' gsts:',f6.2,' - size of galaxy image stamp, in units' 
     *           ,' of ppp optimal diameter')
 404	format(' nupsf:',i4,' - X/Y size of the psf image in pix')
 405	format(' igsj/jgsj:',2i4,' - size of the convolution kernel')
 406	format(' gzpt:',f8.3,' - photometric zero point')
 407	format(' ngftype:',i3,' - Number of fitting types used ')
 408	format(' igfitsave:',i2,' - 0: overwrite, 1: save image',
     *    ' as stamp, 2: save as mosaic')
 409	format(' iginit:',i2,' - fit initialization: 0=fixed default,',
     *           ' 1=computed by ppp')
 410	format(' galfitpath: ',a48,/12x,' - full path of galfit')
 490	format(' noo1: ',i5,' - ppp number, lower limit (for testing)')
 491	format(' noo2: ',i5,' - ppp number, upper limit (for testing)')
 999	return1
	end
c////////////////////////////////////////////////////////
c  subroutine to read in galfit results for objects fitted
c
        subroutine rdgfitres(idev)
	character gstr*100,gstr2*100
        include 'galfitres.inc'
        open(unit=idev,file='fit.log',status='old',err=998)
c preset all fgtype
	do 151 kk=1,ngftot
	  fgtype(1,kk)='fail'
 151	continue
	mkkold=1
c now search for those where there is a fit
	do 100 kk=1,15000
c read object number  (keep reading until "Input" is found)
	  do 250 m=1,10
            read(idev,'(a100)',end=988) gstr 
            if (gstr(1:5).eq.'Input') then
              len1=index(gstr,'_')+1
              len2=index(gstr,'fits')-2
              read(gstr(len1:len2),*,err=901) npppgt
	write(6,*) ' ^found object ppp# ',npppgt,len1,len2
	      goto 255
            end if
 250	  continue
c
 255	  continue
c object is found, now identify it from the master list
	  do 120 m=mkkold,ngftot
	    if (npppgt.eq.npppg(m)) then
c  the object is found
	       mkk=m
	       goto 256
	    end if
 120	  continue
 256	  fgtype(1,mkk)=' '
	  fgtype(2,mkk)=' '
	  mkkold=mkk
c now skip 4 lines and read model type
	write(6,*) ' & skipping 4 lines '
          do 101 j=1,4
            read(idev,*)
 101      continue
c read type and fit parameters, max of 2, stop when "sky" is read
	  ity=0
          do 211 k=1,9
            read(idev,'(a100)',end=988) gstr 
	write(6,'(a100)') gstr
            if (gstr(2:5).eq.'deva') then
	      ity=ity+1
              fgtype(ity,mkk)='deV'
            else if (gstr(2:5).eq.'expd') then
	      ity=ity+1
              fgtype(ity,mkk)='exp'
            else if (gstr(2:5).eq.'sers') then
	      ity=ity+1
              fgtype(ity,mkk)='Ser'
            else if (gstr(2:4).eq.'sky') then
c end of fitting output for object kk, continue and read chisq
c read reduced chi-sq (after 2 lines)
              read(idev,*)
              read(idev,*)
              read(idev,'(a100)',end=988) gstr 
              read(gstr(12:18),*,err=977) chi_nu(mkk)
              goto 100
            else if (gstr(2:4).eq.'---') then
c next object
	      goto 100
            end if
c read the 2nd line of the fit, and the parameters
            read(idev,'(a100)',end=988) gstr2
	write(6,'(a100)') gstr2
            call rdgflog(gstr,gstr2,mkk,ity,iret)
	    if (iret.eq.-1) write(6,*) ' last read error for obj',
     *                  npppg(mkk)
 211	  continue
 100	continue
 988	return
 998	write(6,*) ' *** open error: no fit.log file found ***'
	return
 977	write(6,*) ' *** read error after reading model ***' 
	return
 901	write(6,*) '  *** read error in ppp number ***'
	end
c///////////////////////////////////////////////////////
c   reading each object''s fit
c
	subroutine rdgflog(line1,line2,k,ity,iret)
	character line1*100,line2*100
	include 'galfitres.inc'
c  read first line:
c  first find the brackets
	len1=index(line1,'(')+1
	len2=index(line1,')')-1
	read(line1(len1:len2),*,err=800,end=802) 
     *                          gfcx(ity,k),gfcy(ity,k)
	if (fgtype(ity,k).eq.'deV'.or.fgtype(ity,k).eq.'exp') then
	  read(line1(len2+2:100),*,err=800,end=802) gfmag(ity,k),
     *         gfr(ity,k),gfab(ity,k),gfpa(ity,k),gfpwr(ity,k)
	else if (fgtype(ity,k).eq.'Ser') then
	  read(line1(len2+2:100),*,err=800,end=802) gfmag(ity,k),
     *         gfr(ity,k),gfpwr(ity,k),gfab(ity,k),gfpa(ity,k)
	end if
c read the second line (uncertainties)
	len1=index(line2,'(')+1
	len2=index(line2,')')-1
	read(line2(len1:len2),*,err=801,end=803)
     *              gfcxe(ity,k),gfcye(ity,k)
	if (fgtype(ity,k).eq.'deV'.or.fgtype(ity,k).eq.'exp') then
	  read(line2(len2+2:100),*,err=801,end=803) gfmage(ity,k),
     *          gfre(ity,k),gfabe(ity,k),gfpae(ity,k),gfpwre(ity,k)
	else if (fgtype(ity,k).eq.'Ser') then
	  read(line2(len2+2:100),*,err=801,end=803) gfmage(ity,k),
     *          gfre(ity,k),gfpwre(ity,k),gfabe(ity,k),gfpae(ity,k)
	end if
	iret=0
	return
 800	write(6,*) ' ** read error in fit parameter ** comp ',k
	iret=-1
	return
 801	write(6,*) ' ** read error in fit uncertainty** comp ',k
	iret=-1
	return
 802	write(6,*) ' ** read ended in fit parameter ** comp ',k
	iret=-1
	return
 803	write(6,*) ' ** read ended in fit uncertainty** comp ',k
	iret=-1
	return
	end
c////////////////////////////////////////////////////////
c  subroutine to fill in galfit output for objects not fitted
c
        subroutine galfitdummy(i)
        return
        end
