C///////////////////////////////////////////////////////////
C
C  SUROUTINE PACKAGE TO GENERATE REALISTIC IMAGES FOR TESTING PHOTOMETRY DATA
C
C///////////////////////////////////////////////////////////////////////////
C
C    DRIVING ROUTINE
C    IPAR=IPS=1  : make from a LIST
C        IPAR=2  : Randomly generated
C        IPAR=3  : generate a "cluster" at fixed z, using .cls file
C        IPAR=4  : generate a "cluster" at z with background field
C	 IPAR=5  : generate a "cluster" at z with background from a file
C        IPS<0  : same as +'ve, but only create a .sim file
C    (NCOSRAY<0 -- produce a field with equally spaced number of objects)
C
	SUBROUTINE GENDRI(NFR,NI,NJ,IPS,IX,NU,NV,KF,*)
	CHARACTER IFIL*2,IAN*2,IANF*2,IANT*2,BKOUTNAM*18,IBKOUT*2,
&	             NCOMC*35,BKINN*18,BKOUTN*18,IANP*1,
     *               hplot*18,splot*18,fitsname*24
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION PSF(-70:70,-70:70),XS(40000),YS(40000),SMAG(40000)
&	            ,INDEX(40000),FLUX(40000),TMPL(-75:75,-75:75)
&	            ,TMPLA(-75:75,-75:75),TMPLB(-75:75,-75:75)
&	            ,RKERN(99,99),RESGAL(99,99),GALA(99,99)
&	            ,ARCSEC(40000),ABRAT(40000),ROTA(40000),Z(40000)
&	            ,XCR(40000),YCR(40000),AMP(40000),BD(40000)
&	            ,FRKERN(99,99),IC(40000)
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'zmdist.inc'
	INCLUDE 'picdir.inc'
	common/plotdev/hplot,splot,ipinit
	COMMON/PICC/NCOMC(15),fitsname(15)
	equivalence (iscr(1),PSF(-70,-70)),(iscr(100001),TMPL(-75,-75))
     &	 ,(iscr(200001),TMPLA(-75,-75)),(iscr(300001),TMPLB(-75,-75))
     *               ,(iscr(500001),Z(1)),(iscr(600001),XCR(1))
     &	             ,(iscr(700001),YCR(1)),(iscr(800001),AMP(1))
     &	             ,(iscr(900001),YS(1)),(iscr(1000001),BD(1))
     &	             ,(iscr(1100001),SMAG(1)),(iscr(1200001),XS(1))
     &	             ,(iscr(1300001),INDEX(1)),(iscr(1400001),FLUX(1))
     &	             ,(iscr(1500001),ARCSEC(1)),(iscr(1600001),ABRAT(1))
     &	             ,(iscr(1700001),ROTA(1)),(iscr(1800001),IC(1))
     &           ,(iscr(1900001),rkern(1,1)),(iscr(1920001),resgal(1,1))
     &	          ,(iscr(1940001),gala(1,1)),(iscr(1960001),frkern(1,1))
	CHARACTER FILOUT*18,FILT*18,FDUM*18,FDATE*24
c  for standard small size ppp
c	REAL TEMPX(714,714)
c	EQUIVALENCE (ixb(509797),TEMPX(1,1))
c	maxsize=714
c  for 2X2048
c	REAL TEMPX(1522,1522)
c	EQUIVALENCE (ixb(2316485),TEMPX(1,1))
c	maxsize=1522
c  for 3X2048
 	REAL TEMPX(1776,1776)
 	EQUIVALENCE (ixb(3154177),TEMPX(1,1))
 	maxsize=1776
	if (nu.gt.maxsize.or.nv.gt.maxsize) then
	  write(6,*) '  *** max size must be <=',maxsize,
     *        ' for simulation **'
	end if
	IPAR=IABS(IPS)
	IF (IPS.GT.0) THEN 
	  WRITE(6,1) 
 1	FORMAT('  ++++ Warning: data simulation will ERASE ALL core'
&	         ,' frames ++++'/'   Final result to be stored in 1'/)
	  CALL RBELL(1)	
	  IF (KF.LT.5) THEN
	    WRITE(6,*) ' ** MAX SIZE TOO LARGE FOR DATA SIMULATION **'
	    WRITE(6,*) '    ... total # of frame must be >=5+1 ...'
	    RETURN1
	  END IF
	  NS=70
	  NG=75
	END IF
	FDUM=' '
	NSTAR=0
	NGAL=0
	NOB=0
	SMAGLIM=1000.
C-----------------------------------------------------------------------
C
C  detector charateristics
C
	IF (TSIZE.LE.0.001) THEN
	  TSIZE=3.6
	  RDNOISE=60.
C	! e-/ADU
	  GAIN=20.
	END IF
 600	WRITE(6,30) TSIZE,GAIN,RDNOISE
 30	FORMAT('   Imaging data simulation: Default parameters'/
&	   ,  '     Telescope aperture:',F5.2,'m,  Gain:',F6.2,
&	            ' e-/ADU,  readnoise:',F5.1,'e-,'/
&	      '   Enter new telescope size, g and rn (delt=<cr>): ',$)
	CALL READR4(3,TSIZE,GAIN,RDNOISE,*999,*600,*601,*601)
 601	WRITE(6,31) ZMCT,TEF
 31	FORMAT('     ...Photon rate (0 mag) fixed at ',G8.2,
&	  ' /sec/sq m/Angs,'/
&	  '   Telescope efficiency fixed at',F5.2,/
&	  '     Default I   (Tr=.8, wd=1200) : Sky= 20.4 mag/sq", QE=0.5'/
&	  '     Default r/R (Tr=.85, wd=1000): Sky= 21.4 mag/sq"  QE=0.8'/
&	  '     Default g/G (Tr=.85, wd=900) : Sky= 22.4 mag/sq", QE=0.7'/
&	  '   Enter filter (i, r (=deflt), g, or o for others): ',$)
	call readstr(2,ifil,*999,*601)
	FILTRAN=.85
	IF (IFIL.EQ.' '.OR.IFIL.EQ.'R'.OR.IFIL.EQ.'r') THEN
	  SKYMAG=21.4
	  WIDTH=1000.
	  QE=.8
	ELSE IF (IFIL.EQ.'i') THEN
	  SKYMAG=20.4
	  FILTRAN=.8
	  WIDTH=1200.
	  QE=0.5
	ELSE IF (IFIL.EQ.'g') THEN
	  SKYMAG=22.4
	  WIDTH=900.
	  QE=0.7
	ELSE 
 602	  WRITE(6,32) width,filtran
 32	FORMAT('   Enter filter width (A) and transmission (df:',
     *      f7.1,f5.2,'): ',$)
	  call read2r(width,filtran,*999,*602)
 604	  WRITE(6,34) qe
 34	FORMAT('   Enter quantum efficiency (fraction) (df:',
     *          f6.3,'): ',$)
	  call read1r(qe,*999,*604)
 603	  WRITE(6,33) skymag
 33	FORMAT('   Enter sky magnitude/sq" (df:',f7.2,'): ',$)
	  call read1r(skymag,*999,*603)
	END IF
C  compute number of e- at zero mag (based on approximate relation
C   derived using data from Allen) received at CCD of telescope TSIZ
C   m aperture, with telescope efficiency of TEF
C
	PHOTON=QE*FILTRAN*(TEF*0.25*TSIZE*TSIZE*3.1416)*WIDTH*ZMCT
	WRITE(6,*) '    ...Photon/sec/sq" for 0.0 mag: ',PHOTON
	IF (ABS(PHOTON).LT.0.00001) THEN
	  WRITE(6,*) ' **** NO PHOTONS, you forgot to open the mirror**'
	  RETURN1
	END IF
C	! sky photon flux/sq arc sec/sec
	SKYPHOT=PHOTON/10**(.4*SKYMAG)
	  IF (IREADBK.EQ.1) THEN
 6041       WRITE(6,95) bkinn
 95	FORMAT('   Background frame to be read from REAL*4 disk file,'
     *         /'     ... Enter name of file [',a18,']: ',$)
	    call readstrd(18,bkinn,*999,*6041)
c 96	FORMAT(A18)
	  END IF
	  IF (ISAVEBK.EQ.1) THEN
 6042       WRITE(6,97) bkoutn
 97	FORMAT('   Background frame to be saved in REAL*4 disk file,'/
     *         '     ... Enter name of file[',a18,']: ',$)
	    call readstrd(18,bkoutn,*999,*6042)
	  END IF
C-------------------------------------------------------------------------
C  create or enter object files
C
C   MAKD: data from file or tty entered  
	IF (IPAR.EQ.1.OR.IPAR.EQ.5) THEN
 605	  WRITE(6,35) ianf
 35	FORMAT('   Objects from f(ile)/g(partial file) or '
     *          ,'enter by t(erminal)? f/g/t (df:',a2,'): ',$)
	  call readstrd(2,ianf,*999,*605)
C
C  data from file
	  IF (IANF.EQ.'f'.OR.IANF.EQ.'g') THEN
C	  ! reading poistion file
	    IF (IANF.EQ.'g') THEN
 606	      WRITE(6,36) smaglim
 36	FORMAT('   Enter upper mag limit for inclusion (df:',
     *            f6.2,'): ',$)
	      call read1r(smaglim,*999,*606)
	      IANF='f'
	    END IF
	    CALL RDXYMAG(XS,YS,SMAG,ARCSEC,ABRAT,ROTA,Z,BD,NSTAR,NGAL,
     *         ic,SCALE,SCRAT,NI,NJ,NU,NV,IPAR,MODG,BBDT,SMAGLIM)
C
C options for offsetting positions mags
	    NOB=NGAL+NSTAR
	    DX=0.
	    DY=0.
	    DO M=1,NSTAR
	      IC(M)=3
	    END DO
	    DO M=NSTAR+1,NOB
	      IC(M)=1
	    END DO
 607	    WRITE(6,38) 
 38	FORMAT('   Enter position offsets from file data (arcsec)'
     *         /'     new positions=old+dx,dy (default=no shift): ',$)
	    CALL READ2R(DX,DY,*999,*607)
	    DMAG=0.
 6071	    WRITE(6,39) 
 39	FORMAT('   Enter mag offset for objects'/
     *        '     new mag = old + dmag (default=0): ',$)
	    CALL READ1R(DMAG,*999,*6071)
  	    ITY=0
	    IF (ABS(SCRAT-1.).GT.0.001) THEN
c	      ITY=1
	      DO 113 I=1,NOB
	        XS(I)=XS(I)*SCRAT
 113	        YS(I)=YS(I)*SCRAT
	    END IF 
	    IF (DX.NE.0.OR.DY.NE.0) THEN
	      DX=DX/SCALE
	      DY=DY/SCALE
c	      ITY=1
	      DO 112 I=1,NOB
	        XS(I)=XS(I)+DX
 112	        YS(I)=YS(I)+DY
	    END IF
	    IF (ABS(DMAG).GT.0.001) THEN
c	      ITY=1
	      DO 114 I=1,NOB
 114	        SMAG(I)=SMAG(I)+DMAG
	    END IF
	    IF (ITY.EQ.1) THEN
 6072	      WRITE(6,391)
 391	FORMAT('   Do you want to see the altered list? (y/n=<cr>): ',$)
	      call readstr(2,iant,*999,*6072)
	      IF (IANT.EQ.'y') THEN
	        WRITE(6,*) '  ---- Altered object list ----'
	        DO 115 I=1,NSTAR
 115	          WRITE(6,40) I,XS(I),YS(I),SMAG(I),'   star'
	        DO 116 I=NSTAR+1,NOB
 116	          WRITE(6,40) I,XS(I),YS(I),SMAG(I),'   galx'
	      END IF
	    END IF
 40	FORMAT(I6,3X,2F10.2,2X,F7.3,A7)
	  ELSE
	    IANF='t'
	  END IF
	END IF
C tty entered data (MAKD) or newly generated field
	IF ((IPAR.GE.2.AND.IPAR.LE.4).OR.IANF.EQ.'t') THEN
	  MODG=MODGAL
 608	  WRITE(6,41) NU,NV,ni,nj
 41	FORMAT('   Enter frame size (I,J) (<=',I4,'X',I4,
     *       ') (df:',2i5,'): ',$)
	  call read2i(ni,nj,*999,*608)
 609	  WRITE(6,42) SCALE
 42	FORMAT('   Enter pixel scale ("/pix) [dflt:',F7.3,']: ',$)
	  CALL READ1R(SCALE,*999,*609)
	  IF (SCALE.LE.0.001) GO TO 609
	END IF
C-------------------------------------------------------------------------
C
C  observing conditions (seeing and integration time)
	SCSQ=SCALE*SCALE
 610	WRITE(6,43) SEE
 43	FORMAT('   Enter seeing (FWHM) in arc sec ',/
     *    '      enter negative number for noncircular PSF',
     *    ' [dflt:',F6.2,']: ',$)
	CALL READ1R(SEE,*999,*610)
	IF (SEE.LT.0.001) THEN
	  SEE=-1.*SEE
 6101	  WRITE(6,431) SEEAB
	  CALL READ1R(SEEAB,*999,*6101)
	  IF (SEEAB.LT.0.05) THEN
	    WRITE(6,*)  ' ++++ ILLEGAL a/b ratio, set to 1 +++'
	    SEEAB=1.
	  END IF
 431	FORMAT('  Elliptical PSF to be used: enter A/B ratio [dflt:',
     *          F6.2,']: ',$)
 6102	  WRITE(6,432) SEEROT
	  CALL READ1R(SEEROT,*999,*6102)
 432	FORMAT('     Rotation angle (+''ve=c-clockwise from top)',
     *    ' [dflt:',F6.2,']: ',$)
	  IGE=1
	ELSE
	  IGE=0
	END IF
	FWHM=SEE/SCALE
	SKYADU=SKYPHOT*SCSQ/GAIN
	A0=SKYMAG+2.5*ALOG10(SKYADU/SCSQ)
 611	WRITE(6,44) ttime,SKYMAG,SKYADU,A0
 44	FORMAT('   Enter integration time in sec (df:',f7.0,')'/
     *  '   ..(sky=',F6.1,' ADU/s, mag =',F7.2,' A0=',F6.3,'): ',$)
	call read1r(ttime,*999,*611)
	IF (TTIME.LT.0.01) GO TO 611
C sky level and noise
	SKYADU=SKYADU*TTIME
	SKYNOISE=SQRT(RDNOISE*RDNOISE+SKYPHOT*SCSQ*TTIME)/GAIN
	WRITE(6,45) SKYADU,SKYNOISE
 45	FORMAT('   -- Expected sky:',F8.2,'  noise:',F7.2,' ADU')
C  limit= object with 5 sigma in 2 seeing disks
C	! SQRT of 2 seeing disk in pix
	RFWHMPIX=1.7725*FWHM
	SIG5=A0+2.5*ALOG10(TTIME)-2.5*ALOG10(5.*SKYNOISE*RFWHMPIX)
	SIGMAG=SIG5+GENLIM
	WRITE(6,46) SIG5
	IF (IPAR.GE.2) WRITE(6,461) SIGMAG
 46	FORMAT('   Expected 5 sigma detection limit (2 FWHM): ',F6.3)
 461	FORMAT('       Data generated to magnitude = ',F6.3)
C  output SIM file name
 612	CALL READFN(FILT,FDUM,FILOUT,'sim','o',11,*999,*612,*23001)
23001	CONTINUE
C-------------------------------------------------------------------
C    PSF shape and count laws
C
C  parameters number ct power law and fuzziness
	A0T=A0+2.5*ALOG10(TTIME)
	AREA=SCALE*SCALE*NI*NJ/3600.
	BETAG=2.
	APG=.375
	C0G=-4.39
	BETAS=2.85
	APS=.14
	C0S=0.3
	HN=50
C option to change shape parameters
 613	WRITE(6,47) BETAS,C0S,APS
 47	FORMAT('   Star: shape parameter:',F5.2,', ct law: log N(m) ='
     *         ,F7.3,' +',F6.3,'m')
	IF (MODG.EQ.0) THEN
	  WRITE(6,48) BETAG,C0G,APG
 48	FORMAT('   Galaxy: shape parameter:',F5.2,', ct law: log N(m) ='
     *         ,F7.3,' +',F6.3,'m')
	ELSE
	  WRITE(6,49) HN,C0G,APG
 49	FORMAT('   Galaxy: Ho =',F6.2,', ct law: log N(m) =',F7.3
     *         ,' +',F6.3,'m')
	END IF
	WRITE(6,50)
 50	FORMAT('    ... Do you want to change? no=<cr>/s(tar)/',
     *          'g(alaxy)/b: ',$)
	call readstr(2,ian,*999,*613)
 10	FORMAT(A1)
	IF (IAN.EQ.'s'.OR.IAN.EQ.'b') THEN
	  IF (IPAR.EQ.2.OR.IAPR.EQ.4) THEN
 614	    WRITE(6,51)
 51	FORMAT('   Enter beta, c0 an alpha for stars: ',$)
	    call readr4(3,betas,c0s,aps,*999,*614,*2100,*2100)
 2100	    continue
	  ELSE
 615	    WRITE(6,52) 
	    call read1r(betas,*999,*615)
 52	FORMAT('   Enter shape parameter beta: ',$)
	  END IF
	end if
	IF (IAN.EQ.'g'.OR.IAN.EQ.'b') THEN
	  IF (MODG.EQ.0) THEN
 616	    WRITE(6,53)
 53	FORMAT('   Enter beta, c0 an alpha for galaxies: ',$)
	    call readr4(3,betag,c0g,apg,*999,*616,*2101,*2101)
 2101	    continue
	  ELSE
	    IF (IPAR.EQ.2.OR.IPAR.EQ.4) THEN
 617	      WRITE(6,54)
 54	FORMAT('   Enter new Ho, c0, and alpha'
     *              ,' for galaxies: ',$)
	      call readr4(3,hn,c0g,apg,*999,*617,*2102,*2102)
 2102	      continue
	    ELSE
 618	      WRITE(6,55) hn
 55	FORMAT('   Enter new Ho (df:',f6.1,'): ',$)
	      call read1r(hn,*999,*618)
	    END IF
	  END IF
	END IF
C------------------------------------------------------------------------
C
C generate position and magnitudes
C
	IF (IPAR.EQ.2.OR.IPAR.EQ.4) THEN
c
C  Generate background galaxies and star
C  generate star list by 1) generate star magnitude according to power
C     law log(N(m))= a+m**b and 2) generate x(=I) and y(=J) position 
C
C stars:
C   Number of star brighter than SIGMAG
C	  BEMAGS=16.5  set in SETPARM
	  NSTAR=INTPLD(APS,C0S,BEMAGS,SIGMAG,AREA,SIGFAC)
C Galaxies
C	  BEMAGG=18.5  set in SETPARM
	  NGAL=INTPLD(APG,C0G,BEMAGG,SIGMAG,AREA,SIGFAC)
	  NOB=NSTAR+NGAL
C......................................
C   Section for making evenly spaced objects
	  IF (NCOSRAY.LT.0) THEN
 6181	    WRITE(6,551) npixsep
 551	FORMAT('  Creating picture with evenly spaced number of objects'
     *      /'   Enter distance in pix between objects (df:',i3,'): ',$)
	    call read1i(npixsep,*999,*6181)
	    IF (NPIXSEP.LT.1) GO TO 6181
	    NOBT=(NI/NPIXSEP)*(NJ/NPIXSEP)
	    NSTAR=NINT(FLOAT(NOBT)*FLOAT(NSTAR)/FLOAT(NOB))
	    NGAL=NOBT-NSTAR
	    NOB=NOBT
	  END IF
	  IF (NOB.GT.40000) THEN
	    WRITE(6,*) NSTAR,NGAL,'  ****TOO MANY OBJECTS***'
C	  ELSE IF (NOB.EQ.0) THEN
C	    WRITE(6,*) '  ***** 0 object NOT allowed ***'
C	    GO TO 611
	  END IF
	  WRITE(6,56) NSTAR,NGAL
56	FORMAT('   Number to be generated, stars:',I6,'  galaxies:',I6)
C generate position files
	  CALL GENPOS(NSTAR,XS,YS,NI,NJ)
	  CALL GENPOS(NGAL,XS(NSTAR+1),YS(NSTAR+1),NI,NJ)
C  create evenly placed position
	  IF (NCOSRAY.LT.0) THEN
	    ISTART=NPIXSEP/2
	    JSTART=NPIXSEP/2
	    III=0
	    DO 561 NH=1,NJ/NPIXSEP
	      XTEMP=FLOAT((NH-1)*NPIXSEP+ISTART)
	      DO 561 MH=1,NI/NPIXSEP
	        III=III+1
	        IF (III.GT.NOB) GO TO 562
	        XS(III)=XTEMP+XS(III)-INT(XS(III))-.5
	        YS(III)=((MH-1)*NPIXSEP+JSTART)+YS(III)-INT(YS(III))-.5
 561	    CONTINUE
	    IF (III.LT.NOB) THEN
	      NOB=III
	      NGAL=NOB-NSTAR
	    END IF
 562	    CONTINUE
	  END IF
C generate magnitudes
	  CALL GENMAG(NSTAR,APS,BEMAGS,SIGMAG,SMAG)
	  CALL GENMAG(NGAL,APG,BEMAGG,SIGMAG,SMAG(NSTAR+1))
	ELSE IF (IPAR.EQ.3) THEN
	  NOB=0
	  NGAL=0
	  NSTAR=0
	ELSE IF (IANF.EQ.'t') THEN
 619	  WRITE(6,57)
 57	FORMAT('   Enter number of stars and number of galaxies: ',$)
	  call read2i(nstar,ngal,*999,*619)
	  WRITE(6,*) '   ... Enter x (=I), y(=J) and mag for stars:'
	  NOB=NSTAR+NGAL
	  IF (NOB.EQ.0) THEN
	    WRITE(6,*) '  ***** 0 object NOT allowed ***'
	    GO TO 619
	  END IF
	  DO 110 I=1,NSTAR
 620	    WRITE(6,58) I
 58	FORMAT('  #',I5,'  : ',$)
	    call readr4(3,xs(i),ys(i),smag(i),*999,*620,*110,*110)
 110	    continue 	
	    WRITE(6,*)
     *          '   ... Enter x (=I), y(=J) and mag for galaxies:'
	    DO 111 I=NSTAR+1,NOB
 621	      WRITE(6,58) I
	      call readr4(3,xs(i),ys(i),smag(i),*999,*621,*111,*111)
 111	      continue
	END IF
C-------------------------------------------------------------
C   parameters for stars
C
	DO 180 I=1,NSTAR
C	! 0 for stars
	  ARCSEC(I)=0.
	  ABRAT(I)=0.
	  ROTA(I)=0.
	  BD(I)=0.
	  INDEX(I)=I
	  IC(I)=3
 180	  FLUX(I)=10**(-.4*(SMAG(I)-A0T))
	DO 181 I=NSTAR+1,NOB
	  INDEX(I)=I
	  IC(I)=1
 181	  FLUX(I)=10**(-.4*(SMAG(I)-A0T))
C------------------------------------------------------------------
C
C           determine galaxy size, rotation, a/b ratio, and B/D ratio
C
	IF (NGAL.GT.0) THEN
C if complete disk file is used -- do not compute size
	  IF ((IPAR.EQ.1.OR.IPAR.EQ.5).AND.
     *                (IANF.EQ.'f'.OR.IANF.EQ.'g')) THEN
C  check if there is a scale for the first galaxy
	    IF (ABS(ARCSEC(NSTAR+1)).LE.0.001.AND.MODG.NE.0) THEN
 624	      WRITE(6,71)
 71	FORMAT('  +++ There is NO scale length for galaxies +++'/
     *  '    Do you want to generate them (<cr> or abort (ctr<d>): ',$)
	      call readstr(2,ianf,*999,*624)
	      IANF='TT'
	      GO TO 810
	    END IF
	  ELSE
C  case for data not read from file
C  
C  if data is entered by TTY, allow option of fixed z
 810	    IF (IPAR.LE.2.OR.IPAR.EQ.4) ZFIX=0.000000
	    IF (IANF.EQ.'t'.OR.IANF.EQ.'TT') THEN
 625 	      WRITE(6,72)
 72	FORMAT('   Enter fixed z, deflt <cr> = randomly generated: ',$)
	      CALL READ1R(ZFIX,*999,*625)
	    END IF
C   determine BD ratios
C          MODG(=MODGAL)=0  Fuzzy star as galaxies
C                        1  B/D fixed by BBD
C                        2  B/D variable (BD(i))
C                        3  disk only
C                        4  bulge only
C                        5  old (pre 04/88) fixed B/D
C
C
	    IF (MODG.EQ.3) THEN
	      DO 150 I=NSTAR+1,NOB
 150	        BD(I)=0.
	    ELSE IF (MODG.EQ.4) THEN
	      DO 151 I=NSTAR+1,NOB
 151	        BD(I)=1.
	    ELSE IF (MODG.EQ.5) THEN
	      DO 152 I=NSTAR+1,NOB
 152	        BD(I)=.333
C ! fixed B/D by BBD or BBDT
	    ELSE IF (MODG.EQ.1) THEN
	      IF (IANF.NE.'f') BBDT=BBD	
	      DO 153 I=NSTAR+1,NOB
 153	        BD(I)=BBDT
C  create zero redshift b/d ratios assuming 10% E for field
	    ELSE IF (MODG.EQ.2) THEN
	      CALL BBDMAKE(NGAL,BD(NSTAR+1),.10)
	    END IF
C   get scale size
	    IF (ABS(ZFIX).GT.0.00005) THEN
	      CALL GALDIAMFZ(NGAL,SMAG(NSTAR+1),HN,ZFIX,Z(NSTAR+1)
     *                      ,BD(NSTAR+1),ARCSEC(NSTAR+1))
	    ELSE
 	      CALL GALDIAM(NGAL,SMAG(NSTAR+1),HN,Z(NSTAR+1),BD(NSTAR+1),
     *                    ARCSEC(NSTAR+1),ZMDIST,DISM,DISZ,CK)
	    END IF
	    CALL ROTAB(NGAL,SIGMAG,DMORMAG,SMAG(NSTAR+1),ROTA(NSTAR+1),
     *                  ABRAT(NSTAR+1))
	  END IF
	END IF
C---------------------------------------------------------------------
C
C  add cluster galaxies position and mag from .CLS file
C    all attribute of the galaxies are made in the subroutine
C
	IF (IPAR.GE.3) THEN
C  the first object is NOB+1
	  CALL MKCLUSTER(NGALC,XS(NOB+1),YS(NOB+1),SMAG(NOB+1),BD(NOB+1)
     *         ,ABRAT(NOB+1),ROTA(NOB+1),ARCSEC(NOB+1),ZCL,HN,.02,
     *         XC,YC,SIGMAG,XQSO,YQSO,QSOMAG,DMORMAG,NI,NJ,
     *         SCALE,40000-NOB,*999)
	  DO 130 I=NOB+1,NOB+NGALC
	    FLUX(I)=10**(-.4*(SMAG(I)-A0T))
	    IC(I)=1
 130	    Z(I)=ZCL
	  WRITE(6,*)' N_star',NSTAR,' Ngal bk/cl ',NGAL,NGALC
	  NGALBK=NGAL
	  NGAL=NGAL+NGALC
C	! background count
	  NOBBK=NOB
	  NOB=NOB+NGALC
	  IF (NOBBK.NE.0) THEN
 6251	    WRITE(6,90)
 90	FORMAT('  Do you want to save the background as a ',
     *	   ' separate frame? [y/n=dflt]: ',$)
	    call readstr(2,ibkout,*999,*6251)
	    IF (IBKOUT.EQ.'y') THEN
 6252	      WRITE(6,91) bkoutnam
 91	FORMAT('   Enter backgound frame (INT*2) output file name ['
     *      ,a18,']: ',$)
	      call readstrd(18,bkoutnam,*999,*6252)
	    END IF
	  END IF
	  GO TO 626
	ELSE
C  set NOBBK for no cluster
	  NOBBK=NOB+1
	END IF
C-----------------------------------------------------------------------
C
C
	IF (IPS.LT.0) THEN
 626	  WRITE(6,721)
 721	FORMAT('   Do you want to see the object list? y/n=<cr>: ',$)
	  call readstr(2,iant,*999,*626)
	  IF (IANT.EQ.'y') THEN
	    DO 166 I=1,NSTAR
 166	      WRITE(6,40) I,XS(I),YS(I),SMAG(I),'  star'
	    DO 167 I=NSTAR+1,NGAL
 167	      WRITE(6,722) I,XS(I),YS(I),SMAG(I),Z(I),ARCSEC(I),
     *                   ABRAT(I),ROTA(I),BD(I)
 722	FORMAT('#',I5,' at',2F7.2,' m:',F7.2,' z',F7.4,' ",a/b,rot',
     *        F6.3,F5.2,F6.1,' B/D',F5.2)
 	    IF (FILOUT.EQ.'n') THEN
 627	      WRITE(6,*) '   If you want to save...'
	      CALL READFN(FILT,FDUM,FILOUT,'sim','o',11,*999,*627,*23002)
23002	      CONTINUE
	    END IF
	  END IF
C	! saving list only
	  IF (IPREVIEW.EQ.0) GO TO 888
	END IF
C-----------------------------------------------------------------------
C
C  Start making picture -- fisrt sky and stars
C  Generate sky
	IF (IPREVIEW.EQ.1) THEN
	  WRITE(6,*) '   ... PGplot preview of simulation field:'
	  CALL PLOTMAP(NOB,XS,YS,SMAG,IC,FLOAT(NI),FLOAT(NJ),1,'view',
     *                 *6271)
 6271	  WRITE(6,94) 
 94	FORMAT('   Do you want to continue? (y=dflt/n): ',$)
	  call readstr(1,ianp,*999,*6271)
	  IF (IANP.EQ.'n') RETURN1
	  IF (IPS.LT.0) GO TO 888
	END IF
	WRITE(6,*) '   .....making sky'
	fitsname(1)=' '
	IF (IREADBK.EQ.0) THEN
	  CALL SKYGEN(SKYADU,SKYNOISE,NI,NJ,TEMPX,maxsize,maxsize)
	ELSE
	  CALL IOBACKGR(BKINN,NI,NJ,TEMPX,maxsize,maxsize,1)
	END IF
C  Generate star template (always done)
	WRITE(6,*) '   .....making star template'
	IF (IGE.EQ.0) THEN
	  CALL STARTEM1(SEE,BETAS,PSF,NS)
	ELSE
	  CALL STARTEM2(SEE,BETAS,SEEAB,SEEROT,PSF,NS)
	END IF
C
C  add stars
C
	CELL=SCALE/(.07*SEE)
	NSP=(2*NS+1)/CELL+1
	IF (NSP.GT.99) THEN
	  WRITE(6,*) '  ++++ Warning: Oversampling by too much +++'
	  NSP=99
	END IF
	WRITE(6,73) CELL,NSP
 73	FORMAT('   ...cell size for stars:',F7.2,'  star array size:',I3)
	NIB=NI+FWHM
	NJB=NJ+FWHM
	DO 100 I=1,NSTAR
	  IF (XS(I).GT.NIB.OR.XS(I).LE.-FWHM.OR.YS(I).GT.NJB.OR.
     *            YS(I).LT.-FWHM) THEN
	    WRITE(6,*) '  Star # ',I,' out of bound, not computed..'
	    IC(I)=-1
	  ELSE
	  WRITE(6,74) I,XS(I),YS(I),SMAG(I)
 74	FORMAT(' Star #',I5,' at',2F8.2,'  mag:',F7.2)
	    CALL ADDSTAR(PSF,NS,XS(I),YS(I),FLUX(I),NSP,CELL,inoise,
     *       gain,TEMPX,maxsize,maxsize,NI,NJ)
	  END IF
 100	CONTINUE
C---------------------------------------------------------
C
C  add quasar
	IF (QSOMAG.GT.1.) THEN
	  WRITE(6,741) XQSO,YQSO,QSOMAG
 741	FORMAT('  QUASAR   at',2F8.2,'  mag:',F7.2)
	  FLUXQSO=10**(-.4*(QSOMAG-A0T))
	  CALL ADDSTAR(PSF,NS,XQSO,YQSO,FLUXQSO,NSP,CELL,inoise,
     *       gain,TEMPX,maxsize,maxsize,NI,NJ)
	END IF
C------------------------------------------------------------
C          Galaxies   
C
C  Make template for galaxies
 812	IF (NGAL.LE.0) GO TO 811
	IF (MODG.EQ.0) THEN
C  fake galaxies as fuzzy stars
	  CALL STARTEM1(SEE,BETAG,PSF,NS)
C  add galaxies
	  DO 101 I=NSTAR+1,NOB
	    BD(I)=0.
	    IF (XS(I).GT.NIB.OR.XS(I).LE.-FWHM.OR.YS(I).GT.NJB.OR.
     *            YS(I).LT.-FWHM) THEN
	      WRITE(6,*) '  Glxy # ',I,' out of bound, not computed..'
	      IC(I)=-1
	    ELSE
	  WRITE(6,75) I,XS(I),YS(I),SMAG(I)
 75	FORMAT(' galaxy #',I5,' at',2F8.2,'  mag:',F7.2)
	      CALL ADDSTAR(PSF,NS,XS(I),YS(I),FLUX(I),NSP,CELL,inoise,
     *        gain,TEMPX,maxsize,maxsize,NI,NJ)
	    END IF
 101	  CONTINUE
	ELSE 
C-------------------------------------------------------------------
C  For generating real galaxy models
c
C  a disk template and a bulge template are made, mixed according to
C  parameter BBD or BD(i) = B/(B+D)
	  WRITE(6,*) '   ... making galaxy templates ...'
C       make PSF kernel from PSF
	  NK=NSP+MOD(NSP-1,2)
	  CALL ARRGAL(PSF,NS,0.0,0.0,0.0,1.,NK,CELL,RKERN)
C  fine grid kernel
	  NKF=MIN0(99,2*NK+1)
	  CALL ARRGAL(PSF,NS,0.0,0.0,0.0,1.,NKF,.5*CELL,FRKERN)
C       make galaxy template
C          MODG(=MODGAL)=0  Fuzzy star as galaxies
C                        1  B/D fixed by BBD
C                        2  B/D variable (BD(i))
C                        3  disk only
C                        4  bulge only
C                        5  old (pre 04/88) fixed B/D
C
C
	  IF (MODG.EQ.3) THEN
	    CALL DISKTEM(TMPL,NG,SCL)
	  ELSE IF (MODG.EQ.4) THEN
	    CALL BULGETEM(TMPL,NG,SCL)
	  ELSE IF (MODG.EQ.5) THEN
	    CALL GALTEM1(TMPL,NG,SCL)
	  ELSE
	    CALL DISKTEM(TMPLA,NG,SCL)
	    CALL BULGETEM(TMPLB,NG,SCL)
C ! fixed B/D by BBD or BBDT
	    IF (MODG.EQ.1) THEN
	      IF (IANF.NE.'f') BBDT=BBD	
	      CALL MIXTEMP(TMPL,TMPLA,TMPLB,NG,BBDT)
	    END IF
	  END IF
	  J=0
C	  DO KK=-NG,NG
C	    J=J+1
C	    I=0
C	    DO LL=-NG,NG
C	      I=I+1
C	      IX(I,J,6)=TMPL(LL,KK)*200000
C	    END DO
C	  END DO
C add galaxies
	  N4FWHM=4*FWHM
	  N4FWHMF=8*FWHM
	  WRITE(6,*) '   Minimum galaxy size: ', N4FWHM
	  DO 103 I=NSTAR+1,NOB
C     templet pixels
	    CELL=AMAX1(1.,SCL*SCALE/ARCSEC(I))
	    NSP=MIN0(99,INT((2*NG+1)/CELL)+1)
	    NH=MIN0(12,NSP/2)
	    IF (XS(I).GT.FLOAT(NI+NH).OR.XS(I).LT.FLOAT(-NH).OR
     *	       .YS(I).GT.FLOAT(NJ+NH).OR.YS(I).LT.FLOAT(-NH)) THEN
	      WRITE(6,*) '  Galaxy# ',I,' out of bound, not computed..'
	      IC(I)=-1
	    ELSE
	      IF(MODG.EQ.2) CALL MIXTEMP(TMPL,TMPLA,TMPLB,NG,BD(I))
	      WRITE(6,76) I,XS(I),YS(I),SMAG(I),ARCSEC(I),CELL,NSP,
     *           ROTA(I),ABRAT(I),Z(I),BD(I)
 76	FORMAT(' Galaxy #',I5,' at',2F8.2,'  mag:',F7.2,'  ro":',F6.2,
     *         '  cell size:',F6.2,I4,/,13X,F7.2,2X,F6.2,3X,'z',F7.4,
     *          '  b/d',F5.2)
C  check for small galaxies for which a finer grid is used before convolution
	      IF (NSP.LE.NFGRID) THEN
C    NSP must be odd
	        NSP=NSP+MOD(NSP-1,2)
	        NSPF=MIN0(99,2*NSP+1)
	WRITE(6,*) '   ...Fine grid used:', NSPF
C  compute equivalent co-ordinate in fine grid, 
C    -.00001 because one needs NINT(.5)=0 rather than 1.
	        XX=XS(I)-NINT(XS(I))
	        YY=YS(I)-NINT(YS(I))
	        IF (XX.GE.-0.00001) THEN
	          IBEG=0
	          XX=2.*XX+.50001
	        ELSE
	          IBEG=1
	          XX=2.*XX-.49999
	        END IF
	        IF (YY.GE.-0.00001) THEN
	          JBEG=0
	          YY=2.*YY+.50001
	        ELSE
	          JBEG=1
	          YY=2.*YY-.49999
	        END IF
C  create gridded galaxy
	        CALL ARRGAL(TMPL,NG,XX,YY,ROTA(I),
     *                   ABRAT(I),NSPF,.5*CELL,GALA)
C  pad galaxy with zeroes if it is too small
	        IF (NSPF.LT.N4FWHMF) THEN
	          CALL EXPANDGAL(NSPF,N4FWHMF,GALA,2)
	          NSP=NSPF/2
	        END IF
C  convolve with PSF
	        CALL CONVARR(GALA,NSPF,FRKERN,NKF,RESGAL,RNORM)
C   block-sum fine grid into proper pixels
	        CALL SHRTEMP(RESGAL,NSP,IBEG,JBEG)
	      ELSE
C  larger size galaxies
	        CALL ARRGAL(TMPL,NG,XS(I),YS(I),ROTA(I),ABRAT(I),
     *                   NSP,CELL,GALA)
C  pad galaxy with zeroes if it is too small
	        IF (NSP.LT.N4FWHM) CALL EXPANDGAL(NSP,N4FWHM,GALA,1)
C  convolve with PSF
	        CALL CONVARR(GALA,NSP,RKERN,NK,RESGAL,RNORM)
	      END IF
C generate bleeding column flux
C	      IF (ISATUR.NE.0) CALL BLFLUX(RESGAL,NSP,XS(I),YS(I),NBL
C    *           IBL,JBL,BLFL)
C  add galaxy to master frame
	      CALL ADDGAL(RESGAL,NSP,FLUX(I),XS(I),YS(I),
     *                      TEMPX,maxsize,maxsize,NI,NJ)
c    *                      TEMPX,maxsize,maxsize,NI,NJ,ISATUR)
	    END IF
	    IF (I.EQ.NOBBK) THEN
	      IF (IBKOUT.EQ.'y') THEN
C  put background picture in IX, frame 1
	        WRITE(6,*) '     Writing background frame to disk...'
	        NCOMC(1)=' Background frame for'//FILOUT
	        NII(1)=NI
	        NJJ(1)=NJ
	        CALL MAKEFRAME(IX(1,1,1),TEMPX,nu,nv,maxsize,maxsize,NI,NJ)
	        CALL wdkfits(*1031,1,BKOUTNAM,2,IX,NU,NV,KF,IDUM)
 1031	        IF (ISAVEBK.EQ.1) 
     *             CALL IOBACKGR(BKOUTN,NI,NJ,TEMPX,maxsize,maxsize,0)
	      END IF
	      WRITE(6,*) '   .... Making cluster member galaxies ---'
	    END IF
C  Sort objects and output a data file containing all info
 103	  CONTINUE
	END IF
C  
C  Add cosmic rays, NCOSRAY = number / min
 811	IF (NCOSRAY.GT.0) THEN
	  NCR=NINT(NCOSRAY*TTIME/60.)
C generate positions
	  CALL GENPOS(NCR,XCR,YCR,NI,NJ)
C generate amplitude
	  CALL GENAMP(NCR,400.,40000.,AMP)
	  CALL ADDCOSRAY(NCR,XCR,YCR,AMP,TEMPX,maxsize,maxsize)
	END IF
C  put real number picture in IX, frame 1
	NII(1)=NI
	NJJ(1)=NJ
	nfl(6,1)=1
	CALL MAKEFRAME(IX(1,1,1),TEMPX,nu,nv,maxsize,maxsize,NI,NJ)
C  Sort objects and output a data file containing all info
 888	IF (FILT.EQ.'n') RETURN1
	IF (NOB.GT.1) THEN
	  CALL INDEXX(NOB,YS,INDEX)
	ELSE
	  INDEX(1)=1
	END IF
	call opennew(28,1,18,filout,*999)
c	OPEN(UNIT=28,FILE=FILOUT,status='NEW',ERR=999)
C	CALL DATE(ADATE)
C	CALL TIME(ATIME)
	WRITE(28,21) FDATE(),NI,NJ,GAIN,RDNOISE,QE
 21	FORMAT(' Simulation made: ',A24,' Size:',2I5,
     *         '  gain:',F6.1,'  Readnoise:',F6.1,'e-',' QE:',F5.2)
	WRITE(28,22) SEE,SCALE,A0,TTIME,SIGMAG,TSIZE,ZMCT
 22	FORMAT('  FWHM:',F5.2,'"  scale:',F7.4,'"/pix  zero pt:',
     *         F7.3,' Int time:',F8.1,' 1 sig mag:',F7.3,' Apert',
     *         F5.2,'m',' 0 mag ct ',G8.2)
	IF (IPAR.LE.2) THEN
	  WRITE(28,23) MODG,APS,C0S,APG,C0G
 23	FORMAT('  Glxy Mod: ',I1,'  Ct models: stars: alp=',F6.3,
     *       ' C0=',F7.3,'  glxy: alp=',F6.3,' C0=',F7.3)
	ELSE
	  WRITE(28,27) MODG,APS,C0S,APG,C0G,ZCL
	END IF
 27	FORMAT('  Glxy Mod: ',I1,'  Ct models: stars: alp=',F6.3,
     *       ' C0=',F7.3,'  glxy: alp=',F6.3,' C0=',F7.3,'  Cluster z:'
     *       ,F7.4)
	WRITE(28,24) BETAS,BETAG,SKYADU,SKYNOISE,FILTRAN,WIDTH
 24	FORMAT('  Shape parameters: s:',F5.2,'  g:',F5.2,'   sky ADU:',
     *      F9.3,' noise:',F7.3,'  Filter:',F5.2, ' width:',F6.0 )
	II=0
	DO 102 I=1,NOB
	  IF (IC(INDEX(I)).NE.-1) THEN
	    II=II+1
 	    WRITE(28,25) II,XS(INDEX(I)),YS(INDEX(I)),FLUX(INDEX(I)),
     *                 SMAG(INDEX(I)),IC(INDEX(I)),ARCSEC(INDEX(I)),
     *           ROTA(INDEX(I)),ABRAT(INDEX(I)),Z(INDEX(I)),BD(INDEX(I))
	  END IF
 102	CONTINUE
 	  IF (QSOMAG.GT.1.) THEN
	    ICL=3
	    DUM=0.
	    WRITE(28,25) I,XQSO,YQSO,FLUXQSO,
     *                 QSOMAG,ICL,DUM,DUM,DUM,ZCL,DUM
	  END IF
	CLOSE(UNIT=28)
	WRITE(6,*) '   .... .sim file saved.'
 25	FORMAT(1X,I6,3X,2F8.2,1X,F12.1,2X,F7.3,5X,I1,2X,F7.4,F7.2,
     *           F6.3,1x,F7.5,F5.2)
 999	RETURN1
	END
c
c///////////////////////////////////////////////////////////////
c
C SUBROUTINE TO generate bleeding column flux
C
	SUBROUTINE BLFLUX(ARRAY,NSP,XS,YS,NBL,IBL,JBL,BLFL)
	DIMENSION ARRAY(99,99),IBL(1),JBL(1),BLFL(1)
	        IF (ARRAY(NSP/2,NSP/2).GT.32767) THEN
	          NBL=NBL+1
	          IBL(NBL)=NINT(XS)
	          JBL(NBL)=NINT(YS)
	          BLFL(NBL)=0.
	          DO 230 L=3,NSP-2
	            DO 230 M=3,NSP-2
	              IF (ARRAY(M,L).GT.32768.) 
     *                   BLFL(NBL)=BLFL(NBL)+ARRAY(M,L)-32768.
 230	          CONTINUE
	        END IF
	RETURN
	END
C
C///////////////////////////////////////////////////////////////
C
	SUBROUTINE MAKEFRAME(IX,XX,NU,NV,nus,nvs,NI,NJ)
c	INTEGER*2 IX(NU,NV)
	INTEGER IX(NU,NV)
	DIMENSION XX(nus,nvs)
	  DO 100 J=1,NJ
	    DO 100 I=1,NI
 100	      IX(I,J)=INTLIMR(XX(I,J))
	RETURN
	END
C
C////////////////////////////////////////////////////////////////
C
C   FUNCTION RETURN TOTAL NUMBER OF OBJECTS UP TO LIMIT RML OF
C     A POWER-LOW CT FUNCTION:
C              log(N(m))=C0+alpha*m
C
	FUNCTION INTPLD(ALPHA,C0,BEGMAG,RML,AREA,SIGFAC)
	REAL	ETIME, TARRAY(2)
	INTPLD=NINT(AREA*(10**(C0+ALPHA*RML)-10**(C0+ALPHA*BEGMAG))
     *           /(ALPHA*2.303*3600.))
	IF (ABS(SIGFAC).LT.0.001) THEN
	  RETURN
	ELSE
	  WRITE(6,*) '   expected total number:',INTPLD
C  Compute poissonian scatter in total number
C	  ISEED=-NINT(SECNDS(0.)*100)
	  ISEED=-NINT(ETIME(TARRAY)*100)
	  SIG=SIGFAC*SQRT(FLOAT(INTPLD))
	  INTPLD=INTPLD+NINT(SIG*GASDEV(ISEED))
	  WRITE(6,10) SIGFAC,INTPLD
 10	FORMAT('   rms:',F5.2,' sigma,  total cts:',I5)
	END IF
	RETURN 
	END 
C//////////////////////////////////////////////////////////////
C
C  SUBROUTINE to generate positions and mag of a cluster of galaxies
c     at z, using a King model spatial distribution and a LF
c
C	SUBROUTINE CLUGEN(NG,XS,YS,SMAG,HN,Z,XC,YC,ABELL,RKING,
C    *                    NI,NJ,SCALE)
C	DIMENSION XS(1),YS(1),SMAG(1)
C	RETURN
C	END
C////////////////////////////////////////////////////////////
C
C   Subroutine to generate positions (real) for NOB objects
C     with co-ord in images of size NI, NJ
C
	SUBROUTINE GENPOS(NOB,X,Y,NI,NJ)
	DIMENSION X(*),Y(*)
	REAL	ETIME, TARRAY(2)
C	ISEED=-NINT(SECNDS(0.)*100)
	ISEED=-NINT(ETIME(TARRAY)*100)
	DO 100 I=1,NOB
	  X(I)=NI*RAN1(ISEED)
 100	CONTINUE
C	ISEED=-NINT(SECNDS(FLOAT(ISEED/10))*100)+23
	ISEED=-NINT(ETIME(TARRAY)*100)+23
	DO 101 I=1,NOB
	  Y(I)=NJ*RAN1(ISEED)
 101	CONTINUE
	RETURN
	END
C////////////////////////////////////////////////////////////
C
C   Subroutine to generate magnitudes for NOB objects
C     base on drawing from a power law distribution
C
c    For explanation of algorithm, see programming notes
c
	SUBROUTINE GENMAG(NOB,ALPHA,BEGMAG,RML,SMAG)
	REAL	ETIME, TARRAY(2)
	DIMENSION SMAG(1)
C	ISEED=-NINT(SECNDS(0.)*100)+71
	ISEED=-NINT(ETIME(TARRAY)*100)+71
	DO 100 I=1,NOB
 102	  SMAG(I)=ALOG10(AMAX1(.000001,RAN1(ISEED)))/ALPHA+RML
	  IF (SMAG(I).LT.BEGMAG) GO TO 102
C   *** should make sure that the above statement preserve the ct distribution
 100	CONTINUE
	RETURN
	END
C////////////////////////////////////////////////////////////
C
C   Subroutine to generate amplitude for objects from a distribution
C        of root amp
C       between amp1 and amp2
c
	SUBROUTINE GENAMP(NOB,AMP1,AMP2,AMP)
	REAL	ETIME, TARRAY(2)
	DIMENSION AMP(1)
	DEL=AMP2-AMP1
C	ISEED=-NINT(SECNDS(0.)*100)
	ISEED=-NINT(ETIME(TARRAY)*100)
	DO 100 I=1,NOB
	  RANUM=RAN1(ISEED)
 	  AMP(I)=AMP1+RANUM*RANUM*DEL
 100	CONTINUE
	RETURN
	END
C
C/////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO GENERATE SKY
C
	SUBROUTINE SKYGEN(SKYADU,SKYNOISE,NI,NJ,X,NU,NV)
	REAL	ETIME, TARRAY(2)
	REAL X(NU,NV)
 	ISEED=-NINT(ETIME(TARRAY)*100)
	DO 100 J=1,NJ
C	ISEED=-NINT(SECNDS(0.)*100)
c	ISEED=-NINT(ETIME(TARRAY)*100)
	  DO 100 I=1,NI
	    X(I,J)=SKYADU+SKYNOISE*GASDEV(ISEED)
 100	CONTINUE
	RETURN
	END
C
C////////////////////////////////////////////////////////////////////////
C
C FIXED GALAXY TEMPLATE
C           NS = size of template array, must be odd
C   Bulge to disk ratio is obtained from Boroson's theses
C   template is calculated to 7.5 mag (1000) below central brightness
C        of disk (i.e., NS=6.9 times r0)
C   galaxy is renormalized to sum=1
C
	SUBROUTINE GALTEM1(GAL,NS,R0)
	DIMENSION GAL(-NS:NS,-NS:NS)
	R0=FLOAT(NS)/6.9
	RE=R0/3.
	SUM=0.
	DO 100 J=-NS,NS
	  JSQ=J*J
	  DO 100 I=-NS,NS
	    ISQ=I*I
	    R=SQRT(1.*(ISQ+JSQ))
	    GAL(I,J)=EXP(-R/R0)+1.61*10.**(-3.33*(((R/RE)**.25)-1))
	    SUM=SUM+GAL(I,J)
 100	    CONTINUE
C  recompute r=0 point taking r=.7 (to prevent spike in center)
	    GAL(0,0)=1.+1.61*10.**(-3.33*(((.7/RE)**.25)-1))
	SUM=SUM+GAL(0,0)-1.61*10.**(3.33)
C  Normalize star template AND change into mag
	DO 104 J=-NS,NS
	  DO 104 I=-NS,NS
 104 	    GAL(I,J)=GAL(I,J)/SUM
C 104	    GAL(I,J)=2.5*ALOG10(GAL(I,J))
	WRITE(6,*) '   normalization for galaxy template: ',SUM
	RETURN
	END
C
C////////////////////////////////////////////////////////////////////////
C
C BULGE GALAXY TEMPLATE
C           NS = size of template array, must be odd
C    Re=R0/3
C   template is calculated to 7.5 mag (1000) below central brightness
C        of disk (i.e., NS=6.9 times r0)
C   galaxy is renormalized to sum=1
C
	SUBROUTINE BULGETEM(GAL,NS,R0)
	DIMENSION GAL(-NS:NS,-NS:NS)
	R0=FLOAT(NS)/6.9
	RE=R0/3.
	SUM=0.
	DO 100 J=-NS,NS
	  JSQ=J*J
	  DO 100 I=-NS,NS
	    ISQ=I*I
	    R=SQRT(1.*(ISQ+JSQ))
	    GAL(I,J)=10.**(-3.33*(((R/RE)**.25)-1))
	    SUM=SUM+GAL(I,J)
 100	    CONTINUE
C  recompute r=0 point taking r=.7 (to prevent spike in center)
	    GAL(0,0)=10.**(-3.33*(((.7/RE)**.25)-1))
	SUM=SUM+GAL(0,0)-10.**(3.33)
C  Normalize star template AND change into mag
	DO 104 J=-NS,NS
	  DO 104 I=-NS,NS
 104 	    GAL(I,J)=GAL(I,J)/SUM
	WRITE(6,*) '   normalization for BULGE template: ',SUM
	RETURN
	END
C///////////////////////////////////////////////////////////
C
C  galaxy template: disk 
C   template is calculated to 7.5 mag (1000) below central brightness
C        of disk (i.e., NS=6.9 times r0)
C
	SUBROUTINE DISKTEM(GAL,NS,R0)
	DIMENSION GAL(-NS:NS,-NS:NS)
	R0=FLOAT(NS)/6.9
	SUM=0.
	DO 100 J=-NS,NS
	  JSQ=J*J
	  DO 100 I=-NS,NS
	    ISQ=I*I
	    R=SQRT(1.*(ISQ+JSQ))
	    GAL(I,J)=EXP(-R/R0)
	    SUM=SUM+GAL(I,J)
 100	    CONTINUE
C  Normalize star template AND change into mag
	DO 104 J=-NS,NS
	  DO 104 I=-NS,NS
 104 	    GAL(I,J)=GAL(I,J)/SUM
	WRITE(6,*) '   normalization for DISK template: ',SUM
	RETURN
	END

C
C///////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO FORM TEMPLATE OF DIFFERENT BULGE:DISK RATIO
C
	SUBROUTINE MIXTEMP(TMPL,TMPLA,TMPLB,NS,BBD)
	DIMENSION TMPL(-NS:NS,-NS:NS),TMPLA(-NS:NS,-NS:NS),
     *            TMPLB(-NS:NS,-NS:NS)
	DISK=1.-BBD
	DO 100 J=-NS,NS
	  DO 100 I=-NS,NS
 100	    TMPL(I,J)=DISK*TMPLA(I,J)+BBD*TMPLB(I,J)
	RETURN	
	END
C
C////////////////////////////////////////////////////////////////////////
C
C STAR TEMPLATE, MOFFAT MODEL 1/(1+(r/(seeing/1.1))**2)**beta
C           NS = size of template array, must be odd
C
	SUBROUTINE STARTEM1(SEE,BETA,STAR,NS)
	DIMENSION STAR(-NS:NS,-NS:NS)
	RM=(SEE/1.1)
	RMSQ=RM*RM
	DELRSQ=(.07*SEE)**2
	SUMI=0
	DO 100 J=-NS,NS
	  JSQ=J*J
	  DO 100 I=-NS,NS
	    ISQ=I*I
	    R=(ISQ+JSQ)*DELRSQ
	    STAR(I,J)=1./((1.+R/RMSQ)**BETA)
 	    SUMI=SUMI+STAR(I,J)
 100	CONTINUE
C  Reflect star symmetrically
C	DO 101 J=-NS,-1
C	  J1=-J
C	  DO 101 I=0,NS
C101	    STAR(I,J)=STAR(I,J1)
C	DO 102 J=-NS,NS
C	  DO 102 I=-NS,-1
C102	    STAR(I,J)=STAR(-I,J)
C  Normalize star template
	DO 104 J=-NS,NS
	  DO 104 I=-NS,NS
 104	    STAR(I,J)=STAR(I,J)/SUMI
	WRITE(6,*) '   normalization for star template: ',SUMI
	RETURN
	END
C////////////////////////////////////////////////////////////////////////
C
C STAR TEMPLATE For elliptical star, 
C  MOFFAT MODEL 1/(1+(r/(seeing/1.1))**2)**beta
C           NS = size of template array, must be odd
C
	SUBROUTINE STARTEM2(SEE,BETA,SEEAB,SEEROT,STAR,NS)
	DIMENSION STAR(-NS:NS,-NS:NS),START(141,141)
	RM=(SEE/1.1)
	ABSQ=SEEAB*SEEAB
	RMSQ=RM*RM
	DELRSQ=(.07*SEE)**2
	SUMI=0
	DO 100 J=-NS,NS
	  RJSQ=J*J*ABSQ
	  DO 100 I=-NS,NS
	    RISQ=I*I
	    R=(RISQ+RJSQ)*DELRSQ
	    STAR(I,J)=1./((1.+R/RMSQ)**BETA)
 	    SUMI=SUMI+STAR(I,J)
 100	CONTINUE
C  rotate star
	NN=2*NS+1
	IF (ABS(SEEROT).GT.0.1)
     *   CALL RROT(FLOAT(NS+1),FLOAT(NS+1),SEEROT,STAR,START,
     *             NN,NN,NN,NN)
C  Normalize star template
	DO 104 J=-NS,NS
	  DO 104 I=-NS,NS
 104	    STAR(I,J)=STAR(I,J)/SUMI
	WRITE(6,*) '   normalization for star template: ',SUMI
	RETURN
	END
C///////////////////////////////////////////////////////////////////
C
C SUBOUTINE FOR READING POSITION AND MAG FILE FOR SIMULATION
C
	SUBROUTINE RDXYMAG(X,Y,SMAG,ARCSEC,ABRAT,ROTA,Z,BD,NSTAR,NGAL,
     *              ic, SCALE,SCRAT,NI,NJ,NU,NV,IPAR,MODG,BBDT,SMAGLIM)
	CHARACTER FILNAM1*18,STRING*132,FILNAM1A*18
	DIMENSION X(*),Y(1),SMAG(*),
     *            ARCSEC(*),ABRAT(*),ROTA(*),Z(*),BD(*)
c	INTEGER*2 IC(*)
	INTEGER IC(*)
 600	WRITE(6,20) FILNAM1
 20	FORMAT('   Enter .sim filename (dflt: ',A20,'): ',$)
	call readstr(18,filnam1a,*998,*600)
	CALL READFN(FILNAM1,FILNAM1A,FILNAM1,'sim','i',12,*998,*600,*2301)
2301	NGAL=0
	NSTAR=0
	OPEN(UNIT=30,FILE=FILNAM1,STATUS='OLD',ERR=900)
 	  READ(30,48,END=101,ERR=900) NIT,NJT
 48	  FORMAT(49X,2I5)
	  READ(30,39,END=101,ERR=900) FSCAL
 39	  FORMAT(21X,F7.4)
 606	  WRITE(6,40)  FSCAL
	  SCALE=FSCAL
 40	FORMAT('   File input scale (',F7.4,'"/p), enter new scale,',
     *        ' (<cr>=no change): ',$)
	  CALL READ1R(SCALE,*999,*606)
	  IF (SCALE.NE.FSCAL) WRITE(6,41)
 41	FORMAT('   ++++ Scale changed from file input, all'
     *         ,' positions and piture size will be rescaled')
 	  READ(30,49,END=101,ERR=900) MODG
 49	FORMAT(11X,I2)
  	  READ(30,38,END=101) STRING
 38	FORMAT(A132)
	SCRAT=FSCAL/SCALE
	NIT=NINT(SCRAT*NIT)
	NJT=NINT(SCRAT*NJT)
	NI=MIN0(NIT,NU)
	NJ=MIN0(NJT,NV)
C	IF (NIT.GT.NU.OR.NJT.GT.NV) THEN
 607	  WRITE(6,42) NIT,NJT,NI,NJ
 42	FORMAT('   ...picture size from input file: ',2I5,/
     *    '   Maximum allowable size =',I5,' x',I5,' (=default)'/
     *    '     Enter picture size (<cr>=default): ',$)
	  CALL READ2I(NI,NJ,*999,*607)
	  CONTINUE
C	END IF
	WRITE(6,1) NI,NJ
 1	FORMAT('    ...Picture size:',I5,' x',I5/'    ...reading file')
	I=0
	DO 100 IM=1,40000
	  I=I+1
	  READ(30,25,END=101,ERR=900) X(I),Y(I),DUM,SMAG(I),
     *           IC(I),ARCSEC(I),ROTA(I),ABRAT(I),Z(I),BD(I)
 25	FORMAT(10X,2F8.2,1X,F12.1,2X,F7.3,5X,I1,2X,F7.4,F7.2,
     *           F7.4,F7.3,F5.2)
	  IF (SMAG(I).LE.SMAGLIM) THEN
	    IF (IC(I).EQ.1) NGAL=NGAL+1
	    IF (IC(I).EQ.3) NSTAR=NSTAR+1
	  ELSE
	    I=I-1
	  END IF
C	type*, X(I),Y(I),SMAG(I),IC(I),ARCSEC(I),ABRAT(I),ROTA(I)
 100	CONTINUE
C separate into class 3 and 1
 101	NOB=NSTAR+NGAL
	NGT=NSTAR+1
	DO 102 I=1,NSTAR
C search for the first galaxy
	  IF (IC(I).EQ.1) THEN
C search for the first star after NSTAR
	    DO 103 J=NGT,NOB
	      IF (IC(J).EQ.3) THEN
C switch
	        T=X(I)
	        X(I)=X(J)
	        X(J)=T
	        T=Y(I)
	        Y(I)=Y(J)
	        Y(J)=T
	        T=SMAG(I)
	        SMAG(I)=SMAG(J)
	        SMAG(J)=T
	        T=ARCSEC(I)
	        ARCSEC(I)=ARCSEC(J)
	        ARCSEC(J)=T
	        T=ABRAT(I)
	        ABRAT(I)=ABRAT(J)
	        ABRAT(J)=T
	        T=ROTA(I)
	        ROTA(I)=ROTA(J)
	        ROTA(J)=T
	        T=Z(I)
	        Z(I)=Z(J)
	        Z(J)=T
	        T=BD(I)
	        BD(I)=BD(J)
	        BD(J)=T
	        IC(J)=1
	        NGT=J+1
	        GO TO 104
	      END IF
 103	    CONTINUE
 104	    CONTINUE
	  END IF
 102	CONTINUE
 608	WRITE(6,50) MODG
 50	FORMAT('    ...input galaxy model: ',I1/
     *         '   Enter new (0-5) model, <cr>=no change: ',$)
	CALL READ1I(MODG,*999,*608)
	BBDT=BD(NGT)
	IF (MODG.EQ.1) THEN
 609	  WRITE(6,51) BBDT
 51	FORMAT('  Fixed bulge/total ratio: ',F6.2/
     *         '    Enter new (0.-1.) ratio, <cr>=no change: ',$)
	  CALL READ1R(BBDT,*999,*609)
	  CONTINUE
	END IF
 999	CLOSE(UNIT=30)
 998	RETURN
 900	WRITE(6,*) ' ***** FILE IS NOT STANDARD .sim FILE ***'
	CLOSE(UNIT=30)
        WRITE(6,*) '       PLEASE ABORT by Control <d> '
	RETURN
	END
C///////////////////////////////////////////////////////////////////
C
C SUBOUTINE FOR CREATING POSITION FILE FROM SIMULATION FILE
C
C  IPAR=0 create interger posf
C
	SUBROUTINE SIMPOSF(*,NFR,IPAR)
	CHARACTER FILNAM1*18,STRING*80
	CHARACTER FILOUT*18,FILT*18,FDUM*18
        include 'objcat.inc' 
	CALL QUERYNFR(NFR,7,0,*999)
	FDUM=' '
 600	CALL  READFN(FILT,FDUM,FILNAM1,'sim','i',12,*999,*600,*23010)
23010	NGAL=0
	NSTAR=0
 606	WRITE(6,50) 
 50	FORMAT('  Enter magnitude limit for inclusion in POSF (df:',
     *      f6.2,'): ',$)
	call read1r(rml,*999,*606)
	OPEN(UNIT=30,FILE=FILNAM1,STATUS='OLD',ERR=900)
	WRITE(6,*) '   ..... reading file '
	NOB(NFR)=0
	DO 110 I=1,4
 110	  READ(30,30,ERR=900,END=101) STRING
 30	FORMAT(A80)
	DO 100 I=1,3000
	  READ(30,25,END=101,ERR=900) X,Y,DUM,SMAG
 25	FORMAT(10X,2F8.2,1X,F12.1,2X,F7.3)
C  Place in position file
 	  IF (SMAG.LT.RML) THEN
	    NOB(NFR)=NOB(NFR)+1
	    IJOI(NOB(NFR),NFR)=NINT(X)
	    IJOJ(NOB(NFR),NFR)=NINT(Y)
	    IDOB(NOB(NFR),NFR)=-1
C	    IF (FILOUT.NE.'n') WRITE(28,80) NOB(NFR),X,Y
 80	FORMAT(1X,I6,3X,2F8.2)
	  END IF
 100	CONTINUE
	GO TO 101
 900	WRITE(6,*) '  **** File not .sim format ****'
 101	CLOSE(UNIT=30)
C	IF (FILOUT.NE.'n') CLOSE(UNIT=28)
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO ADD ONE STAR ON TO IMAGE
C
	SUBROUTINE ADDSTAR(STAR,NS,X,Y,FLUX,NSP,CELL,inoise,
     *      gain,XX,NU,NV,NI,NJ)
	DIMENSION STAR(-NS:NS,-NS:NS),SUM(99,99),XX(NU,NV)
	REAL	ETIME, TARRAY(2)
	II=NINT(X)
	JJ=NINT(Y)
C  shifts 
	DX=X-II
	DY=Y-JJ
	NH=NSP/2
	HX=NH+DX+1.5
	HY=NH+DY+1.5
	SUMI=0.
C  Calculate integrated flux in each pixel
C  CELL=number of small cell in STAR for one real pixel
	DO 100 J=1,NSP
C	! upper boundry of pixel
	  V1=(HY-J)*CELL
	  V2=V1-CELL
	  DO 100 I=1,NSP
	    U1=(HX-I)*CELL
	    U2=U1-CELL
C  integrate STAR array between V1,V2,U1 and U2.
	    CALL ARINT(STAR,NS,U1,U2,V1,V2,SUM(I,J))
C	IF (I.EQ.1.AND.J.EQ.1) WRITE(6,*) V1,V2,U1,U2,SUM(I,J)
	    SUMI=SUMI+SUM(I,J)
 100	CONTINUE
C	WRITE(6,*) '    Normalization ',SUMI
C renormalize and insert in image
C	!     /SUMI
c  noise and normalization  (added Jan 2001)
c     note that flux is expressed in ADU
	if (inoise.le.1) then
	  if (inose.eq.0) then
	    FT=FLUX/SUMI
	  else
c  noise is added as a fluctuation in the total counts, but not psf shape
 	    ISEED=-NINT(ETIME(TARRAY)*100)
	    fluxnoise=sqrt(flux*gain)/gain
	    ft=(flux+fluxnoise*gasdev(iseed))/sumi
	  end if
	  do 200 j=1,nsp
	    do 200 i=1,nsp
	      sum(i,j)=sum(i,j)*ft
 200	  continue
	else if (inoise.eq.2) then
c error is added pixel by pixel, first scale each pixel to the proper 
c    error free flxu
	  ft=flux/sumi
	  do 201 j=1,nsp
	    do 201 i=1,nsp
	      sum(i,j)=sum(i,j)*ft
 201	  continue
c  now modify each pixel's value according to photon statistics
 	  ISEED=-NINT(ETIME(TARRAY)*100)
	  do 202 j=1,nsp
	    do 203 i=1,nsp
	      fluxnoise=sqrt(sum(i,j)*gain)/gain
	      sum(i,j)=sum(i,j)+fluxnoise*gasdev(iseed)
 203	    continue
 202	  continue
	end if
	NHJ=JJ-NH-1
	NHI=II-NH-1
	DO 101 J=1,NSP
	  J1=NHJ+J
	  IF (J1.LT.1.OR.J1.GT.NJ) GO TO 101
	  DO 102 I=1,NSP
	    I1=NHI+I	
	    IF (I1.LT.1.OR.I1.GT.NI) GO TO 102
	    XX(I1,J1)=XX(I1,J1)+SUM(I,J)
c	    XX(I1,J1)=XX(I1,J1)+SUM(I,J)*FT
 102	  continue
 101	CONTINUE
	RETURN
	END
C//////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO MAKE A GALAXY IMAGE ARRAY, NOT SCALED BY FLUX
C
	SUBROUTINE ARRGAL(TMPL,NS,X,Y,ROT,AB,NSP,CELL,SUM)
	DIMENSION TMPL(-NS:NS,-NS:NS),SUM(99,99),SUMT(99,99)
	II=NINT(X)
	JJ=NINT(Y)
	RNS=FLOAT(NS)
C  shifts 
	DX=X-II
	DY=Y-JJ
	NH=NSP/2
	HX=NH+DX+1.5
	HY=NH+DY+1.5
C  Calculate integrated flux in each pixel
C  CELL=number of small cell in TMPL for one real pixel
C  ratio of CELL to CELL2 takes care of the axial ratio
	CELL2=CELL/AB
	DO 100 J=1,NSP
C	! upper boundry of pixel
	  V1=(HY-J)*CELL2
	  IF (ABS(V1).GT.RNS) THEN
	    DO 103 I=1,NSP
 103	      SUM(I,J)=0.000
	  ELSE
	    V2=V1-CELL2
	    DO 101 I=1,NSP
	      U1=(HX-I)*CELL
	      U2=U1-CELL
C  integrate STAR array between V1,V2,U1 and U2.
	      CALL ARINT(TMPL,NS,U1,U2,V1,V2,SUM(I,J))
C	IF (I.EQ.1.AND.J.EQ.1) WRITE(6,*) V1,V2,U1,U2,SUM(I,J)
 101	    CONTINUE
	  END IF
 100	CONTINUE
C  rotate image
	IF (ABS(ROT).GT.5..AND.AB.LT.0.93) 
     *	   CALL RROT(HX-.5,HY-.5,ROT,SUM,SUMT,99,99,NSP,NSP)
	RETURN
	END
C
C////////////////////////////////////////////////////////////////////
C
C  Subroutine to expand galaxy by padding zeroes
C
	SUBROUTINE EXPANDGAL(NSP,MINWID,GALA,NN)
	DIMENSION GALA(99,99),GALATEMP(99,99)
	NADD=(MINWID-NSP+1)/2
	IF (NN.EQ.2) NADD=NADD+MOD(NADD,2)
	NEWNSP=NSP+NADD+NADD
	IF (NEWNSP.GT.99) THEN
	  NEWNSP=99
	  NADD=(99-NSP)/2
	END IF
C	write(3,*) '    ... galaxy being padded with 0s'
	DO 100 J=1,NEWNSP
	  DO 100 I=1,NEWNSP
 100	    GALATEMP(I,J)=0.
	DO 101 J=1,NSP
	  DO 101 I=1,NSP
 101	    GALATEMP(I+NADD,J+NADD)=GALA(I,J)
	NSP=NEWNSP
	DO 102 J=1,NSP
	  DO 102 I=1,NSP
 102        GALA(I,J)=GALATEMP(I,J)
	RETURN
	END
C
C///////////////////////////////////////////////////////////////
C   
C  SUBROUTINE TO SHRINK TEMPLATE BY FACTOR OF 2
C
	SUBROUTINE SHRTEMP(X,NSP,IBEG,JBEG)
	DIMENSION X(99,99),XT(49,49)
	DO 100 J=1,NSP
	  J2=J*2+JBEG
	  J1=J2-1
	  DO 100 I=1,NSP
	    I2=I*2+IBEG
	    I1=I2-1
 100	    XT(I,J)=X(I1,J1)+X(I2,J1)+X(I1,J2)+X(I2,J2)
	DO 101 J=1,NSP
	  DO 101 I=1,NSP
 101	    X(I,J)=XT(I,J)
	RETURN
        END
C///////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO ROTATE REAL NUMBER IMAGE AROUND A POINT CX,CY
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR PICTURE ROTATION
C
	SUBROUTINE RROT(CX,CY,DEG,X,XT,NU,NV,NI,NJ)
	REAL X(NU,NV),XT(NU,NV)
 200	ROT=DEG/57.2958
	DO 100 J=1,NJ
	  DY1=FLOAT(J)-CY
	  SDY1=DY1*DY1
C	  KK=(J-1)*NI
        DO 100 I=1,NI
	  DX1=FLOAT(I)-CX
	  DIST=SQRT(DX1*DX1+SDY1)
	  IF (DY1.EQ.0.0.AND.DX1.EQ.0.0) GO TO 102
	  THERES=ATAN2(DY1,DX1)
	  THEOLD=THERES-ROT
	  XOLD=DIST*COS(THEOLD)+CX
	  IP=INT(XOLD)
	  IF (IP.LT.1.OR.IP.GE.NI) GO TO 101
	  YOLD=DIST*SIN(THEOLD)+CY
	  JP=INT(YOLD)
	  IF (JP.LT.1.OR.JP.GE.NJ) GO TO 101
	  DX=XOLD-FLOAT(IP)
	  DY=YOLD-FLOAT(JP)
	  XT(I,J)=X(IP,JP)*(1.-DX)*(1.-DY)+X(IP+1,JP)*DX*(1.-DY)
     *           +X(IP,JP+1)*DY*(1.-DX)+X(IP+1,JP+1)*DY*DX
	  GO TO 100
 102	    XT(I,J)=X(I,J)
C	  GO TO 100
C  pixel out of bound
 101	    XT(I,J)=0.
 100	CONTINUE
C put shifted pixels back in original array
	DO 103 J=1,NJ
C	  KK=(J-1)*NI
	  DO 103 I=1,NI
 103	    X(I,J)=XT(I,J)
	RETURN
	END
C
C//////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO ADD ONE GALAXY (ALREADY SCRUNCHED AND ROTATED) ON TO IMAGE
C
	SUBROUTINE ADDGAL(OBJ,NSP,FLUX,X,Y,XX,NU,NV,NI,NJ)
	DIMENSION OBJ(99,99),XX(NU,NV)
	II=NINT(X)
	JJ=NINT(Y)
	NHJ=JJ-NSP/2-1
	NHI=II-NSP/2-1
	SUMI=0.
	DO 100 J=1,NSP
	  DO 100 I=1,NSP
 100	    SUMI=SUMI+OBJ(I,J)
C	WRITE(6,*) '  NORMALIZTION ',SUMI
C renormalize and insert in image
	IF (SUMI.LT.0.0000001) THEN
	  WRITE(6,*)  ' *** object too small, not added to frame ***'
	  RETURN
	END IF
	FT=FLUX/SUMI   
	DO 101 J=1,NSP
	  J1=NHJ+J
	  IF (J1.LT.1.OR.J1.GT.NJ) GO TO 101
	  DO 102 I=1,NSP
	    I1=NHI+I	
	    IF (I1.LT.1.OR.I1.GT.NI) GO TO 102
	    XX(I1,J1)=XX(I1,J1)+OBJ(I,J)*FT
 102	  continue
 101	CONTINUE
	RETURN
	END
C
C/////////////////////////////////////////////////////////////////
C
C  add cosray detection: 8 random directions, for adu<200 = single pix
C    2000<adu<20000  2 pixels, 2nd = 15%
C    adu>20000 4 pixels 5% 15% 100% 
C
	SUBROUTINE ADDCOSRAY(NOB,X,Y,AMP,XX,NU,NV)
	REAL	ETIME, TARRAY(2)
	DIMENSION X(*),Y(*),AMP(*),XX(NU,NV),IDA(2,8)
C  IDA = direction matrix for multi-pix cosrays
	DATA IDA/-1,-1, 0,-1, 1,-1,  -1,0, 1,0,  -1,1, 0,1, 1,1/
C	ISEED=-NINT(SECNDS(0.)*100)
	ISEED=-NINT(ETIME(TARRAY)*100)
	WRITE(6,*) '   .....adding cosmic rays'
	DO 100 I=1,NOB
	  IXX=NINT(X(I))
	  IYY=NINT(Y(I))
	  WRITE(6,*)I,IXX,IYY,AMP(I)
	  XX(IXX,IYY)=AMP(I)
	  IF (AMP(I).GT.2000.) THEN
C  determine direction for cr with more than one pix
	    IDIR=INT(RAN1(ISEED)*7.999)+1
	    XX(IXX+IDA(1,IDIR),IYY+IDA(2,IDIR))=.15*AMP(I)
	    IF (AMP(I).GT.20000.)
C  for more than 1 pixel
     *        XX(IXX+2*IDA(1,IDIR),IYY+2*IDA(2,IDIR))=.5*AMP(I)
	  END IF
 100	CONTINUE
	RETURN
	END
C
C//////////////////////////////////////////////////////////////////
C
C    SUBROUTINE TO INTEGRATE FINE PSF ARRAY INTO ONE PIXEL
C          RETURNED IN ANS
C
	SUBROUTINE ARINT(ARR,NS,X1,X2,Y1,Y2,ANS)
	DIMENSION ARR(-NS:NS,-NS:NS)
	ANS=0.
C  transform co-orinate
	IX1=MIN0(NS,MAX0(-NS,NINT(X1-.499999)))
	IX2=MIN0(NS,MAX0(-NS,NINT(X2+.499999)))
	IY1=MIN0(NS,MAX0(-NS,NINT(Y1-.499999)))
	IY2=MIN0(NS,MAX0(-NS,NINT(Y2+.499999)))
C sum pixels that are ALL in
	DO 100 J=IY2,IY1
	  DO 100 I=IX2,IX1
 100	    ANS=ANS+ARR(I,J)
C sum stripes
	IF (IY1.LT.NS) THEN
	  DY1=Y1-IY1
	  IYT1=IY1+1
	  DO 101 I=IX2,IX1
 101	    ANS=ANS+ARR(I,IYT1)*DY1
	ELSE
	  IYT1=-NS
	  DY1=0.00000
	END IF
	IF (IY2.GT.-NS) THEN
	  DY2=IY2-Y2
	  IYT2=IY2-1
	  DO 102 I=IX2,IX1
 102	    ANS=ANS+ARR(I,IYT2)*DY2
	ELSE
	  DY2=0.000000
	  IYT2=-NS
	END IF
	IF (IX1.LT.NS) THEN
	  DX1=X1-IX1
	  IXT1=IX1+1
	  DO 103 I=IY2,IY1
 103	    ANS=ANS+ARR(IXT1,I)*DX1
	ELSE
	  IXT1=-NS
	  DX1=0.00000
	END IF
	IF (IX2.GT.-NS) THEN
	  DX2=IX2-X2
	  IXT2=IX2-1
	  DO 104 I=IY2,IY1
 104	    ANS=ANS+ARR(IXT2,I)*DX2
	ELSE
	  IXT2=-NS
	  DX2=0.000000
	END IF
C Sum four corners
	ANS=ANS+DY1*DX1*ARR(IXT1,IYT1)+DY1*DX2*ARR(IXT2,IYT1)
     *         +DY2*DX1*ARR(IXT1,IYT2)+DY2*DX2*ARR(IXT2,IYT2)
	RETURN
	END
C//////////////////////////////////////////////////////////////////////
C
C   CONVOLUTION OF TWO ARRAYS: ARR AND RKERN, STOR IN RES
C      BOTH ARE ODD and square, AND RKERN IS SYMMETRIC
C
C//////////////////////////////////////////////////////////////////////
 	SUBROUTINE CONVARR(ARR,NAR,RKERN,NK,RES,RNORM)
	DIMENSION ARR(99,99),RKERN(99,99),RES(99,99)
	IF (ABS(RNORM).LT.0.00001) THEN
	  RNORM=0.
	  DO 110 J=1,NK
	    DO 110 I=1,NK
 110	      RNORM=RNORM+RKERN(I,J)
	  IF (ABS(RNORM).LT.0.00001) THEN
	    WRITE(6,*) ' **** Convolution kernel is a zero array ****'
	    RETURN
	  END IF
	END IF
	NK2=NK/2
	DO 100 J=1,NAR
	  JK1=J-NK2-1
	  J1=MAX0(J-NK2,1)
	  J2=MIN0(J+NK2,NAR)
	  DO 100 I=1,NAR
	    IK1=I-NK2-1
	    I1=MAX0(I-NK2,1)
	    I2=MIN0(I+NK2,NAR)
	    SUM=0.
	    DO 101 JJ=J1,J2
C  j co-ordinate of KERNEL
C   This is for symmetric kernel only, for proper general convolution,
C       should us JK2 and and change sign
	      JK=JJ-JK1
	      DO 101 II=I1,I2
	        SUM=SUM+RKERN(II-IK1,JK)*ARR(II,JJ)
 101	    CONTINUE
 100	    RES(I,J)=SUM
C 100	    RES(I,J)=SUM/RNORM
	RETURN
	END
c
C//////////////////////////////////////////////////////////////////////
c
c   SUBROUTINE TO DETERMINE A DIAMETER OF GALAXY OF MAG SM, DRAWN
C      FROM PROBABLILITY DISTRIBUTION OF Z  AS A FUNCTION OF M
c
C      For m>23, z is drawn from the same distribution
C
	SUBROUTINE GALDIAM(NG,SM,HN,Z,BBD,ARCSEC,ZMDIST,DISM,DISZ,CK)
	REAL	ETIME, TARRAY(2)
	DIMENSION SM(*),Z(*),BBD(*),ARCSEC(*),
     *             ZMDIST(16,20),DISM(20),DISZ(0:16),RKC(4)
	DATA RKC/0.,.5,.5,0./
C zmdist is a integral z dist normalized to 1,
C        has m scale in DISM and z scale in DISZ
C select the z distrib to use
C	ISEED=-NINT(SECNDS(0.)*121)
	ISEED=-NINT(ETIME(TARRAY)*121)
	DO 200 N=1,NG
	  DO 100 MBIN=1,19
	    IF (DISM(MBIN).GE.SM(N)) GO TO 101
 100	  CONTINUE 
C pick a random number
 101	  RANUM=RAN1(ISEED)
C interpolate z distribution to get z
	  DO 102 I=1,15
	    IF (ZMDIST(I,MBIN).GE.RANUM) GO TO 103
 102	  CONTINUE
 103	  Z(N)=DISZ(I-1)+(DISZ(I)-DISZ(I-1))*(ZMDIST(I,MBIN)-RANUM)/
     *              (ZMDIST(I,MBIN)-ZMDIST(I-1,MBIN))
	  Z(N)=AMAX1(Z(N),.05)
C	WRITE(6,*)SM(N),' MBIN ',MBIN,' RANUM ',RANUM,' ZBIN',I
C calculate scale length in "
C   first get absolute mag, 
	  ABM=ABMAG(SM(N),Z(N),HN,.02)
     *         -CK*RKCOR(Z(N),INT(BBD(N)),RKC,0.)
C         WRITE(6,*)CK*RKCOR(Z(N),INT(BBD(N)),RKC,0.),BBD(N)
C  correct BBD for differential bulge-disk K-correction
	  IF (BBD(N).LT..9.AND.BBD(N).GT.0.001) THEN
	    RAT=10**(-.4*CK*(RKCOR(Z(N),0,RKC,0.)-RKCOR(Z(N),1,RKC,0.)))
	    BBD(N)=1./(((1./BBD(N))-1.)*RAT+1.)
	  END IF
C size in "
	  ARCSEC(N)=DIAMMET(BBD(N),ABM)*HN*206266.*(1.+Z(N))/
     *           (299790000.*COSTERM(.02,Z(N)))
C	WRITE(6,*)'  Z',Z(N),' ABM ',ABM,' " ',ARCSEC(N),
C    *           DIAMMET(BBD(N),ABM),BBD(N)
 200	CONTINUE
	RETURN
	END
C
C//////////////////////////////////////////////////////////////////
C
C  Function to determine diameter of galaxy from Absolute Mag
C
	FUNCTION DIAMMET(BBD,ABM)
C  for ellipticals
	  IF (BBD.GT.0.99) THEN
C  the 3* is because the template is make using 1/3 disk scale length
C   B-r for E is 1.14
C	  ! Kormendy's relation
C	    DIAMMET=10**(-.57*(ABM+1.14)-11.18)
C	  ! Strom and Strom
	    DIAMMET=10**(-.2423*(ABM+.2)-4.59)
	    DIAMMET=3.*AMAX1(.4,AMIN1(14.,DIAMMET))
	  ELSE
C disk galaxy
	    BDCOR=1.-BBD
	    IF (ABS(BDCOR).GT.0.01) THEN
	      BDCOR=2.5*ALOG10(BDCOR)
	    ELSE
	      BDCOR=0.
	    END IF
	    DIAMMET=10**(-.2*(ABM+.7-BDCOR)-3.35)
	    DIAMMET=AMAX1(.4,AMIN1(14.,DIAMMET))
	  END IF
	RETURN
	END
c
C//////////////////////////////////////////////////////////////////////
c
c   SUBROUTINE TO DETERMINE A DIAMETER OF GALAXY OF MAG SM, with
C      fixed z
C
	SUBROUTINE GALDIAMFZ(NG,SM,HN,ZFIX,Z,BBD,ARCSEC)
	DIMENSION SM(*),Z(*),BBD(*),ARCSEC(*)
	ABMCON=25.+5.*ALOG10(AMAX1(.00000001,
     *         299790.*COSTERM(0.02,ZFIX)*(1.+ZFIX)/HN))
	DIAMCON=HN*206266.*(1.+ZFIX)/
     *           (299790000.*COSTERM(.02,ZFIX))
	DO 100, N=1,NG
	  Z(N)=ZFIX
C calculate scale length in "
C   first get absolute mag, 
	  ABM=SM(N)-ABMCON
	  ARCSEC(N)=DIAMMET(BBD(N),ABM)*DIAMCON
	WRITE(6,*)'  Z',Z(N),' ABM ',ABM,' " ',ARCSEC(N),DIAMMET(BBD(N),ABM)
 100	CONTINUE
	RETURN
	END
C/////////////////////////////////////////////////////////////////
C
C  Subroutine to create B/B+D ratioes
C
C     EFRAC= fraction of E galaxies (ie B/B+D=1)
C
C/////////////////////////////////////////////////////////////////
	SUBROUTINE BBDMAKE(NGAL,BBD,EFRAC)
	REAL	ETIME, TARRAY(2)
	DIMENSION BBD(*)
	ESP=AMAX1(0.01,1.-EFRAC)
C	ISEED=-NINT(SECNDS(0.)*103)
	ISEED=-NINT(ETIME(TARRAY)*103)
	DO 100 I=1, NGAL
	  AA=RAN1(ISEED)
	  IF (AA.LE.EFRAC) THEN
C	  ! E galax
	    BBD(I)=1.000000
	  ELSE
C  BBD is choosen so that it has a uniform distribution with
C    B/D between 0.0 and 1.5, or BBD between 0. and .6
	    BBD(I)=.6*(AA-EFRAC)/ESP
	  END IF
 100	CONTINUE
	RETURN
	END

C/////////////////////////////////////////////////////////////////
C
C  Subroutine to chose rotation angle, and a/b ratio
C
C//////////////////////////////////////////////////////
	SUBROUTINE ROTAB(NG,RM,DMORMAG,SM,ROT,AB)
	REAL	ETIME, TARRAY(2)
	DIMENSION SM(*),ROT(*),AB(*)
	RML=AMAX1(21.,RM-DEMORMAG)
C	ISEED=-NINT(SECNDS(0.)*117)
	ISEED=-NINT(ETIME(TARRAY)*117)
	DO 101 I=1,13
 101	  AB(1)=RAN1(ISEED)
	DO 100 I=1,NG
	  IF (SM(I).LE.RML) THEN
 	    ROT(I)=180.*RAN1(ISEED)
C   a/b ratio is limited from 0 to 81 deg 
C    a/b >0.15    (because the disk is infinitely thin
C	    AB(I)=COS(1.3614*RAN1(ISEED)) ! this is incorrect
	    AB(I)=1-.85*RAN1(ISEED)
	  ELSE
	    ROT(I)=0.
	    AB(I)=1.
	  END IF
 100	CONTINUE
	RETURN
	END
C////////////////////////////////////////////////////////////////////
C
C  Function for K-correction for Gunn r FROM SEBOK
C  calculate RKCOR relative to redshift ZREFK
C  IT=0 use CK coef for linear comb. CK(i)*RKCOR(IT=i), i=1,4
C  IT=1 for E+S0
C  IT=2 for Sa+Sb 
C  IT=3 for Sbc
c  IT=4 for Sdm Irr
	FUNCTION RKCOR(Z,IT,CK,ZREFK)
	DIMENSION RK(19,4),RS(19),A(4),B(4),CK(4),RKC(2),ZZ(2)
C	DATA A/.833,1.8,2.4/,B/1.318,-.072,-.91/
 	DATA A/1.06,1.72,2.55,1.25/,B/1.091,.169,-1.064,-0.611/
	DATA RK/0.0,.019,.038,.057,.073,.089,.106,.125,
     *    .150,.178,.206,.337,.499,.801,1.237,1.640,1.916,
     *    2.045,2.151,
C! ABOVE FOR E+S0
C  for Sa+Sb
     *    0.0,.016,.031,.047,.062,.078,.096,.115,.139,.166,
     *    .192,.311,.438,.66,.969,1.289,1.537,1.717,1.889,
C   below for average of Sa+Sb and Sbc
C     *    0.0,.012,.023,.035,.046,.057,.070,.085,.104,.124,
C    *    .143,.231,.331,.513,.772,1.060,1.313,1.522,1.728,  
C    for Sbc
     *    0.0,0.005,0.011,.016,.021,.026,.032,.041,.051,.06,.069
     *    ,.11,.171,.292,.477,.717,.976,1.229,1.486,
C   for Sdm+Irr
     *    0.,-.008,-.016,-.022,-.024,-.026,-.029,-.029,-.028,
     *    -.029,-.043,-.121,-.097,-.029,.037,.15,.324,.514,.639/
C array of redshift
	DATA RS/0.0,.02,.04,.06,.08,.10,.12,.14,.16,.18
     *         ,.20,.30,.4,.5,.6,.7,.8,.9,1./ 
	ZZ(1)=Z
	ZZ(2)=ZREFK
	RKC(1)=0.
	RKC(2)=0.
	DO 150 M=1,2
	  IF(ZZ(1).GT.0.00) THEN
	  IF (IT.NE.0) THEN
C	  ! single morphology
	    IF(ZZ(M).LT.1.0) THEN
C	   !  use Sebok table
	      DO 30 I=1,19	
 30	        IF (ZZ(M).LE.RS(I)) GO TO 31
              IF (I.GE.19) GO TO 40  
 31	      RKC(M)=RK(I-1,IT)+(RK(I,IT)-RK(I-1,IT))*(ZZ(M)-RS(I-1))/
     *            (RS(I)-RS(I-1))
	    ELSE
C   K-cor for r = constant at z>1.8
 40	     IF (IT.LE.3) THEN 
	       ZZT=AMIN1(ZZ(M),1.8)
	     ELSE
	       ZZT=ZZ(M)
	     END IF
C	   ! use extrapolation
 	     RKC(M)=A(IT)*ZZT+B(IT)
 	    END IF
C---------------------------------------------------------------------
C   average K-cor weighted by CK
	  ELSE   
	    IF (ZZ(M).LT.1.0) THEN
	      DO 301 I=1,19	
 301	        IF (ZZ(M).LE.RS(I)) GO TO 311
 311	      IF (I.GT.19) GO TO 401
	      DO 100 IKC=1,4
 100	        RKC(M)=RKC(M)+CK(IKC)*
&			(RK(I-1,IKC)+(RK(I,IKC)-
&			RK(I-1,IKC))*(ZZ(M)-RS(I-1))/(RS(I)-RS(I-1)))
	    ELSE
 401	      CONTINUE
	      DO 101 IKC=1,4
	        IF (IKC.EQ.4) THEN
	          ZZT=ZZ(M)
	        ELSE
	          ZZT=AMIN1(ZZ(M),1.8)
	        END IF
C		! use extrapolation
 101	        RKC(M)=RKC(M)+CK(IKC)*A(IKC)*ZZT+B(IKC)
 	    END IF
	  END IF
	  END IF
 150	CONTINUE
	RKCOR=RKC(1)-RKC(2)
	IF (ZREFK.NE.0.) WRITE(6,*)' K-correction ',RKCOR,RKC(1),RKC(2)
	RETURN
	END
c//////////////////////////////////////////////////////////////////
c
c   SUBROUTINE to create galaxies for cluster
c
	SUBROUTINE MKCLUSTER(NGC,X,Y,SM,BD,AB,ROT,ARCSEC,ZCL,HN,QN,
     *                       XC,YC,SIGMAG,XQSO,YQSO,QSOMAG,DMORMAG,
     *                       NI,NJ,SCALE,NMAX,*)
	DIMENSION X(*),Y(*),SM(*),BD(*),AB(*),ROT(*),ARCSEC(*),RKC(4)
	CHARACTER FILNAM1*18,FILNAM1A*18,STR*80
	DATA RKC/0.,.5,.5,0./
 600	WRITE(6,20) FILNAM1
 20	FORMAT(' ...Cluster to be created from .cls file (from "gca")..'
     *        /'   Enter .cls filename (dflt: ',A18,'): ',$)
	call readstr(18,filnam1a,*998,*600)
	CALL  READFN(FILNAM1,FILNAM1A,FILNAM1,'cls','i',12,*998,*600,*601)
 601	WRITE(6,22) ZCL,EVM
 22	FORMAT('   Enter cluster z and E/S0 evolution in -mag [dflt:',
     *      F7.4,1X,F6.2,']: ',$)
	CALL READ2R(ZCL,EVM,*998,*601)
 602	WRITE(6,23) XC,YC
 23	FORMAT('   Enter central co-ord in pixel [dflt:',2F7.1,']: ',$)
	CALL READ2R(XC,YC,*998,*602)
	WRITE(6,24) 
 24	FORMAT('   If you want to put a quasar in the brightest galaxy,'/
     *         '     Enter its ABSOULTE MAG, else enter n: ',$)
	call read1r(qsomag,*998,*303)
	GO TO 304
 303	  WRITE(6,*) '   No quasar added...'
	  IQSO=0
	GO TO 305
 304	  IQSO=1
	  QSOMAG=APMAG(QSOMAG,ZCL,HN,QN)
	  WRITE(6,*) '   ...QSO apparent mag: ',QSOMAG
 305	NGC=0
	RNI=NI+.5
	RNJ=NJ+.5
	OPEN(UNIT=30,FILE=FILNAM1,STATUS='OLD',ERR=600)
C   read header
	SIGMAGAB=AMAX1(21.,SIGMAG-DMORMAG)
	READ(30,1) STR
	READ(30,1) STR
	READ(30,1) STR
 1	FORMAT(A80)
C  beginning of read DO While LOOP
 100	NGC=NGC+1
	  IF (NGC.LT.NMAX) THEN
 101	    READ(30,*,ERR=889,END=110) IDUM,X(NGC),Y(NGC),ABM,BD(NGC),
     *               AB(NGC),ROT(NGC)
C  check if galaxy is within CCD frame
	      X(NGC)=ANGDM(X(NGC)*1000.,ZCL,HN,QN)/SCALE+XC
	    IF (X(NGC).LE.0..OR.X(NGC).GE.RNI) GO TO 101
	      Y(NGC)=ANGDM(Y(NGC)*1000.,ZCL,HN,QN)/SCALE+YC
	    IF (Y(NGC).LE.0..OR.Y(NGC).GE.RNJ) GO TO 101
C check if mag is with in SIGMAG
	    IF (BD(NGC).GT.0.6) THEN
	        IT=1
	        EVMT=EVM
	    ELSE IF (BD(NGC).GT.0.3) THEN
	        IT=2
	        EVMT=.8*EVM
	    ELSE IF (BD(NGC).GT.0.10) THEN
	        IT=3
	        EVMT=.6*EVM
	    ELSE
	        IT=4
	        EVMT=0.
	    END IF
	    SM(NGC)=APMAG(ABM,ZCL,HN,QN)+RKCOR(ZCL,IT,CK,0.)-EVMT
C	  ! too faint for list
	    IF (SM(NGC).GT.SIGMAG) GO TO 101
C  galaxy meets all requirement, now get morphology parameters
	    IF (SM(NGC).GT.SIGMAGAB) THEN
	      AB(NGC)=1.
	      ROT(NGC)=0.
	    END IF
	    ARCSEC(NGC)=ANGDM(DIAMMET(BD(NGC),ABM),ZCL,HN,QN)
C  K-correct B/D ratio
	    IF (BD(NGC).LT..9.AND.BD(NGC).GT.0.001) THEN
	      RAT=10**(-.4*CK*(RKCOR(ZCL,0,RKC,0.)
     *                  -RKCOR(ZCL,1,RKC,0.)))
	      BD(NGC)=1./(((1./BD(NGC))-1.)*RAT+1.)
	    END IF
C   read the next object
	    GO TO 100
	  END IF
 110	NGC=NGC-1
C	! end of file
	CLOSE(UNIT=30)
C  put quasar in
	IF (IQSO.EQ.1) THEN
C  find obj nearest zero
	  RMAX=1000
	  DO 120 I=1,NGC
	    IF (SM(I).LT.RMAX) THEN
	      RMAX=SM(I)
	      IMAX=I
	    END IF
 120	  CONTINUE
	  XQSO=X(IMAX)
	  YQSO=Y(IMAX)
	END IF
	RETURN
 889	WRITE(6,*) '  **** READ ERROR IN .cls FILE ****'
 998	RETURN1
	END
C//////////////////////////////////////////////////////////////////
C
C  COSMOLOGICAL FUNCTIONS
C
C   
C ANGDM: converts metric diameter to angular size, input in KPC, output "
	FUNCTION ANGDM(DIAM,Z,HN,QN)
	ANGDM=DIAM*HN*206266*(1.+Z)/(299790000.*COSTERM(QN,Z))
	RETURN
	END
C
C RMDM: converts metric diameter to angular size, input in KPC, output "
	FUNCTION RMDM(ANGDM,Z,HN,QN)
	RMDM=ANGDM*299790000.*COSTERM(QN,Z)/(HN*206266*(1.+Z))
	RETURN
	END
C
C APMAG: convers absolute mag to apparent mag (NO K-correction)
	FUNCTION APMAG(ABM,Z,HN,QN)
	APMAG=25+ABM+5.*ALOG10(AMAX1(.00000001,
     *          299790.*COSTERM(QN,Z)*(1.+Z)/HN))
	RETURN
	END
C
C ABMAG:  converts apparent mag to absolute mag (NO K-correction)
	FUNCTION ABMAG(APM,Z,HN,QN)
	ABMAG=-25+APM-5.*ALOG10(AMAX1(.00000001,
     *          299790.*COSTERM(QN,Z)*(1.+Z)/HN))
	RETURN
	END
C
C/////////////////////////////////////////////////////////////
C
C  Subroutine to out/input a direct acess file of a frame in REAL*4
C
	SUBROUTINE IOBACKGR(FILENAM,NI,NJ,X,NU,NV,IPAR)
	DIMENSION X(NU,NV)
	CHARACTER*18 FILENAM,FILEN
	DO 100 I=1,15
	  IF (FILENAM(I:I).EQ.' ') GO TO 101
 100	CONTINUE
 101	FILEN=FILENAM(1:I-1)//'.tbk'
	IF (IPAR.EQ.0) THEN
C
C  write:
C
          OPEN(UNIT=20,FILE=FILEN,STATUS='NEW',ACCESS='DIRECT',
&		RECL=NI,ERR=9001)
 	  DO 265 J=1,NJ
 265	    WRITE (UNIT=20, REC=J) (X(I,J),I=1,NI)
	ELSE
C  read
          OPEN(UNIT=20,FILE=FILEN,STATUS='OLD',ACCESS='DIRECT',
&		RECL=NI,ERR=9001)
 	  DO 266 J=1,NJ
 266	    READ(UNIT=20, REC=J) (X(I,J),I=1,NI)
	END IF
	CLOSE(UNIT=20)
	RETURN
 9001	WRITE(6,*) '   ****ERROR IN OPENING BACKGROUND FILE ***'
	RETURN
	END
C
C//////////////////////////////////////////////////////////////////////
C
C  Subroutine to plot .SIM qauntities
C      IPAR=0  Object and ID number
C      IPAR=1  Object with magitude scale
C
C
	SUBROUTINE PLOTMAP(NOB,XX,YY,SM,IC,SIZEI,SIZEJ,IPAR,
     *        FILTYPE,*)
	CHARACTER STR*4,STR1*18,DEV*18,FILTYPE*4,splot*18,hplot*18
	common/plotdev/hplot,splot,ipinit
	DIMENSION XX(*),YY(*),SM(*),IC(*)
 600	WRITE(6,1) CUTOFF
 1	FORMAT('  Enter apparent mag cut-off [dflt:',F6.2,']: ',$)
	CALL READ1R(CUTOFF,*999,*600)
	DEV=splot
	RL=SIZEJ
	RR=0.
	YMINT=SIZEI
	YMAXT=0.
 770	call openpg(dev,ipinit,*999)
 790 	CALL PGENV(RL,RR,YMINT,YMAXT,1,0)
	UP=ABS(YMINT-YMAXT)*.017
	IF (IPAR.EQ.0) THEN
	  DO 100 I=1,NOB
	    IF (SM(I).LT.CUTOFF) THEN
	      IF (IC(I).GE.3) THEN
	        CALL PGPOINT(1,YY(I),XX(I),12)
	      ELSE IF (IC(I).EQ.1.OR.IC(I).EQ.2) THEN
	        CALL PGPOINT(1,YY(I),XX(I),11)
	      END IF
	      CALL PGTEXT(YY(I),XX(I)-UP,STR)
	    END IF
 100	  CONTINUE
	ELSE IF (IPAR.EQ.1) THEN
	  DO 101 I=1,NOB
	    IF (SM(I).LE.CUTOFF) THEN
	      IF (IC(I).EQ.2.OR.IC(I).EQ.1) THEN
	        IPOINT=45-SM(I)
	        IPOINT=MIN0(27,MAX0(20,IPOINT))
	        CALL PGPOINT(1,YY(I),XX(I),IPOINT)
	      ELSE IF (IC(I).GE.3) THEN
	        IPOINT=22-SM(I)
	        PSIZE=IPOINT
	        IF (PSIZE.LE.1.) PSIZE=1.
	        CALL PGSCH(PSIZE)
	        CALL PGPOINT(1,YY(I),XX(I),12)
	        CALL PGSCH(1.)
	      END IF
	    END IF
 101	  CONTINUE
C Magnitudet scale
	  DO 102 I=1,8
	    DX=I*10.-5.
 102	    CALL PGPOINT(1,SIZEJ-DX,10.,I+19)
	  IITMP=24
	  idum=encode(str,24.0,1,0,idum1)
C	  ENCODE(4,300,STR) 24
	  CALL PGTEXT(RL+15.,-5.,STR)
	  idum=encode(str,23.0,1,0,idum1)
C	  ENCODE(4,300,STR) 23
	  STR1=STR(1:lnblnk(str))//' mag scale'
	  CALL PGTEXT(RL,-5.,STR1)
	END IF
	CALL PGLABEL('Y/J','X/I',FILTYPE)
799	CALL ITACUR(RL,RR,YMINT,YMAXT,CX,CY,DEV,ipinit,IRET)
	IF (IRET.EQ.1) THEN
	    GO TO 790
	ELSE IF (IRET.EQ.2) THEN
	    call closepg(ipinit)
	    GO TO 790
	ELSE IF (IRET.EQ.-1) THEN
	    WRITE(6,*) CX,CY
	    GO TO 799
	ELSE IF (IRET.EQ.0) THEN
	    RETURN1
	ELSE IF (IRET.EQ.3.OR.IRET.EQ.4) THEN
	    GO TO 790
	ELSE IF (IRET.EQ.10) THEN
	    GO TO 790
	END IF
  999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C   CONVOLUTION OF TWO ARRAYS: NFR AND NFRK, STOR IN NFRR
C      BOTH ARE ODD, NFRK is square, AND RKERN IS SYMMETRIC ?
C
C//////////////////////////////////////////////////////////////////////
 	SUBROUTINE CONVOLVE(*,NFR,NFRK,NFRR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,1,*999)
	CALL QUERYNFR(NFRK,KF,2,*999)
	CALL QUERYNFR(NFRR,KF,4,*999)
C normalize
	  RNORM=0.
	  DO 110 J=1,NJJ(NFRK)
	    DO 110 I=1,NII(NFRK)
 110	      RNORM=RNORM+IX(I,J,NFRK)
	WRITE(6,*) 'Normalization ', RNORM
	  IF (ABS(RNORM).LT.0.00001) THEN
	    WRITE(6,*) ' **** Convolution kernel is a zero array ****'
	    RETURN
	  END IF
	NK2=NII(NFRK)/2
	DO 100 J=1,NJJ(NFR)
	  JK1=J-NK2-1  
	  J1=MAX0(J-NK2,1)
	  J2=MIN0(J+NK2,NJJ(NFR))
	  DO 100 I=1,NII(NFR)
	    IK1=I-NK2-1
	    I1=MAX0(I-NK2,1)
	    I2=MIN0(I+NK2,NII(NFR))
	    SUM=0.
	    DO 101 JJ=J1,J2
C  j co-ordinate of KERNEL
C   This is for symmetric kernel only, for proper general convolution,
C       should us JK2 and and change sign  ???? IS THIS TRUE?
C
C NORMALIZATION FOR THE EDGE IS NOT CORRECT!!
	      JK=JJ-JK1
	      DO 101 II=I1,I2
	        SUM=SUM+FLOAT(IX(II-IK1,JK,NFRK))*IX(II,JJ,NFR)
 101	    CONTINUE
 100	    IX(I,J,NFRR)=NINT(SUM/RNORM)
	NII(NFRR)=NII(NFR)
	NJJ(NFRR)=NJJ(NFR)
 999	RETURN1
	END
