C////////////////////////////////////////////////////////////////
C
c    driving routine to call Bob Abraham''s morphology parameter 
c           program
C
	SUBROUTINE morphdri(*,NFR,IX,NU,NV,KF)
c maximum objects
	parameter(nmax=10000)
c	INTEGER*2 IX(NU,NV,KF),ICL(nmax),NNG(200),
	INTEGER IX(NU,NV,KF),ICL(nmax),NNG(200),
     *    NMASK(500,500),NNEI(nmax),IDBR(nmax)
	real*8 pix(0:39999),x0,y0,cntrt,asymt,rsky,rskyrms,
     *          rmask(0:39999),areat,ctt,sbrt,rnsigma
	integer nx,ny,ids(nmax)
	DIMENSION  RMAG(nmax),cntr(nmax),asym(nmax),
     *    area(nmax),cts(nmax),sbr(nmax),
     *   SKY(nmax),ZSIG(nmax),err(nmax),rad(nmax),SKARAY(50000)
c    *     index(nfmax),distpsf(nfmax),xline(250),dlograd(29)
	CHARACTER*1 IANS,IANS2,secstr
	CHARACTER COMMENT*60,fdate*24,filout*20,filroot*18
     *        ,tempname*20,tempname2*20
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=6 FOR POSITION FILE'
	  RETURN1
	END IF
c  read object information from .phm file
	call mordaper(nfr,rad,rmag,err,sky,zsig,icl,ids,nmax,
     *       comment,filroot,*999)
	write(6,*) filroot
	filout=filroot(1:lnblnk(filroot))//'.mph'
	write(6,2) filout
 2	format('  ...Output file name: ',a20)
c search for date string on phm file comment
	do 161 i=1,60
	  if (comment(i:i).eq.':') goto 162
 161	continue
 162    comment=comment(1:i-14)//'(.phm file: '//comment(i-9:i-4)//
     *     comment(i+6:i+10)//') '
 601	WRITE(6,10) COMMENT
 10	FORMAT('   ENTER comment, <=60 characters: Default: '/,' (',
     *        A60,')'/' :',$)
	CALL READSTRD(60,COMMENT,*999,*601)
	if (nsct(nfr).ne.0) then
	  istatus=encode(secstr,float(nsct(nfr)),1,0,dum)
	  filout=filout(1:lnblnk(filout))//'.'//secstr
	end if
c backup sky from circle, from 3 positions 
	iap2=45
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	NI=NII(nfr)
 	NJ=NJJ(nfr)
        I1=NI/3
        J1=NJ/3
        CALL RCSKY(1,BKG1,BSIG1,1,I1,J1,NI,NJ,IX(1,1,nfr),NU,NV,SKARAY,
     *           50000,nsky,0,IPR)
        I1=2*NI/3
        CALL RCSKY(1,BKG,BSIG,1,I1,J1,NI,NJ,IX(1,1,nfr),NU,NV,SKARAY,
     *             50000,nsky,0,IPR)
        J1=2*NJ/3
        CALL RCSKY(1,BKG2,BSIG2,1,I1,J1,NI,NJ,IX(1,1,nfr),NU,NV,SKARAY,
     *             50000,nsky,0,IPR)
c  backup is the middle one
        if (bkg.gt.bkg1.and.bkg2.gt.bkg1) then
          if (bkg.gt.bkg2) then
            bkg1=bkg2
          else
            bkg1=bkg
          end if
        else if (bkg.lt.bkg1.and.bkg2.lt.bkg1) then
          if (bkg.gt.bkg2) then
            bkg1=bkg
          else
            bkg1=bkg2
          end if
        end if
	bsig=0.3333*(bsig+bsig1+bsig2)
        WRITE(6,*) '  Back-up sky value: ',BKG,bsig
c multiply by .5 for testing
	bkg=bkg*.5
	if (cplx.le.1.001) then
	  s_nlim=25.0
	else
	  s_nlim=cplx
	end if
c sigma cut for mask (created in morph) fixed at .6 for now.
	if (rnsigma.lt.0.00001) rns=1.0
 610	write(6,22) rns
 22	format('  Enter rnsigma [',f10.4,']: ',$)
	call read1r(rns,*999,*610)
	rnsigma=rns
	do 100 i=1,nob(nfr)
C  check for neighbours
c	  CALL NNEIGH(NNEI(I),NNG,II,JJ,NOBB,IJOI(1,NFR),IJOJ(1,NFR),
c    *          I,IRMAX,IRMAXSQ)
c105	  WRITE(6,12) I,NNEI(I)
 12	FORMAT(/' Object #',I4,'  Number of neighbours:',I3)
c
	if (i.eq.-ipgdate) goto 100
	  iob=ijoi(i,nfr)
	  job=ijoj(i,nfr)
c default non-values for the parameters
	  cntr(i)=-99.
	  asym(i)=-99.
c	 write(6,*) i,iob,job,rmag(i)
c  check if object has sufficient S/N (temp set at 25) or saturated
	  if (err(i).lt.s_nlim.or.icl(i).ge.4) goto 100
c        any objects with center less than rad from edge are not  done
	  if (float(iob).lt.rad(i).or.float(iob).gt.float(ni)-rad(i))
     *       goto 100
	  if (float(job).lt.rad(i).or.float(job).gt.float(nj)-rad(i))
     *       goto 100
c  object accepted
C  cut out object and place in input array pix
c    the size of the array is 3*radius, with a min of 31 pix.
c
c    Need to deal with objects at edges:
	  nx=min(2*(iob-1),max(51,nint(3.*rad(i))))
	  nx=min(nx,2*(ni-iob))
	  ny=min(nx,2*(job-1))
	  ny=min(ny,2*(nj-job))
c  need to figure out what x0 and y0 are exactly in pppmorph
	  x0=nx/2
	  y0=ny/2
	  rsky=sky(i)
          rskyrms=zsig(i)	
	  ITT=IOB-nx/2
	  JTT=JOB-ny/2
	  DO 103 jm=0,ny
	    jk=jtt+jm
	    DO 104 im=0,nx
	      npx=jm*nx+im
 	      pix(npx)=IX(itt+im,jk,NFR)
c temporary filling of the mask
	      radiusq=(im-x0)**2+(jm-y0)**2
	      if (radiusq.lt.rad(i)*rad(i)) then
	        rmask(npx)=1.
	      else
	        rmask(npx)=0.
	      end if
 104	    continue
 103	  continue
 	    WRITE(6,24) I,iob,job,rmag(i),3*rad(i),nx,ny,x0,y0,
     *             rsky,rskyrms 
 24	FORMAT(' #',i5,1x,2i6,f8.3,f7.1,2i4,1x,2f5.1,2f10.2)
c output files for Bob''s debugging
c	if (ipgdate.eq.1) then
c	write(6,383) 
c 383	format('  Save? y/n :',$)
c	read(5,'(a1)',end=999) ians
c	if (ians.eq.'y') then
c	tempname='stamp.dat'
c	tempname2='mask.dat'
c	call opennew(38,1,20,tempname,*999)
c	call opennew(39,1,20,tempname2,*999)
c	write(38,*) nx,ny,x0,y0,rsky,rskyrms,rnsigma
c	do 390 k=1,npx
c	  write(38,'(f10.1)') pix(k)
c	  write(39,'(f10.1)') rmask(k)
c 390	continue
c	close(unit=38)
c	close(unit=39)
c	end if
c	end if
	if (ipgdate.eq.i) then
	  do 300 jj=1,ny
	    do 301 ii=1,nx
	      kk=(ii-1)+(jj-1)*nx
	      ix(ii,jj,2)=rmask(kk)
	      ix(ii,jj,1)=pix(kk)
 301	    continue
 300	  continue
	  nii(1)=nx
	  njj(1)=ny	  
	  nii(2)=nx
	  njj(2)=ny	  
	  nfl(6,1)=1
	  nfl(6,2)=1
	  return1
	end if
c call morph subroutine
c	write(6,20) (pix(n), n=nint(x0)-2,nint(x0)+2)
c20	format(5f6.0)
c  this is removed so that it can compile without morphology.o
c	    call pppmorph(pix,rmask,nx,ny,x0,y0,rsky,rskyrms,
c    *         rnsigma,areat,ctt,cntrt,asymt,sbrt)
	    cntr(i)=cntrt
	    asym(i)=asymt
	    area(i)=areat
	    cts(i)=ctt
	    sbr(i)=sbrt
	    write(6,23) cntr(i),asym(i),sbr(i),cts(i),area(i)
 23     format(   ' cntr,asym,sb,cts,area',f9.2,f7.2,1x,3f10.3)
 100	CONTINUE
c
C  output results
C
C
	call opennew(28,1,20,filout,*999)
c   header
	comment=COMMENT(1:lnblnk(comment))//':: '//fdate()//':morp'
 	WRITE(28,'(1x,a60)') comment 
c write section information
        write(28,8)  nsecpos(nfr),isecpos1(nfr),
     *      jsecpos1(nfr),isecpos2(nfr),jsecpos2(nfr),nedgepos(nfr)
 8      format('#secinfo',i2,10x,4I6,9x,i4)
c  determine world co-ordinate of defined area
        if (nsecpos(nfr).gt.0) then
	  call worldpos(nfr,nsecpos(nfr),ip1,jp1,ip2,jp2)
        else
          ip1=ilpos(nfr)
          jp1=jlpos(nfr)
          ip2=iupos(nfr)
          jp2=jupos(nfr)
        end if
        write(28,9) ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr)
     *             ,ip1,jp1,ip2,jp2
 9      format('#posinfo',4i6,5x,4i6)
	write(28,25)
 25	FORMAT(' ppp#     I     J     mag  PCl rad(pix)   cntr   +/- ',
     *               '     asymm   +/-')
	DO 102 I=1,NOB(NFR)
 	  WRITE(28,26) I,ijoi(i,nfr),ijoj(i,nfr),rmag(i),icl(i),rad(i)
     *            ,cntr(i),asym(i),sbr(i)
 26	format(i5,2i6,f9.3,i3,f6.0,3(f9.4,'  0.0000'))
 102	continue
 	CLOSE(UNIT=28)
 999	RETURN1
	END
c////////////////////////////////////////////////////////////////
c  subroutine to read aperture information for morphology 
c
c
	subroutine mordaper(nfr,rad,rmag,err,sky,zsig,icl,ids,
     *        nmax,comstr,filroot,*)
c	INTEGER*2 icl(1)
	INTEGER icl(*)
	dimension rad(*),rmag(*),err(*),ids(*),sky(*),zsig(*)
	character phmname*20,nfrstr*3,refstr*4
     *      ,comstr*60,secstr*1,filroot*18
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
c request .phm file and read position and compute diameter
 600	write(6,20)
 20	format('  Enter .phm name (++posfil array will',
     *         ' be over-written++): ',$)
	read(5,'(a20)',end=999) phmname
c add .phm if it does not end in ".B"
	if (phmname(lnblnk(phmname)-1:lnblnk(phmname)).ne.'.B') 
     *     phmname=phmname(1:lnblnk(phmname))//'.phm'
c add section number if needed
	if (nsct(nfr).gt.0) then
	  istatus=encode(secstr,float(nsct(nfr)),1,0,dum)
          phmname=phmname(1:lnblnk(phmname))//'.'//secstr
	end if
	do 160 i=1,20
	  if (phmname(i:i).eq.'.') goto 161
 160	continue
 161	filroot=phmname(1:i-1)
	open(unit=34,file=phmname,status='old',err=601)
	go to 150
 601	  write(6,1) phmname
 1	format('  +++ ',a20,' does not exist ++++')
	  go to 600
 150    call readrad2(34,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),
     *     ids,rad,rmag,err,icl,sky,zsig,comstr,nmax,icflag)
	close(unit=34)
	return
 999	return1
	end
c///////////////////////////////////////////
c  subroutine to read .phm file
c     ipar=1: normal read, rad() is the radius in pixels
c     ipar=0: rad() is used to store scaled magnitude values
c                     for plot size
c
	subroutine readrad2(idev,nob,ii,jj,ids,rad,rmag,err,icl,
     *            sky,zsig,comment,nmax,icflag)
	character teststr*2,teststr2*3,comment*60,string*80
c	integer*2 ii(1),jj(1),icl(1),iref(100)
	integer ii(*),jj(*),icl(*),iref(100)
	dimension ids(*),rad(*),rmag(*),err(*),sky(*),zsig(*)
c   read first line, including ref star numbers
	read(idev,1) comment,(iref(k),k=1,7)
 1	format(a60,8x,7i4)
	nref=0
	do 130 k=1,7
	  if (iref(k).le.0) goto 131
	  nref=nref+1
 130	continue
c read aperture info
 131	READ(idev,9,ERR=998) IAP1,IAP2,ideld,SIZ1,SIZ2
 9	FORMAT(27X,I2,13X,I3,1x,i1,7X,F4.0,1X,F4.0)
 	if (ideld.eq.0)  then
	  write(6,*) ' ++ ideld=0, ideld from ppparm.dat used ++ '
	  ideld=ideldt
	end if
        NAP=(IAP2-IAP1)/ideld+1
	nline=(nap-1)/10+1
c determine how many lines there are in the growth curve
	write(6,10) IAP1,IAP2,ideld, NAP,nline
 10	format(' 1st aper ',i3,'; last aper ',i3,', deld:',i2,
     *     '; max aperture number:',i3, ' #line:',i2)
c read additional reference stars if there are any
 199    read(idev,'(1x,3a)',end=998) teststr2
        backspace idev
        if (teststr2.eq.'Ref') then
	  k1=nref+1
	  read(idev,2,err=199) iref(8)
 2	format(36x,i5)
	  go to 199
        end if
c read section info
	do 200 i=1,5
	  read(idev,'(a80)') string
	  if (string(1:1).eq.'#') then
c	     write(6,'(a10)') string(1:10)
c  it is an additional header line
c    *** need to read the section info
	  else
            backspace idev
	    goto 201
	  end if
 200	continue
 201	continue 
c read data, need I and J, and ids
	do 100 i=1,nmax  
          READ(idev,11,END=999,ERR=981) RI,RJ,rmag(i),err(i),
     *            sky(i),zsig(i),icl(i) 
 11     FORMAT(5X,2(F6.2,1X),7x,f7.2,7x,f7.2,29x,f10.3,f8.3,9x,6x,i2)
	  ii(i)=nint(ri)
	  jj(i)=nint(rj)
c  check if it is a long format growth curve
	  if (icflag.eq.0) then
            READ(idev,12,END=999,ERR=982) ids(i)
 12	FORMAT(23X,83x,I2)
	  else
	    read(idev,112,end=999,err=982) ids(i)
 112	format(23x,93x,i2)
	  end if
c check if it is a big galaxy
	  read(idev,13,end=999,err=983) teststr,idum
 13	format(10x,a2,1x,i3)
 	  if (teststr.eq.'BG') then
c  read aperture number
 	    rad(i)=idum*.5
 	  else
c compute size (radius)
	    rad(i)=(iap1+ideld*(ids(i)-1))*.5
 	  end if
c  read one more line
          if (nline.eq.3) read(idev,'(1x)',end=999)
	  goto 100
 981	write(6,*) '  ** read error headerline, obj#',i,' obj skipped'
          read(idev,'(1x)',end=999)
          read(idev,'(1x)',end=999)
          if (nline.eq.3) read(idev,'(1x)',end=999)
	  goto 100
 982	write(6,*) '  ** read error ids, obj#',i,' obj skipped'
          read(idev,'(1x)',end=999)
          if (nline.eq.3) read(idev,'(1x)',end=999)
	  goto 100
 983	write(6,*) '  ** read error BG, obj#',i,' obj skipped'
          if (nline.eq.3) read(idev,'(1x)',end=999)
 100	continue
c..................................................
 999	nob=i-1
	write(6,*) '  ... total number of objs read: ',nob
	return
 998	write(6,*) ' ** .phm file read error, reading aborted at obj'
     *      ,i
	nob=i-1
	return
	end
