c     // Replace old diskio subroutines with cfitsio -- allow MEFs //
c
c     **** can read compressed MEFs 
c       (e.g. 616209o.fits.Z, use: rdis 1 616209o[1] )
c     basic routine seems to work, but:
c     check for **precision**, transposition of arrays, etc.
c     [propagation of header needs more careful thought, see comments]
c
c       ** RDFILND doesn't seem to pass the suffix. So, convention will be:
c       ** out --> out.fits
c       ** out.fits.gz --> out.fits.gz
c       ** NB. out.fits --> out.fits.fits!
c     ****
c
c
c     wdkfits
c     rdkfits
c     fitsin
c     makefhd
c     wrpic
c     rdpic
c     rdirfil
c     headout
c     whead

	SUBROUTINE wdkfits(*,NFR,FILENC,IREP,IX,NU,NV,KF,IR)
	INTEGER IX(NU,NV,KF),NFLAG,NID,NJD
        integer status,nkeys,nspace,lun,out,rmode,wmode,bitpix
	integer firstpix,naxis,naxes(2),timeref,len,izf
        logical extend,simple
	CHARACTER*24 NFILEN,FILEN
	CHARACTER*24 FILENC,FILENF,fitsname*24,filenh,objnam*18
	CHARACTER*36 NCOM,NCOMC,imdir*55
	character datestr*22
	character headblk*2880,hdr(36)*80,size*20,fdate*24,nyes*1
     *            ,itest1*3,blank*20,tmphdr*80,errmsg*80
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	common/imagedir/imdir
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254)
	common/header/headblk
	equivalence (headblk(1:1),hdr(1)(1:1))


	CALL QUERYNFR(NFR,KF,0,*900,*20001)
C decode filename
20001	IR=0
	blank='                   '
	IF (FILENC.EQ.' ') WRITE(6,1)
	CALL RDFILND(FILENC,NC,IPF)
c	print *,'checking for compressed output name...'
	call zipcheck(filenc,nc,izf)
c	print *,'izf=',izf
	if (izf.ge.2) then
	   ! zipped file requested, make sure it's a fits
	   IPF=1
	endif
	IF (IPF.LE.-1) THEN
C  name too long or aborted
	  IR=-1
	  RETURN1
	END IF              
C  get name for checking with directory
	FILEN=FILENC(1:NC)
C  get name for OPEN statement
	IF (IPF.EQ.0) THEN
C  no qualifier, append 
	  if (mod(irep,2).eq.1) then
	    FILENF=FILENC(1:NC)//'.pic'
	    filenh=filenc(1:nc)//'.fhd'
	  else
	    FILENF=FILENC(1:NC)//'.fits'
	  end if
	ELSE
c	   print *,'qualifier exists'
C	  qualifier exists
	  FILENF=FILENC
	  if (izf.eq.2) then
	     stop '**** .Z compression not supported ****'
	     filenf=filenc//'.fits.Z'
	     nc=nc+7
	  endif
	  if (izf.eq.3) then
	     filenf=filenc//'.fits.gz'
	     nc=nc+8
	     print *,filenf
	  endif
	END IF
C
 1	FORMAT('  Enter output .fits file name for image: ',$)
C
C  Write into disk directory from disk, first check for duplicate
C 
C	  over write, dir taken care by calling prog
	select case (irep)
	     case (4,5)
		goto 71 !yuk
	     case (0,1) 
 79		CALL DIREC(FILEN,FILENF,NFR,IP,2,IDF)
	     case (2,3,6,7)
		CALL DIREC(FILEN,FILENF,NFR,IP,3,IDF)
		IP=0
	     end select

c	IF (IREP.eq.4.or.irep.eq.5) GO TO 71
c 79	IF (IREP.EQ.0.or.irep.eq.1) CALL DIREC(FILEN,FILENF,NFR,IP,2,IDF)
c	IF (IREP.EQ.2.or.irep.eq.3.or.irep.eq.6.or.irep.eq.7) THEN 
c	  CALL DIREC(FILEN,FILENF,NFR,IP,3,IDF)
c	  IP=0
c	END IF
C a duplicate name is found in DIR  
	IF (IP.EQ.1) THEN   
 600	  WRITE(6,2) FILEN
 2	FORMAT(' --- ',A9,' --- ALREADY EXIST, DO YOU WANT TO'
     *         ,' DELETE? (y/n): ',$)
	  call readstr(1,nyes,*900,*600)
	  IF (NYES.EQ.'y') THEN
C	      delete original
 	    CALL DIREC(FILEN,FILENF,NFR,IP,0,IDF)
	    GO TO 79
	  ELSE
	    WRITE(6,*) ' ...NO FILE WRITTEN.'
	    RETURN1
	  END IF
C   directory full
	ELSE  IF (IP.EQ.2) THEN
	  WRITE(6,*) ' *** NO FILE WRITTEN *** '
	  IR=-1
	  RETURN1
	ELSE IF (IP.EQ.-1) THEN
	  RETURN1
	END IF
C
C  start write:
C
 71	NI=NII(NFR)
	NJ=NJJ(NFR)

	rmode=0
	wmode=1 ! rwmode

	status=0
	call ftgiou(out,status)

c  writing fits
	bitpix=16

c       -- I've only made sure this works for irep=0, so far
c       -- don't know how often the other options are used
cc	print *,'irep = ',irep
	select case (irep) 
	    case (0,2) ! create new fits file
	       call ftinit(out,imdir(1:lnblnk(imdir))//filenf,1,status)
	       call printerror(status)
	       print *,'created new file ',imdir(1:lnblnk(imdir))//filenf
	    case (4) ! overwrite existing fits file
	       call ftnopn(out,imdir(1:lnblnk(imdir))//filenf,wmode,status)
	    case (1,3,7) ! create new .pic file
	       print *,'need to open new .pic file'
	    case (5)
	       print *,'need to open new .pic file'
	    case (6) 
	       call ftinit(out,imdir(1:lnblnk(imdir))//filenf,1,status)
	       call printerror(status)
	       print *,' call ftcopy (and write to HEADBLK?)'
	end select
	call printerror(status)

	! bail if trying to open a file which already exists
	if(status.ne.0) stop 

c       ---- write FITS header to new file
c	print *,'need to read header here 2 !'
	call ftgiou(lun,status)
        call ftnopn(lun,imdir(1:lnblnk(imdir))//fitsname(nfr),0,
	1    status)
 	call printerror(status)
	if (status .eq. 0) then ! file exists, assume it has header!
	   call ftghsp(lun,nkeys,nspace,status)
	   call printerror(status)
c	   print *,'nkeys = ',nkeys

C       Read each 80-character keyword record, and print it out.
	   if(nkeys .gt. 36) then 
	      print *,'header longer than one block:'
	      print *,'only copied first 36 lines of ',nkeys,' to HEADBLK'
	   endif
c	   print *,lun,out
	   len=min(nkeys,36)
	   do i = 1, min(nkeys,36)
	      hdr(len-1)='END'
	      hdr(len)=''
	      if (i .lt. 35) call ftgrec(lun,i,hdr(i),status)
	      do j=1,80
		 k=(i-1)*80+j
		 tmphdr=hdr(i)
		 headblk(k:k)=tmphdr(j:j)
	      enddo
c       print *,hdr(i)
	   enddo
c       Now, copy full header to output image, careful of NAXISn keywords if size changed
c       Open output file
				! ****
c       initialise (write required words like bitpix and NAXISn)
	   naxis=2
	   naxes(1)=ni
	   naxes(2)=nj
c	   print *,simple,bitpix,naxis,naxes,0,1,extend,status
	   call ftphpr(out,simple,bitpix,naxis,naxes,0,1,extend,status)

c       change OBJECT field, make sure bscale and bzero are 1 and 0, and
c       add a header card with the new time and ppp history

	   i=6
	   call printerror(status)
	   do i=6,nkeys
	      call ftgrec(lun,i,tmphdr,status)
c	      print *,tmphdr
ccc	      print *,i
	      call printerror(status)
	      call ftirec(out,i,tmphdr,status)
	   enddo
	   call ftgstm(datestr,timeref,status)
c	   print *,datestr,timeref
	   call ftirec(out,i+1,'HISTORY = Saved from PPP: '//datestr,status)
c	   call ftirec(out,i+1,'END',status) !**** do i need to write END, manually????
c	   call ftirec(out,i+2,'',status)
c	   print *,'written header'
	   call printerror(status)

	   nbuffer=ni
	   do j=1,nj
	      call ftpprj(out,1,firstpix,nbuffer,ix(1,j,nfr),status,ni,j)
	      firstpix=firstpix+ni
	   enddo

c       call fitsdataout(out,ihb,ix(1,1,nfr),nu,nv,
c       *                    nii(nfr),njj(nfr),ibyte)
	   fitsname(nfr)=filenf
	else
	   write(6,*) '  *** .pic files no longer supported ***'
	end if
	CLOSE(UNIT=20)
c 	WRITE(6,27) FILENF,ihb,NFR
c 27	FORMAT ('  .fits file: ',A18,i4,' blks written to disk from <f>'
c     *         ,I3)

	call ftclos(out,status)
	call ftclos(lun,status)
	call ftfiou(out,status)
	call ftfiou(lun,status)
	print *,'written ',filenf
c	print *,'closed files!'

	  RETURN1
 9001	WRITE(6,*) '  ****ILLEGAL FILE NAME***'
	close(unit=20)
	IR=-1
 900	RETURN1
	END

c//////////////////////////////////////////////////
c
c  subroutine to write out fits data (data only)
c
	subroutine fitsdataout(idev,nblk,ix,nu,nv,ni,nj,ibyte)
c	integer*2 ix(nu,nv),ixt(1440)
	integer ix(nu,nv)
	integer*2 ixt(1440)
	i=1
	j=1
 201	nblk=nblk+1
	do 202 k=1,1440
	  if (i.gt.ni) then
c  go to next line
	    j=j+1
	    if (j.gt.nj) then
c  pad with zeros
	      do 203, l=k,1440
	        ixt(l)=0
 203	      continue
	      if (ibyte.eq.1) call byte_swap(ixt,2880)
	      write(idev,rec=nblk) ixt
	      return
	    end if
	    i=1
	  end if
	  ixt(k)=ix(i,j)
	  i=i+1
 202	continue
	if (ibyte.eq.1) call byte_swap(ixt,2880)
	write(idev,rec=nblk) ixt
	go to 201
	end
c/////////////////////////////////////////////////////////////////////
c
c  Subroutine to read data from disk either .pic or .fits file
c    if it is a .pic file, a .fhd (fits header file) is assumed to 
c    accompany the data
c
C///////////////////////////////////////////////////////////////////////
C   DISK I-O ROUTINE
C        IREP=1 READ FROM DISK
C        IREP=3 READ FROM DISK WITH NAME SUPPLIED FROM
C               THE DIRECTORY DIRECTLY
c
c        return IR=-1 read not successful
c               IR= 4 picture is in fits format
c               IR= 5 picture is in .pic format
c                       (the last 2 output is for MFO operations)
C
C///////////////////////////////////////////////////////////////////////
	SUBROUTINE rdkfits(*,NFR,FILENC,IREP,IX,NU,NV,KF,IR)
	INTEGER IX(NU,NV,KF),NFLAG,NID,NJD
        integer lun,status,naxes(2),nfound,nbuffer,group,firstpix
        integer bitpix,pcount,gcount,nkeys,nspace,extn,rmode,wmode
        character*4 cextn
	CHARACTER*24 NFILEN,FILEN
	CHARACTER FILENC*24,FILENF*24,filenh*18,fitsname*24
	character headblk*2880,hdr(36)*80,tmphdr*80
	CHARACTER*36 NCOM,NCOMC,objnam,imdir*55
        character*30 errmsg
	logical ex,anynull,simple,extend
	INCLUDE 'picdir.inc'
	INCLUDE 'mosaic.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	common/imagedir/imdir
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254)
	common/header/headblk
	include 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
C decode filename
20001	IR=0
	IF (FILENC.EQ.' ') WRITE(6,10)
 10	FORMAT('  Enter NAME of file to be READ: ',$)
c	CALL RDFILN(FILENC,NC,IPF)
	CALL RDFILND(FILENC,NC,IPF)
C  name too long or aborted
	IF (IPF.LE.-1) go to 991
C  get name for checking with directory
	FILEN=FILENC(1:NC)
	IF (IPF.EQ.0) THEN
C	get name for OPEN statement

c     -- check for [??] extension
c           print *,'NC1 ',NC
cc           print *,filen
           do i=1,24
              if( filen(i:i) .eq. '[') then
c                 print *,'here'
                 do j=i+1,min(24,i+3)
                    if ( filen(j:j) .eq. ']') then
                       NC = i-1
                       cextn=filen(i:j)
                    endif
                 enddo
              endif
           enddo
c           print *,'NC2 ',NC
cc           print *, 'MEF extension requested ',cextn
           if (cextn(1:1) .eq. '[') then
              ! strip extension first
              filenf=FILENC(1:NC)//'.fits'//cextn
           else
C  no qualifier, append .fits
              FILENF=FILENC(1:NC)//'.fits'
           endif
	ELSE                           
C  qualifier exits
	  FILENF=FILENC
	END IF
C
C  first check for name in directory, IP=0 if not exist
C
 	CALL DIREC(FILEN,FILENF,NFR,IP,1,IDF)

C
C  File name does not exit in pppdir; 
	IF (IP.EQ.0) then
	  WRITE(6,301) FILENF
 301	FORMAT(' ++ ',A20,' ++ does not exist in ppp DIRECTORY'
     *        /'    attempting to locate unlisted .fits file....')
	else
c           WRITE(6,22) FILEN,ncom(idf),nid(idf),njd(idf)
	end if
C     **** READ IN FITS FILE
C     file=imdir(1:lnblnk(imdir))//filenf

	rmode=0
	wmode=1
        status=0
 3011   call ftgiou(lun,status)

c        print *,'here1',status
        call ftnopn(lun,imdir(1:lnblnk(imdir))//
     *       filenf(1:lnblnk(filenf)),rmode, status)
c        call ftnopn(lun,'tmp.fits',rmode, status)
c        call ftgerr(status,errmsg)
c        print *,errmsg
c        print *,'status1 ',status
c        print *,'here2'

c     ---
c     -- read header 
c     (**** header doesn't seem to be written for .gzipped file - this
c     is cuz it's still using Howard's routine to check for the header's 
c        existence - need to be careful as the headblk common-block
c     is used in many subroutines)
             pcount=0           ! this stuff req'd for MEFs?
             gcount=1
             extend=.true.
c     call ftphpr(lun,simple,bitpix,naxis,naxes,pcount,gcount,extend,
c     *            status)

C     The FTGHSP subroutine returns the number of existing keywords in the
C     current header data unit (CHDU), not counting the required END keyword,
             call ftghsp(lun,nkeys,nspace,status)
cc             print *,';;;;;;;;; ',status
cc             print *,'nkeys = ',nkeys
C     Read each 80-character keyword record, and print it out.
             if(nkeys .gt. 36) then 
                print *,'header truncated:'
                print *,'only taken first 36 lines of ',nkeys,'!!!!'
             endif
             do i = 1, min(nkeys,36)
                hdr(35)='END'
                hdr(36)=''
                if (i .lt. 35) call ftgrec(lun,i,hdr(i),status)
                do j=1,80
                   k=(i-1)*80+j
                   tmphdr=hdr(i)
                   headblk(k:k)=tmphdr(j:j)
                enddo
cc                print *,hdr(i)
             enddo

c             print *,'headblk',headblk
c     ---

c     -- determine the size of the image
c     **** need to go to correct extension
c                   unit,keyroot,startno,maxkeys,>keyvals,nfound,status
           call ftgknj(lun,'NAXIS',1,2,naxes,nfound,status)
           print *,'status ',status
c     -- check that it found both NAXIS1 and NAXIS2 keywords
           if (nfound .ne. 2)then
              print *,'READIMAGE failed to read the NAXISn keywords.'
              stop
           end if


        print *, naxes
        NI=naxes(1)
        NJ=naxes(2)

c     ---- Read FITS file (may be compressed) using CFITSIO routines
        nbuffer=min(nu*nv,NI*NJ)
        group=1
        firstpix=1

c     -- need implied do loop as ix buffer is 3D and ftgpve expects 2D
c          this is probably quite a slow-down!
c     **** check exact details of this loop on non-square image
        nbuffer=ni
        do j=1,nj
           call ftgpvj(lun,group,firstpix,nbuffer,nullval,
     *          ix(1,j,nfr),anynull,status,ni,j)
           firstpix=firstpix+ni
        enddo
c     -- close file and free lun
	call ftclos(lun, status)
	call ftfiou(lun, status)

	iftype=0
	if (ip.eq.0) WRITE(6,22) FILEN,objnam,NI,NJ
	fitsname(nfr)=filenf
	IR=4
	go to 305
 302	close(unit=20)
 22	FORMAT(1X,A18,' : ''',A35,''' size: ',I4,' X ',I4)
c     ........................ done reading FITS file



c  reading finished, now tidy up the ppp and core directory
c
 305	NII(NFR)=NI
	NJJ(NFR)=NJ
C 1) file exists in ppp directory
 	if (ip.ne.0) then
C       change core directory
	  NF(NFR)=IDF
	  NCOMC(NFR)=NCOM(IDF)
	  DO 233 K=1,5
 233	    NFL(K,NFR)=NFLAG(K,IDF)
	  if (ipppfile.le.1) then
	    nfl(6,nfr)=0
	  else
	    nfl(6,nfr)=1
	  end if
          WRITE(6,270) FILENF,NFR
  270 FORMAT ('  Image ',A18,' read from DISK into FRAME',I3)
	  if (iftype.eq.4) then
c  create a .fhd file
	    objnam=ncom(idf)
	    call makefhd(ni,nj,objnam)
	    write(6,85) filenh
	    open(unit=21,file=imdir(1:lnblnk(imdir))//filenh,
     *         access='direct',recl=2880,status='new',err=979)
	    write(21,rec=1) headblk
	    close(unit=21)
	  end if
 85	format(3x,a18,' file created for .pic file...')
 	  RETURN1
	else 	
C 2) file does not exist in directory -- up date ppp directory
C
	  DO 230 M=1,5
 230	    NFL(M,NFR)=0
c a)  it was a fits or a .pic file with a header 
	  if (iftype.le.2) then
	    call direc(filen,filenf,nfr,ip,4,idf)
c add header to ncom
	    ncom(nof)=objnam
	  else if (iftype.eq.3) then
	    CALL DIREC(FILEN,FILENF,NFR,IP,2,IDF)
c  create a header file for the .pic picture
	    call makefhd(ni,nj,objnam)
	    fitsname(nfr)=filen(1:lnblnk(filen))//'.fhd'
	    open(unit=21,file=imdir(1:lnblnk(imdir))//fitsname(nfr),
     *         access='direct',recl=2880,status='new',err=979)
	    write(21,rec=1) headblk
	    close(unit=21)
	    write(6,85) fitsname(nfr) 
	  end if
	  IF (IP.EQ.2) THEN
	    NF(NFR)=0 
   	    WRITE(6,*) ' **** NO NEW DIRECTORY ENTRY IS MADE ****'
	  ELSE	     
	    NF(NFR)=NOF
	    WRITE(6,*) ' ...NEW ENTRY to ppp DIRECTORY has been made'
	  END IF
	  return1
	END IF
 997	WRITE(6,19) NFILENF
 19	FORMAT(' **** OPEN ERROR ****',A18,' NO such file, or incrorre'
     *    ,'ct SIZE')
	IR=-1
	RETURN1 
c
c  ***error messages***
 991	WRITE(6,*) '  ****ILLEGAL FILE NAME***'
	IR=-1
	RETURN1
 996	WRITE(6,18) NI,NJ
 18	FORMAT(1X,' ***** PICTURE SIZE: ',I4,' X',I4,' TOO LARGE FOR',
     *         ' CURRENT CONFIGURATION***')
	return1
 995	write(6,*) '  **** error in .fhd file ****'
	return1
 979	write(6,*) '  ** error in creating .fdh file, already exist **'
	return1
 998	write(6,*) '   +++ image not read +++'
 999	RETURN1
	END


c
c//////////////////////////////////////////////////////////////
c
c  subroutine to make a simple .fits header, returning 1 2880 byte
c     block
	subroutine makefhd(ni,nj,objnam)
	character objnam*35,fdate*24,headblk*2880,hdr(36)*80,size*5
     *            ,blank*20
	common/header/headblk
	equivalence (headblk(1:1),hdr(1)(1:1))
	blank='                    '
	hdr(1)='SIMPLE  =                    T  /  FITS STANDARD'
	hdr(2)='BITPIX  =                   16  /  FITS BITS/PIXEL'
	hdr(3)='NAXIS   =                    2  /  NUMBER OF AXES'
	istatus=encode(size,float(ni),1,0,idum)
	hdr(4)='NAXIS1  ='//BLANK(1:21-lnblnk(size))//size(1:
     *         lnblnk(size))//'  /'
	istatus=encode(size,float(nj),1,0,idum)
	hdr(5)='NAXIS2  ='//BLANK(1:21-lnblnk(size))//size(1:
     *         lnblnk(size))//'  /'
	hdr(6)='BSCALE  =       1.0000000000E0  /  PIX= FITS*BS + BZ'
	hdr(7)='BZERO   =       0.0000000000E0  /  PIX= FITS*BS + BZ'
	hdr(8)='OBJECT  = '''//objnam//''''
	hdr(9)='HISTORY = Saved from PPP '//fdate()
	hdr(10)='END'
	do 100 i=11,36
	  hdr(i)=' '
 100	continue
	return
	end
c
	subroutine wrpic(ixt,ni,j)
c	integer*2 ixt(ni)
	integer ixt(ni)
 	WRITE (20,rec=j) ixt
	return
	end
c
	subroutine rdpic(ixt,ni,j)
c	integer*2 ixt(ni)
	integer ixt(ni)
	    READ (20,rec=J) ixt
	return
	end
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO READ DISK PICTURE OF A GIVEN PPPDIR FILE NUMBER
C
C///////////////////////////////////////////////////////////////////////
	SUBROUTINE RDIRFIL(*,NFR,NFIL,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),NFLAG,NID,NJD
	INTEGER IX(NU,NV,KF),NFLAG,NID,NJD
	CHARACTER*24 NFILEN,NFILDUM
	CHARACTER*36 NCOM,NCOMC,fitsname*24
	INCLUDE 'picdir.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFIL.EQ.0) THEN
 600	  WRITE(6,10)
 10	FORMAT('  Enter PPPDIR file number to be read: ',$)
	  call read1i(nfil,*999,*600)
	END IF
	IF (NFIL.LT.1.OR.NFIL.GT.NOF) THEN
	  WRITE(6,*) ' **** File number too large or <0 ****'
	  RETURN1
	ELSE
	  NFILDUM=' '
	  CALL rdkfits(*80,NFR,NFILEN(NFIL)//NFILDUM,3,IX,NU,NV,KF,IR)
 80	  CONTINUE
	END IF
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
c
c subroutine to output header of data file
c
	SUBROUTINE headout(*,nfr,filenc,ifitshead,kf)
	CHARACTER*18 FILENC,filenf,fitsname*24
	CHARACTER*36 NCOMC,imdir*55
	COMMON/PICC/ NCOMC(15),fitsname(15)
	common/imagedir/imdir
c check input
	if (nfr.ne.0.or.filenc.eq.' ') then
	  CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	  filenc=fitsname(nfr)
	end if
c	CALL RDFILN(FILENC,NC,IPF)
 	CALL RDFILND(FILENC,NC,IPF)
c	write(6,*) filenc,ipf
C decode filename
C  name too long or aborted
	IF (IPF.LE.-1) go to 991
	IF (IPF.EQ.0) THEN
C	get name for OPEN statement
C  no qualifier, append .fits
	  FILENF=FILENC(1:NC)//'.fits'
	ELSE                           
C  qualifier exits
	  FILENF=FILENC
	END IF
c
c  PART 1 for .fits file
c  attempt to open file
 150	open(unit=20,file=imdir(1:lnblnk(imdir))//filenf,
     *        access='direct',recl=2880,status='old',err=302)
	go to 151
c try .fhd file
 302	close(unit=20)
	IF (IPF.EQ.0) THEN
	  FILENF=FILENC(1:NC)//'.fhd'
	ELSE 
	  filenf=filenc(1:nc-4)//'.fhd'
	end if
 	open(unit=20,file=imdir(1:lnblnk(imdir))//filenf,
     *        access='direct',recl=2880,status='old',err=997)
 151	call whead(20,ifitshead)
 152 	CLOSE(UNIT=20)
	return1
c  ***error messages***
 997	WRITE(6,19) NFILENF
 19	FORMAT(' **** OPEN ERROR ****',A18,' NO such file')
	goto 152
c
 991	WRITE(6,*) '  ****ILLEGAL FILE NAME***'
 999	RETURN1
	END

c
c  subroutine to output file header
c
	subroutine whead(idev,ifh)
	character headblk*2880,hdr(36)*80,itest1*7,idum*1
	equivalence (headblk(1:1),hdr(1)(1:1))
	ihb=1
c	  read(idev,rec=ihb,end=998) headblk
	  read(idev,rec=ihb) headblk
c write out the first 5 card
	  do 105 i=1,5
 105	    write(6,30) hdr(i)(1:79)
	  nhd=6
	  iwt=6
 106	  DO 110 i=nhd,36
            IF (hdr(i).EQ.' ') GO TO 110
            ITEST1=hdr(i)(1:7)
            IF (itest1(1:3).EQ.'OBJ')  then
	      if (ifh.eq.1) write(6,30) hdr(i)
	    else if (ITEST1(1:3).EQ.'BSC') then
	      if (ifh.eq.1) write(6,30) hdr(i)
            else if (ITEST1(1:3).EQ.'BZE') then
	      if (ifh.eq.1) write(6,30) hdr(i)
	    else if (itest1(1:6).eq.'FILTER') then
	      if (ifh.eq.1) write(6,30) hdr(i)
	    else if (itest1(4:7).eq.'TIME') then
	      if (ifh.eq.1) write(6,30) hdr(i)
	    else if (itest1(1:2).eq.'UT') then
	      if (ifh.eq.1) write(6,30) hdr(i)
	    else if (itest1(1:4).eq.'DATE') then
	      if (ifh.eq.1) write(6,30) hdr(i)
            else IF(ITEST1.EQ.'END') then
	      if (ifh.eq.2) then 
	        do 109 k=nhd,i
	          iwt=iwt+1
	          if (iwt.eq.21) then
 600	            write(6,'(''  ... <cr> to continue: '',$)')
	            read(5,'(a1)',end=600) idum
	            iwt=0
	          end if
 109	          write(6,30) hdr(k)(1:79)
	      end if
	      return
	    end if
 110      CONTINUE
C   "END" is not reached, read another header block
	 if (ifh.eq.2) then
	   do 112 k=nhd,36
	     iwt=iwt+1
	     if (iwt.eq.21) then
 601	       write(6,'(''  ... <cr> to continue: '',$)')
	       read(5,'(a1)',end=601) idum
	       iwt=0
	     end if
 112	     write(6,30) hdr(k)
	 end if
 30	format(1x,a79)
	ihb=ihb+1
c	read(idev,rec=ihb,end=998) headblk
	read(idev,rec=ihb) headblk
	nhd=1
	go to 106
 998	write(6,1) ihb-1
 1	format('  +++ error in header: no END card.',I4,
     *         ' header block read...')
	return
	end



C *************************************************************************
      subroutine printerror(status)

C  This subroutine prints out the descriptive text corresponding to the
C  error status value and prints out the contents of the internal
C  error message stack generated by FITSIO whenever an error occurs.

      integer status
      character errtext*30,errmessage*80

C  Check if status is OK (no error); if so, simply return
      if (status .le. 0)return

C  The FTGERR subroutine returns a descriptive 30-character text string that
C  corresponds to the integer error status number.  A complete list of all
C  the error numbers can be found in the back of the FITSIO User's Guide.
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

C  FITSIO usually generates an internal stack of error messages whenever
C  an error occurs.  These messages provide much more information on the
C  cause of the problem than can be provided by the single integer error
C  status value.  The FTGMSG subroutine retrieves the oldest message from
C  the stack and shifts any remaining messages on the stack down one
C  position.  FTGMSG is called repeatedly until a blank message is
C  returned, which indicates that the stack is empty.  Each error message
C  may be up to 80 characters in length.  Another subroutine, called
C  FTCMSG, is available to simply clear the whole error message stack in
C  cases where one is not interested in the contents.
      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      end do
      end
C *************************************************************************


	subroutine zipcheck(name,iend,flag)
c       check if a zipped output file has been requested
c	if '.Z' return flag=2; if '.gz' return flag=3; otherwise flag=0

c       **** note sure cfitsio will write .Z
c       - no it doesn't

	character*24 name
	integer iend,flag,i,tt

	i=1
	tt=0
	flag=0
c	print *,'searching ',name
c	print *,'for a .gz'
c	print *,i,name(i:i)
	do while ( (name(i:i).ne.' ').and.(i.lt.24) )
c	   print *,i
	   if( (name(i:i).eq.'.') .and. (tt.eq.0) ) then 
c	      print *,'found first . at ',i
				! first extension found
	      tt=tt+1
	   endif
	   if( (name(i:i).eq.'.').and.(tt.eq.1) ) then
	      ! second extension found. is there a 'z' in it?
c	      print *,'found second . at ',i
	      if( name(i+1:i+1).eq.'Z' ) then 
		 flag=2
	      else 
		 if( (name(i+1:i+2).eq.'gz') .and. (i.le.22) ) then 
c		    print *,'yep, theres the .gz'
		    flag=3
		 endif
	      endif
	   endif
c	   print *,'flag=',flag
	   i=i+1
	enddo

	return
	end
