c....
c   added Dec 17, 2000: subroutine to add artificial noise to a 
c        smoothed image
C///////////////////////////////////////////////////////////////////////
C
C       DRIVING SUBROUTINE 
C         IPAR=-2 find saturated stars
C         IPAR=-1 MASK USED
C         IPAR=0  MODIFIEDED KRON ROUTINE
C	  IPAR=1  USE SEBOK APERTURE 7 FOR SKY
C         IPAR=2  UNMODIFIED KRON ROUTINE (QUICK FIND)
C	  IPAR=3 SHRINK PICTURE BEFORE FINDING OBJECTS WITH MODIFIED KRON
C         IPAR=4  SHRINK PICTURE, THEN SAME AS 1
C         IPAR=6 USE CONNECTING AREA FOR FINDING OBJECTS
c         ipar=7 quick find (ipar=2), but with 
c             upper bound=.8(adusat-sky)+sky, and 
c	      lower bounda min(2.5*sky, 0.4(adusat-sky))
c                 
	SUBROUTINE FINOBD(*,NFR,STRF,TCOMMENT,THT,IPAR,IX,NU,NV,KF)
	DIMENSION NFRT(5),idgh(5),jdgh(5)
	INTEGER IX(NU,NV,KF),ibct(21)
	CHARACTER*18 FILOUT*28,FILT,secstr*1
	CHARACTER*60 COMMENT,STRF,TCOMMENT
	INCLUDE 'ppparm.inc'
	INCLUDE 'pppcore.inc'
        include 'objcat.inc' 
	INCLUDE 'picdir.inc'
	INCLUDE 'mosaic.inc'
	INCLUDE 'pipeparm.inc'
	CALL QUERYNFR(NFR,KF,0,*200,*20001)
20001	IF (NFR.GT.nposfil.or.nfr.le.0) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=',nposfil,
     *          ' FOR POSITION FILE'
	  RETURN1
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
c  for quick find with no file output
	if (ipar.eq.7) goto 133
c
c added  Feb 20 1999: check preset defined field boundry
c   (April 13, 99) defined field boundries are set up either automatically
c   when sectioned images with edges are used, or can be set explicitly
c   via a command
c
	if (ilpos(nfr).le.0.or.jlpos(nfr).eq.0) then
	  if (nsct(nfr).eq.0) then
	    write(6,*) ' +++ warning: no field boundary given, full'
     *             ,' field used +++'
	    ilpos(nfr)=1
	    jlpos(nfr)=1
	    iupos(nfr)=ni
	    jupos(nfr)=nj
	  else
	    write(6,*) ' +++ warning: no field boundary given, full'
     *             ,' field minus edges used +++'
	    call secposlim(nfr)
	  end if
c  sectioned image
	end if
	write(6,*) ' pos lim',ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr)
c661	CALL READFN(FILT,STRF(1:18),FILOUT,'pos','o',14,*200,*661,*451)
	if (strf.eq.' ') then
	  write(6,78)
 78	format(' Enter output .pos file name (.pos appended): ',$)
	  read(5,'(a28)',end=200)  filout
	  if (lnblnk(filout).gt.24) then 
	    write(6,*) '  Output file name too long, truncated at 24 chars'
	  end if
	  filout=filout(1:min0(lnblnk(filout),24))//'.pos'
 451	  IF (FILOUT.NE.'n') THEN
	    IF (TCOMMENT.EQ.' ') THEN
 670	      WRITE(6,1) COMMENT
 1	FORMAT(' ENTER comment, <=60 characters, default:'/' (',A60,')'
     *        /' :',$)
	      CALL READSTRD(60,COMMENT,*200,*670)
	    ELSE
	      COMMENT=TCOMMENT
	    END IF
            if (nsct(nfr).ne.0) then
              istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
              filout=filout(1:lnblnk(filout))//'.'//secstr
            end if
 	  END IF
	else
	  filout=strf(1:min0(lnblnk(strf),24))//'.pos'
	write(6,*) ' pos name ',filout
	  if (tcomment.ne.' ') then
	    comment=tcomment
	  else
 6701	    WRITE(6,1) COMMENT
	    CALL READSTRD(60,COMMENT,*200,*6701)
	  end if
	end if 
c  use 
 133	IPAR1=IABS(IPAR)
	IF (IPAR.LE.5.or.ipar.eq.7) THEN
	  if (abs(thresky).le.0.0001) then
c request threshold
	    if (abs(THT).lt.0.00001) then
	      if (ircspipe.ne.1) then
 600	        WRITE(6,21) TH
 21	FORMAT('  Enter detection threshold in fraction of sky '
     *          ,'(default:',F7.4,'): ',$)
	        CALL READ1R(TH,*200,*600)
	      else
	        th=THT
	      end if
	    ELSE
	      TH=THT
	    END IF
	    icompthres=0
	  else
c  automatic determination of threshold
c     modified Feb 16, 2004 to use a specialized sburoutine
c     which account for very bright stars
c
c
c	    ibct(1)=njj(nfr)*0.2
c	    idelc=nint(njj(nfr)*.6/20)
c	    do 181 i=2,20
c	      ibct(i)=ibct(i-1)+idelc
c181	    continue
c	    ncolt=20
c	    call scbc(*182,nfr,ibct,ncolt,' ',2,sigmed,rcmed,
c    *                ix,nu,nv,kf)
	    icompthres=1
	  end if
C input mask frame number, if no mask, dummy of KF-1 is used
	  IF (IPAR.eq.-1) THEN
	    if (ircspipe.eq.0) then
 601	      WRITE(6,22) IBL
 22	FORMAT('  Enter mask frame [',i2,']: ',$)
	      CALL READ1I(IBL,*200,*601)
	    else
	      ibl=imaskpipe
	      write(6,*) '  ... rcspipe mask frame: ',ibl
	    end if
	  ELSE
	    IBL=KF-1
	  END IF
	  if (icompthres.eq.1) then
c  compute automatic threshold, allowing masking if ipar=-1
	    if (ipar.eq.-1) then
	      nfm=ibl
	    else
	      nfm=0
	    end if
	    nrow=min(100,nj/5)
	    call rowskyval(nfr,nfm,nrow,50,nii(nfr),
     *            rcmed,sigmed,ix,nu,nv,kf,*182)
 182	    th=abs(thresky)*sigmed/rcmed
c  TH is the threshold based on global sky value
	    write(6,15) th
 15	format('  ..adopted (average) threshold:',f7.4,' X sky')
	  end if
C All object finding routine uses scratch frame as working frame, 
C           except QFIND AND CFIND
 11	  IF (IPAR1.EQ.3.OR.IPAR1.EQ.4) THEN
C SHRINK PICTURE BY FACTOR OF 2
 456	    NI1=NI/2
	    NJ1=NJ/2
	    DO 460 J=1,NJ1
	      JJ=2*(J-1)+1
	      DO 460 I=1,NI1
	        II=2*(I-1)+1
	        NTEMI=0
	        DO 461 M=JJ,JJ+1
	          DO 461 L=II,II+1
 461	            NTEMI=NTEMI+IX(L,M,NFR)
 460	            IX(I,J,KF)=NTEMI/4
	  ELSE
C for IPAR = 0,1, no shrinking, simply move frame to scartch
 	    IF (IPAR.NE.2) THEN
c	      CALL MOVE(NFR,KF,IX,NU,NV,KF)
	      NI1=NI
	      NJ1=NJ
 	    END IF
 	  END IF
C  for connecting area finding routine: input
	ELSE if (ipar1.eq.6) then
	  NFRT(1)=NFR
 620	  WRITE(6,27) nfrt(2)
 27	FORMAT('  Enter frame # for storing connected area map (df:'
     *        ,i3,'): ',$)
	  call read1i(nfrt(2),*200,*620)
	  DO 105 I=3,5
 105	    NFRT(I)=0
	END IF
C  Call object finding routines
	IADU=ADUSAT
	IF (IPAR1.EQ.0) THEN
	  CALL FINOBJ(IX(1,1,NFR),IX(1,1,nfr),IX(1,1,IBL),NU,NV,NI1,
     *     NJ1,NFR,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),TH,IPAR,nobmax,IADU)
	else if (ipar1.eq.3) then
	  CALL FINOBJ(IX(1,1,NFR),IX(1,1,KF),IX(1,1,IBL),NU,NV,NI1,
     *     NJ1,NFR,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),TH,IPAR,nobmax,IADU)
 	ELSE IF (IPAR1.EQ.1) THEN
	  CALL AFINOB(IX(1,1,NFR),IX(1,1,nfr),IX(1,1,IBL),NU,NV,NI1,nj1,
     *          ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr),
     *    NFR,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),TH,IPAR,nobmax,IADU,*200)
	else if (ipar1.eq.4) then
	  CALL AFINOB(IX(1,1,NFR),IX(1,1,KF),IX(1,1,IBL),NU,NV,NI1,nj1,
     *          ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr),
     *    NFR,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),TH,IPAR,nobmax,IADU,*200)
	else if (ipar1.eq.2.and.ipar.eq.-2) then
	  item=-iadu
	  CALL AFINOB(IX(1,1,NFR),IX(1,1,nfr),IX(1,1,IBL),NU,NV,NI1,nj1,
     *          ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr),
     *    NFR,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),TH,1,nobmax,item,*200)
	ELSE IF (IPAR1.EQ.2.and.ipar.eq.2) THEN
	  iadulow=nint(0.8*rcmed)
	  CALL FINOBA(IX(1,1,NFR),NU,NV,NI,NJ,IJOI(1,NFR)
     *          ,IJOJ(1,NFR),NOB(NFR),TH,nobmax,IADU,iadulow)
	else if (ipar.eq.7) then
c	      lower bound  min(2.5*sky, 0.4(adusat-sky))
	  iadulow=min0(nint(2.5*rcmed),
     *           nint(0.4*(adusat-rcmed)+rcmed))
	  iadu=nint(0.8*(adusat-rcmed)+rcmed)
	  CALL FINOBA(IX(1,1,NFR),NU,NV,NI,NJ,IJOI(1,NFR)
     *          ,IJOJ(1,NFR),NOB(NFR),TH,nobmax,IADU,iadulow)
	ELSE IF (IPAR1.EQ.6) THEN
	  CALL CONAREA(*106,NFRT,1,IX,NU,NV,KF)
 106	  IF (NOB(NFR).EQ.0) THEN
	    WRITE(6,*) '   .... No object found '
	    RETURN1
	  END IF
	END IF
	WRITE(6,3) NOB(NFR)
 3	FORMAT(1X,' ... Total of ',I5,' OBJECTS detected ...')
	IF (IPAR1.NE.6) THEN
C	  CALL RBELL(IBELL)
	  DO 100 I=1,NOB(NFR)
	    IDOB(I,NFR)=0
  100	  CONTINUE
	END IF
c  for ipar=7, exit, (no saving to file, no merging etc)
c deal with saturated objects
	if (ipar.eq.7) return1
	call satstar(nfr,ix,nu,nv,kf,iadu,rcmed,ibflag)
C merge objects that are too close togehter
 	CALL MERGEOBJ(NFR,IX,NU,NV,KF,NJJ(NFR),IJOI(1,NFR),
     *                IJOJ(1,NFR),NOB(NFR))
c delete ghost images
c  request ghost image positions
	nghost=0
	if (ircspipe.eq.0) then
 621	  write(6,40) nghost
 40	format('  Enter number of ghost images (0=none) [',i1,']: ',$)
	  call read1i(nghost,*200,*621)
	end if
	if (nghost.gt.0) then
 	  write(6,41) nghost
 41	format('  Enter',i3,' ghost image positions ')
   	  ngh=min0(5,nghost)
 	  do 171 i=1,ngh
  622	    write(6,42) i,idgh(i),jdgh(i)
  42	format('  Enter delta ghost position (i,j) for #',i2,
     *        ' [',2i3,']: ',$)
 	    call read2i(idgh(i),jdgh(i),*200,*622)
 	    if (idgh(i).eq.0.and.jdgh(i).eq.0) then
 	      write(6,*)' ** ghost cannot have delta xy=0, set to 5000'
 	      idgh(i)=5000
 	      jdgh(i)=5000
 	    end if
  171	  continue
 	  call ghostbuster(nfr,ix(1,1,nfr),nu,nv,iadu,idgh,jdgh,ngh)
	end if
	IF (FILOUT.NE.'n') THEN
	  call opennew(25,1,28,filout,*200)
	  IF (IPAR.NE.6) THEN
c regular output
 	    WRITE(25,4) NOB(NFR),TH,COMMENT
	    call wtsecinfo(nfr,25)
	    DO 111 I=1,NOB(NFR)
  	      WRITE(25,5) IJOI(I,NFR),IJOJ(I,NFR),IDOB(I,NFR)
     *             ,IX(IJOI(I,NFR),IJOJ(I,NFR),NFR),I
 111	    continue
	  ELSE
c out put for connecting area object finding
	    WRITE(25,8) NOB(NFR),COMMENT,(NFRT(I),I=3,5)
	    call wtsecinfo(nfr,25)
	    IDDOB=0
	    DO 112 I=1,NOB(NFR)
 112	      WRITE(25,9) IJOI(I,NFR),IJOJ(I,NFR),IDDOB
     *             ,IX(IJOI(I,NFR),IJOJ(I,NFR),NFR),IDOB(I,NFR),I
	  END IF
	  CLOSE(UNIT=25)
	  PCOMMENT(NFR)=COMMENT
	  WRITE(6,*) '  .....Position file saved'
	ELSE
	  PCOMMENT(NFR)=' Positions not saved'
	END IF
	IF (IPAR.EQ.6) THEN
	  DO 113 I=1,NOB(NFR)
 113	    IDOB(I,NFR)=0
	END IF
 4	FORMAT( 1X,I5,1X,'TH=',F6.4,' ',A60)
 5	FORMAT(1X,2i6,1X,I2,1X,I6,1x,I5)
 6	FORMAT(1X,'#:',I4, '  (I,J): ',2I5,3X,I3,'  peak:',I6,'  % ',
     *            F10.4)
 8	FORMAT(1X,I4,10X,A60,' min. peak',I5,' limit',I5,' min pix',I3)
 9	FORMAT(1X,2(I7),1X,I2,1X,I6,4X,I6,1x,I5)
 200	RETURN1
	END	
c////////////////////////////////////////////////////////////////
c  subroutine to set object finding area limits
c
	subroutine pfbound(nfr,*)
	character str*20
	include 'objcat.inc'
	include 'picdir.inc'
        write(6,4) nsct(nfr),ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr)
 4      format(' Current Section#=',i2,'  IJ bounds: lower',2i6,
     *        ' ; upper:',2i6)
 600	write(6,1) ilpos(nfr),jlpos(nfr)
 1	format('  Enter lower I,J or ``auto'' (for subsection limits)['
     *    ,2i5,']: ',$)
	read(5,'(a20)',end=999) str
	if (str(1:4).eq.'auto') then
	  call secposlim(nfr)
	  return1
	else
c  interpret str into two integers
	  if (str.eq.' ') go to 601
	  read(str,*,err=600) ilpos(nfr),jlpos(nfr)
	end if
 601	write(6,2) iupos(nfr),jupos(nfr)
 2	format('  Enter upper I,J [',2i5,']: ',$)
	call read2i(iupos(nfr),jupos(nfr),*999,*601)
	call worldpos(nfr,nsct(nfr),ipl,jpl,ipu,jpu)
	write(6,5) ipl,jpl,ipu,jpu
 5	format('  posf limits in world co-ord: ',2I6,2x,2I6)
 999	return1
	end
C///////////////////////////////////////////////////////////////////////
C
C ******** SUBROUTINE FINOBJ *********
C	FOR LOCATING OBJECTS TH % ABOVE SKY LEVEL
C	CREATS A CATALOGUE OF LOCATION IJOBJ, UP TO 2500 OBJECTS
C       MODIFIED KRON ROUTINE, USES MMM INSTEAD OF STRAIGHT MEAN FOR SKY
C
	SUBROUTINE FINOBJ(IXX,IX,IXM,NU,NV,NI,NJ,NFR,IJI,IJJ,NOB,
     *           TH,IPAR,MAXNOB,IADU)
	DIMENSION ZRAY1(50),ZRAY3(50)
c	INTEGER*2 IXX(NU,NV),IX(NU,NV),IXM(NU,NV),IJI(*),IJJ(*)
	INTEGER IXX(NU,NV),IX(NU,NV),IXM(NU,NV),IJI(*),IJJ(*)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        NOB=0
	THER=TH+1.
	DO 100 J=4,NJ-3
	  DO 100 I=4,NI-3
	    IF (IPAR.LT.0) THEN
	      IF (IXM(I,J).NE.0) GO TO 100
	    END IF
	    NNZ=0
C  COMPARE PIXEL VALUE WITH 17 NEIGHBOURS
C	IM=0
C	DO 102 L=J-2,J+2
C	KK=2
C	IM=IM+1
C	IF (IM.EQ.1.OR.IM.EQ.5) KK=1
C	DO 102 M=I-KK,I+KK
C 	IF (IX(M,L).GT.IX(I,J)) GO TO 100
C 102	CONTINUE
C
C   COMPARE PIXEL VALUE WITH 8 NEIGHBOURS
	    DO 102 L=J-1,J+1
	      DO 102 M=I-1,I+1
	        IF (IX(M,L).GT.IX(I,J)) GO TO 100
 102	    CONTINUE
C   A LOCAL MAXIMUM IS FOUND
C check for saturated image
CC  CHECK IF THIS IS PART OF A SATURATED IMAGE
C	    IF (IX(I-1,J).EQ.IX(I,J)) GO TO 100
C	    DO 111 M=I-1,I+1
C	      IF (IX(M,J-1).EQ.IX(I,J)) GO TO 100
C111	    CONTINUE
	    IF (IX(I,J).GE.IADU) GO TO 100
 103	    IS1=0
	    IS2=0
	    IS3=0
C  CALCULATE AVERAGE PIXEL VALUE ADJACENT TO LOC MAX (B)
C    AND ADJACENT 'SKY' PIXEL VALUE (S2)
 	    DO 104 M=J-3,J+3
	      DO 104 L=I-3,I+3
 104	        IS2=IS2+IX(L,M)
	    XT1=FLOAT(IX(I-1,J))+FLOAT(IX(I,J-1))
     *           +FLOAT(IX(I,J))+FLOAT(IX(I,J+1))+FLOAT(IX(I+1,J))
	    XT2=FLOAT(IX(I-1,J-1))+FLOAT(IX(I-1,J+1))
     *           +FLOAT(IX(I+1,J-1))+FLOAT(IX(I+1,J+1))
	    B=(XT1+0.5*XT2)/7.0
	    S2=(FLOAT(IS2)-B*7.)/42.
C  CALCULATE SKY VALUES IN BOXES (S1 AND S3) NEXT TO S2
C
	    IF (I.GE.9.AND.I.LE.(NI-9)) THEN
C  CALCULATE S1 AND S3 FOR NORMAL CASES
 	      DO 110 M=J-2,J+2
	        DO 110 L=I-8,I-4
	          NNZ=NNZ+1
 	          ZRAY1(NNZ)=FLOAT(IX(L,M))
 110 	          ZRAY3(NNZ)=FLOAT(IX(L+12,M))
	      CALL MMM(ZRAY1,NNZ,NZ,ZMEAN1,ZMED1,S1,ZSIG1,
     *	               ZSKEW1,ZREJ1,NIT1,1.,ONEMEAN)
	      IF (ZSKEW1.GT.1.E08) S1=ONEMEAN
	      CALL MMM(ZRAY3,NNZ,NZ,ZMEAN3,ZMED3,S3,ZSIG3,
     *	               ZSKEW3,ZREJ3,NIT3,1.,ONEMEAN)
	      IF (ZSKEW3.GT.1.E08) S3=ONEMEAN
	    ELSE
C  CASES FOR OBJECTS NEAR AN EDGE
c ! edge on left 
	      IF (I.GT.9) THEN 
 11	        DO 17 M=J-2,J+2
	          DO 17 L=I-8,I-4
	            NNZ=NNZ+1
 17	            ZRAY1(NNZ)=FLOAT(IX(L,M))
	        CALL MMM(ZRAY1,NNZ,NZ,ZMEAN1,ZMED1,S1,ZSIG1,
     *	                 ZSKEW1,ZREJ1,NIT1,1.,ONEMEAN)
	        IF (ZSKEW1.GT.1.E08) S1=ONEMEAN
	        S3=S1
c    ! edge on right
	      ELSE        
	        DO 15 M=J-2,J+2
	          DO 15 L=I+4,I+8
	            NNZ=NNZ+1
 15	            ZRAY3(NNZ)=FLOAT(IX(L,M))
	            CALL MMM(ZRAY3,NNZ,NZ,ZMEAN3,ZMED3,S3,ZSIG3,
     *	                      ZSKEW3,ZREJ3,NIT3,1.,ONEMEAN)
	        IF (ZSKEW3.GT.1.E08) S3=ONEMEAN
	        S1=S3
	      END IF
 	    END IF
C	IF (I.GT.6) S1=FLOAT(IS1)/(5.*(I-4))
C  DETERMINE BACKGROUND AND TEST THRESHOLD
 12	    BKG=.5*(S1+S3)
	    IF (ZSKEW1.GT.1.E08.AND.ZSKEW3.GT.1.E08) THEN
	      IF (((BKG-S2)/BKG).GT.0.015) BKG=.5*(S2+AMIN1(S1,S3))
	    ELSE
	      IF (ZSKEW1.GT.1.E08) BKG=S3
	      IF (ZSKEW3.GT.1.E08) BKG=S1
	    END IF
 28	    FRA=B/BKG
	    IF (FRA.LT.THER) GO TO 100
C CHECK IF THERE IS A SHAPR DISCONTINUITY BETWEEN THE LOC MAX
C    AND THE ADJACENT PIXELS (E.G. DUE TO COSMIC RAYS)
	    IC=I
	    JC=J
C for cases where the picture has been shrunk
	    IF (ABS(IPAR).GE.3) THEN
	      II=2*(I-1)+1
	      JJ=2*(J-1)+1
	      IBIG=IXX(II,JJ)
	      IC=II
	      JC=JJ
C choose the highest pixel from the 4
	      DO 468 M=JJ,JJ+1
	        DO 468 L=II,II+1
	          IF (IBIG.GE.IXX(L,M)) GO TO 468
	          IBIG=IXX(L,M)
	          IC=L
	          JC=M
 468	      CONTINUE
	    END IF
C determine sharpness of drop-off
 97	    IXB=NINT(BKG-SQRT(ABS(BKG)))
	    IXT=nint(1.*(IXX(IC,JC)-IXB)/abs(RWD))
	    NPWHG=0
	    NPHG45=0
	    DO 106 L=JC-1,JC+1,2
	      IF ((IXX(IC,L)-IXB).LE.IXT) NPWHG=NPWHG+1
 106	    CONTINUE
	    DO 105 M=IC-1,IC+1,2
	      IF ((IXX(M,JC)-IXB).LE.IXT) NPWHG=NPWHG+1
 105	    CONTINUE
	    DO 107 L=JC-1,JC+1,2
	      DO 107 M=IC-1,IC+1,2
	      IF ((IXX(M,L)-IXB).LE.IXT) NPHG45=NPHG45+1
 107	    CONTINUE
	    IF (NPWHG.GE.1.AND.NPHG45.GE.1) GO TO 100
C SUCCESS***, CATALOGUE POSISTION OF THE NOB TH OBJECT
	    NOB=NOB+1
	    IF (NOB.GT.MAXNOB) THEN
 99	      WRITE(6,*)   ' ****** OBJECT CATALOGUE FULL *********'
	      NOB=NOB-1
 	      RETURN
	    END IF
	    IJI(NOB)=IC
	    IJJ(NOB)=JC
	    WRITE(6,1) NOB,IC,JC,IXX(IC,JC),BKG,B,FRA
1	FORMAT(' #',I4,2X,'I,J:',2I5,1X,' pk:',I6,'  bk,fl:',2F8.1,
     *         ' % ',F9.4)
 100	CONTINUE
 200	RETURN
	END
C///////////////////////////////////////////////////////////////////////////
C
C ******** SUBROUTINE AFINOB *********
C	FOR LOCATING OBJECTS TH % ABOVE SKY LEVEL
C       USES SEBOK APERTURE + MMM for sky, 
c       IX is the working array, IXX the orginal array, IXM the mask array
c        ipar=1: normal
c        ipar=3,4 object finding is done with a shrunken array
c        ipar=negative : masking is invoked
c
c  modification Oct 11, 1998.
c     threshold in units of sky sigma is passed through
c     two options of actual threshold in ADU: (1) global sigma
c                                             (2) local sigma
c                   if thresky=0, then TH is used (as in old version)
c                   if thresky=\0, then the two options are in effect
c                   global sigma is expressed as negative
c                   local sigma is expressed as positive
c            TH passed through the call statement is the global threshold
C
c  modification Feb 19, 1999: implemented field limit as set by the
c      ilpos etc parameter
	SUBROUTINE AFINOB(IXX,IX,IXM,NU,NV,NI,NJ,ilpos,jlpos,iupos,
     *         jupos,NFR,IJI,IJJ,NOB,TH,IPAR,MAXNOB,IADUT,*)
	DIMENSION ZRAY(3000),itch(5),itph(7),rkern(15,15)
	INTEGER IXX(NU,NV),IX(NU,NV),IXM(NU,NV),IJI(1),IJJ(1)
     *            ,ixtemp(15,15)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	include 'pipeparm.inc'
        NOB=0
	iadu=iabs(iadut)
	iaduthres=0.95*iadu
c  for uniform threshold (for negative thresky)
	if (thresky.lt.-0.00001) THER=1.+TH
	IF (IOR.GT.51) THEN
	  WRITE(6,*) ' ***** SKY DIAMETER TOO LARGE ****'
	  RETURN
	END IF
c set up parameters for detailed checking (no checking if rwd<1)
	if (rwd.ge.1.0) then
c connectivity diameter
	  if (ircspipe.ne.1) then
	    if (ircon.eq.0) ircon=2
 600	    write(6,1) conthres,ircon
 1	format('  Enter diameter for connectivity (@',f5.3,
     *       ' thres), max 5[',i2,']: ',$)
	    call read1i(ircon,*999,*600)
	  else
	   ircon=irconp
	  end if
	  ircon=min0(ircon,5)
c smoothing function
	  if (iabs(iobjsm).le.2) then
	    if (nsmooth.eq.0) nsmooth=3
c note rcspipe works only for iobjsm<=1
	    if (ircspipe.ne.1) then
 601	      write(6,2) nsmooth
 2	format('  Enter smoothing box size (3 or 5):[',i2,']: ',$)
	      call read1i(nsmooth,*999,*601)
	    else
	      nsmooth=nsmthlenp
	    end if
	    nsmooth=min0(5,nsmooth)
c  for tapered smoothing
	    if (iabs(iobjsm).eq.1) then
c  create filter:  weight=1/(distance+1) from central point
              nfc=nsmooth/2+1
              sumw=0.
	write(6,*) '  computing taper 1/d kernel',nfc
              do 203 j=1,nsmooth
                kw1=iabs(nfc-j)
                do 203 i=1,nsmooth
                  rkern(i,j)=1./(sqrt(float(kw1*kw1+
     *                        (iabs(nfc-i))**2))+1.)
                  sumw=sumw+rkern(i,j)
 203          continue
              do 202 j=1,nsmooth
                write(6,*) j,' kernal ',(rkern(i,j),i=1,nsmooth)
                do 202 i=1,nsmooth
                  rkern(i,j)=rkern(i,j)/sumw
 202          continue
	    else if (iabs(iobjsm).eq.2) then
c  create filter:  weight=1/(distance+1)^2 from central point
              nfc=nsmooth/2+1
              sumw=0.
	write(6,*) '  computing taper 1/d^2 kernel',nfc
              do 293 j=1,nsmooth
                kw1=iabs(nfc-j)
                do 293 i=1,nsmooth
                  rkern(i,j)=1./(sqrt(float(kw1*kw1+
     *                        (iabs(nfc-i))**2))+1.)**2.
                  sumw=sumw+rkern(i,j)
 293          continue
              do 292 j=1,nsmooth
                write(6,*) j, 'kernel', (rkern(i,j),i=1,nsmooth)
                do 292 i=1,nsmooth
                  rkern(i,j)=rkern(i,j)/sumw
 292          continue
	    end if
	  else 
c use gaussian kernel
 602	    write(6,3) smfwhm
 3	format('  Enter smoothing FWHM in pixels [',f5.2,']: ',$)
	    call read1r(smfwhm,*999,*602)
	    call gauskern(smfwhm,nsmooth,rkern,15)
	  end if
c  make aperture for checking connectivity
	  CALL APARAY(ircon,itch,irowch,QDUM,RDUM,PDUM,NDUM,1)
c	  np=max0(5,2*nsmooth+1)
	  np=max0(9,2*nsmooth+3)
c  np2 is the 1/2 size of the cut out for smoothing, it should be
c    large enough so that the central 7 pixels are properly smoothed
c         e.g., if the smoothing box is 5, then the array must be
c         at least 13
	  np2=np/2  
c  these numbers for checking boundries
	  np22=np2+1
	  ni22=ni-np2
	  nj22=nj-np2
	  chthres=1.+conthres*th
	write(6,*) 'nsmooth ',nsmooth,np,np2,np22
	end if
c set up array for computing flux (ipth(i) contains apterure info)
	iobjdiam=min0(7,max0(iobjdiam,3))
	call aparay(iobjdiam,itph,irowph,qdum,rdum,pdum,ndum,1)
c  number of pixels in photometry aperture
	naper1=0
	do 112 i=1,2*irowph+1
	  naper1=naper1+itph(i)
 112	continue
C  make inner and outer circle for ring sky
	CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,1)
c backup sky from circles
	I1=NI/3
	J1=NJ/3
	CALL RCSKY(0,BKG,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,1,IPR)
	J1=2*NJ/3
	CALL RCSKY(0,BKG1,ZSIG1,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,1,IPR)
	I1=2*NI/3
	CALL RCSKY(0,BKG2,ZSIG2,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,1,IPR)
c  backup is the middle one
	if (bkg.gt.bkg1.and.bkg2.gt.bkg1) then
	  if (bkg.gt.bkg2) then
	    bkg1=bkg2
	  else
	    bkg1=bkg
	  end if
	else if (bkg.lt.bkg1.and.bkg2.lt.bkg1) then
	  if (bkg.gt.bkg2) then
	    bkg1=bkg
	  else
	    bkg1=bkg2
	  end if
	end if
	satsky=bkg1+0.50*(iadu-bkg1)
	zsig1=0.3333*(zsig+zsig1+zsig2+zsig3)
	zsig1=amax1(3.*zsig1,bkg1)
	WRITE(6,*) '  Back-up sky : ',BKG1,' upper sky limit: ',
     *             satsky,' back-up max sig',zsig1,' iaduth',iaduthres
c..............................................................
c  MAIN LOOP
c object finding loop
c	write(6,*) ' finding starts ',jlpos,jupos,ilpos,iupos,ni,nj
	DO 100 J=max(2,jlpos),min(jupos,NJ-1)
	  DO 100 I=max(2,ilpos),min(iupos,NI-1)
	    IF (IPAR.LT.0) THEN
	      IF (IXM(I,J).NE.0) GO TO 100
	    END IF
	    if (iadut.lt.0) then
	      if (ix(i,j).lt.iaduthres) goto 100
	    end if
	    NNZ=0
	    IR1=I-1
	    IR2=I+1
	    JR1=J-1
	    JR2=J+1
C   COMPARE PIXEL VALUE WITH 8 NEIGHBOURS
c  added Dec 14 2006: a choice of definition of maximum:
c                ipgdate=1: consider a max if pixels are equal (original)
c                       0: true max (i.e., all 8 pixles are smaller) (new)
	    if (ipgdate.eq.1) then
	      DO 102 L=JR1,JR2
	        DO 102 M=IR1,IR2
	          IF (IX(M,L).GT.IX(I,J)) GO TO 100
 102	      CONTINUE
	    else
	      DO 1021 L=JR1,JR2
	        DO 1021 M=IR1,IR2
	          IF (IX(M,L).GE.IX(I,J)) GO TO 100
 1021	      CONTINUE
	    end if
C   A LOCAL MAXIMUM IS FOUND
C  CALCULATE AVERAGE PIXEL VALUE ADJACENT TO LOC MAX (B)
	    sumf=0.
	    m=0
c  for the case when the pixel is near an edge
	    if (j-irowph.lt.1.or.j+irowph.gt.nj.or.
     *          i-irowph.lt.1.or.i+irowph.gt.ni) then
	      naper=0
	      do 113 l=max0(1,j-irowph),min0(j+irowph,nj)
	        m=m+1
	        do 113 k=max0(1,i-itph(m)/2),min0(i+itph(m)/2,ni)
	          naper=naper+1
	          sumf=sumf+ix(k,l)
 113	      continue
	      aperpix=naper
	    else
              do 114 l=j-irowph,j+irowph
                m=m+1 
                do 114 k=i-itph(m)/2,i+itph(m)/2
                  sumf=sumf+ix(k,l) 
 114          continue 
	      aperpix=naper1
	    end if	
c	    XT1=FLOAT(IX(IR1,J))+FLOAT(IX(I,JR1))
c     *              +FLOAT(IX(I,J))+FLOAT(IX(I,JR2))+FLOAT(IX(IR2,J))
c	    XT2=FLOAT(IX(IR1,JR1))+FLOAT(IX(IR1,JR2))
c     *              +FLOAT(IX(IR2,JR1))+FLOAT(IX(IR2,JR2))
c	    B=(XT1+XT2)/9.0
C  CALCULATE SKY VALUES FOR RADIUS IOR,IIR
	    CALL RCSKY(1,BKG,ZSIG,1,I,J,NI,NJ,IX,NU,NV,
     *                      ZRAY,3000,nsky,0,IPR)
	    IF (IPR.EQ.999) RETURN
c check to make sure sky makes sense.  If sky is <0 or too close
c  to saturation, use back-up sky
 28	    IF (BKG.LT.0.0001.or.bkg.gt.satsky) BKG=BKG1
c check sigma, if sigma is greated than backup sigma
	    zsig=amin1(zsig,zsig1)
	    b=sumf/aperpix
	    fra=b/bkg
c  ther is the threshold to be tested
c	    if (thresky.gt.-0.00001) then
c  local threshold
c	      ther=1.+abs(thresky)*zsig/bkg
c	    end if
	    if (thresky.gt.-0.00001) ther=1.+thresky*zsig/bkg
c  threshold test
	    IF (FRA.LT.THER) GO TO 100
C find real peak for cases with picture shrunk by factor of 2
            IF (ABS(IPAR).GE.3) THEN
              II=2*(I-1)+1
              JJ=2*(J-1)+1
              IBIG=IXX(II,JJ)
              IC=II
              JC=JJ
              DO 468 M=JJ,JJ+1
                DO 468 L=II,II+1
                  IF (IBIG.LT.IXX(L,M)) THEN
                    IBIG=IXX(L,M)
                    IC=L
                    JC=M
                  END IF
 468          CONTINUE
	    else
              IC=I
              JC=J
            END IF
C CHECK IF THERE IS A SHARP DISCONTINUITY BETWEEN THE LOC MAX and
c   surrounding pixels
 	    IXB=NINT(BKG-SQRT(ABS(BKG)))
	    IXT=NINT(1.*(IXX(IC,JC)-IXB)/abs(RWD))
	    NPWHG=0
	    NPHG45=0
	    DO 106 L=JC-1,JC+1,2
	      IF ((IXX(IC,L)-IXB).GT.IXT) GO TO 106
              NPWHG=NPWHG+1
 106	    CONTINUE
	    DO 105 M=IC-1,IC+1,2
	      IF ((IXX(M,JC)-IXB).GT.IXT) GO TO 105
              NPWHG=NPWHG+1
 105	    CONTINUE
	    DO 107 L=JC-1,JC+1,2
	      DO 107 M=IC-1,IC+1,2
	        IF ((IXX(M,L)-IXB).GT.IXT) GO TO 107
                NPHG45=NPHG45+1
 107	    CONTINUE
	    IF (NPWHG.GT.0.AND.NPHG45.GT.1) THEN
 	      WRITE(6,*) ' ..rwd test REJECT',IC,JC
	      GO TO 100
	    END IF
	    if (rwd.gt.0.) then
c  set ic and jc back to the original i and j (for shrunken array)
	      ic=i
	      jc=j
	      if (ic.lt.np22.or.jc.lt.np22.or.ic.gt.ni22.or.jc.gt.nj22)
     *          then
c for the case where the candidate pixel is too close to the edge
c pad the small array with average sky value
	        do 141 k=1,np
	          do 141 l=1,np
	            ixtemp(l,k)=nint(bkg)
 141	        continue
                n=max0(0,np2-jc+1)    
                do 142 k=max0(1,jc-np2),min0(nj,jc+np2)
                  m=max0(0,np2-ic+1)    
                  n=n+1
                  do 142 l=max0(1,ic-np2),min0(ni,ic+np2)
                    m=m+1
                    ixtemp(m,n)=ix(l,k)
 142            continue
	      else
c normal case
c  create a small array around the object and pass it to subroutine
	        n=0
	        do 145 k=jc-np2,jc+np2
	          m=0
	          n=n+1
	          do 145 l=ic-np2,ic+np2
	            m=m+1
	            ixtemp(m,n)=ix(l,k)
 145	        continue
	      end if
c  detailed check of the candidate
	      call chfind(ic,jc,ther,ixtemp,np,nsmooth,itch,irowch,
     *        chthres,smsig,iret,bkg,zsig,rkern,itph,irowph,aperpix,
     *        iobjsm,imerad)
              IF (ABS(IPAR).GE.3) THEN
c for shrunken array, redetermine the real high point
                II=2*(IC-1)+1
                JJ=2*(JC-1)+1
                IBIG=IXX(II,JJ)
                IC=II
                JC=JJ
                DO 469 M=JJ,JJ+1
                  DO 469 L=II,II+1
                    IF (IBIG.LT.IXX(L,M)) THEN
                      IBIG=IXX(L,M)
                      IC=L
                      JC=M
                    END IF
 469            CONTINUE
	      end if
	      if (iret.ne.1) then
 	        WRITE(6,13) IC,JC,IXX(IC,JC),BKG,B,FRA
	        go to 100
	      end if
	    end if
c added Jun 27 2003: make sure the co-ordinate is within the image
c    May 9 2006, corrected typo on the 2nd ic
	    if (ic.lt.1.or.ic.gt.ni.or.jc.lt.1.or.jc.gt.nj) then
	      write(6,*) '  * final co-ord out of bound * ',ic,jc,ni,nj
	      goto 100
	    end if
C SUCCESS***, CATALOGUE POSISTION OF THE NOB TH OBJECT
 333	    NOB=NOB+1

	    IF (NOB.GT.MAXNOB) THEN
 99	      WRITE(6,*) '  ****** OBJECT CATALOGUE FULL *********'
	      NOB=NOB-1
	      RETURN
	    END IF
	    IJI(NOB)=IC
	    IJJ(NOB)=JC
c  write out every 500th object
c	    if (mod(nob,500).eq.0) 
 	    if (mod(nob,1).eq.0) 
     *         WRITE(6,11) NOB,IC,JC,IXX(IC,JC),BKG,B,FRA
13	FORMAT('  Rejected,',2I5,1X,' pk:',I7,'  bk,flx:',2F8.1,
     *         '  %:',F10.4)
11	FORMAT(' #',I5,1X,'(I,J):',2I5,1X,' pk:',I7,'  bk,flx:',2F8.1,
     *         '  %:',F10.4)
 100	CONTINUE
 200	RETURN
 999	return1
	END
C///////////////////////////////////////////////////////////////////////
C
C ******** SUBROUTINE FINOBJ *********
C	FOR LOCATING OBJECTS TH % ABOVE SKY LEVEL
C	CREATS A CATALOGUE OF LOCATION IJOBJ, UP TO 1000 OBJECTS
C       THIS IS THE UNMODIFIED KRON ROUTINE -- USES MEAN SKY
c          added ladulow (lower pix limit) feb 18 2004
C
	SUBROUTINE FINOBA(IX,NU,NV,NI,NJ,IJI,IJJ,NOB,TH,MAXNOB,IADU,
     *           iadulow)
c	INTEGER*2 IX(NU,NV),IJI(*),IJJ(*)
	INTEGER IX(NU,NV),IJI(*),IJJ(*)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	include 'pipeparm.inc'
	iwd=nint(rwd)
	BKGP=0.
        NOB=0
	THER=1.+TH
	DO 100 J=4,NJ-3
	DO 100 I=4,NI-3
	  IF (IX(I,J).GE.IADU.or.ix(i,j).lt.iadulow) GO TO 100
C  CHECK IF THIS IS PART OF A SATURATED IMAGE
	  IF (IX(I-1,J).EQ.IX(I,J)) GO TO 100
	  DO 111 M=I-1,I+1
 	    IF (IX(M,J-1).EQ.IX(I,J)) GO TO 100
 111	  CONTINUE
C  COMPARE PIXEL VALUE WITH 8 NEIGHBOURS
	  DO 102 L=J-1,J+1
	  DO 102 M=I-1,I+1
 	    IF (IX(M,L).GT.IX(I,J)) GO TO 100
 102	  CONTINUE
C   A LOCAL MAXIMUM IS FOUND
 103	  IS1=0
	  IS2=0
	  IS3=0
C  CALCULATE AVERAGE PIXEL VALUE ADJACENT TO LOC MAX (B)
C    AND ADJACENT 'SKY' PIXEL VALUE (S2)
 	  DO 104 M=J-3,J+3
	    DO 104 L=I-3,I+3
 104	      IS2=IS2+IX(L,M)
	  XT1=FLOAT(IX(I-1,J))+FLOAT(IX(I,J-1))
     *       +FLOAT(IX(I,J))+FLOAT(IX(I,J+1))+FLOAT(IX(I+1,J))
	  XT2=FLOAT(IX(I-1,J-1))+FLOAT(IX(I-1,J+1))
     *       +FLOAT(IX(I+1,J-1))+FLOAT(IX(I+1,J+1))
	  B=(XT1+.5*XT2)/7.0
	  S2=(FLOAT(IS2)-B*7.)/42.
C  CALCULATE SKY VALUES IN BOXES (S1 AND S3) NEXT TO S2
C
C  FIRST, CASES FOR OBJECTS NEAR AN EDGE
	  IF (I.GE.9.AND.I.LE.(NI-9)) GO TO 10
	  IF (I.GT.9) GO TO 11
	  DO 16 M=J-2,J+2
	    DO 16 L=I+4,I+8
 16	      IS3=IS3+IX(L,M)
	  S3=FLOAT(IS3)/25.
	  S1=S3
	  GO TO 12
 11	  DO 17 M=J-2,J+2
	    DO 18 L=I-8,I-4
 	      IS1=IS1+IX(L,M)
 18	    continue
 17	  CONTINUE
	  S1=FLOAT(IS1)/25.
	  S3=S1
	  GO TO 12
C  CALCULATE S1 AND S3 FOR NORMAL CASES
 10	  DO 110 M=J-2,J+2
	    DO 110 L=I-8,I-4
	      IS1=IS1+IX(L,M)
 110	      IS3=IS3+IX(L+12,M)
	  S1=FLOAT(IS1)/25.
	  S3=FLOAT(IS3)/25.
 12	  CONTINUE
C  DETERMINE BACKGROUND AND TEST THRESHOLD
 13	BKG=.5*(S1+S3)
	  IF (((BKG-S2)/BKG).GT.0.010) BKG=.5*(S2+AMIN1(S1,S3))
	  FRA=B/BKG
	  IF (FRA.LT.THER) GO TO 100
C CHECK IF THERE IS A SHAPR DISCONTINUITY BETWEEN THE LOC MAX
C    AND THE ADJACENT PIXELS (E.G. DUE TO COSMIC RAYS)
 	IXB=INT(BKG*.8)
 	IXT=(IX(I,J)-IXB)/IWD
 	NPWHG=0
 	DO 105 L=J-1,J+1
 	DO 105 M=I-1,I+1
 	IF ((IX(M,L)-IXB).GT.IXT) GO TO 105
 	NPWHG=NPWHG+1
 105	CONTINUE
 	IF (NPWHG.GE.3) GO TO 100
C SUCCESS***, CATALOGUE POSISTION OF THE NOB TH OBJECT
	  NOB=NOB+1
	  IF (NOB.GT.MAXNOB) GO TO 99
	  IJI(NOB)=I
	  IJJ(NOB)=J
	  if (mod(nob,500).eq.0) 
     *           WRITE(6,1) NOB,I,J,IX(I,J),BKG,B,FRA
c	  if (ircspipe.eq.0) WRITE(6,1) NOB,I,J,IX(I,J),BKG,B,FRA
1	FORMAT(' #',I4,2X,'(I,J):',2I5,1X,' pk:',I7,' bk,flx:',2F8.1,
     *         '  %:',F10.4)
 100	CONTINUE
	GO TO 200
 99	WRITE(6,*) '****** OBJECT CATALOGUE FULL *********'
	NOB=NOB-1
 200	RETURN
	END
C/////////////////////////////////////////////////////////////////
C
C   Subroutine to eliminate objects too close to each another
C      All objects with in certain radius is assumed to be the
C      same object, and a single object is created by choosing the
C      one with closest to the fractional centroid.
C         Maximum radius allowed is 3
C       
c  jul 8, changed ig and jg to integer*4. Int 2 is not big enough
c       when it sums over many overlapping obj co-ord
c
c   the array ID must be the size of nobmax or greater
	SUBROUTINE MERGEOBJ(NFR,IX,NU,NV,KF,NJJ,II,JJ,NOB)
c	INTEGER*2 IX(NU,NV,KF),II(*),JJ(*),it,jt
	INTEGER IX(NU,NV,KF),II(*),JJ(*),it,jt
	integer ig(80000),jg(80000),inum(80000),ID(170000)
	INCLUDE 'ppparm.inc'
	include 'pppcore.inc'
	include 'pipeparm.inc'
c	equivalence (id(1),iscr(1)),
c     *              (ig(1),iscr(50001)),
c    *              (jg(1),iscr(60001)),
c    *              (inum(1),iscr(70001))
c  nmermax should be the dimension size of inum
	nmermax=80000
	IF (IMERAD.LT.1) THEN
	  WRITE(6,*)  '  ...merging radius <1, no merging done..'
	  RETURN
	END IF
	IF (IMERAD.GT.3) THEN 
	  WRITE(6,*) '  **** Merger radius too large, MERGING NOT DONE '
	  RETURN
	END IF
	if (njj.eq.0) then
	  write(6,*) ' *** no image in frame ',nfr
	  return
	end if
	if (nob.le.1) then
	  write(6,*) ' +++ fewer than 2 objects, no merging done '
	  return
	end if 
	NOBCHECK=MAX0(50,10*IMERAD*NOB/NJJ)
	write(6,*) NOBCHECK
C search list for objects within IMERAD from each another.  These objects
C  are grouped with ID of the same integer.
	NMER=0
	DO 111 I=1,NOB
 111	  ID(I)=0
	DO 100 I=1,NOB
	  KBEG=MAX0(1,I-NOBCHECK)
	  KEND=MIN0(NOB,I+NOBCHECK)
	  DO 101 K=KBEG,KEND
	    IF (K.EQ.I) GO TO 101
	    IF (IABS(JJ(K)-JJ(I)).LE.IMERAD) THEN
	      IF (IABS(II(I)-II(K)).LE.IMERAD) THEN
C  a close by object is found
C   1: checK if the offending object already belongs to a group
C         if so, the test object is added to the group
                IF (ID(K).NE.0) THEN
	          ID(I)=ID(K)
	        ELSE IF (ID(I).NE.0) THEN
	          ID(K)=ID(I)
	        ELSE
C  2:  start a new group
	          NMER=NMER+1
	          IF (NMER.GT.nmermax) THEN
	            WRITE(6,*) '  **** grouping array overflow **'
	            GO TO 110
	          END IF
	          ID(I)=NMER
	          ID(K)=NMER
	        END IF
	        if (ircspipe.eq.0) 
     *            WRITE(6,1) I,II(I),JJ(I),K,II(K),JJ(K),ID(I)
1	FORMAT(7I5)
C	        GO TO 100
	      END IF
	    END IF
 101	  CONTINUE
 100	CONTINUE
 110	WRITE(6,10) NMER
10	FORMAT(1X,I3,' groupings found --')
C  For each grouping, find the integer centroid of the grouping, 
C       
	IF (NMER.EQ.0) RETURN
c	if (nmer.gt.1000) then
c	  write(6,*) ' ++ warning, more than 1000 merge obj '
c	  nmer=1000
c	end if
c initialize group array
	DO 103 I=1,NMER
	  IG(I)=0
	  JG(I)=0
 	  INUM(I)=0
 103	continue
c compute average I J of group ID(I)
	write(6,*)  ' ++++ computing ig and jg for group merging ++++ '
	DO 102 I=1,NOB
	  IF (ID(I).gt.0) THEN
	    IG(ID(I))=IG(ID(I))+II(I)
	    JG(ID(I))=JG(ID(I))+JJ(I)	
            INUM(ID(I))=INUM(ID(I))+1
c	write(6,*) I,'id(i),ig,jg,inum ',id(i),ig(id(i)),jg(id(i)),
c    *         inum(id(i)),ii(i),jj(i)
	  END IF
 102	CONTINUE
	DO 104 I=1,NMER
c May31 1997: do not understand the reason for the following
c   statements -- seems odd to adjust IG by inum??
c    this possibly takes care of getting the nearest integer
c	  IG(I)=(IG(I)+INUM(I)-1)/INUM(I)
c	  JG(I)=(JG(I)+INUM(I)-1)/INUM(I)
c  new statements
c	write(6,*) 'before dividing  ',i,ig(i),jg(i),inum(i)
	  if (inum(I).gt.0) then
 	    IG(I)=nint(float(IG(I))/float(INUM(I)))
 	    JG(I)=nint(float(JG(I))/float(INUM(I)))
	  else
	    write(6,*) '  group ',i,' has zero members ***'
	    goto 104
	  end if
C     Refine to fractional centroid via CENT.  
	  it=ig(i)
	  jt=jg(i)
c	write(6,*) 'call pcentr group ',i,it,jt
	  CALL PCENTR(NFR,0,IX,NU,NV,KF,XN,YN,DUMAG,DUMSKY,it,jt
     *                ,1,FLOAT(NAPCEN),45,1,ITERCEN)
c	  if (xn.gt.0.1.and.yn.gt.0.1) then
	    IG(I)=NINT(XN)
	    JG(I)=NINT(YN)
	    if (ircspipe.eq.0) 
     *               write(6,*) INUM(I),' I ',IG(I),' J ',JG(I)
c	  else
c	    write(6,*) '  ** centroid problem ** ', xn,yn
c	    write(6,*) INUM(I),' unchanged  I ',IG(I),' J ',JG(I)
c	  end if
 104	CONTINUE
C  replace new objects in Posfil
	NOBT=0
	DO 105 I=1,NOB
	  IF (ID(I).NE.0) THEN
C object belongs to a multiple group
	    IF (IG(ID(I)).NE.0) THEN
C place new position in file if this is the first time for the group
	      NOBT=NOBT+1
	      II(NOBT)=IG(ID(I))
	      JJ(NOBT)=JG(ID(I))
	      IG(ID(I))=0
	    END IF
	  ELSE
C object is not part of a group, keep object in file
	    NOBT=NOBT+1
	    II(NOBT)=II(I)
	    JJ(NOBT)=JJ(I)
	  END IF
 105	CONTINUE
	NOB=NOBT
	WRITE(6,*) NOB,' objects in merged file'
C resort position file according to J co-ordinate
	IF (NOB.GT.1) CALL N2SORT2(NOB,JJ,II)
	RETURN
	END
c///////////////////////////////////////////////////////////
c  subroutine to check object for (1) number of connected pixels
c                                      above a threshold
c                                 (2) noise via smoothed image
c
c  modifications put in july and  Oct, 2007
c
	subroutine chfind(ii,jj,bigthrest,ix,np,nsmooth,it,irow,
     *        thres,smsig,iret,bk,sig,rkern,itph,irowph,aperpix,
     *         iobjsm,imerad)
c	integer*2 ix(15,15),ix2(15,15)
	integer ix(15,15),ix2(15,15)
	dimension rkern(15,15)
	integer it(1),itph(1)
	io=np/2+1
	if (irow.gt.1) then
c  Oct 1, 2007
c the connectivity test is based on how many pixels within the
c  test area that are below the threshold.  The old test simply use
c   2 as the number for area=+/-2 or larger, this has been loosened to irow
c   (This should have little change of effect compared to the original)
c	  icrit=2
	  icrit=irow
	else
	  icrit=1
	end if
c added Oct 1, 2007: for iobjsm negative (looser condition), the threshold
c  for checking the new peak is less stringent (10% lower)
	if (iobjsm.lt.0) then
	  bigthres=bigthrest*0.9
	else
	  bigthres=bigthrest
	end if
c	write(6,*) '  cfind for ',ii,jj,ix(io,io)
c (0) see if the pixel value is large (ie, a cosmic ray), 
c  save the original unsmoothed copy in ix2
	if (float(ix(io,io))-bk.ge.smsig*sig) then
	  do 200 j=1,np
	    do 200 i=1,np
	      ix2(i,j)=ix(i,j)
 200	  continue
	  icopy=1
	else
	  icopy=0
	end if
c (1)  check if this pixel is still a local peak in a smoothed image
	if (iobjsm.eq.0) then
	  call ssmooth(ix,np,nsmooth)
	else if (iabs(iobjsm).ge.1) then
	  call ssmooth1(ix,np,nsmooth,rkern)
	end if
c  write out the cut out stamp for debugging
c	do kk=1,np
c 	  write(6,*) (ix(kkk,kk),kkk=2,np-1),' | ',
c     *               (ix2(kkk,kk),kkk=2,np-1)
c 	end do
	itemp=-10000
	mm=io
	ll=io
c check if there is any pixel around this point that is higher
c   if so, initiate a new check for peak
c  the checking is over the smoothing box half dimension io
        DO 102 L=io-1,io+1
          DO 102 M=io-1,io+1
            IF (IX(M,L).GT.IX(io,io)) then
c keep track to find the largest pixel
	      if (ix(m,l).gt.itemp) then
	        itemp=ix(m,l)
	        mm=m
	        ll=l
	      end if
	    end if
 102    CONTINUE
c	inopk=max0(2,imerad)
	inopk=max0(2,imerad)+1
c   this statement is okay, if no pixel greater than the central
c    pixel, itemp remain -1000
 	if (itemp.gt.-1000) then
c there is a new higher pt, check if this new point is a local max, 
c    allowing imerad pixel shifting;
	  ihighneig=itemp
 510	  inopk=inopk-1
c	  write(6,*) ' .. new high point',ii-(io-mm),jj-(io-ll),ix(mm,ll)
c  it has gone as far away as allowed, giving up finding new peak
	  if (inopk.eq.0) then
 	    write(6,2) ii,jj
 2	format(' ...smoothed image has no local max ',2i6)
c  added July 18 2007
c   if there is no peak in the smoothed image, go back to the
c    original image, and accept the object, if the central pixel
c     is only slightly smaller than the high pixel
c       this option is trigger by iobjsm being negative
	    if (iobjsm.lt.0) then 
c  see how many pix are above the original center
	      nhigh=0
c  nhigh keeps track of how many pixels are higher than the center pix
              DO 112 L=io-1,io+1
                DO 112 M=io-1,io+1
                  IF (IX(M,L).GT.IX(io,io)) then
	            nhigh=nhigh+1
	            ihighneig=ix(m,l)
	          end if
 112          CONTINUE
	      if (nhigh.eq.1) then
	        if (float(ihighneig-ix(io,io)).lt.sig) then
	          write(6,*) 
     *   ' ..neighboring higher pix within 1 sig, accept orig pk'
	          go to 505
	        end if
	      end if
	    end if
	    go to 500
	  end if
c  the search for new peak algorithm:
c     search for immediate pixels (3X3 around the new pt), if there
c    is a higher pt, move to that pt as the new center, and start
c    anew.  One is allowed imerad-1 shift
c
c  (mm,ll) is the co-ordinate of the center of the 3x3 box
c
	  do 103 j=ll-1,ll+1
	    do 103 i=mm-1,mm+1
	      if (ix(i,j).gt.ix(mm,ll)) then
	        mm=i
	        ll=j
	        go to 510
	      end if
 103	  continue

c  yes there is a new peak, now recompute flux to see if it is a legit obj
	  temp=0.
	  m=0
	  do 104 j=ll-irowph,ll+irowph
	    m=m+1
	    do 104 i=mm-itph(m)/2,mm+itph(m)/2
	      temp=temp+ix(i,j)
 104	  continue
	  if((temp/aperpix)/bk.gt.bigthres) then
c still an object, now adjust i and j 
 	      write(6,*) '     (old peak :',ii,jj
	    ii=ii-(io-mm)
	    jj=jj-(io-ll)
 	    write(6,*) ' ..new peak after smoothing ',ii,jj
	  else
c not an object, return
 	    write(6,*) ' ..new peak below threshold'
	    go to 500
	  end if
	end if
c (2) see if there are enough connected points above thres
 505	m=0
	itemp=0
        if (icopy.eq.0) then
	  do 100 j=ll-irow,ll+irow
	    m=m+1
	    do 101 i=mm-it(m)/2,mm+it(m)/2
	      if (float(ix(i,j))/bk.lt.thres) then
	        itemp=itemp+1
	        if (itemp.ge.icrit) then
 	        write(6,*) '.. connect test:adjacent pixs too low (unsm)'
	          go to 500
	        end if
	      end if
 101	    continue
 100	  continue
	else
	  do 110 j=ll-irow,ll+irow
	    m=m+1
	    do 111 i=mm-it(m)/2,mm+it(m)/2
	      if (float(ix2(i,j))/bk.lt.thres) then
	        itemp=itemp+1
	        if (itemp.ge.icrit) then
 	        write(6,*) '...connect test: adjacent pixs too low (sm)'
	          go to 500
	        end if
	      end if
 111	    continue
 110	  continue
	end if
 501	iret=1
	return
 500	iret=0
	return
	end
c//////////////////////////////////////////////////////////
c  May 17 1999
c
c  subroutine to recheck accepted position file.  This is normally
c   done when the object finding is performed using a smoothed image.
c   The rechecking is conducted on the unsmoothed image to pick out
c   cosmic ray detections using the RWD check.
c   It is found that the chfind algorithm eliminates too many real objects.
c   and it is not used.
c   Future improvement may include other objects which may be in halos
c   of galaxies, and eliminate them.
c
c   The command offers a choice of producing a "reject.pos" file 
c    which lists the objects deleted.
c
	subroutine rchkpos(*,nfr,ix,nu,nv,kf)
c	integer*2 ix(nu,nv,kf),ixtemp(15,15),irej(5000),jrej(5000)
c    *            ,idrej(5000)
	integer ix(nu,nv,kf),ixtemp(15,15),irej(5000),jrej(5000)
     *            ,idrej(5000)
	DIMENSION ZRAY(3000),itch(5),itph(7),rkern(15,15)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	include 'objcat.inc'
	parameter (maxrej=5000)
	CALL QUERYNFR(NFR,KF,0,*999,*2001)
 2001   IF (NFR.GT.nposfil.or.nfr.le.0) THEN
          WRITE(6,*) ' *** Frame number must be <=',nposfil,
     *          ' for Position File'
          RETURN1
        END IF
	IF (IOR.GT.51) THEN
	  WRITE(6,*) ' ***** SKY DIAMETER TOO LARGE ****'
	  RETURN
	END IF
	ni=nii(nfr)
	nj=njj(nfr)
c set up parameters for detailed checking (no checking if rwd<1)
c
c  currently disabled
c	if (rwd.ge.1.) then
	if (rwd.ge.1000.) then
c connectivity diameter
	  if (ircon.eq.0) ircon=2
 600	  write(6,1) conthres,ircon
 1	format('  Enter diameter for connectivity (@',f5.3,
     *       ' thres), max 5[',i2,']: ',$)
	  call read1i(ircon,*999,*600)
	  ircon=min0(ircon,5)
c smoothing function
	  if (iabs(iobjsm).le.1) then
	    if (nsmooth.eq.0) nsmooth=3
 601	    write(6,2) nsmooth
 2	format('  Enter smoothing box size (max 5):[',i2,']: ',$)
	    call read1i(nsmooth,*999,*601)
	    nsmooth=min0(5,nsmooth)
c  for tapered smoothing
	    if (iabs(iobjsm).eq.1) then
c  create filter:  weight=1/(distance+1) from central point
              nfc=nsmooth/2+1
              sumw=0.
              do 203 j=1,nsmooth
                kw1=iabs(nfc-j)
                do 203 i=1,nsmooth
                  rkern(i,j)=1./(sqrt(float(kw1*kw1+
     *                        (iabs(nfc-i))**2))+1.)
                  sumw=sumw+rkern(i,j)
 203          continue
              do 202 j=1,nsmooth
                write(6,*) (rkern(i,j),i=1,nsmooth)
                do 202 i=1,nsmooth
                  rkern(i,j)=rkern(i,j)/sumw
 202          continue
	    end if
	  else 
 602	    write(6,3) smfwhm
 3	format('  Enter smoothing FWHM in pixels [',f5.2,']: ',$)
	    call read1r(smfwhm,*999,*602)
	    call gauskern(smfwhm,nsmooth,rkern,15)
	  end if
c  make aperture for checking connectivity
	  CALL APARAY(ircon,itch,irowch,QDUM,RDUM,PDUM,NDUM,1)
	  np=max0(5,2*nsmooth+1)
	  np2=np/2
	  np22=np2+1
	  ni22=ni-np2
	  nj22=nj-np2
	  chthres=1.+conthres*th
	end if
c set up array for computing flux (ipth(i) contains apterure info)
	iobjdiam=min0(7,max0(iobjdiam,3))
	call aparay(iobjdiam,itph,irowph,qdum,rdum,pdum,ndum,1)
c  number of pixels in photometry aperture
	naper1=0
	do 112 i=1,2*irowph+1
	  naper1=naper1+itph(i)
 112	continue
C  make inner and outer circle for ring sky
	CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,1)
c backup sky from circles
	I1=NI/3
	J1=NJ/3
	CALL RCSKY(0,BKG,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,0,IPR)
	J1=2*NJ/3
	CALL RCSKY(0,BKG1,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,0,IPR)
	I1=2*NI/3
	CALL RCSKY(0,BKG2,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,0,IPR)
c  backup is the middle one
	if (bkg.gt.bkg1.and.bkg2.gt.bkg1) then
	  if (bkg.gt.bkg2) then
	    bkg1=bkg2
	  else
	    bkg1=bkg
	  end if
	else if (bkg.lt.bkg1.and.bkg2.lt.bkg1) then
	  if (bkg.gt.bkg2) then
	    bkg1=bkg
	  else
	    bkg1=bkg2
	  end if
	end if
	BKG1=0.5*(BKG1+BKG)
	WRITE(6,*) '  Back-up sky value: ',BKG1
c..............................................................
c  MAIN LOOP for each object
	nrej=0
	DO 100 k=1,nob(nfr)
	  ic=ijoi(k,nfr)
	  jc=ijoj(k,nfr)
C  CALCULATE SKY VALUES FOR RADIUS IOR,IIR
	  CALL RCSKY(1,BKG,ZSIG,1,IC,JC,NI,NJ,IX(1,1,nfr),NU,NV,
     *                      ZRAY,3000,nsky,0,IPR)
c	    IF (IPR.EQ.999) RETURN
 28	    IF (BKG.LT.0.0001) BKG=BKG1
C CHECK IF THERE IS A SHARP DISCONTINUITY BETWEEN THE LOC MAX and
c   surrounding pixels
 	    IXB=NINT(BKG-SQRT(ABS(BKG)))
	    IXT=NINT(1.*(IX(IC,JC,nfr)-IXB)/abs(RWD))
	    NPWHG=0
	    NPHG45=0
	    DO 106 L=JC-1,JC+1,2
	      IF ((IX(IC,L,nfr)-IXB).GT.IXT) GO TO 106
              NPWHG=NPWHG+1
 106	    CONTINUE
	    DO 105 M=IC-1,IC+1,2
	      IF ((IX(M,JC,nfr)-IXB).GT.IXT) GO TO 105
              NPWHG=NPWHG+1
 105	    CONTINUE
	    DO 107 L=JC-1,JC+1,2
	      DO 107 M=IC-1,IC+1,2
	        IF ((IX(M,L,nfr)-IXB).GT.IXT) GO TO 107
                NPHG45=NPHG45+1
 107	    CONTINUE
	    IF (NPWHG.GT.0.AND.NPHG45.GT.1) THEN
c	      WRITE(6,*) ' ..rwd test REJECT',IC,JC
	      nrej=nrej+1
	      if (nrej.gt.maxrej) then
	        write(6,24) nrej,k
 24	format('  +++ rejection buffer overflows (',i4,
     *         ') stopped at obj#',i6)
	        nrej=nrej-1
	        goto 140
	      end if
	      irej(nrej)=ic
	      jrej(nrej)=jc
	      idob(k,nfr)=-999
	      idrej(nrej)=-1
	      GO TO 100
	    END IF
c set up temp small array for the remaining tests
c
c  currently disabled
c	    if (rwd.gt.0.) then
 	    if (rwd.gt.1000.) then
	      if (ic.lt.np22.or.jc.lt.np22.or.ic.gt.ni22.or.jc.gt.nj22)
     *          then
c for the case where the candidate pixel is too close to the edge
c pad the small array with average sky value
	        do 141 kk=1,np
	          do 141 l=1,np
	            ixtemp(l,kk)=nint(bkg)
 141	        continue
                n=max0(0,np2-jc+1)    
                do 142 kk=max0(1,jc-np2),min0(nj,jc+np2)
                  m=max0(0,np2-ic+1)    
                  n=n+1
                  do 142 l=max0(1,ic-np2),min0(ni,ic+np2)
                    m=m+1
                    ixtemp(m,n)=ix(l,kk,nfr)
 142            continue
	      else
c normal case
c  create a small array around the object and pass it to subroutine
	        n=0
	        do 145 kk=jc-np2,jc+np2
	          m=0
	          n=n+1
	          do 145 l=ic-np2,ic+np2
	            m=m+1
	            ixtemp(m,n)=ix(l,kk,nfr)
 145	        continue
	      end if
c  detailed check of the candidate
c  currently disabled.
c	      call chfind(ic,jc,ther,ixtemp,np,nsmooth,itch,irowch,
c    *        chthres,smsig,iret,bkg,zsig,rkern,itph,irowph,aperpix,
c    *        iobjsm,imerad)
	    iret=1
	    if (iret.ne.1) then
               WRITE(6,13) IC,JC,IX(IC,JC,nfr),BKG,B,FRA
13	FORMAT('  Rejected,',2I5,1X,' pk:',I7,'  bk,flx:',2F8.1,
     *         '  %:',F10.4)
	      nrej=nrej+1
	      if (nrej.gt.maxrej) then
	        write(6,24) nrej,k
	        nrej=nrej-1
	        goto 140
	      end if
	        irej(nrej)=ic
	        jrej(nrej)=jc
	        idob(k,nfr)=-999
	        idrej(nrej)=-2
	      end if
	    end if
 100	continue
c adjust current pos file, and write out reject file
 140	call adjposf(nob(nfr),ijoi(1,nfr),ijoj(1,nfr),idob(1,nfr),
     *        nrej,irej,jrej,-1,ix(1,1,nfr),nu,nv)

 999	return1
	end
c/////////////////////////////////////////////////////////
c  subroutine to adjust the current pos file, and output rejected
c     posf
	subroutine adjposf(nob,ijoi,ijoj,idob,nrej,irej,jrej,iadd,
     *                     ix,nu,nv)
	character filout*18,addstr*1
c	integer*2 ijoi(1),ijoj(1),idob(1),irej(1),jrej(1),ix(nu,nv)
	integer ijoi(1),ijoj(1),idob(1),irej(1),jrej(1),ix(nu,nv)
    	ntem=nob
	do 110 i=nob,1,-1
	  if (idob(i).eq.-999) then
	    do 111 j=i+1,ntem
	      ijoi(j-1)=ijoi(j)
	      ijoj(j-1)=ijoj(j)
	      idob(j-1)=idob(j)
 111	    continue
	    ntem=ntem-1
	  end if
 110	continue
        WRITE(6,31) nob,nrej,ntem
 31	format(' ....original # of obj:',i6,', rejected:',i5,
     *        ', current: ',i5,/' ...writing reject.pos')
	nob=ntem
c out put rejected positions as a position file
c    temp for checking
	if (iadd.lt.-100) goto 999
	istatus=encode(addstr,float(iabs(iadd)),1,0,idum)
	filout='reject'//addstr//'.pos'
	call opennew(25,1,18,filout,*999)
        WRITE(25,4) nrej
 4	format(I6,' Post-verification rejects ')
c       call wtsecinfo(nfr,25)
        DO 113 I=1,nrej
          WRITE(25,5) irej(I),jrej(I),iadd,
     *         IX(irej(I),jrej(I)),I
 113    continue
	close(unit=25)
 5	FORMAT(1X,2i6,1X,I2,1X,I6,1x,I5)
 999	return
	end
c////////////////////////////////////////////////////////////
c  subroutine to determine if an object in a bright halo is real
c
c   nfm = frame number for temp array for smoothed and mask maps
c
	subroutine chalopos(*,nfr,nfm,ix,nu,nv,kf)
c	integer*2 ix(nu,nv,kf),irej(300),jrej(300),
c    *         itc(20000),jtc(20000)
	integer ix(nu,nv,kf),irej(300),jrej(300),
     *         itc(20000),jtc(20000)
	DIMENSION ZRAY(3000),itph(9),xline(200)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	include 'objcat.inc'
	parameter (maxrej=300)
	CALL QUERYNFR(NFR,KF,0,*999,*2001)
 2001   IF (NFR.GT.nposfil.or.nfr.le.0) THEN
          WRITE(6,*) ' *** Frame number must be <=',nposfil,
     *          ' for Position File'
          RETURN1
        END IF
	if (nfm.le.0.or.nfm.eq.nfr.or.nfm.ge.kf) then
 600	  write(6,1) nfm
 1	format('  Enter frame number for temporary contour map [',i2,
     *         ']: ',$)
	  call read1i(nfm,*999,*600)
	  if (nfm.le.0.or.nfm.eq.nfr.or.nfm.ge.kf) goto 600
	end if
	if (abs(thresky).lt.0.01) then
 601	  write(6,2) thresky
 2	format('  Enter thresky [',f6.3,']: ',$)
	  call read1r(thresky,*999,*601)
	else
	  write(6,3) thresky
 3	format('  thresky=',f7.4,' used....')
	end if
c set up array for computing flux (ipth(i) contains apterure info)
c   5 is default
	iodiam=max0(iobjdiam,5)
	call aparay(iodiam,itph,irowph,qdum,rdum,pdum,ndum,0)
	ni=nii(nfr)
	nj=njj(nfr)
c  np is the size of the temp cut array for smoothed image
	np=201
c  np2 is the center of the array where the object is placed
	np2=np/2
	np22=np2+1
	ni22=ni-np2
	nj22=nj-np2
C  make inner and outer circle for ring sky
	CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,1)
c backup sky from circles
	I1=NI/3
	J1=NJ/3
	CALL RCSKY(0,BKG,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,0,IPR)
	J1=2*NJ/3
	CALL RCSKY(0,BKG1,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,0,IPR)
	I1=2*NI/3
	CALL RCSKY(0,BKG2,ZSIG,1,I1,J1,NI,NJ,IX,NU,NV,
     *             ZRAY,3000,nsky,0,IPR)
c  backup is the middle one
	if (bkg.gt.bkg1.and.bkg2.gt.bkg1) then
	  if (bkg.gt.bkg2) then
	    bkg1=bkg2
	  else
	    bkg1=bkg
	  end if
	else if (bkg.lt.bkg1.and.bkg2.lt.bkg1) then
	  if (bkg.gt.bkg2) then
	    bkg1=bkg
	  else
	    bkg1=bkg2
	  end if
	end if
	WRITE(6,*) '  Back-up sky value: ',BKG1
	nrej=0
	ntest=nob(nfr)*300/nj
c main do loop for each object
	do 100 i=1,nob(nfr)
	  if (idob(i,nfr).eq.-999) goto 100
c compute central pixel value and compare to sky, only
c  deal with objects >.25X sky.
	  ic=ijoi(i,nfr)
	  jc=ijoj(i,nfr)
C  CALCULATE SKY VALUES FOR RADIUS IOR,IIR
	  CALL RCSKY(1,BKG,ZSIG,1,IC,JC,NI,NJ,IX,NU,NV,
     *                      ZRAY,3000,nsky,0,IPR)
	  IF (IPR.EQ.999) goto 100
 28	  IF (BKG.LT.0.0001) BKG=BKG1
c  determine flux within aperture
	  sumf=0.
	  m=0
	  naper=0
	  do 113 l=max0(1,jc-irowph),min0(jc+irowph,nj)
	    m=m+1
	    do 113 k=max0(1,ic-itph(m)/2),min0(ic+itph(m)/2,ni)
	      naper=naper+1
	      sumf=sumf+ix(k,l,nfr)
 113	  continue
	  flux=(sumf-bkg*naper)/float(naper)
c  if flux/pix is greater than 0.2*sky and 5sigma/pix do the checking
	  if (flux.gt.0.2*bkg) then
c  cut out a piece of the sky with the object and smooth it
c
	    if (ic.lt.np22.or.jc.lt.np22.or.ic.gt.ni22.or.jc.gt.nj22)
     *          then
c for the case where the candidate pixel is too close to the edge
c pad the small array with average sky value
	      do 141 k=1,np
	        do 141 l=1,np
	          ix(l,k,nfm)=nint(bkg)
 141	      continue
              n=max0(0,np2-jc+1)    
              do 142 k=max0(1,jc-np2),min0(nj,jc+np2)
                m=max0(0,np2-ic+1)    
                n=n+1
                do 142 l=max0(1,ic-np2),min0(ni,ic+np2)
                  m=m+1
                  ix(m,n,nfm)=ix(l,k,nfr)
 142          continue
	    else
c normal case
c  create a small array around the object and pass it to subroutine
	      n=0
	      do 145 k=jc-np2,jc+np2
	        m=0
	        n=n+1
	        do 145 l=ic-np2,ic+np2
	          m=m+1
	          ix(m,n,nfm)=ix(l,k,nfr)
 145	      continue
	    end if
c  redetermine sky with larger aperture
	    CALL APARAY(65,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	    CALL APARAY(45,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,0)
	    CALL RCSKY(1,bkgb,zsigb,1,IC,JC,NI,NJ,IX,NU,NV,
     *                      ZRAY,3000,nsky,0,IPR)
	    ilevel=nint(bkgb+conthres*zsigb)
c	write(6,*) '  contour level for checking: ',ilevel
c reset sky apertures
	    CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	    CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,0)
c  smooth cut picure: n2=1 --> 3X3 smoothing
            N2=1
            DO 165 jb=1,np
              JL=MAX0(jb-N2,1)
              JU=MIN0(jb+N2,np)
              sumt=ju-jl+1
              DO 165 ib=1,np
                IL=MAX0(ib-N2,1)
                IU=MIN0(ib+N2,np)
                TEMP=0.
                DO 166 JJ=JL,JU
                  DO 166 II=IL,IU
                    TEMP=TEMP+ix(II,JJ,nfm)
 166            continue
                sumw=sumt*(iu-il+1)
                IX(ib,jb,kf)=nint(TEMP/sumw)
 165        continue 
c  put back into array
            do 167 jj=1,np
              do 167 ii=1,np
                ix(ii,jj,nfm)=ix(ii,jj,kf)
 167        continue 
c
c  form connected pixel map (store in frame nfm) down to 1 sigma
c	 recall   center of frame = np22
            CALl SEGCON(np22,np22,ilevel,ITC,JTC,IPT,np,np,
     *                 IX(1,1,nfm),NU,NV)
	    do 168 k=1,np
	      do 168 m=1,np
	        ix(m,k,nfm)=0
 168	    continue
	    do 169 k=1,ipt
	      if (itc(k).gt.0.and.jtc(k).gt.0) 
     *            ix(itc(k),jtc(k),nfm)=1
 169	    continue
c  determine if there are other object within the connect pixel map
c    test ntest objects around the bright object
            do 170 k=i-ntest,i+ntest
	      if (idob(k,nfr).eq.-999) goto 170
	      if (iabs(ic-ijoi(k,nfr)).le.np2.and.
     *	          iabs(jc-ijoj(k,nfr)).le.np2) then
c don't do the object itself
	        if (k.eq.i) goto 170
	        if (ix(ijoi(k,nfr)-ic+np2,ijoj(k,nfr)-jc+np2,nfm)
     *              .eq.1) then
c   an object is in the connected area
	          io=ijoi(k,nfr)
	          jo=ijoj(k,nfr)
	          write(6,31) i,ic,jc,k,io,jo
 31	format(' ...Within Obj#',i5,'(',2i5,') -- ',' find obj#',i5,
     *         '(',2i5,')')
c  check significance above the connected pixel area
c  
c  first determine new sky, using only pixels within contour, and
c  primary object masked
c
c  make the primary object mask :
C determine cut from object to neighbour, xline starts with ic,jc
	          CALL MKLINE(IC,JC,IO,JO,NPT,200,XLINE,NI,NJ
     *             ,IX(1,1,nfr),NU,NV)
C seach for minimum,  IMINR is the radius of the circle to be blocked out
	          XLMIN=.75*XLINE(1)+.25*xline(2)
	          iminr=2
	          DO 181 M=3,NPT-1
                    xlt=.25*xline(m-1)+.5*xline(m)+.25*xline(m+1)
                    IF (XLT.LT.XLMIN) THEN
                      XLMIN=XLT
                      IMINR=M
                    END IF
c stop when it reaches sky value
	            if (xlt.le.bkgb) goto 182
 181              CONTINUE
 182	          iminr=iminr-1
	          iminrsq=iminr*iminr
	          K1=0
	          NSK=0
	          JR1=JO-IROW1(1)
	          JR2=JO+IROW1(1)
                  DO 171 JJ=MAX0(1,JO-IROW2),MIN0(NJ,JO+IROW2)
                    K1=K1+1
                    DO 172 II=MAX0(1,IO-IT2(K1)/2),
     *                              MIN0(NI,IO+IT2(K1)/2)
                      IF (J.LT.JR1.OR.J.GT.JR2) GO TO 173
                      KK=IT1(K1+IROW1(1)-IROW2,1)/2
                      IR1=IO-KK
                      IR2=IO+KK
                      IF (II.LT.IR1.OR.II.GT.IR2) GO TO 173
	              GO TO 172
c  check if it is in the contour mask, and at least iminr from center
c      (note: np22=np/2+1)
 173	              idx=ii-ic
	              jdy=jj-jc
    	              if (ix(idx+np22,jdy+np22,nfm).eq.1) then
 	                if (idx*idx+jdy*jdy.gt.iminrsq) then
	                  NSK=NSK+1
                          ZRAY(NSK)=FLOAT(IX(II,JJ,nfr))
 	                end if
	              end if
 172                CONTINUE
 171              CONTINUE
                  if (nsk.le.0) then
	            write(6,*) ' +++ no sky pixel, not done +++'
	            goto 100
	          end if
	          CALL MMM(ZRAY,NSK,N3,ZMEAN,ZMED,ZMODE,ZSIG,
     *                        ZSK,ZREJ,NIT,1.,ZM1)
c	          bkg=SKCMED*ZMED-SKCMEAN*ZMEAN
	          bkg=ZMED
                  WRITE(6,12) N3,ZMEAN,ZMED,ZMODE,bkg,zsig,iminr
 12     FORMAT(' #pix',I5,1x,'mean,med,mod,sky:',4F8.1,' sig',f7.2,I4)
c  determine sky subtracted flux, using previously determined total counts
 	          IF (BKG.LT.0.0001) BKG=BKG1
c  determine flux within aperture
	          call aparay(iobjdiam,itph,irowph,qdum,rdum,pdum,ndum,0)
	          sumf=0.
	          m=0
	          naper=0
	          do 175 l=max0(1,jo-irowph),min0(jo+irowph,nj)
	            m=m+1
	            do 175 kk=max0(1,io-itph(m)/2),min0(io+itph(m)/2,ni)
	            naper=naper+1
	            sumf=sumf+ix(kk,l,nfr)
 175	          continue
c only reject if flux of subsidiary obj is fainter than primary
	          flux1=(sumf-bkg*naper)/float(naper)
	          if (flux1.gt.flux) goto 170
	          ther=1.+thresky*zsig/bkg
	          frac=(sumf/float(naper))/bkg
	          if (frac.lt.ther) then
c  this object removed
	            nrej=nrej+1
	            idob(k,nfr)=-999
	            irej(nrej)=io
	            jrej(nrej)=jo
                    write(6,*) '  ++rejected :',k,io,jo
	          end if
c reset photometry aperture to larger number
	          call aparay(iodiam,itph,irowph,qdum,rdum,pdum,ndum,0)
	        end if
	      end if
 170	    continue
	  end if
 100	continue
c adjust current pos file, and write out reject file
	call adjposf(nob(nfr),ijoi(1,nfr),ijoj(1,nfr),idob(1,nfr),
     *        nrej,irej,jrej,-2,ix(1,1,nfr),nu,nv)
 999	return1
	end
c///////////////////////////////////////////
c  subroutine to make a gaussian kernel
c
	subroutine gauskern(fwhm,nsmooth,rkern,nar)
	dimension rkern(nar,nar)
c determine sigma
	sigma=0.5*0.8493*fwhm
c the size of the array should go down to min 4 sigma
	nsmooth=int(8.*sigma)
c  make it into the next largest odd number
	if (mod(nsmooth,2).eq.0) nsmooth=nsmooth+1
c make array
	n2=nsmooth/2+1
	sum=0.
	do 100 j=1,nsmooth
	  do 100 i=1,nsmooth
	    rkern(i,j)=exp(-((i-n2)*(i-n2)+(j-n2)*(j-n2))*.5/sigma)
	    sum=sum+rkern(i,j)
 100	continue
c normalize
	do 101 j=1,nsmooth
	  do 101 i=1,nsmooth
	    rkern(i,j)=rkern(i,j)/sum
 101	continue
c
	do 500 j=1,nsmooth
	  write(6,1) (rkern(i,j), i=1,nsmooth)
 1	format(10f8.5)
 500	continue
	return
	end
c//////////////////////////////////////////////
c
c  smoothing routine with a kernal (normalized and symmetric)
	subroutine ssmooth1(ix,np,nsmooth,rkern)
c	integer*2 ix(15,15),ixt(15,15)
	integer ix(15,15),ixt(15,15)
	dimension rkern(15,15)
	if (nsmooth.le.1) return
        N2=NSMOOTH/2
        DO 100 J=1,np
          JK1=J-N2-1
          J1=J-N2
          if (j1.le.0) then 
            j1=1 
            inorm=1
            rnorm=0.
          end if 
          J2=J+N2
          if (j2.gt.np) then 
            j2=np 
            inorm=1
            rnorm=0.
          end if 
          DO 100 I=1,np
            IK1=I-N2-1
	    i1=i-n2
	    if (i1.le.0) then
	      i1=1
	      inorm=1
	      rnorm=0.
	    end if
            I2=I+N2
	    if (i2.gt.np) then
	      i2=np
	      inorm=1
	      rnorm=0.
	    end if
            SUM=0.
	    if (inorm.eq.0) then
              DO 101 JJ=J1,J2
C  j co-ordinate of KERNEL
C   This is for symmetric kernel only, for proper general convolution,
C       should us JK2 and and change sign
                JK=JJ-JK1
                DO 101 II=I1,I2
                  SUM=SUM+RKERN(II-IK1,JK)*ix(II,JJ)
 101          CONTINUE
	    else
              DO 102 JJ=J1,J2    
C  do the renormalization for points near the edge
                JK=JJ-JK1
                DO 102 II=I1,I2
                  SUM=SUM+RKERN(II-IK1,JK)*ix(II,JJ)
	          rnorm=rnorm+rkern(ii-ik1,jk)
 102          CONTINUE
	      sum=sum/rnorm
	      inorm=0
	    end if
 100        ixt(I,J)=nint(SUM)
c  put back into array
	do 103 j=1,np
	  do 103 i=1,np
	    ix(i,j)=ixt(i,j)
 103	continue
	return
	end
c//////////////////////////////////////////////
c
c  old box car smoothing
        subroutine ssmooth(ix,np,nsmooth)
c       integer*2 ix(15,15),ixt(15,15)
        integer ix(15,15),ixt(15,15)
        if (nsmooth.le.1) return
        N2=NSMOOTH/2
        DO 165 J=1,np
          JL=MAX0(J-N2,1)
          JU=MIN0(J+N2,np)
          sumt=ju-jl+1
          DO 165 I=1,np
            IL=MAX0(I-N2,1)
            IU=MIN0(I+N2,np)
            TEMP=0.
            DO 166 JJ=JL,JU
              DO 166 II=IL,IU
                TEMP=TEMP+IX(II,JJ)
 166        continue
            sumw=sumt*(iu-il+1)
            IXT(I,J)=nint(TEMP/sumw)
 165    continue 
c  put back into array
        do 101 j=1,np
c	write(6,'(15i5)') (ixt(k,j),k=1,np)
          do 101 i=1,np
            ix(i,j)=ixt(i,j)
 101    continue 
        return
        end
C//////////////////////////////////////////////////////////
C sorting routine for integer 2's, RA is sorted , RB is changed along with it
C
      SUBROUTINE N2SORT2(N,RA,RB)
	INTEGER RRA,RRB
c     INTEGER*2 RA(N),RB(N)
      INTEGER RA(N),RB(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END
c////////////////////////////////////////////////////////
c subroutine to deal with saturated stars
c
	subroutine satstar(nfr,ix,nu,nv,kf,iadu,bkg,ibflag)
	parameter (maxsat=150000)
c	integer*2 ix(nu,nv,kf),ksat(maxsat),ii(maxsat),jj(maxsat)
c     *      , itc(200000),jtc(200000),itc2(200000),jtc2(200000)
	integer ix(nu,nv,kf),ksat(maxsat),ii(maxsat),jj(maxsat)
     *      , itc(200000),jtc(200000),itc2(200000),jtc2(200000)
	include 'objcat.inc'
	include 'picdir.inc'
	include 'pppcore.inc'
	EQUIVALENCE (ITC(1),iscr(200001)),(JTC(1),iscr(400001))
	EQUIVALENCE (ITC2(1),iscr(600001)),(JTC2(1),iscr(800001))
c  compute centroid around objpos with peak>.9adusat
	iaduthres=0.9*iadu
	nsat=0
	do 150,k=1,nob(nfr)
	  if (ix(ijoi(k,nfr),ijoj(k,nfr),nfr).gt.iaduthres) then
            call PCENTR(NFR,0,IX,NU,NV,KF,REALI,REALJ,RMAG,SKY,
     *            ijoi(k,nfr),ijoj(k,nfr),1,7.,65,1,20)
c  set new position
	    ijoi(k,nfr)=nint(reali)
	    ijoj(k,nfr)=nint(realj)
	    nsat=nsat+1
	    if (nsat.gt.maxsat) then
	      write(6,1) maxsat
 1	format(' +++ max # (',i5,
     *      ') of saturated stars have been reached')
	      goto 151
	    end if
	    ksat(nsat)=k
	    ii(nsat)=ijoi(k,nfr)
	    jj(nsat)=ijoj(k,nfr)
	  end if
 150	continue
C Check if within a radius of 10 pixel whether there are other
c    accepted poistions, if so, the average poistions are taken
c   of the group.
 151	continue
	do  100 i=1,nsat
c  ii=0 is used to indicate an object is already absorbed by another.
	  if (ii(i).eq.0) goto 100
	  item=ii(i)
	  jtem=jj(i)
	  naver=0
	  sumi=0.
	  sumj=0.
c check for objects within 10 pixels
	  do 101 j=1,nsat
	    if (ii(j).eq.0) goto 101
	    if (iabs(item-ii(j)).le.10.and.iabs(jtem-jj(j)).le.10) then
	      naver=naver+1
	      sumi=sumi+ii(j)
	      sumj=sumj+jj(j)
	      ii(j)=0
	    end if
 101	  continue
	  ii(i)=nint(sumi/naver)
	  jj(i)=nint(sumj/naver)
 100	continue
c now go back to original position file, delete all the saturated
c  objects, and then replace the left overs
	call delobj(ksat,nsat,nfr)
	nobtem=nob(nfr)
	do 102 i=1,nsat
	  if (ii(i).gt.0) then
	    nob(nfr)=nob(nfr)+1
	    ijoi(nob(nfr),nfr)=ii(i)
	    ijoj(nob(nfr),nfr)=jj(i)
	    idob(nob(nfr),nfr)=0
	  end if
 102	continue
	write(6,10) nsat,nob(nfr)-nobtem
 10	format('  ....',i4,' saturated stars found initially '/
     *         '      Consolidated to ',i4,' stars')
	call arranpos(nob,ijoi,ijoj,idob)
c now go through the position file again to pick up satuarted
c   objects and recompute centroid using connected area
c    all pixels above 0.9adusat are connected
	iadu=0.9*iadu
	if (ibflag.eq.1) then
	  iadu2=iadu
	  iadu3=.7*iadu
	else
	  iadu2=nint(0.7*iadu)
	  iadu3=nint(bkg+0.09*(iadu2-bkg))
	end if
	write(6,*) ' ...contour cuts for centroiding ',iadu2,iadu3
	do 103 i=1,nob(nfr)
	  if (ix(ijoi(i,nfr),ijoj(i,nfr),nfr).gt.iadu) then
	    icen=ijoi(i,nfr)
	    jcen=ijoj(i,nfr)
	    CALL SEGCON(ICEN,JCEN,iadu2,ITC,JTC,IPT,NII(NFR),NJJ(NFR),
     *                 IX(1,1,NFR),NU,NV)
	    CALL SEGCON(ICEN,JCEN,iadu3,ITC2,JTC2,IPT2,NII(NFR),
     *                 njj(nfr),IX(1,1,NFR),NU,NV)
C  find   centroid
            ICX=0
            ICY=0
	    icx2=0
	    icy2=0
            PT=FLOAT(ipt2-IPT)
            DO 111 N=1,IPT
              ICX=ICX+ITC(N)
 111          ICY=ICY+JTC(N)
            DO 112 N=1,IPT2
              ICX2=ICX2+ITC2(N)
 112          ICY2=ICY2+JTC2(N)
            ijoi(i,nfr)=nint(FLOAT(ICX2-icx)/PT)
            ijoj(i,nfr)=nint(FLOAT(ICY2-icy)/PT)
	  end if
103	continue
	return
	end 
c/////////////////////////////////////////////////////////////////
c  subroutine to check ghost images
c
	subroutine ghostbuster(nfr,ix,nu,nv,iadusat,idgh,jdgh,ngh)
c	integer*2 ix(nu,nv),nodt(600)
	integer ix(nu,nv),nodt(600)
	dimension idgh(1),jdgh(1),igh(5),jgh(5)
	include 'objcat.inc'
c go through list and pickout detection with peak>.75 adusat
	nobf=nob(nfr)/40
	nghost=0
	iadusat1=iadusat*.75
	iadusat2=iadusat*.9
	do 100 i=1,nob(nfr)
	  if (ix(ijoi(i,nfr),ijoj(i,nfr)).gt.iadusat1) then
c compute expected position of ghost
	    do 150 m=1,ngh
	      igh(m)=ijoi(i,nfr)+idgh(m)
	      jgh(m)=ijoj(i,nfr)+jdgh(m)
 150	    continue
	    if (ix(ijoi(i,nfr),ijoj(i,nfr)).gt.iadusat2) then
c bright stars gets more latitude on search box
	      irad=3
	    else
	      irad=2
	    end if
c  check position of objects near by
	    klim1=max0(1,i-max0(30,nobf))
	    klim2=min0(nob(nfr),i+max0(30,nobf))
	    nngh=0
	    do 101 k=klim1,klim2
	      do 151 m=1,ngh
	        if (iabs(igh(m)-ijoi(k,nfr)).le.irad.and.
     *               iabs(jgh(m)-ijoj(k,nfr)).le.irad)
     *            then
c record the object number of the ghost
	          nghost=nghost+1
                  nodt(nghost)=k
	          nngh=nngh+1
	          if (nngh.ge.ngh) go to 100
	        end if
 151	      continue
 101	    continue
	  end if
 100	continue
c         delete object
	if (nghost.gt.600) write(6,*) ' ++ total ghosts: ',nghost,
     *     ' -- > 600, only first 600 deleted'
	call delobj(nodt,min0(600,nghost),nfr)
	write (6,1) min0(600,nghost)
 1	format( '+++ ',i4,' ghosht positions deleted +++')
	return
	end
c/////////////////////////////////////////////////////////////////
c  driver routine for matching two position files
c      nfr1 is the mother file, nfr2 the offspring file to be modified
c
c   ipar=0 erase all intermediate file
c   ipar=1 keep intermediate file
c   itrs=0 default initial guess for transformation matrix
c   itrs=1 preliminary guess for transformation matrix based
c          on scale and ref object input
c
	subroutine posmatch(*,nfr1,nfr2,ipar,itrs)
	parameter (nmax=20000)
	integer ij1(20000,2),ij2(20000,2),ijout(20000,2)
	include 'objcat.inc'
	include 'pppcore.inc'
	equivalence (iscr(1),ij1(1,1)),(iscr(100001),ij2(1,1)),
     *              (iscr(200001),ijout(1,1))
 599	continue
	if (nfr1.eq.0.or.nfr1.gt.nposfil) then
 600	  write(6,1) nposfil
 1	format('  Enter master pos file (<=',i2,'): ',$)
	  call read1i(nfr1,*999,*600)
	  go to 599
	end if
	if (nfr2.eq.0.or.nfr2.gt.nposfil) then
 601	  write(6,2) nposfil
 2	format('  Enter slave pos file (<=',i2,'): ',$)
	  call read1i(nfr2,*999,*601)
	  go to 599
	end if
	if (nfr1.eq.nfr2) then
	  write(6,*)  ' +++ the two position files cannot be the same'
	  goto 599
	end if
c  set up interim pos files for call
	do 100 i=1,nob(nfr1)
	  ij1(i,1)=ijoi(i,nfr1)
	  ij1(i,2)=ijoj(i,nfr1)
 100	continue
c make sure the ends are marked with zeroes
	do 101 i=nob(nfr1)+1,nob(nfr1)+10
	  ij1(i,1)=0
	  ij1(i,2)=0
 101	continue
	do 102 i=1,nob(nfr2)
	  ij2(i,1)=ijoi(i,nfr2)
	  ij2(i,2)=ijoj(i,nfr2)
 102	continue
	do 103 i=nob(nfr2)+1,nob(nfr2)+10
	  ij2(i,1)=0
	  ij2(i,2)=0
 103	continue
	call matshift(ij1,ij2,ijout,20000,ipar,itrs,nfr1,nfr2,*999)
	nob(nfr2)=nob(nfr1)
	do 104 i=1,nob(nfr2)
	  ijoi(i,nfr2)=ijout(i,1)
	  ijoj(i,nfr2)=ijout(i,2)
 104	continue
 999	return1
	end
c
c////////////////////////////////////////////////
c   subroutine from Patton, modified for ppp with nmax being passed
c         through and using get_env  
c
C     This fortran subroutine takes as input arrays a and b, 
C     and gives array c as output.  Arrays are in the form 
C     a(n,1:2), where a(i,1) and a(i,2) are the  
C     x and y coordinates respectively, for the i-th object. 
C     Array a is the master list of coordinates (usually r filter).
C     Array b is the object finding in the secondary filter. 
C     Output array c is the master list, with coordinates transformed 
C     onto the secondary coordinate system. 
C     This subroutine makes system calls to daomaster (executable) 
C     and match.csh (a cshell script); at present, the program 
C     expects to find these in the current directory.  
c
c  modified nov 5 1998 to include initial transformation

      subroutine matshift(a,b,c,nmax,ipar,itrs,nfr1,nfr2,*)
      integer nmax,i
c     parameter(nmax=5000) ! nmax is passed through
      integer a(nmax,1:2),b(nmax,1:2),c(nmax,1:2)
      real m,merr,sh,ch,one,zero,co(1:6)
	character cshname*60
      parameter(m=21.0,merr=0.1,sh=1.0,ch=1.0,one=1.0,zero=0.0)
c
c
      if (itrs.eq.0) then
C     Create files a.temp, b.temp, and a.mch (needed as input to daomaster)
C     Note that it is imperative that the format of these files 
C     be precisely as given here. 
        open(21,file="a.temp",status="unknown")
        open(22,file="b.temp",status="unknown")
        open(23,file="a.mch",status="unknown")
        do i = 1,100000
          if (a(i,1).eq.0.and.a(i,2).eq.0) go to 95
          write(21,102) i,float(a(i,1)),float(a(i,2)),m,merr,sh,ch
        enddo
 95     na=i-1
	nc=na
        do i = 1,100000
          if (b(i,1).eq.0.and.b(i,2).eq.0) go to 96
          write(22,102) i,float(b(i,1)),float(b(i,2)),m,merr,sh,ch
        enddo
 96     nb=i-1  
        write(23,103) "a.temp",zero,zero,one,zero,zero,one
        write(23,103) "b.temp",zero,zero,one,zero,zero,one
        close(21)
        close(22)
        close(23)
      else
c tposmat will request input for initial transformation, and write
c   the 3 files
	call tposmat(a,b,c,nmax,na,nb,nc,nfr1,nfr2,*999)
      end if
C     Call daomaster : this creates output file coeff.dat.  
C     This file contains the transformation coefficients, 
C     as well as the diagnostic file cshift.out (which can be ignored)
c     call system('csh < match.csh >! cshift.out')
      call getenv('POS_MATCH',cshname)
      call system('csh <'//cshname//' >! cshift.out')
c     call system('csh <'//cshname//' > cshift.out')
      open(40,file="coeff.dat",status="unknown")
      read(40,*) (co(k),k=1,6)
      close(40)

C     Use transformation to generate new position file
      do i = 1,100000
         if (a(i,1).eq.0.and.a(i,2).eq.0) go to 98
         c(i,1) = nint((co(2)*co(5)-co(1)*co(6) + co(6)*float(a(i,1)) 
     $        - co(5)*float(a(i,2)))/(co(3)*co(6)-co(5)*co(4)))
         c(i,2) = nint((co(3)*co(2)-co(4)*co(1) + co(4)*float(a(i,1)) 
     $        - co(3)*float(a(i,2)))/(co(4)*co(5)-co(3)*co(6)))
      enddo
 98   continue
c  
C     Test for success of transformation 
C     Output score is percentage of secondary filter objects which 
C     have a primary filter neighbour with 3 pixels after transformation. 
C     Scores of order 50% indicate success 
C     Scores of order 0-5% indicate failure
      nmatch=0
	tol=3.0
      do i=1,nb
         nm = 0
         do j=1,nc
            sep = sqrt((b(i,1)-c(j,1))**2.0+(b(i,2)-c(j,2))**2.0)
            if (sep.le.tol) nm = nm + 1
         enddo
         if (nm.gt.0) nmatch = nmatch + 1
      enddo
      score = 100.0*float(nmatch)/float(nb)
      write(6,12) int(score)
 12   format('  Matching Score = ',i3,'% (>50%=success, 0-5% failed)')
C     Cleanup files
      if (ipar.eq.1) then
        call system('"\"rm -f *.temp a.mch')
	write(6,*) '  Transformation coefficent stored in coeff.dat '
      else
        call system('"\"rm -f *.temp a.mch coeff.dat')
      end if
 102  format(i6,3f9.3,f9.4,2f8.3)
 103  format(1x,"'",a6,24x,"'",2f10.2,4f10.5)
      return
 999  return1
      end
c////////////////////////////////////////////////////////////////
c
c Driving routine for matching two pos file, but with input
c  to create an inital transformation input file for daomaster
c    Nov 5 1998
c
c    it transforms nfr2 to match nfr1
c
c   a=master list of ij, there are na objects
c   b=list of ij from secondary file, there are nb objects
c   c= final list of ij (master list transformed), there are nc objects
c   nmax is the max size of the arrays
c
	subroutine tposmat(a,b,c,nmax,na,nb,nc,nfr1,nfr2,*)
	dimension ib(2),ie(2)
      integer a(nmax,1:2),b(nmax,1:2),c(nmax,1:2)
	character string*16,stringold*16,ccd1*8,ccd2*8
c request scale info
 602	write(6,3) nfr1,nfr2,stringold
 3	format('  Enter CCD names *or* pix sizes, or scales for ',I2,
     *        ' and ',I2/'       [',a16,']: ',$)
	read(5,'(a16)') string
	if (string.eq.' ') string=stringold
	if (string.ne.' ') then
c  parse string
	  call fstr(string,16,ib,ie,ns)
	  read(string,*,err=201) sc1,sc2
	  goto 603
 201	  ccd1=string(ib(1):ie(1))
	  ccd2=string(ib(2):ie(2))
	  if (ccd1.eq.'orbit'.or.ccd1.eq.'loral') then
	    sc1=15
	  else if (ccd1.eq.'stis2') then
	    sc1=21
	  else
	    write(6,4) ccd1
 4	format('  ++ ccd (',a8,') not recognized ++')
	    go to 602
	  end if
	  if (ccd2.eq.'orbit'.or.ccd2.eq.'loral') then
	    sc2=15
	  else if (ccd2.eq.'stis2') then
	    sc2=21
	  else
	    write(6,4) ccd2
	    go to 602
	  end if
	else
c empty string, assume scale =1
	  sc1=1.
	  sc2=1.
	end if
c reference stars
 603	write(6,5) nfr1,i1a,j1a
 5	format('  Enter x,y pix co-ord of ref obj#1 in ',i2,' [',
     *         2i6,']: ',$)
	call read2i(i1a,j1a,*999,*603)
 604	write(6,5) nfr2,i1b,j1b
	call read2i(i1b,j1b,*999,*604)
c ask for 2nd one if there is rotation
 605	write(6,6) nfr1,i2a,j2a 
6	format(' IF a rotation is required, 2nd obj needed:'
     *          ,' (0 0 for no rotation) ' / 
     *	       '  enter x,y pix co-ord of ref obj#2 in ',i2,' [',
     *         2i6,']: ',$)
	call read2i(i2a,j2a,*999,*605)
	if (i2a.eq.0.and.j2a.eq.0) then
	  i2b=0
	  j2b=0
	else
 606	  write(6,7) nfr2,i2b,j2b
 7	format('  Enter x,y pix co-ord of ref obj#2 in ',i2,' [',
     *         2i6,']: ',$)
	call read2i(i2b,j2b,*999,*606)
	end if
	call geomatch(a,b,c,nmax,na,nb,nc,nfr1,nfr2,sc1,sc2,
     *      i1a,j1a,i1b,j1b,i2a,j2a,i2b,j2b)
	return
 999	return1
	end
c///////////////////////////////////////////////////////////////
c
c  Subroutine written by D. Patton, modified Nov 5, 98 for ppp.
c
C     This subroutine computes the transformation for 
C     a given pair of position files.  The input is as follows : 
c     scalea=pixel size of primary
c     scaleb=pixel size of secondary
C     x1a = x coordinate of first object in primary filter
C     y1a = y coordinate of first object in primary filter
C     x1b = x coordinate of first object in secondary filter
C     y1b = y coordinate of first object in secondary filter
C     x2a = x coordinate of second object in primary filter
C     y2a = y coordinate of second object in primary filter
C     x2b = x coordinate of second object in secondary filter
C     y2b = y coordinate of second object in secondary filter
c
      subroutine geomatch(a,b,c,nmax,na,nb,nc,nfr1,nfr2,scalea,scaleb,
     *        xa1,ya1,xb1,yb1,xa2,ya2,xb2,yb2)
c     implicit none
c     integer nmax,i,j
      integer a(nmax,1:2),b(nmax,1:2),c(nmax,1:2)
c     integer flag(nmax),level(nmax),ppp(nmax)
      character*1 FMT
      parameter(FMT="N")
      real scalea,scaleb,scale,xshift,yshift,thetaa,thetab,theta
      integer xa1,ya1,xb1,yb1,xa2,ya2,xb2,yb2
      real a0,b0,a1,b1,a2,b2,a0p,b0p,a1p,b1p,a2p,b2p
      real zero,one,pi
      parameter(zero=0.0,one=1.0,pi=3.141592654)
c     integer na,nb,nc,nm,nmatch
      scale = scalea/scaleb
      if (abs(scale-1.).gt..0001) then
         write(6,*) '  ....No scaling used'
      else
         write(6,1) nfr2,scale
 1	format(' .....Scaling frame ',i2, ' by ',f8.5)
      endif
      
C     Compute rotation
      if (xa2.eq.0.and.ya2.eq.0.and.xb2.eq.0.and.yb2.eq.0) then
         theta = 0.0
         write(6,*) ' ....No rotation used (by default)'
      else
         thetaa = acos(float(xa2-xa1)/
     *        sqrt(float(xa2-xa1)**2.0+float(ya2-ya1)**2.0))
         thetab = acos(float(xb2-xb1)/
     *        sqrt(float(xb2-xb1)**2.0+float(yb2-yb1)**2.0))
         theta = thetab - thetaa
         write(6,10 ) theta*180.0/pi
 10   format(' ...rotation of ',f6.1,' deg applied')
      endif

C     Compute shift 
      if (xa1.eq.0.and.ya1.eq.0.and.xb1.eq.0.and.yb1.eq.0) then
         xshift = 0.0 
         yshift = 0.0
         write(6,*) "No shift used (by default)"
      else
         xshift = float(xb1)-scale*float(xa1)*cos(theta) 
     *        + scale*sin(theta)*float(ya1)
         yshift = float(yb1)-scale*float(xa1)*sin(theta)
     *        -scale*float(ya1)*cos(theta)
         write(6,*) ' ...Shift of ',xshift,' along X axis'
         write(6,*) ' ...Shift of ',yshift,' along Y axis'
      endif
      
C     Create initial transformation estimate (file="a.mch") 
C     Define coefficients in transformed matrix
      a0p = xshift
      a1p = scale*cos(theta)
      a2p = -scale*sin(theta)
      b0p = yshift
      b1p = scale*sin(theta)
      b2p = scale*cos(theta)

C     Define coefficients in non-transformed matrix
      a0 = (a2p*b0p-b2p*a0p)/(b2p*a1p-a2p*b1p)
      a1 = b2p/(b2p*a1p-a2p*b1p)
      a2 = -a2p/(b2p*a1p-a2p*b1p)
      b0 = (a1p*b0p-b1p*a0p)/(b1p*a2p-a1p*b2p)
      b1 = b1p/(b1p*a2p-a1p*b2p)
      b2 = -a1p/(b1p*a2p-a1p*b2p)
      
c      write(6,*) a0,a1,a2,b0,b1,b2
      open(24,file="a.mch",status="unknown")
      write(24,13) "a.temp",zero,zero,one,zero,zero,one
      write(24,13) "b.temp",a0,b0,a1,b1,a2,b2
      close(24)
      
      open(21,file="a.temp",status="unknown")
      open(22,file="b.temp",status="unknown")
 
      do i = 1,100000
         if (a(i,1).eq.0.and.a(i,2).eq.0) go to 95
         write(21,12) i,float(a(i,1)),float(a(i,2)),m,merr,sh,ch
      enddo
 95   na=i-1  
      nc=na
      do i = 1,100000
         if (b(i,1).eq.0.and.b(i,2).eq.0) go to 96
         write(22,12) 
     *     i,float(b(i,1))+offset,float(b(i,2)),m,merr,sh,ch
      enddo
 12   format(i6,3f9.3,f9.4,2f8.3)
 13   format(1x,"'",a6,24x,"'",2f10.2,4f10.5)
 96   nb=i-1  
      close(21)
      close(22)
      return
	end
c//////////////////////////////////////////////////////////
c  subroutine to add noise
c         add noise to all pixels within xcrit fraction of the sky value.
c         the noise is sqrt(gain*sky+(gain*readnoise) sq)/gain),
c         with a gaussian distribution
	subroutine addnoise(*,nfr,ix,nu,nv,kf)
c	integer*2 ix(nu,nv,kf),ibct(20)
	integer ix(nu,nv,kf),ibct(20)
	real etime,TARRAY(2)
	include 'ppparm.inc'
	include 'picdir.inc'
	if (xcrit.le.0.000001) xcrit=0.02
        CALL QUERYNFR(NFR,kf,0,*999,*601)
 601	write(6,1) xcrit
 1	format('  Enter threshold for adding noise',
     *     ' (fraction of sky) [',f6.3,']: ',$)
	call read1r(xcrit,*999,*601)
 602	write(6,2) gain,readnoise
 2	format('  Enter gain and readnoise (ADU) [',f6.3,f6.2,']: ',$)
	call read2r(gain,readnoise,*999,*602)
c   compute mean sky, and threshold level
c  automatic determination of threshold
	ibct(1)=njj(nfr)*0.2
	idelc=nint(njj(nfr)*.6/20)
	do 181 i=2,20
	  ibct(i)=ibct(i-1)+idelc
 181	continue
	ncolt=20
	call scbc(*182,nfr,ibct,ncolt,' ',2,sigmed,rcmed,
     *                ix,nu,nv,kf)
 182	ithres=nint((1.+xcrit)*rcmed)
	ithres=max(nint(rcmed+3),ithres)
c  the amplitude of the error includes a correction to the
c   existing variations (note that this does not correct
c   strictly for correlated noise, as that is still part of it)
	sigma=sqrt(gain*(rcmed+gain*(readnoise*readnoise-
     *         sigmed*sigmed)))/gain
	sigma=amax1(3.0,sigma)
	write(6,3) ithres,sigma
 3	format('  noise added -- threshold: ',i5,' sigma:',f9.4)
	inocor=0
	ISEED=-NINT(ETIME(TARRAY)*100)
	do 100 j=1,njj(nfr)
	  do 101 i=1,nii(nfr)
	    if (ix(i,j,nfr).gt.ithres) then
	      inocor=inocor+1
	      goto 101
	    else
	      IX(I,J,nfr)=ix(i,j,nfr)+sigma*GASDEV(ISEED)
	    end if
 101	  continue
 100	continue
	nfl(6,nfr)=1
 999	return1
	end
