C   parameters for pipelining photometry PPPARM.INC
c     (1) parameters for non-interactive entries
c             ipipe:   0 if subroutine needs to request inputs
c                      1 if inputs are in common block
c            
c     (2) object finding: irconp = ircon: connecting pixel diameter
c                         nsmoothp = nsmoothp: smoothing box size
c
c                         nfilref = file number of primary image 
c                                    (position in filestr)
c      
c      
c     (3) photometry:  ccenter: cdiampipe,ishmaxpipe
c 
c     
c     (4) misc:  rple: irplim: upper lim, irprep: replacement value
c                matchpos (subroutine simposmat):
c                   iinit,jinit
c                arf:  i) initref: AUD lim fraction: adulow (set to default)
c                      ii) iapmaxpipe (max aperture for autoref phot)
c                bleedmap: npad: npadpipe
c                smooth:   ismopipe: 0 = taper, 1=box
c                crm1:    isbpipe,jsbpipe: med filter size
c                         crsigpipe: sigma cut for CR
c                         ncemexpipe: mask file number for exclusion for CR map
c
c     (5) output name and output comment
c
	character poutname*24,poutcomm*60,phmname*24,fobsdate*20,
     *       futdate*20,arefname*24,pfiltstr*60,fobser*4,
     *       fdecstr*20,frastr*20,fobstime*20,ffiltn*1
 	common/pipeparm/ircspipe,irplim,irprep,iwcssh,
     *       iinitpipe,jinitpipe,iaprefpipe,cdiampipe,ishmaxpipe,
     *       iapmaxpipe,poutname,poutcomm,jchip,imaskpipe,npadpipe,
     *       ismtypepipe,ismthlenp,arefname,nsmthlenp,isbpipe,jsbpipe,
     *       crsigpipe,ncrexcpipe,isatpixpipe,adulowpipe,adulowfil(5),
     *       adusatpipe
c  common statement for storing info from each filter
c    fracen= RA(hr) of the center of chip, fdecen = dec of center
	common/filinfo/pfiltstr,nfilt,nfilref,phmname(10),fobsdate(10)
     *    ,fobstime(10),fzpt(10),fairmterm(10),fcolterm(10)
     *       ,frlat(10),frlong(10),fgain(10),fscale(10)
     *       ,fexptime(10),fobser(10),frastr,fdecstr,colapert 
     *       ,ffiltn(10)
c  WCS solution for each filter (appears alone in subr: readheadwcs)
c    fra11,fdec11: the RA and Dec of pixel 1,1
	common/fwcspar/fcrpix1(10),fcrpix2(10),fcrval1(10),fcrval2(10),
     *       fcd1_1(10),fcd1_2(10),fcd2_1(10),fcd2_2(10),ifwcs
     *       ,fra11(10),fdec11(10)
c   matching info for each filter and chip
c        imatch=1: good match; imatch=0: okay, but not used for average;
c        imatch<0: bad match, need redoing with average shift.
c        ichipsh= parameter for doing shift of posfil between filters
	common/matchinfo/xchshift(10,40),ychshift(10,40),
     *     pmxshift(10,40),pmyshift(10,40),imatch(10,40),ichipsh
