c///////////////////////////////////////////////////////////
c   subroutine package for mosaic images, up to 12.3 K
c
c
c/////////////////////////////////////////////////////
c
c  interpreter for 8k related commands
C
C
	SUBROUTINE mosaicom(*,MND,NFR,SCOM,RN,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION NFR(5),RN(5)
	CHARACTER*60 SCOM(6)
	CHARACTER*4 MND
	include 'ppparm.inc'
        include 'objcat.inc' 
	include 'mosaic.inc'
	if (mnd.eq.'rd8k') call r8kfits(nfr(1),nfr(2),scom(3),scom(4)
     *            ,0 ,ix,nu,nv,kf,*999)
	if (mnd.eq.'setm') call subimage(nfr,1,*999)
	if (mnd.eq.'scpo') call secpos(*999,nfr)
	if (mnd.eq.'sect') call setnsct(nfr(1),nfr(2),kf,*999)
	if (mnd.eq.'mkba') call mkbatch(*999)
	return
999 	RETURN1
	END
c/////////////////////////////////////////////////////
c  subroutine to manually set up section number
c
	subroutine setnsct(nfr,nsec,kf,*)
	include 'picdir.inc'
        CALL querynfr(NFR,KF,0,*999,*2001)
 2001	if (nsec.le.0) then
 600	  write(6,1) 
 1	format('  Enter section number: ',$)
	  call read1i(nsec,*999,*600)
	end if
	nsct(nfr)=nsec
 999	return1
	end 
c//////////////////////////////////////////////////////////
c   subroutine to decide the size of subimages
c  ipar=1: always ask for isubim input
c       0: ask for input only if isubim=0
c      -1: no input, if isubim=0, use isubim=1 default
c    
c   nxsec nysec are the sections allowable
	subroutine subimage(nfr,ipar,*)
	include 'mosaic.inc'
	include 'picdir.inc'
	include 'objcat.inc'
c  check isubim
	if (ipar.eq.-1.and.isubim.le.0) isubim=1
	if (isubim.le.0) then
 600	  write(6,1) 
 1	format(' ++ No subimage sectioning info, requesting set up:')
 	  call simsetup
	else if (ipar.eq.1) then
	   call simsetup
	end if
	if (nxsec.le.0) nxsec=3
	if (nysec.le.0) nysec=2
	if (nedge.le.0) nedge=100
	if (isubim.eq.1) then
c  divide image into chunks of nsiXnsjpixels, plus nedge pixel edge
c   give default values if none exist.
	  if (nsi.le.0) nsi=4100
	  if (nsj.le.0) nsj=4100
	else 
c  divide the image into even chunks, if it is bigger than 4500
	  ntemp=naxx(nfr)/4500+1
	  nsi=(naxx(nfr)+1)/ntemp
	  ntemp=nayy(nfr)/4500+1
	  nsj=(nayy(nfr)+1)/ntemp
 	  isubim=2
	end if	
	call secsetup(nfr)
c
c  figure out what is the max section
	do 100 k=1,6
	  if (isec2(k)-isec1(k).lt.nedge) go to 101
 100	continue
 101	k=k-1
	write(6,13) nsi,nsj,nedge,
     *      (i,isec1(i),jsec1(i),isec2(i),jsec2(i),i=1,k)
 13	format('  Section size: ',2I6, ' section edge:',i5/,6(' Sec#',
     *         i2,' :',4i7/))
 999	return1
	end
c/////////////////////////////////////////////
	subroutine simsetup
	include 'mosaic.inc'
 600	write(6,1) isubim
 1	format('  Enter subsection parameter (1=user entered size,',
     *    ' 2=equal size) [',i1,']: ',$)
	call read1i(isubim,*999,*600)
 	if (isubim.eq.1) then
 601	  write(6,2) nsi,nsj
 2	format('  Enter I, J sizes for subsection [',2i5,']: ',$)
	  call read2i(nsi,nsj,*999,*601)
	end if
 602	write(6,3) nedge
 3	format('  Enter padding edge size in pixels [',i3,']: ',$)
	call read1i(nedge,*999,*602)
 999	return
	end 
c////////////////////////////////////////////////////////////////
c  set up section pixel boundry parameters for all subsection of a
c   mosaic image 
c
	subroutine secsetup(nfr)
	include 'mosaic.inc'
	include 'picdir.inc'
	nsec=0
	do 100 i=1,nxsec
	  do 101 j=1,nysec
	    nsec=nsec+1
	    isec1(nsec)=(i-1)*nsi+1
	    isec1(nsec)=max0(1,isec1(nsec)-nedge)
	    jsec1(nsec)=(j-1)*nsj+1
	    jsec1(nsec)=max0(1,jsec1(nsec)-nedge)
	    isec2(nsec)=i*nsi
	    isec2(nsec)=min0(naxx(nfr),isec2(nsec)+nedge)
	    jsec2(nsec)=j*nsi
	    jsec2(nsec)=min0(nayy(nfr),jsec2(nsec)+nedge)
 101	  continue
 100	continue
	return
	end
c/////////////////////////////////////////////////////
c  set-up object finding boundry parameters
c   for sectioned image with edge padded
	subroutine secposlim(npf)
	include 'mosaic.inc'
	include 'objcat.inc'
	include 'picdir.inc'
	if (isubim.eq.0.or.nsct(npf).le.0) then
	  if (isubim.eq.0) then
	    write(6,*) '  ++ no subimging, largest size used'
	  else 
	    write(6,*) '  ++warning: Section#=0, largest size used'
	  end if
	  ilpos(npf)=1
	  jlpos(npf)=1
	  iupos(npf)=nii(npf)
	  jupos(npf)=njj(npf)
	  goto 900
	end if
c	if (nsct(npf).le.0) then
c	end if
 	nsec=nsct(npf)
	if (isec1(nsec).eq.1) then
	  ilpos(npf)=1
	else 
	  ilpos(npf)=1+nedge
	end if
	if (jsec1(nsec).eq.1) then
	  jlpos(npf)=1
	else 
	  jlpos(npf)=1+nedge
	end if
	if (isec2(nsec).eq.naxx(npf)) then
	  iupos(npf)=nii(npf)
	else 
	  iupos(npf)=nii(npf)-nedge
	end if
	if (jsec2(nsec).eq.nayy(npf)) then
	  jupos(npf)=njj(npf)
	else 
	  jupos(npf)=njj(npf)-nedge
	end if
 900	write(6,2) ilpos(npf),jlpos(npf),iupos(npf),jupos(npf)
 2	format('  Position file limits: lower IJ:',2i5,'  upper IJ',2i5)
	call worldpos(npf,nsct(npf),ipl,jpl,ipu,jpu)
	write(6,5) ipl,jpl,ipu,jpu
 5	format('                 in world co-ord:',2I5,10x,2I5)
	return
	end
c/////////////////////////////////////////////
c  subroutine to map a single world co-ordinate posfile onto
c     the section
c    - this takes the pos file in existence and remake the posfile
c      to contain only the objects within the defined section
c                   April 11 2000
	subroutine secpos(*,nfr)
	parameter(ntmax=10000)
c	integer*2 itemp(ntmax),jtemp(ntmax)
	integer itemp(ntmax),jtemp(ntmax)
	include 'objcat.inc'
	include 'mosaic.inc'
	include 'picdir.inc'
c  determine upper and lower limits for sectional boundry
c    the sectional boundry info is stored in isec and jsec,
c    but need to deal with the edge effect
	call secposlim(nfr)
	call worldpos(nfr,nsct(nfr),mini,minj,maxi,maxj)
	newnob=0
	do 110 i=1,nob(nfr)
	  if (ijoi(i,nfr).le.maxi.and.ijoi(i,nfr).ge.mini) then
	    if (ijoj(i,nfr).le.maxj.and.ijoj(i,nfr).ge.minj) then
	      newnob=newnob+1
	      itemp(newnob)=ijoi(i,nfr)
	      jtemp(newnob)=ijoj(i,nfr)
	    end if
	  end if
 110	continue
c  put the temp array into pos file array, overwriting it
	nobold=nob(nfr)
	nob(nfr)=newnob
	do 111 i=1,newnob
c must correct from world co-ordinate to section co-ordin
	  ijoi(i,nfr)=itemp(i)-isec1(nsct(nfr))+1
	  ijoj(i,nfr)=jtemp(i)-jsec1(nsct(nfr))+1
 111	continue
	write(6,10) nsct(nfr),nob(nfr),nobold
 10	format('  .. pos file reduced to section',i2,':',i6,
     *      ' objs (from original',i6,')')
 999	return1
	end
c///////////////////////////////////////////////////
c  subroutine to combine sectional pos files into a single
c    super world co-ordinate file

c/////////////////////////////////////////////////////
c   subroutine to take a single world co-ordinate file
c     break it up into the various sections and save it as .pos.n files

c/////////////////////////////////////////
C
C   Subroutine to read mosaic image
c
c   flexible input: if nsec=0, nam1 is the fits name
c                   if nsec not= 0, nam2 is the name.
C
c    ipar=0 entry via ppp
c    ipar=1 entry via rdf
        subroutine r8kfits(NFR,nsec,NAM1,nam2,ipar,IX,NU,NV,KF,*)
c       INTEGER*2 IX(NU,NV,KF),ixy(1440),nflag,nid,njd
        INTEGER IX(NU,NV,KF),ixy(1440),nflag,nid,njd
        INTEGER NPAX(2),bitpix
        REAL*8 BSCALE,BZERO
	logical ex
        CHARACTER*24 filenc,filenf,ITEST1*20,nam1*60,nam2*60,ncomc*35
        CHARACTER HEADBLK*2880,IANS*1,imdir*55,ncom*35,nfilen*24,
     *            fitsname*18,filen*24
        COMMON/PICC/NCOMC(15),fitsname(15)
	common/imagedir/imdir
        INCLUDE 'picdir.inc'
        INCLUDE 'mosaic.inc'
	include 'tvparm.inc'
        COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254)
        CALL querynfr(NFR,KF,0,*999,*2001)
C   get fits file name, default extension=fits
2001    if (nsec.le.0) then
	  filenc=nam1
	else 
	  filenc=nam2
	end if
C decode filename
	IR=0
        IF (FILENC.EQ.' ') WRITE(6,10)
 10     FORMAT('  Enter fits file name: ',$)
 309    CALL RDFILN(FILENC,NC,IPF)
C  name too long or aborted
        IF (IPF.LE.-1) go to 999
C  get name for checking with directory
        FILEN=FILENC(1:NC)
        IF (IPF.EQ.0) THEN
C       get name for OPEN statement
C  no qualifier, append .fits
          FILENF=FILENC(1:NC)//'.fits'
        ELSE       
C  qualifier exits
          FILENF=FILENC
        END IF
C
C  first check for name in directory, IP=0 if not exist
C
        CALL DIREC(FILEN,FILENF,NFR,IP,1,IDF)
C
C  File name does not exit in pppdir;
        IF (IP.EQ.0) then
          WRITE(6,301) FILENF
 301    FORMAT(' ++ ',A18,' ++ does not exist in ppp DIRECTORY'
     *        /'    attempting to locate unlisted .fits file....')
        else
          WRITE(6,22) FILEN,ncom(idf),nid(idf),njd(idf)
 22	FORMAT(1X,A18,' : ''',A35,''' size: ',I4,' X ',I4)
        end if
	inofile=0
c
c  attempt to open file
 3011   open(unit=20,file=imdir(1:lnblnk(imdir))//filenf,
     *       access='direct',recl=2880,status='old',err=302)
c  successfully read
	goto 305
 302    close(unit=20)
	if (inofile.eq.1) then
	  write(6,41) finlenf
 41	format( '  +++ file [',a20,'] does not exits'/
     *          '     Enter file name: ',$)
	  goto 309
	end if
	inofile=1
c   try to find compressed version
c  for unix version -- first try for compressed version
        inquire(file=imdir(1:lnblnk(imdir))//filenf(1:lnblnk(filenf))
     *               //'.Z',exist=ex)
        if (ex.eqv..true.) then
c  uncompress
          write(6,*) '   +++ uncompressing .Z version ... '
          idum=system('uncompress '//imdir(1:lnblnk(imdir))//
     *         filenf(1:lnblnk(filenf))//'.Z')
          go to 3011
c  else look for gz file
        else
          inquire(file=imdir(1:lnblnk(imdir))//filenf(1:lnblnk(filenf))
     *               //'.gz',exist=ex)
          if (ex.eqv..true.) then
c gunzip
            write(6,*) '   +++ gunzipping .gz version ... '
            idum=system('gunzip '//imdir(1:lnblnk(imdir))//
     *         filenf(1:lnblnk(filenf))//'.gz')
            go to 3011
          end if
        end if
 305	fitsname(nfr)=filenf
	  krec=1
          READ (unit=20,rec=krec,ERR=987) HEADBLK
c         READ (unit=20,rec=krec,ERR=987,END=986) HEADBLK
C  go through header block and extract needed info
          NHEAD=1
          IHB=0
          N1=1
          N2=80
          IANS=HEADBLK(30:30)
          IF (IANS.NE.'T') GO TO 987
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get "Number-of-bits-per-data-point"
          READ (HEADBLK(N1:N2),502) bitpix
	  if (bitpix.ne.16) then
	    write(6,*) '  *** cannot read fits not in short integer ***'
	    return1
	  end if	
502     FORMAT (10X,I20)
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get number of axes
          READ (HEADBLK(N1:N2),502) NAXIS
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get number of data points along first axis, etc.
          DO 108 I=1,NAXIS
            READ (HEADBLK(N1:N2),502) NPAX(I)
            if (ip.eq.0) WRITE(6,12) headblk(n1:n2) 
 12   FORMAT(1X,A79)
            NHEAD=NHEAD+1
            N1=N1+80
            N2=N2+80
            N3=N1+2
 108      CONTINUE
          IF (NPAX(1).GT.NU.OR.NPAX(2).GT.NV) THEN
            WRITE(6,*)' Image > 4500, subsectioning required '
          END IF
	  naxx(nfr)=npax(1)
	  nayy(nfr)=npax(2)
	  bscale=1.
	  bzero=0.
c  read remaining header
C  get bscale and bzero
C  find objectname and put it in the comment field
          KNH=36-NHEAD
 150      IF (IHB.GE.1) KNH=36
          DO 110 I=1,KNH
c	    if (krec.le.2) write(6,'(a80)') headblk(n1:n2)
            IF (headblk(n1:n2).EQ.' ') GO TO 117
            ITEST1=HEADBLK(N1:N3)
            IF (ITEST1.EQ.'OBJ')  then
	        READ(HEADBLK(N1+11:N1+39),'(a29)') NCOMC(NFR)
                if (ip.eq.0) WRITE(6,12) headblk(n1:n2)
	    else if (ITEST1.EQ.'BSC') then
	      READ(HEADBLK(N1+11:N1+30),*) BSCALE
            else if (ITEST1.EQ.'BZE') then
	      READ(HEADBLK(N1+11:N1+30),*) BZERO
            else IF(ITEST1.EQ.'END') then
	      GO TO 111
	    end if
c            NHEAD=NHEAD+1
 117        N1=N1+80
            N2=N2+80
            N3=N1+2
c            N4=N1+11
110      CONTINUE
C   "END" is not reached, read another header block
	 krec=krec+1
         READ (20,rec=krec,ERR=986) HEADBLK
c        READ (20,rec=krec,ERR=986,END=986) HEADBLK
         IHB=IHB+1
	 n1=1
	 n2=80
	 n3=3
c	 n4=n1+11
         GO TO 150
 111     CONTINUE
C
C  read data
	if (npax(1).gt.4500.or.npax(2).gt.4500) then
c subimage division needed
c  check if section arrays are set up
	  call subimage(nfr,-1,*6001)
 6001	  if (nsec.le.0) then
 601	    write(6,13) nsec
 13	format('  Enter subimage section number [',i1,']: ',$)
	    call read1i(nsec,*999,*601)
	  end if
	  nsct(nfr)=nsec
c set default position file limits
          NII(NFR)=min(npax(1),isec2(nsec))-isec1(nsec)+1
          NJJ(NFR)=min(npax(2),jsec2(nsec))-jsec1(nsec)+1
	  if (nii(nfr).le.0.or.njj(nfr).le.0) then
	    write(6,*) ' *** section requested beyond image, ',
     *                   'read aborted'
	    goto 123
	  end if
	  call secposlim(nfr)
	  nfl(6,nfr)=1
	else
	  write(6,20)
 20	format('  +++ image smaller than 4.5K, no subsectioning needed')
	  nsec=1
	  nsct(nfr)=0
          NII(NFR)=NPAX(1)
          NJJ(NFR)=NPAX(2)
	  nfl(6,nfr)=0
	end if
c find the first record of the first pixel
        write(6,*) 'BSCALE ',BSCALE,'    BZERO ',BZERO
c first pixel of the section
	i=1
	j=1	
c  row number and the 1st pixel of the section in the total image
	mrow=0
	krecd=krec
	maxrec=npax(1)*npax(2)/1440+1+krec
	if (abs(1.-bscale).lt.0.0001.and.abs(bzero).lt.0.01) then
c for the case where no scaling was done to the data
c
c  reading is done by rows, all pixels are tagged by their
c    sequential number, beginning at (1,1)
c npix1 and npix2 are the beginning and end pixel number of row mrow,
 124  	  npix1=mrow*npax(1)+(jsec1(nsec)-1)*npax(1)+isec1(nsec)
	  npix2=npix1+nii(nfr)-1
c   the next record number (krecd) in which contains pixels that needs
c    to be read is determined (krec is the number of header record)
c  
 125	  krecd=krecd+1
c  check to make sure krecd is not too big
	  if (krecd.gt.maxrec) then
	    write(6,18) krecd
 18	format('  Try to read beyond largest record number ',i5, 
     *        ' ** aborted ')
	    goto 123
	  end if
c  kr1 is the ordinal number of the first pixel of the record
	  kr1=(krecd-krec-1)*1440+1
	  kr2=kr1+1439
c  determine if this record contains any data: if k1 or k2 is between
c         npix1 and npix2, then the record contains needed data
c	if (mrow.le.10.and.krecd.lt.20) write(6,*) mrow,npix1,npix2,kr1,kr2
	  if ((kr1.ge.npix1.and.kr1.le.npix2).or.
     *        (kr2.ge.npix1.and.kr2.le.npix2)) then
 	    read(20,rec=krecd,err=985) ixy
c	    read(20,rec=krecd,err=985,end=984) ixy
c Jan 4 2000: do byte switch if imemcheck=-1
	if (imemcheck.eq.-1) call byte_swap(ixy,2880)
c  determine the first and last pixels in the record to be assinged
c   to subimage array
c   k1:    ----kr1---npix1----kr2---------npix2  or
c          ----------npix1-kr1-----kr2----npix2
c   i.e., k1 is 1, if kr1 is outside of npix1, and k1 is the
c            diff of the two if it is inside npix1
	    k1=max(1,npix1-kr1+1)
	    k2=min(1440,1440-(kr2-npix2))
c	if (krecd.lt.20) write(6,*) '   record ',krecd,' read ',k1,k2
	  else
c  record not in section, increase number by 1
	    goto 125
	  end if
c record read, now assign the pixels into the correct IJ position
          do 122 k=k1,k2
	    ix(i,j,nfr)=ixy(k)
	    if (i.eq.nii(nfr)) then
c  the current row is done, set up for the next row
	      j=j+1
c  all rows are read
	      if (j.gt.njj(nfr)) go to 123
c  set up for next row
	      i=1
	      mrow=mrow+1
	    else
	      i=i+1
	    end if
 122	  continue
	  go to 124
	else
c with scaling
	end if
 123	CLOSE(UNIT=20)
c tiddy up directories
	if (ip.ne.0) then
	  nf(nfr)=idf
	  ncomc(nfr)=ncom(idf)
	  do 210 k=1,5
 	    nfl(k,nfr)=nflag(k,idf)
 210	  continue
	else
c image not in ppp dir, update pppdir
	  do 211 k=1,5
 	    nfl(k,nfr)=0
 211	  continue
c trick direc to put in the correct total size
	  nit=nii(nfr)
	  njt=njj(nfr)
	  nii(nfr)=naxx(nfr)
	  njj(nfr)=nayy(nfr)
          call direc(filen,filenf,nfr,ip,4,idf)
c add header to ncom
          ncom(nof)=ncomc(nfr)
	  nii(nfr)=nit
	  njj(nfr)=njt
	end if
	write(6,29) filen,nsct(nfr),nfr
 29	format('  Image ',A18,' section',i2,' read from Disk to Frame'
     *          ,i3)
 999    RETURN1
 998    WRITE(6,*) '  **** NO SUCH FILE ***'
        RETURN1
 986    WRITE(6,*) '  **** CAN''T READ HEADER *** ',IHB+1
        CLOSE(UNIT=20)
        RETURN1
 987    WRITE(6,*) '  **** NOT SIMPLE FITS ***'
        CLOSE(UNIT=20)
        RETURN1
 985    WRITE(6,*) '  **** ERR READING DATA *** at ',I,J
        CLOSE(UNIT=20)
        RETURN1
 984    WRITE(6,*) '  +++ DATA ENDED PREMATURELY +++ at ',I,J
        CLOSE(UNIT=20)
        RETURN1
        END
c//////////////////////////////////////////////
c
c  subroutine for generating obj finding and photometry batch
c    files based on template files. 
c    the command reads in a template batch job, and an input
c   file that contains the name (name+chip number) and the shifts
c    between two filters.  It searches for XXXXXX and replaces it
c    with the name, and YY and replaces it with the chip number.
c    it also search for the command wtav or shif and replace the
c    shifts in the pos file.
c     it generates a batch job with the name: ofXXXXXX.pppin or
c                            photXXXXXX.pppin
c     
c
	subroutine mkbatch(*)
c  can do up to 300 frames
	character batstr(900)*80,fieldstr(500)*80,infil*20,outfil*20,
     *     outhead*4,outstr*80,chipname*2,fieldname*12,fieldfile*20,
     *     dumstr*4,fstr10*20,batchname*20,master*20,outfilout*20,
     *     adustr*6,ppppath*48,lnstr*4
	common/pppname/ppppath
	dimension ie(10),ib(10),sky(2)
 600	write(6,1)
 1	format('  Enter template .pppin name (.pppin appended): ',$)
	read(5,'(a20)',end=999) infil  
	infil=infil(1:lnblnk(infil))//'.pppin' 
	open(unit=28,file=infil,status='old',err=600)
	do 100 i=1,900
	  read(28,'(a80)',end=101) batstr(i)
 100 	continue
	write(6,*) ' **** WARNING **** line exceeds ',900
 101	nlbat=i-1
	write(6,*) nlbat
	close unit=28
c figure out the filter names
 601	write(6,2)
 2	format('  Enter full field and shift data file name: ',$)
	read(5,'(a20)',end=999) fieldfile 
	open(unit=28,file=fieldfile,status='old',err=601)
	do 102 i=1,500
	  read(28,'(a80)',end=103) fieldstr(i)
 102	continue
	write(6,*) ' *** warning: number of images exceeds ',500
 103	nlfield=i-1
	close unit=28
c  determine header for the output file: "of" for obj finding,
c                                        "phot" for photometry
	if (infil(1:2).eq.'of') then
	  outhead=infil(1:2)
	else if (infil(1:4).eq.'phot') then
	  outhead=infil(1:4)
	else
	  outhead=infil(1:4)
	end if
c  open file for the master batch
	master=outhead(1:lnblnk(outhead))//'.batch'
	call opennew(30,1,20,master,*999)
c
c  do for each field
	do 110 i=1,nlfield
c  determine field name, chip number, shift, and sky values
c
c  parse string
	  call fstr(fieldstr(i),80,ib,ie,ntok)
c  err=120 ensures that if there is no shift data, nothing is done
	  if (ntok.lt.2) then
	    xshift=0.0
	    yshift=0.0
	  else 
 	    read(fieldstr(i)(ib(2):ie(2)),*,err=110) xshift
c  old format
c	    read(fieldstr(i)(ib(4):ie(4)),*,err=110) yshift
 	    read(fieldstr(i)(ib(3):ie(3)),*,err=110) yshift
	  end if
c read background sky level if exist
	  if (ntok.ge.4)
     *         read(fieldstr(i)(ib(4):ie(4)),*,err=110) sky(1)
	  if (ntok.ge.5)
     *         read(fieldstr(i)(ib(5):ie(5)),*,err=110) sky(2)
c
c  there is shift data, now read the name
	  istatus=encode(dumstr,float(ie(1)-ib(1)+1),1,0,idum)
	  fstr10='(a'//dumstr(1:lnblnk(dumstr))//')'
	  read(fieldstr(i)(ib(1):ie(1)),fstr10) batchname
c parse the batchname into field name and chip number
	  do 111 k=1,ie(1)-ib(1)+1
	    if (batchname(k:k).eq.'_') then
	      fieldname=batchname(1:k-1)
	      chipname=batchname(k+1:k+2)
	      goto 112
	    end if
 111	  continue
 112	  write(6,10) batchname,nint(xshift),nint(yshift)
 10	format(a20,2i6)
c  create the output file name 
	  outfil=outhead(1:lnblnk(outhead))//
     *      batchname(1:lnblnk(batchname))//'.pppin'
	  outfilout=outhead(1:lnblnk(outhead))//
     *      batchname(1:lnblnk(batchname))//'.pppout'
	  call opennew(29,1,20,outfil,*999)
c
c   go line by line from the batch string (batstr).
c  For each string in the template, search for XXXXX, YY, 
c   (XXXXX are replaced by field names, and YY replaced by chip number)
c   and commands wtav and shif and "set adusat"
c       (when commands are find, the subsequent line is replaced
c            by the input values).
	  kshift=-99
	  do 120 k=1,nlbat
	    lent=lnblnk(batstr(k))
	    if (kshift.eq.k) then
c  write out the shift 
	      write(29,'(2i5)') nint(xshift),nint(yshift)
	      kshift=-99
	      goto 120
	    end if
c  replace YY in mask file name by chip number
	    if (batstr(k)(1:4).eq.'mask') then
	      do 131 j=5,lent
	        if (batstr(k)(j:j+1).eq.'YY') then
	          outstr=batstr(k)(1:j-1)//chipname//batstr(k)(j+2:lent)
	          goto 140
	        end if
 131	      continue
c search for command wtav, shif, and "set adu"
c   when these commands are found, the command is written out
c   as outstr, and the next line is writen out as number inputs
c    for the command.  In the case for wtav, the shift comes
c    2 lines later (kshift=k+2), for shif, one line later,
c    for "set adu", on the same line.
	    else if (batstr(k)(1:4).eq.'wtav') then
	      kshift=k+2
	      outstr=batstr(k)
	    else if (batstr(k)(1:4).eq.'shif') then
	      kshift=k+1
	      outstr=batstr(k)
	    else if (batstr(k)(1:12).eq.'set adusat Z') then
c replace ZZZZ with sky +1000
	      iaduval=sky(1)+1000.
              istatus=encode(adustr,float(iaduval),1,0,idum)
	      outstr='set adusat '//adustr
c
c  XX's are replaced by field name
	    else if (batstr(k)(1:2).eq.'XX') then
	      do 132 j=3,lent
	        if (batstr(k)(j:j).eq.'X') then
	          goto 132
	        else
	          outstr=fieldname(1:lnblnk(fieldname))
     *             //batstr(k)(j:lent)
	          goto 133
	        end if
 132	      continue
c now search for chipname
 133	      do 134 jj=j+1,lent
	        if (batstr(k)(jj:jj+1).eq.'YY') then
	          outstr=outstr(1:jj-1)//chipname//batstr(k)(jj+2:lent)
	          goto 140
	        end if
 134	      continue
	    else
	      outstr=batstr(k)
	    end if
c it seems that lnblnk consider _ as the end of the string!
c   th3 max0(24) make sure any underscores in a name is not truncated.
	    istat=encode(lnstr,float(max0(24,lnblnk(outstr))),1,0,idum)
	    fstr10='(a'//lnstr(1:lnblnk(lnstr))//')'
 140	    write(29,fstr10) outstr(1:max0(24,lnblnk(outstr)))
 120	  continue
	  close(unit=29)
	  write(30,20) ppppath, outfil,outfilout
c20	format('nice -15 /d/makalu/hyee/bpppxS2/ppp8ksmall/ppp8k < ',
c20	format('nice /d/makalu/hyee/bpppxS2/ppp8ksmall/ppp8k < ',
 20	format('nice ',a48,' < ', 
     *    a20,' > ',a20)
 110	continue
	close(unit=30)
 999	return1
	end 
c/////////////////////////////////////////////////
c  subroutine to do byte swapping
c
	subroutine byte_swap(b,nbyte)
	byte b(nbyte),temp
	do 100 i=1,nbyte,2
	  temp=b(i)
	  b(i)=b(i+1)
	  b(i+1)=temp
 100	continue
	return
	end
