C////////////////////////////////////////////////////////////////
C
C    SUBROUTINE  PACKAGE TO DO high precision relative stella photometry
C     	USING sincshift centroided images
C
C////////////////////////////////////////////////////////////////////
c       
c    driving routine
C
C               IPRT=0 DO NOT PRINT INTERMEDIATE RESULTS
C 		IPR1=1 PRINT ALL INTERMEDIATE STEPS
C               IPO=0 SAVE RESULTS
C               IPO>0 NO WRITE
C               IPAR=1 automatic choice for reference objects and
C                      automatic /PRI plot of PC2
	SUBROUTINE sapdri(*,NFRA,strf,tcomment,IPART,IX,NU,NV,KF)
c maximum objects
	parameter(nmax=15000)
c maximum psfs
	parameter(nfmax=300)
c	INTEGER*2 IX(NU,NV,KF),IDS(nmax),ipsff,jpsff
	INTEGER IX(NU,NV,KF),IDS(nmax),ipsff,jpsff
     *    ,ICLP(nmax),ICLS(nmax),
     *    NMASK(500,500),NNEI(nmax),IDBR(nmax),nhalo(500)
	integer NNG(200)
	DIMENSION  NFRA(5),RI(30),RMAG(30,nmax),PK(nmax),
     *   REALI(nmax),REALJ(nmax),SKY(nmax),ZSIG(nmax),
     *    DELMAG(nmax),EXMAG(nmax),SP(0:30,nmax)
     *     ,SKYERR(nmax),SUMDEL(nmax),RAD(nmax),
     *   SKARAY(50000),CLSCT(3),PIXN(30),REFST(30,5,5),IREF(10,5,5),
     *   idsref(5,5),nref(5,5),refpk(5,5),refstt(30),
     *     irefv(nfmax),see(5,5),psfpx(5,5),psfpy(5,5),refstv(30,nfmax)
     *     ,idsrefv(nfmax),psfpxv(nfmax),psfpyv(nfmax),refpkv(nfmax),
     *     index(nfmax),distpsf(nfmax),xline(250),dlograd(29)
c    *       ELL(nmax),ANG(nmax),RSQ(nmax)
	CHARACTER*18 FILOUT,FILT,DEV,HPLOT,SPLOT
	CHARACTER*1 IANS,IANS2,secstr
	CHARACTER*60 COMMENT,STRF,TCOMMENT
	character*64 string1,string2,fstr24,fstr27
c	CHARACTER ADATE*9,ATIME*8
	character*24 fdate,ian*1
	REAL*8 FIL
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	COMMON/PLOTDEV/ HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
 	equivalence (iscr(1),rmag(1,1)),(iscr(900001),sp(0,1))
     *       ,(iscr(1900001),skaray(1))
      
c     *     ,(iscr(300001),PK(1)),(iscr(310001),REALI(1)),
c     *     (iscr(320001),REALJ(1)),(iscr(330001),SKY(1)),
c     *     (iscr(845001),ZSIG(1)),(iscr(861001),ELL(1)),
c     *     (iscr(874001),ANG(1)),(iscr(887001),RAD(1)),
c     *     (iscr(380001),DELMAG(1)),(iscr(390001),EXMAG(1)),
c     *     (iscr(400001),SKYERR(1)),(iscr(410001),nnei(1)),
c     *     (iscr(415001),IDS(1)),(iscr(420001),ICLP(1)),
c     *     (iscr(425001),ICLS(1)),(iscr(430001),idbr(1)),
c     *     (iscr(435001),rsq(1)),(iscr(445001),sumdel(1)),
c     *     (iscr(455001),refstv(1,1)),(iscr(460001),ri(1)),
c     *     (iscr(460101),pixn(1)),(iscr(460201),index(1)),
c     *     (iscr(460401),see(1,1)),(iscr(460501),distpsf(1)),
c     *     (iscr(463001),iref(1,1,1)),(iscr(464001),irefv(1)),
c     *     (iscr(500001),APERMASK(1,1)),(iscr(540001),NMASK(1,1))
c     *     ,(iscr(610001),sp(0,1)),(iscr(920001),skaray(1))
 	equivalence (refstv(1,1),refst(1,1,1)),(psfpxv(1),psfpx(1,1)),
     *               (psfpyv(1),psfpy(1,1)),(idsrefv(1),idsref(1,1)),
     *               (refpkv(1),refpk(1,1))
c	iprt=1
	CDIAM=NAPCEN
	NFR=NFRA(1)
	IPAR=IPART
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=6 FOR POSITION FILE'
	  RETURN1
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	kf1=2
	nfl(6,kf1)=1
	WRITE(6,20) KF1,2*ISINCF+1,2*ISINCF+1
 20	FORMAT('  -- interim sinc-shifted picture to be stored in <f>',
     *      i2,', size',I4,' x',I4)
	NOBB=NOB(NFR)
	IF (NOBB.GT.nmax) THEN
          WRITE(6,*) '  *** Warning, number of objects > ',nmax
	  write(6,*) '    photometry for object# >',nmax,
     *             ' may be incorrect'
	ELSE IF (NOBB.LE.0) THEN
	  WRITE(6,*) '  **** Position file contains zero object ***'
	  RETURN1
	END IF
 600	CALL READFN(FILT,STRF(1:18),FILOUT,'phm','o',11,*999,*600,*20010)
20010	IF (FILOUT.NE.'n') THEN 
	  IF (TCOMMENT.EQ.' ') THEN
 601	    WRITE(6,10) COMMENT
 10	FORMAT('   ENTER comment, <=60 characters: Default: '/,' (',
     *        A60,')'/' :',$)
	    CALL READSTRD(60,COMMENT,*999,*601)
	  ELSE
	    COMMENT=TCOMMENT
	  END IF
	  if (nsct(nfr).ne.0) then
	    istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
	    filout=filout(1:lnblnk(filout))//'.'//secstr
	  end if
	END IF
 602	K=4
	IF (FILOUT.EQ.'n') K=3
c aperture info
	IF (NFRA(K).LE.IAPMIN+4) THEN
	  WRITE(6,11) IAPMIN,IAPIS,IAPMAX
 11	FORMAT(' Initial obj diameter:',I2,', Max sky diam=(max obj dia'
     *        ,'m)+',I2,
     *	  /'   Enter MAX obj DIAMETER in integer pixels [',i3,']: ',$)
	  CALL READ1I(IAPMAX,*999,*602)
	ELSE
	  IAPMAX=NFRA(K)
	  NFRA(K)=0
	END IF
	IF (IAPMAX.LE.IAPMIN) GO TO 602
	IAP2=IAPMAX+IAPIS+3
	IF (IAP2.GT.maxap) THEN
	  WRITE(6,*) '  **** Diameter too large ******'
	  GO TO 602
	END IF
 599	WRITE(6,5)
 5	FORMAT('  Do you want automatic iterative re-centroding '
     *         ,'[y=dflt/n]: ',$)
	call readstr(1,ian,*999,*599)
	IF (IAN.NE.'n') THEN
	  CALL CCENTER(*5994,NFR,0,IX,NU,NV,KF)
 5994	  IF (IPAR.NE.1) THEN
 	    CALL RBELL(1)
 5991	    WRITE(6,29)
 29	FORMAT('  Proceed with photometry? y(=<cr>)/n: ',$)
	    call readstr(1,ian,*999,*5991)
	    IF (IAN.EQ.'n') RETURN1 
	  END IF
C reset sky aperture
	  IAP2=IAPMAX+IAPIS+3
	END IF
c set up frame kf1 parameters
	irobj=iap2
	NII(KF1)=MAX0(IROBJ+2,2*ISINCF+1)
	NJJ(KF1)=NII(KF1)
	IPSFF=NII(KF1)/2+1
	JPSFF=NJJ(KF1)/2+1
c	WRITE(6,*)  nii(kf1),irobj,iap2
	WRITE(6,*) '  --- Photometry starts ... '
C create sky aperture
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
C number of apertures
	NAP=MIN0(30,(IAPMAX-IAPMIN+IDELD)/IDELD)
	IEXAP1=MIN0(IEXAP,NAP)
C
C   MAKE APERTURES
C
	DO 100 I=1,NAP
	  IAP1(I)=IAPMIN+(I-1)*IDELD
	  CALL APARAY(IAP1(I),IT1(1,I),IROW1(I),QQ(I),RR(I),PP(I),NA(I),
     *           IPRT)
 	write(6,*) iap1(i),na(i),irow1(i)
 100	continue
	IAP1(31)=IAP1(NAP)+3
C  set inner sky aperture radius
	IF (IAP2-IAP1(NAP).GT.8) THEN
	  NNAP=31
	ELSE
	  NNAP=NAP
	END IF
	CALL APARAY(IAP1(NNAP),IT1(1,NNAP),IROW1(NNAP),QDUM,RDUM,PDUM
     *                 ,NA(NNAP),IPRT)
c    !Max radius
	IRMAX=IAP1(NAP)          
	IRMAXSQ=IRMAX*IRMAX          
c  ! array size for neighbor mask
	MASKSIZE=MIN0(500,2*IAP1(NAP)+1)     
	iexapf=min0(iexap,nap)
c  compute average sky for purpose of checking in case
c   bright stars or bad columns
c backup sky from circle, from 2 positions 
        I1=NI/3
        J1=NJ/3
        CALL RCSKY(1,BKG1,BSIG1,1,I1,J1,NI,NJ,IX,NU,NV,SKARAY,
     *           50000,nsky,0,IPR)
        I1=2*NI/3
        CALL RCSKY(1,BKG,BSIG,1,I1,J1,NI,NJ,IX,NU,NV,SKARAY,
     *             50000,nsky,0,IPR)
        J1=2*NJ/3
        CALL RCSKY(1,BKG2,BSIG2,1,I1,J1,NI,NJ,IX,NU,NV,SKARAY,
     *             50000,nsky,0,IPR)
c  backup is the middle one
        if (bkg.gt.bkg1.and.bkg2.gt.bkg1) then
          if (bkg.gt.bkg2) then
            bkg1=bkg2
          else
            bkg1=bkg
          end if
        else if (bkg.lt.bkg1.and.bkg2.lt.bkg1) then
          if (bkg.gt.bkg2) then
            bkg1=bkg
          else
            bkg1=bkg2
          end if
        end if
	bsig=0.3333*(bsig+bsig1+bsig2)
        WRITE(6,*) '  Back-up sky value: ',BKG,bsig
	iskyaper=0
c set up delta log radius
	do 144 i=1,nap-1
	  itemp=iapmin+i*ideld
	  dlograd(i)=alog10(float(itemp)/float(itemp-ideld))
 144	continue
c multiply by .5 for testing
	bkg=bkg*.5
	mh=0
	nvpsf=min0(4,nvpsf)
 	IS2=(ISINCF+2)/2    
c cplx is used as a proxy for the parameter to control the
c   sinc shift cut off, in units of 1% saturation
	pkcrit=cplx*.01*(adusat-bkg)
C
C...............................................................
C  Big loop #1
C  do photometry for each objects
C
	DO 101 I=1,NOB(NFR)
c ! Maximum allowable final aperture
	  MAXIDS=nap         
	  II=IJOI(I,NFR)
	  JJ=IJOJ(I,NFR)
	  if (ii.le.0.or.ii.gt.ni.or.jj.le.0.or.jj.gt.nj) then
	    write(6,87) i,ii,jj
 87	format('  +++ obj#',i4,' at',2i4,
     *             ' outside of image: photometry not done ')
	    ids(i)=1
	    reali(i)=ii
	    realj(j)=jj
	    do 1011 k=1,nap
	      rmag(k,i)=99.
 1011	    continue
	    nnei(i)=0
	    sky(i)=-99.0
	    zsig(i)=0
	    REALI(I)=II
	    REALJ(I)=JJ
	    pk(i)=0.
	    skyerr(i)=0.
	    go to 101
	  end if
C  check for neighbours
	  CALL NNEIGH(NNEI(I),NNG,II,JJ,NOBB,IJOI(1,NFR),IJOJ(1,NFR),
     *          I,IRMAX,IRMAXSQ)
 105	  WRITE(6,12) I,NNEI(I)
 12	FORMAT(/' Object #',I4,'  Number of neighbours:',I3)
C  determine sky
	  IF (ISKYSEC.EQ.0) THEN
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,1,IPR)
	  ELSE
	    CALL RING8SKY(SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,IPRT,IPR)
	  END IF
c check if sky is reasonable (ie > 0.5 of average)
c  May 20 1997: do not quite understand why this is used. Apparently
c     it causes problems.   Jun 3 1999, the problem could be due
c         to not resetting the aperture; this has been added.
	  if (sky(i).lt.bkg) then
c  reduce aperture to 2/3 max aperture to max aperture
	    iap2=iapmax
C create sky aperture
	    CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	    nnaptem=nap*2/3
	    write(6,*) '  ... sky too low, reduced sky aperture used '
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAPTEM,II,JJ,NI,NJ,
     *                 IX(1,1,NFR),NU,NV,SKARAY,50000,nsky,1,IPR)
C reset sky aperture
	    IAP2=IAPMAX+IAPIS+3
	    CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
c  if there still is a problem, use 1.5* average
	    if (sky(i).lt.bkg) then
	      sky(i)=2*bkg
	      zsig(i)=3*bsig
	    end if
	    write(6,*) '    +++ sky problem, recomputed: ',sky(i)
	  end if
 	  IF (IPR.NE.0) THEN
	    WRITE(6,*) ' ****  photometry not done *****'
	    DO 106 JK=1,30
	      RI(JK)=0.
 106	    CONTINUE
	    ZSIG(I)=0.
	    REALI(I)=II
	    REALJ(I)=JJ
	    GO TO 107
	  END IF
C  set up mask  (turned off by making NNEI(i)=0
 	  CALL MAKEMASK(500,MASKSIZE,NMASK,NNEI(I),NNG,
     *       IJOI(1,NFR),IJOJ(1,NFR),II,JJ,
     *       SKY(I),IRMAX,IX(1,1,NFR),NU,NV,NI,NJ,maxids,iapmin)
C Determine fractional pixel centroid
 399	  CALL PHOTCEN(II,JJ,REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,CDIAM,
     *         IX(1,1,NFR),NU,NV,NI,NJ,CENSTEP,ITERCEN,IPRT)
c  	  write(6,*) ' adopted centroid: ',REALI(I),REALJ(I)
c 
c   check the brightness of the object (via central pixel), if the
c    central pixel is less than 1/50 of saturation above sky, do
c    ordinary photometry
	  PK(I)=float(IX(NINT(REALI(I)),NINT(REALJ(I)),NFR))-SKY(I)
	  if (pk(i).lt.pkcrit) then
	    CALL PPPHOT(RI,SP(0,I),REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,
     *           NAP,IAP1,IX(1,1,NFR),NU,NV,NI,NJ,PIXN,IPRT)
c the array rad is used as a stand in to record whether sinc shift is used
	    rad(i)=0.000
	  else
c SINCSHIFT
C  cut out PSF and place in frame KF1, 
	  iob=nint(reali(i))
	  job=nint(realj(i))
	  ITT=IOB-NII(KF1)/2-1
	  JTT=JOB-NJJ(KF1)/2-1
	  DO 103 jm=1,NJJ(KF1)
	    Jk=jtt+jm
	    DO 104 im=1,NII(KF1)
 	      IX(im,jm,KF1)=IX(itt+im,Jk,NFR)
 104	    continue
c	  write(6,'(5i6)') (ix(kk,jm,kf1), kk=nii(kf1)/2-2,nii(kf1)/2+2)
 103	  continue
c sinc shift
	    CALL PSFCEN2(KF1,IPSFF,JPSFF,CDIAM,IROBJ,
     *       TXSH,TYSH,sky(i),is2,itercen,IX,NU,NV,KF)
	    WRITE(6,24) I, TXSH,TYSH
 24	FORMAT(i5,'..net sinc shift:',2F8.5)
c    *         '  Centroid in result frame:',2F10.4)
c
c do aperture photometry
	    call aperphot(kf1,ipsff,jpsff,RI,sp(0,i),
     *      NII(kf1),NJJ(kf1),SKY,ZSIG,IX,NU,NV,KF,IW,ISKYSEC)
	    do 191 m=1,nap
	      pixn(m)=na(m)
 191	    continue
	    rad(i)=1.000
	  end if
 107	  SKYERR(I)=amin1(999.9,RI(ISE)/
     *             (AMAX1(.0001,ZSIG(I)*SQRT(AMAX1(0.,PIXN(ISE))))))
C  convert integrated and surface profile to magnitudes
	  DO 120 L=1,NAP
 	    IF (RI(L).GT.0.0000001) THEN
	      RMAG(L,I)=-2.5*ALOG10(RI(L))
	    ELSE 
	      RMAG(L,I)=99.
	    END IF
 120	  CONTINUE
C determine best integration magnitude
	  CALL IDSDET(NAP,RMAG(1,I),RI,PIXN,ZSIG(I),DER1X,DER2X,NSTOP)
C check that it is smaller than MAXIDS (dependent on neigbour distance)
	  IDS(I)=MAX0(1,MIN0(MAXIDS,NSTOP))
c
c  added June 1999: check log slope of last 4 points: if their
c   mean is >1.9, or if >1.7 and greater than the average of the
c    pts 2 and 3, then re-do photometry with adjusted sky
	  if (ids(i).gt.8.and.iskypar.eq.0) then
	    call chkslope(rmag(1,i),ids(i),dlograd,iskypar)
	    if (iskypar.eq.1) then
c  set sky aperture to 2/3 of current, and redo photometry with
c      sky=median instead of mode
	      iap2=iapmax+iapis*.6 
	      nnaptem=nap*2/3
	      skcmedtem=skcmed
	      skcmeantem=skcmean
	      skcmed=1.
	      skcmean=0.
	      CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	      CALL RCSKY(1,SKY(I),ZSIG(I),NNAPTEM,II,JJ,NI,NJ,
     *                 IX(1,1,NFR),NU,NV,SKARAY,50000,nsky,1,IPR)
C reset sky aperture
	      IAP2=IAPMAX+IAPIS+3
	      CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	      skcmed=skcmedtem
	      skcmean=skcmeantem
	      mh=mh+1
	      if (mh.lt.500) nhalo(mh)=i
	      goto 399
	    end if
	  end if
	  iskypar=0
C
C  output results
C
 	  WRITE(6,14) REALI(I),REALJ(I),RI(IDS(I)),RMAG(IDS(I),I),
     *      SKYERR(I),PK(I)
 14	FORMAT(3X,'centroid:',2F7.2,'  cts:',F8.0,'  mag:',F8.3,
     *        '  S/N:',F7.1,'  Npk:',F8.2)
	  WRITE(6,15) (RMAG(L,I), L=1,MIN0(10,NAP))
	  IF (NAP.GT.10) WRITE(6,16) (RMAG(L,I),L=11,NAP)
 15	FORMAT(3X,'m(rad):',10F7.2)
 16	FORMAT(10X,10F7.2)
 101	CONTINUE
C
C   End of loop for photometry for each object
c
C  ...........................................
c   loop #1A
c  new section added Jan 1995 to limit IDS for objects in the
c   halos of bright objects
c    procedure: (1) see if object is within IDS of another object
c                    which is 2 mag or more brighter
c               (2) redefine mask and limit IDS of the object to
c                    mask radius +ideld.
c               (3) redo-classification if final IDS>2
	write(6,*) '  ..... checking for objects near bright objects'
	rmax1=irmax*.75
	rmax2=irmax*.5
	irmax1=nint(rmax1)
	irmaxsq1=nint(rmax1*rmax1)
	irmaxsq2=nint(rmax2*rmax2)
c  beginning of loop 1A
	do 1800 i=1,nob(nfr)
	  jj=ijoj(i,nfr)
	  ii=ijoi(i,nfr)
	  if (ii.le.0.or.ii.gt.ni.or.jj.le.0.or.jj.gt.nj) goto 1800
c  determine if there is any bright object near-by
	  kk=0
	  dist1=1000000.
c  going backward to determine beginning of search
	  do 1801 k=i-1,1,-1
	    jrt=jj-ijoj(k,nfr)
c  out of range, end search
 	    if (jrt.gt.irmax1) go to 1803
 1801	  continue
 1803	  kend=max0(1,k)
	  do 1804 k=kend,nob(nfr)
	    jrt=ijoj(k,nfr)-jj
	    if (jrt.gt.irmax1) go to 1805
            IRT=IABS(II-IJOI(K,nfr))
            IF (IRT.LE.IRMAX1) THEN
c else see if it is 2 mag brighter
	      if (rmag(ids(k),k).le.bgmag+0.5.and.
     *               rmag(ids(i),i)-rmag(ids(k),k).gt.2.0) then
c determine the exact distance
	        dist=irt*irt+jrt*jrt
                IF (dist.LE.float(IRMAXSQ1)) then
c  for fainter object, use more strigent criterion
                  if (rmag(ids(k),k).gt.bgmag.and.
     *              dist.gt.float(irmaxsq2)) go to 1804
c determine the closest objec
	          if (dist.lt.dist1) then
	            dist1=dist
	            kk=k
	          end if
	        end if
	      end if
	    end if
 1804	  continue
 1805	  if (kk.gt.0) then
c set new ids
	    iin=ijoi(kk,nfr)
	    jjn=ijoj(kk,nfr)
	    call mkline(iin,jjn,ii,jj,npt,250,xline,ni,
     *                   nj,ix(1,1,nfr),nu,nv)
c  check for minimum in xline. Since it is a bright object,
c    assume the minimum will not be the first point
	    iminrr=1
c take care of funny shape of saturated stars
	    if (ix(iin,jjn,nfr).gt.nint(adusat)) then
	      nstart=5
	    else
	      nstart=2
	    end if
	    xlmin=xline(nstart-1)
	    DO 1810 M=nstart,NPT-1
c smooth the current point
              xlts=.25*xline(m-1)+.5*xline(m)+.25*xline(m+1)
              xlt=xline(m)
              IF (XLT.LT.XLMIN) THEN
                XLMIN=XLT
                IMINRR=M
c	      else 
c if the point is going up relative to the last point, stop here
c	        go to 1812
              END IF
c if xline reach sky, stop there
              IF (XLTS.LT.SKY(i)) THEN
                XLMIN=XLINE(M)
                IMINRR=M
                GO TO 1812
              END IF
 1810       CONTINUE
c  distance from faint object to boundry
 1812	    ndist=npt-iminrr
c  compare with ids
	    idsdis=0.5*(iapmin+(ids(i)-1)*ideld)
	    iolddis=ids(i)
	    if (idsdis.gt.ndist) then
c change ids
	      ids(i)=min0(ids(i),
     *            nint((ndist*2.-iapmin+ideld*0.5)/ideld+1))
	      if (iolddis.gt.2) ids(i)=max0(ids(i),2)
	      ids(i)=max0(1,ids(i))
	      write(6,1833) i,ii,jj,kk,iin,jjn,ndist,iolddis,ids(i)
 1833	format(' #',i4,'@',2I5,' N#',i4,'@',2i5,'  d_max:',i3,
     *    ' old ids:',i3,'  new ids:',i3)
	    else
	      write(6,1834) i,ii,jj,kk,iin,jjn,ndist,ids(i)
 1834	format(' #',i4,'@',2I5,' N#',i4,'@',2i5,'  d_max:',i3,
     *    ' ids:',i3, ' NO change')
	    end if
	  end if
1800	continue
c end of loop 1A
c
c..............................................................
c   Star-Galaxy classification
C
C    create reference stars for the N X N sections
c
c.......
c  if npsfsec>=1, sectioned psf (npsfsec=1: equivalent to uniform
c                                psf over the whole field).
c   
 606	continue
	if (npsfsec.ge.1) then
	  dx=float(ni)/float(npsfsec)
	  dy=float(nj)/float(npsfsec)
	  delx=0.15*dx
	  dely=0.15*dy
	  naa=npsfsec/2+1
	  do 270 l=1,npsfsec
	    jy1=nint((l-1)*dy)
	    jy2=nint(l*dy)
	    do 270 m=1,npsfsec
	      ix1=nint((m-1)*dx)
	      ix2=nint(m*dx)
	      write(6,64) m,l,ix1,ix2,jy1,jy2
 64	format(/'  Reference stars for sector (',i1,',',i1,')'/
     *        '  Boundry: I:',2i5,' J:',2i5)
	      iparref=ipar
	      CALL REFSTAR(REFST(1,m,l),REFPK(m,l),IDSREF(m,l),SKYERR,
     *            NAP,RMAG,PK,IDS,SKY,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),
     *         IREF(1,m,l),NREF(m,l),IPARREF,ADUSAT,IREFMIN,
     *           iexapf,ix1,ix2,jy1,jy2,npsfsec,nmax,*999)
	      IDSREF(m,l)=MIN0(IDSREF(m,l),IEXAP1)
C  determine FWHM
	      CALL SEEING1(SP(0,IREF(NREF(m,l),m,l)),IAPMIN,
     *             IDS(IREF(NREF(m,l),m,l)),IDELD,SEE(m,l))
	      WRITE(6,46) IREF(NREF(m,l),m,l),SEE(m,l)
 46	FORMAT('  Estimated FWHM from object',I5,':',F7.3,' pix')
	  write(6,*) ' REFSTAR',(refst(mm,m,l),mm=1,5)
 270	  continue
	  ipar=iparref
	else
c.........
c  variable psf, no grids, but from individual objects over the fields
c    the psfs are always read from a .ref file
c
	  naa=1
	  call inrefst(refstv,refpkv,idsrefv,psfpxv,psfpyv,skyerr,
     *        NAP,RMAG,PK,IDS,reali,realj,irefv,nrefv,nob(nfr),npsfsec
     *        ,ADUSAT,IREFMIN,nfmax,nmax,nsct(nfr),*999)
c find the most central star and compute the estimated fwhm
	  do 271 m=1,nrefv
	    distpsf(m)=(psfpxv(m)-0.5*ni)**2+(psfpyv(m)-0.5*nj)**2
 271	  continue
c sort them in order from the center
 	  call indexx(nrefv,distpsf,index)
	  CALL SEEING1(SP(0,IREFV(index(1))),IAPMIN,
     *             IDS(IREFV(index(1))),IDELD,SEE(1,1))
	  WRITE(6,46) IREFV(index(1)),SEE(1,1)
	end if
	DO 199 KK=1,3
	  CLSCT(KK)=CLSC(KK)
199	CONTINUE
c......................................................
C   Loop # 2
C    BIG LOOP FOR EACH OBJECT TO DETERMINE EXTRAPOLATED MAG,
C      SURFACE PROFILE AND PARAMETERS, AND TWO CLASSIFICATIONS
C
c   .................................................................
	ISDAPT=MIN0(2,MAX0(1,ISDAP))
	IBRIGHT=0
	write(6,*) '  Classification:'
c fixed psf
	if (npsfsec.gt.0) then
	  AA=REFST(IDSREF(naa,naa),naa,naa)+
     *       2.5*ALOG10(AMAX1(.0001,REFPK(naa,naa)))
	else
c variable psf
	  aa=0.
	  do 273 kk=1,nrefv
	    aa=aa+refstv(idsrefv(kk),kk)+
     *             2.5*alog10(amax1(.0001,refpkv(kk)))
 273	  continue
	  aa=aa/float(kk)
	  rmaxsq=rrefmax*rrefmax*ni*nj
	  delx=10.
	  dely=10.
	  write(6,*) ' max dist sq',rmaxsq
	end if
c compute average position of the grid of psfs
	if (npsfsec.ge.3) then
	  call 
     *     psfgridp(npsfsec,reali,realj,iref,nref,psfpx,psfpy)
	  rmaxsq=rrefmax*rrefmax*ni*nj
	  write(6,*) ' max dist sq',rmaxsq
	end if
c...................................................
c
c   begin of do loop2: determine extrapolation mag and 
c                         star-galaxy classification
	DO 200 I=1,NOB(NFR)
C
C	  CALL EXPFITP(SP(0,I),IDS(I),IAP1,SZ(I),RZ(I),RSQ(I))
C 	IF (IPO.NE.0) RETURN1
C
	  if (npsfsec.eq.1) then
c   fixed psf
C Determine first order extrapolated magnitude : up to aperture IEXAP
	    CALL MAGEXT(IDS(I),IDSREF(1,1),EXMAG(I),RMAG(IDS(I),I),
     *                  REFST(1,1,1))
C  classification
	    CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *        REFST(1,1,1),IDSREF(1,1),AA,SKY(I),ADUSAT*raduclas,
     *        ISDAPT,CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	  else 
	    if (npsfsec.gt.1) then
c  gridded psf
c      determine sector of object
	      call refstcur(reali(i),realj(i),refst,idsref,psfpx,psfpy,
     *           refstt,idsreft,npsfsec,delx,dely,rmaxsq,iexapf)
	    else if (npsfsec.lt.1) then
c  variable psf
c  determine average refstar from 4*nvpsf nearest 
	      if (nvpsf.eq.1) then
	        call refstcurv1(reali(i),realj(i),refstv,idsref,psfpxv,
     *             psfpyv,nrefv,refstt,idsreft,delx,dely,rmaxsq,
     *             iexapf)
	      else
	        call refstcurv(reali(i),realj(i),refstv,idsref,psfpxv,
     *             psfpyv,nrefv,refstt,idsreft,delx,dely,rmaxsq,
     *             iexapf,nvpsf)
	      end if
	    end if
	    CALL MAGEXT(IDS(I),IDSREFT,EXMAG(I),RMAG(IDS(I),I),REFSTT)
	    CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *        REFSTT,IDSREFT,AA,SKY(I),ADUSAT*raduclas,
     *        ISDAPT,CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	  end if
c  determine best reference curve to use
	  WRITE(6,41) I,reali(i),realj(i),EXMAG(I),IDS(I),
     *          SUMDEL(I),ICLS(I)
 41	FORMAT(1X,'#',I4,'@',2f7.1,'  mag:',F6.2,'  apert.:',I2,
     *        '  C2:',F7.3,'   Cl:',I2)
	  IF (EXMAG(I).LT.BGMAG.AND.ICLS(I).EQ.1) IBRIGHT=1
  200	CONTINUE
c..............big loop #3... only done for variable psf
c         ie npsfsec=-1
c  May 6, 97 : reclassify class 2 objects in a wedge where bright stars
c             are expected to stars
c
c  determine decision line equation
c    (1) point #1: y=cls(1) and x=mag of faintest class 4 object
c                   below cls(2) and greater than .5, if there are no 
c                   such object, the brightest star is used
c        point #2: y=cls(2)-0.03, x=mag of the faintest ref star, but less
c                     than 4 mag from x1
c           
	if (npsfsec.ne.-1) go to 160
c	  call brstcrit(nob(nfr),sumdel,exmag,icls,nrefv,irefv,clsct,
c    *                   slope,cc)
c search for bright end mag: x1
	xs1=-100
	do 210 i=1,nob(nfr)
	  if (icls(i).eq.4) then
	    if (sumdel(i).lt.clsct(2).and.sumdel(i).gt.-.5) then
	      if (exmag(i).gt.xs1) xs1=exmag(i)
	    end if
	  end if
 210	continue
c no saturated star, search for brigtest star
	if (xs1.lt.-17.) then
	  xs1=100
	  do 221 i=1,nob(nfr)
	    if (icls(i).eq.3) then
	      if (exmag(i).lt.xs1) xs1=exmag(i)
	    end if
 221	  continue
	end if
c search for faint end mag, x2
	xs2=-100
	do 212 i=1,nrefv
	  if (exmag(irefv(i)).gt.xs2) xs2=exmag(irefv(i))  
 212	continue
	xs2=amin1(xs2+.5,xs1+4)
c added July 20 1999, to allow the fainter magnitude to be set
c  by a parameter
c	write(6,*) 'xs2,sseqmag',xs2,sseqmag
	xs2=amax1(xs2,sseqmag)
c  equation:  slope
	slope=(clsct(2)-0.03-clsct(1)+.03)/(xs2-xs1)
c     intercept c=(x1y2-x2y1)/(x1-x2)
c	cc=(xs1*(clsct(2)-0.03)-xs2*(clsct(1)-.03))/(xs1-xs2)
 	cc=clsct(2)-0.03-slope*xs2
c loop for objects
	newc=0
	do 213 i=1,nob(nfr)
	  if (icls(i).eq.2) then
c  decision point
	    clcrit=exmag(i)*slope+cc
	    if (sumdel(i).gt.clcrit.and.exmag(i).lt.xs2) then
	      icls(i)=3
	      newc=newc+1
	    end if
	  end if
 213	continue
	write(6,*) '  ... ',newc,' class 2 obj reclassifed as 3'
	write(6,*) '  crit eqn: xs1,y1,xs2,y2,slope,c'
	write(6,*) xs1,clsct(1)-.03,xs2,clsct(2)-.03,slope,cc
C  
C
C  plotting options
C
 160	CONTINUE
c  for plotting, the reference star numbers are put into a
c        single temporaray array
	if (npsfsec.ge.1) then
	  nrefv=0
	  do 192 l=1,npsfsec
	    do 192 m=1,npsfsec
	      do 192 n=1,nref(m,l)
	        nrefv=nrefv+1
	        irefv(nrefv)=iref(n,m,l)
 192	  continue
	end if
	DEV=HPLOT
	CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREFV,nrefv,CLSCT,
     *                icls,FILOUT,DEV,nsct(nfr))
C  end of re-computing mag of bright galaxies (NOT DONE)
C..................................................................
c  output .phm file
C
1601 	IF (FILOUT.EQ.'n') RETURN1
	KAP=MIN0(10,NAP)
C save results in disk
	call opennew(28,1,18,filout,*999)
	IF (COMMENT.EQ.'c') COMMENT=PCOMMENT(NFR)
c	CALL DATE(ADATE)
c	CALL TIME(ATIME)
C attach date and time to comment
	DO 300 JN=60,1,-1
 300	  IF (COMMENT(JN:JN).NE.' ') GO TO 301
 301	COMMENT=COMMENT(1:MIN0(32,JN+1))//fdate()//':ppph'
c
C Write 2 line header
c   only the central section ref stars are recorded in the first line.
c    the other refer stars are recorded in the next npfsecXnpfsec lines
	if (npsfsec.gt.0) then
	  istatus=encode(string1,float(max0(1,min0(7,nref(naa,naa)))),
     *              1,0,idum)
c the format statement make sure that C2 entries starts at the same place
c     for all cases
	  istatus=encode(string2,float(max0(1,4*(7-nref(naa,naa))+1)),
     *              1,0,idum)
	  fstr24='(1X,A60,1X,''REF *:'','
&	       //string1(1:lnblnk(string1))//
&	     'I4,'//string2(1:lnblnk(string2))//'X,'' C2'',3F6.3)'
c line 1 of header
	  WRITE(28,fstr24) COMMENT,(IREF(K,naa,naa),K=NREF(naa,naa),
     *               MAX0(NREF(naa,naa)-6,1),-1)
     *               ,CLSCT(3),CLSCT(2),CLSCT(1)
c 24	FORMAT(1X,A60,1X,'REF *:',<MAX0(1,MIN0(7,NREF))>I4,
c     *                  <MAX0(1,4*(7-NREF)+1)>X,' C2',3F6.3)
	else
c header out put for non-sectioned psf
c   reference stars are sorted from the distance from center
	  istatus=encode(string1,float(max0(1,min0(7,nrefv))),
     *              1,0,idum)
	  istatus=encode(string2,float(max0(1,4*(7-nrefv)+1)),
     *              1,0,idum)
	  fstr24='(1X,A60,1X,''REF *:'','
&	       //string1(1:lnblnk(string1))//
&	     'I4,'//string2(1:lnblnk(string2))//'X,'' C2'',3F6.3)'
	  WRITE(28,fstr24) COMMENT,(IREFV(index(k)),K=1,
     *               min0(NREFV,7))
     *               ,CLSCT(3),CLSCT(2),CLSCT(1)
	end if
c  line 2 of header
c	WRITE(28,25) iap2old,iap11,iap1nap,ideld,
 	WRITE(28,25) iap2,iap1(1),iap1(nap),ideld,
     *       NI,NJ,ISE,IEXAP1,SEE(naa,naa)
 25	FORMAT(1X,'SKY APERT:',I3,'  1ST APERT:',I3,'  LAST APERT:',I3
     *     ,i2,' SIZE:',2I5,3X,'ERR APER ',I2,3X,'EXTRP APER ',I2,
     *      3X,'FWHM:',F5.2,' PIX')
c record the other reference stars
	if (npsfsec.gt.1) then
	  do 308 l=1,npsfsec
	    do 308 m=1,npsfsec
	      write(28,44) m,l,see(m,l),(iref(k,m,l),k=1,nref(m,l))
 44	format(' Ref * sector(',i1,',',i1,'): fwhm',f6.2,
     *        ' pix ',10i5)
 308	  continue
	else if (npsfsec.lt.0) then
c  write the remaining stars
	  if (nrefv.gt.7) then
	    nprit=(nrefv-7)/10+1
	    do 324 j=1,nprit
	      write(28,72) (irefv(index(k)),k=8+(j-1)*10,min0(nrefv,
     *                     17+(j-1)*10))
 324	    continue
	  end if
 72	format(' Ref * ',29x,10i5)
	end if
c added Feb 19 1999, write # lines for section and field info
c write section information
        write(28,8)  nsecpos(nfr),isecpos1(nfr),
     *      jsecpos1(nfr),isecpos2(nfr),jsecpos2(nfr),nedgepos(nfr)
 8      format('#secinfo',i2,10x,4I6,9x,i4)
c  determine world co-ordinate of defined area
        if (nsecpos(nfr).gt.0) then
	  call worldpos(nfr,nsecpos(nfr),ip1,jp1,ip2,jp2)
        else
          ip1=ilpos(nfr)
          jp1=jlpos(nfr)
          ip2=iupos(nfr)
          jp2=jupos(nfr)
        end if
        write(28,9) ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr)
     *             ,ip1,jp1,ip2,jp2
 9      format('#posinfo',4i6,5x,4i6)
	ANGT=0.0
        ELLT=0.0
	DO 302 I=1,NOB(NFR)
C  calculate sky err for adopted best aperture
	  TERR=amin1(999.9,10.**(-RMAG(IDS(I),I)/2.5)
     *        /(ZSIG(I)*SQRT(AMAX1(1.,PIXN(IDS(I))))))
c line 1 of data
	  if (reali(i).gt.999.999.or.realj(i).gt.999.999.or.
     *        reali(i).lt.-99.999.or.realj(i).lt.-99.999) then
	    WRITE(28,261)I,REALI(I),REALJ(I),RMAG(IDS(I),I),EXMAG(I),
     *        TERR,SKYERR(I),PK(I),NNEI(I),ELLT,ANGT,SKY(I),
     *        amin1(999.99,ZSIG(I)),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
	  else
	    WRITE(28,26)I,REALI(I),REALJ(I),RMAG(IDS(I),I),EXMAG(I),
     *        TERR,SKYERR(I),PK(I),NNEI(I),ELLT,ANGT,SKY(I),
     *       amin1(999.99,ZSIG(I)),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
	  end if
	  istatus=encode(string1,float(kap),1,0,idum)
	  istatus=encode(string2,float(8*(10-kap)+3),1,0,idum)
	  fstr27='(4X,2(I4,3X),I2,3X,'//string1(1:lnblnk(string1))//
     *      'F9.4,'//string2(1:lnblnk(string2))//'X,I2)'
c  2nd line of data
	  WRITE(28,fstr27) IJOI(I,NFR),IJOJ(I,NFR),IDOB(I,NFR)
     *	                   ,(RMAG(L,I), L=1,KAP),IDS(I)
c  3rd line of data  (RAD is used to store max aperture size for big galaxies)
	  IF (RAD(I).GT.0.01) THEN
	    WRITE(28,2811) INT(RAD(I)),IDBR(I),(RMAG(L,I),L=11,NAP)
	  ELSE
	    WRITE(28,28) (RMAG(L,I),L=11,NAP)
	  END IF
 302	CONTINUE
 	CLOSE(UNIT=28)
 28     FORMAT(23X,10F9.4)
 2811   FORMAT(9X,'*ss',I4,I4,3X,10F9.4)
 26     FORMAT(I4,1X,2(F6.2,1X),2F7.2,F7.1,F7.1,F8.1,I7,F7.3,F7.1,F10.3,
     *      F8.3,1X,F6.2,I2,F6.2,I2)
 261    FORMAT(I4,1X,2(F7.1),2F7.2,F7.1,F7.1,F8.1,I7,F7.3,F7.1,F10.3,
     *      F8.3,1X,F6.2,I2,F6.2,I2)
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CENTER OBJECT (PSFCEN modified to run quietly)
C
	SUBROUTINE PSFCEN2(KF1,IPSFF,JPSFF,CDIAM,IROBJ,
     *       TXSH,TYSH,sky,is2,itercen,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ipsff,jpsff
	INTEGER IX(NU,NV,KF),ipsff,jpsff
	DIMENSION YY(5,5),DERI(5),DERJ(5),DERDUM(5),YT(5)
	CHARACTER IAN*1
	INCLUDE 'picdir.inc'
	INCLUDE 'apert.inc'
C determine fractional centroid and back ground (from cut frame)
c  note that this centroiding routine changes the 1 and 2nd aperture,
c   need to reset. 
c       A new routine should be written so that this does not happen
	iapt1=iap1(1)
	iapt2=iap1(2)
	iap2t=iap2
 	CALL PCENTR(KF1,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              IPSFF,JPSFF,1,CDIAM,IROBJ,1,20)
c  TEMP: reset apertures
	iap1(1)=iapt1
	iap1(2)=iapt2
	CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),PP(1),NA(1),0)
	CALL APARAY(IAP1(2),IT1(1,2),IROW1(2),QQ(2),RR(2),PP(2),NA(2),0)
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
c	WRITE(6,9) CENOX,CENOY,OBJSKY
c9	FORMAT( '     Centroid in cut frame: ',2F9.4,'   Sky: ',F8.2)
	TXSH=IPSFF-CENOX
	TYSH=JPSFF-CENOY
	ITER=0
c	WRITE(6,30) TXSH,TYSH
c30	FORMAT( ' ..Initial guess (I, J axis shifts):',2F8.4,
c    *         /     '      First 5 interations are automatic...')
	ipsff4=ipsff
	jpsff4=jpsff	
C save a copy of the unshifted PSF
	DO 101 J=1,NJJ(KF1)
	  DO 101 I=1,NII(KF1)
            IX(I+NII(KF1),J+NJJ(KF1),KF1)=IX(I,J,KF1)
 101	continue
 555	CALL PSINCSH2(KF1,TXSH,TYSH,IPSFF4,JPSFF4,3,is2,sky,
     *     IX,NU,NV,KF)
C   ratio between PSF and OBJECT
C   fill array for TESTING
 130	DO 104 J=1,5
	  K=JPSFF-3+J
	  DO 104 I=1,5
 104	    YY(I,J)=FLOAT(IX(IPSFF-3+I,K,KF1))-SKY
	DO 115 J=1,5
 115	  YT(J)=YY(3,J)
	CALL DERIV(YY(1,3),DERI,DERDUM,1.,5)
	CALL DERIV(YT,DERJ,DERDUM,1.,5)
	IF (DERJ(2).NE.DERJ(3)) THEN
	  YSH=0.5*(YY(3,2)-YY(3,4))/(DERJ(2)-DERJ(3))
	ELSE
	  YSH=0.
	END IF
c	write(6,*)' Y',YSH,DERJ(2),DERJ(3)
	YSH=SIGN(AMIN1(ABS(YSH),1.),YSH)
	IF (ABS(YSH).GT..15) THEN
	  YSH=YSH*.8
	ELSE 
	  YSH=YSH*.75
	END IF
	IF (DERI(2).NE.DERI(3)) THEN
	  XSH=0.5*(YY(2,3)-YY(4,3))/(DERI(2)-DERI(3))
	ELSE
	  XSH=0.
	END IF
c	write(6,*)' X',XSH,DERI(2),DERI(3)
	XSH=SIGN(AMIN1(ABS(XSH),1.),XSH)
	IF (ABS(XSH).GT..15) THEN
	  XSH=XSH*.8
	ELSE 
	  XSH=XSH*.75
	END IF
	ITER=ITER+1
c	WRITE(6,17) ITER
c17	FORMAT(/'  ..Iteration #',I3)
c	DO 108 I=1,5
c108	  WRITE(6,18) (YY(I,J),J=5,1,-1)
 18	FORMAT(3X,5F7.0)
	WRITE(6,19) iter,TXSH,TYSH,XSH,YSH
 19	FORMAT(i3,'  Tot shift:',2F8.4,',  new delta:',2F8.4)
	if (((iter.lt.5).or.(ABS(XSH).GT.0.005.OR.ABS(YSH).GT.0.005))
     *          .and.(iter.lt.itercen)) then
C atuomatically do the first 5 iterations, but quit after itercen
C  get the new shift and do the test shift again
	  TXSH=TXSH+XSH
	  TYSH=TYSH+YSH
C reset PSF
	  DO 111 J=1,NJJ(KF1)
	    DO 111 I=1,NII(KF1)
 111          IX(I,J,KF1)=IX(I+NII(KF1),J+NJJ(KF1),KF1)
	  GO TO 555
c maximum of  iteration+ itercen 
c	ELSE 
c the shift is good,  shift the PSF before exiting
c	  CALL SINCSHIF2(KF1,TXSH,TYSH,sky,is2,IX,NU,NV,KF)
	END IF
 999	RETURN
	END

C//////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR aperture photometry, modified from AUPHOT.
C
C      CALCULATE TOTAL INTENSITY WITH MODAL SKY SUBTRACTION, (SKY
C      DETERMINED IN RING WITH OUTER DIAMETER IAP2, INNER, IAP1 =
C      PHOTOMETRY APERTURE);  
C
C
	subroutine aperphot(NFR,IO,JO,RI,sp,
     *     NI,NJ,SKY,ZSIG,IX,NU,NV,KF,IW,ISKYSEC)
	DIMENSION RI(30),sp(*),SKARAY(50000)
c	INTEGER*2 IX(NU,NV,KF),IO,JO
	INTEGER IX(NU,NV,KF),IO,JO
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	include 'apert.inc'
C  set inner sky aperture radius
	IF (IAP2-IAP1(NAP).GT.8) THEN
	    NNAP=NAP
	ELSE
	    NNAP=NAP-1
	END IF
	IO1=IO
	JO1=JO
	IF (ISKYSEC.EQ.0) THEN
	  CALL RCSKY(1,SKY,ZSIG,NNAP,IO1,JO1,NI,NJ,IX(1,1,NFR),NU,NV
     *                    ,SKARAY,50000,nsky,IW,IPR)
	ELSE
	  CALL RING8SKY(SKY,ZSIG,NNAP,IO1,JO1,NI,NJ,IX(1,1,NFR),NU,NV
     *                    ,SKARAY,50000,nsky,IW,IPR)
	END IF
	IF (IPR.NE.0) THEN
	  WRITE(6,*) ' *** sky evaluation problem, photometry not done **'
	  DO JK=1,30
	    RI(JK)=0.
	  END DO
	  ZSIG=0.
	  RETURN
	END IF
	DO 250 I=1,NAP
	  JR1=JO1-IROW1(I)
	  JR2=JO1+IROW1(I)
	   K=0
  	  RI(I)=0.
	  DO 251 J=MAX0(1,JR1), MIN0(NJ,JR2)
	    K=K+1
	    DO 251 L=MAX0(1,IO1-IT1(K,I)/2), MIN0(NI,IO1+IT1(K,I)/2)
 	      RI(I)=RI(I)+FLOAT(IX(L,J,NFR))-SKY
 251	  continue
c	write(6,*) jr1,jr2,ri(i)
	  if (i.eq.1) then
	    sp(1)=ri(1)
	  else
	    sp(i)=ri(i)-ri(i-1)
	  end if
 250	continue
	RETURN
 	END
C/////////////////////////////////////////////////////////////////////
C
C  SINC FUNCTION INTERPOLATION FOR SHIFTING: SINC FILTER SIZE=ISINCF FROM PPPARM
C       SINC FNC IS TAPERED WITH A HAMMING FILTER, EDGES ARE SET TO MEAN VALUES
C       DOING IT ONE DIMENSION AT A TIME
C
c  this shifts the whole picture. This is done before photometry
c
	SUBROUTINE SINCSHIF2(NFR,XSH,YSH,sky,is2,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL SINC(151)
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
C shifting X and Y axis separately
C first check if the shift in X is zero
c  !  central index of filter = size of filter+1
c	IS2=(ISINCF+2)/2    
	IF (ABS(XSH).LT.0.00001) THEN
C must move the frame to the scartch
	  CALL MOVE(NFR,KF,IX,NU,NV,KF)
	ELSE
C shifting in X (I) directiion, the temp frame is stored in scratch
	  CALL MAKESINC2(-XSH,ISINCS,ISINCF,IS2,ISH,SINC)
c
c edges are replaced by the overall sky value to save cpu
c
C  first determine means of edges I=1 I=NII
c	    CALL PSTAT(*220,NFR,1,0,0,0,ED1,DUM,NDUM,-7,IX,NU,NV,KF)
c220	    CALL PSTAT(*221,NFR,NII(NFR),0,0,0,ED2,DUM,NDUM,
c    *                  -7,IX,NU,NV,KF)
 221	    DO 200 J=1,NJJ(NFR)
	      DO 205 I=1,NII(NFR)
	        KK=I-IS2+ISH
	        SUMT=0.
	        DO 206 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.nii(nfr)) THEN
	            SUMT=SUMT+SINC(K)*sky
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(KKK,J,NFR)
	          END IF
 206	        CONTINUE
 205 	      IX(I,J,KF)=INTLIMR(SUMT)
 200 	    CONTINUE
	END IF
C shifting in Y (J) directiion,  
C check if the y shift if zero
	IF (ABS(YSH).LT.0.00001) THEN
	  CALL MOVE(KF,NFR,IX,NU,NV,KF)
	ELSE
C the array is moved back to NFR during the shift
	  CALL MAKESINC2(-YSH,JSINCS,ISINCF,IS2,ISH,SINC)
 231	    DO 300 J=1,NJJ(NFR)
	      KK=J-IS2+ISH
	      DO 305 I=1,NII(NFR)
	        SUMT=0.
	        DO 306 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.njj(nfr)) THEN
	            SUMT=SUMT+SINC(K)*sky
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(I,KKK,KF)
	          END IF
 306	        CONTINUE
 305 	      IX(I,J,NFR)=INTLIMR(SUMT)
 300 	    CONTINUE
	END IF
 999	RETURN 
	END
C////////////////////////////////////////////////////////////
C
C  subroutine MAKESINC creates the sinc funtion for SINCSHIFT
c
c  is2=isincf/2+1
c  bis2=float(is2-1)
C
	SUBROUTINE MAKESINC2(SHIFT,NSCALE,ISINCF,IS2,ISH,SINC)
	DIMENSION SINC(*)
	SCALE=FLOAT(NSCALE)
	bis2=float(is2-1)
	PSC=3.14159/SCALE
C  calculate sinc function (ISH = integer part of shift)
 	  ISH=NSCALE*NINT(SHIFT/SCALE)
	  X=ISH-SHIFT
	  SUMFIL=0.
	  DO 201 K=1,ISINCF
	    XT=PSC*(X+FLOAT(K-IS2))
	    IF (ABS(XT).GT.0.001) THEN
	      SINC(K)=SIN(XT)/XT
	    ELSE
 	      SINC(K)=1.
	    END IF
C  taper by Hamming filter (see Digital Filter by R.W. Hamming)
	    SINC(K)=SINC(K)*(.46*COS(XT/BIS2)+.55)
	    SUMFIL=SUMFIL+SINC(K)
 201	  CONTINUE
C  Normalize the filter
	  DO 207 K=1,ISINCF
 207	    SINC(K)=SINC(K)/SUMFIL
	RETURN
	END
C/////////////////////////////////////////////////////////////////////
C
C  Subroutine to sinc shift part of a picture, for use in CENPSF
C    size of shift = 2*NPS+1 centered around I0 and J0
c     this minimze the shift only to the pixels necessary
C
	SUBROUTINE PSINCSH2(NFR,XSH,YSH,I0,J0,NPS,is2,sky,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL SINC(151)
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
C shifting X and Y axis separately
C first check if the shift in X is zero
	IF (ABS(XSH).LT.0.00001) THEN
C must move the frame to the scartch
	  CALL MOVE(NFR,KF,IX,NU,NV,KF)
	ELSE
C shifting in X (I) directiion, the temp frame is stored in scratch
	  CALL MAKESINC2(-XSH,ISINCS,ISINCF,IS2,ISH,SINC)
C  first determine means of edges I=1 I=NII
c	    CALL PSTAT(*220,NFR,1,0,0,0,ED1,DUM,NDUM,-7,IX,NU,NV,KF)
c220	    CALL PSTAT(*221,NFR,NII(NFR),0,0,0,ED2,DUM,NDUM,
c    *                  -7,IX,NU,NV,KF)
 	    DO 200 J=MAX0(1,J0-IS2-NPS),MAX0(NJJ(NFR),J0+IS2+NPS)
	      DO 205 I=I0-NPS,I0+NPS
	        KK=I-IS2+ISH
	        SUMT=0.
	        DO 206 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.nii(nfr)) THEN
	            SUMT=SUMT+SINC(K)*sky
	          else
	            SUMT=SUMT+SINC(K)*IX(KKK,J,NFR)
	          END IF
 206	        CONTINUE
 205 	      IX(I,J,KF)=INTLIMR(SUMT)
 200 	    CONTINUE
	END IF
C shifting in Y (J) directiion,  
C check if the y shift if zero
	IF (ABS(YSH).LT.0.00001) THEN
	  CALL MOVE(KF,NFR,IX,NU,NV,KF)
	ELSE
C the array is moved back to NFR during the shift
	  CALL MAKESINC2(-YSH,JSINCS,ISINCF,IS2,ISH,SINC)
 231	    DO 300 J=J0-NPS,J0+NPS
	      KK=J-IS2+ISH
	      DO 305 I=I0-NPS,I0+NPS
	        SUMT=0.
	        DO 306 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1.or.kkk.gt.njj(nfr)) THEN
	            SUMT=SUMT+SINC(K)*sky
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(I,KKK,KF)
	          END IF
 306	        CONTINUE
 305 	      IX(I,J,NFR)=INTLIMR(SUMT)
 300 	    CONTINUE
	END IF
 999	RETURN
	END
