C****************************************************************************
C     SUBPROGRAMS TO READ CCD DATA IN FITS FORMAT, MAX DIMENSION 512X512
C     THE DATA ARE IN 'FITS' FORMAT.
C     THE PRINCIPAL ROUTINES ARE 'TPFTS', 'FTSPS', 'READ', AND 'RTWAD',
C     ALL OF WHICH ARE FROM DAO [HILL]HIOLIB.FOR.
C     
C     modified to take size up to 800*800    
C
C     Modified for Unix:
C     -Second attempt: using f77 tape I/O library.
C
C     Modified again on Mar. 15, 1990
C****************************************************************************

C
C DRIVING ROUTINE
C
	SUBROUTINE RFITSD(*,NFR,NFITF,IPAR,IFILE,IX,NU,NV,KF)
	INTEGER*2 IX(NU,NV,KF),NPAX(4),IFF,IFILE,nflag,nid,njd
	CHARACTER NFILEN*24,chead*2
	CHARACTER*1 NCE(35),OBT(9),C(3)
	CHARACTER*20 OBJNAM,OBN,fitsname*18
	CHARACTER*35 NCOM,NCOMFITS,NCOMC,imdir*55
	logical ex
	INCLUDE 'pppcore.inc'
	COMMON/PICC/NCOMC(15),fitsname(15)
	common/imagedir/imdir
	INCLUDE 'picdir.inc'
	COMMON/DIR/nof,NCOM(254),NFILEN(254),NFLAG(5,254)
&	          ,NID(254),NJD(254)
	DIMENSION YS(2),DY(2)
	INTEGER*4 NY(10),NCH,IERR
	BYTE LABEL(36)
	EQUIVALENCE (NCE(1),NCOMFITS),(NCE(1),OBJNAM),(OBT(1),OBN)
	EQUIVALENCE (C(1),OBT(5))
	DATA (NCE(I),I=1,35)/35*' '/,(OBT(I),I=1,4)/'F','I','T','S'/
 1001	FORMAT(36A1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IFF=0
	IF (IPAR.EQ.1) IFF=IFILE
c create fits header file
	istat=encode(chead,float(nfr),1,0,idum)
	fitsname(nfr)='temp'//chead(1:lnblnk(chead))//'.fhd'
	inquire(file=imdir(1:lnblnk(imdir))//fitsname(nfr),exist=ex)
	if (ex.eqv..true.) then
c  delete current header file
	  open(unit=44,file=fitsname(nfr),status='old')
	  close(unit=44,status='delete')
	end if
	open(unit=44,file=imdir(1:lnblnk(imdir))//fitsname(nfr),
     *       status='new',access='direct',
     *	     recl=2880)
	IYSTART=NU*NV*(KF-1)+1
 	CALL TPFTS(IXB(IYSTART),NY,NAXIS,YS,DY,LABEL,NCH,IERR,
&		NPAX,OBJNAM,NFITF,IFF,NU*NV,44)
	NII(NFR)=NPAX(1)
	NJJ(NFR)=NPAX(2)
	DO 105 J=1,5
 105	NFL(J,NFR)=0
	IFFF=IFF
	CALL NTOCHA(IFFF,C)
	IF (OBJNAM.EQ.' ') OBJNAM='Read from fits'
	NCOMC(NFR)=NCOMFITS
	iys=iystart-1
	DO 100 J=1,NJJ(NFR)
	K=(J-1)*NII(NFR)
	DO 100 I=1,NII(NFR)
 100	IX(I,J,NFR)=IXB(I+K+IYS)
 999	RETURN1
	END

C
C SUBROUTINE TO REWIND TAPE AND SET FILE COUNTER TO ZERO
C
	SUBROUTINE REWD(*,NFITF)
	INTEGER*4 NFITF, CHANNEL
	integer trewin
C  Assign TLU to CHANNEL:
	CALL TASSIGN(CHANNEL,*99)
	istatus=trewin(channel)
	NFITF=0
99	RETURN1
	END

C
C **********************************************************************
C  READ DATA FROM 'FITS' TAPE
C        (See SUBROUTINE FITOUT for more format details)
C
C  INPUT:  LABEL  -  File name (maximum 36 characters)
C                     If an file extension is not given the default "FTS
C                     is used.
C
C  RETURN: IXB      -  data array
C          NPAX   -  array contains # of data points along each axis
C          NAXI   -  # of axes
C          XS     -  array contains coordinates of first data element
C          DX     -  array contains data point increments along each axi
C          LABEL  -  array contains header (NCH bytes long, ASCII)
C          NCH    -  number of bytes in header
C          IERR   -  set to 0  --  Normal return, no error.
C                    set to -1 --  No file name was specified (a default
C                                      not provided.
C                    set to -2 --  Not FITS format.  No data returned.
C                    set to -3 --  Specified file could not be accessed.
C                                            No data returned.
C
C  Example:  If the number of axes is 3, and there are 25, 3, and 4 data
C               elements along each of the three axes, respectively, and
C               first data element has the coordinates x=1.6, y=4.5, z=-
C               and the increment along the x (first) axis is .04, along
C               y axis -0.5, and along the z axis 1.8
C          then:
C             NAXI = 3                        NPTS = 25,3,4
C             XS   = 1.6,4.5,-9.8             DX   = 0.04,-0.5,1.8
C            and the data is contained in a 25 X 3 X 4 array  (X)
C
C
	SUBROUTINE TPFTS(IY,NY,NAXIS,YS,DY,LABEL,NCH,IERR,NPAX,
     *                 OBJNAM,NFITF,IFF,IYSTOP,idevf)
	INTEGER*2 IY(1),NPAX(4)
	INTEGER*2 II(8),IFF,NB(1440)
	INTEGER*4 NY(1),na(720),IK,IYSTOP,CHANNEL
	CHARACTER*2880 RECBL
	CHARACTER*20 OBJNAM
	BYTE LABEL(1)
	DIMENSION YS(1),DY(1)
	COMMON/QTPIE2/IOSB(4)
	equivalence(na,recbl)
	EQUIVALENCE(NB,RECBL)
	DATA II/8*0/
C  Assign TLU to CHANNEL:
	CALL TASSIGN(CHANNEL,*82)
	WRITE(6,*) IYSTOP
C     Call to 'FTSPS' positions tape at desired file
 1	CALL FTSPS(CHANNEL,II,NHEAD,NNY,NPAX,IHB,NFITF,OBJNAM,IFF,
     *       nbit,bzero,bscale,idevf)
C     II(1)=100 means no file was specified (IERR=-1)
	IF (II(1).EQ.100) GO TO 90
C     II(1)=99 means ? (IERR=99)
	IF (II(1).EQ.99) GO TO 80
C     II(1)=98 means ? (IERR=98)
	IF (II(1).EQ.98) GO TO 81
C     II(1)=0 means normal return, no errors
	IF (II(1).NE.0) GO TO 82

C  Read DATA records (unformatted integer*2)
	if (nbit.eq.16) then
c	  N=0
C     NNY == NO COLUMNS X NO ROWS 
	  NROWS=IFIX(FLOAT(NNY)/1440.+1.)
	  WRITE(6,*) 'Total pixel',NNY,NROWS
	  DO 50 N=0,NROWS-1
	    CALL READF(CHANNEL,RECBL,2880,II)
C  Convert to "real" INTEGERS	
	    IF (IOSB(2).NE.2880) THEN
	    WRITE(6,5002) N,IOSB(2),IYSTOP
 5002	FORMAT( ' *** Block Length Error ****',I5,I6,I10)
	     IOSB(2)=2880
	    END IF
	    DO 51 I=1,1440
	      IK=N*1440+I
	      IF (IK.LE.IYSTOP) THEN
	        IY(IK)=NB(I)
	      ELSE
	        WRITE(6,456) N+1
 456  FORMAT('  **** ERR in rfits: PICTURE OVERFLOW MEMORY AT BLK #'
     *            ,I5,' ****')
	        WRITE(6,*) IK,I,IYSTOP,IOSB(2)
	        WRITE(6,*) NB(I)  
	        GO TO 511
	      END IF
 51         CONTINUE
 50 	  CONTINUE
692   FORMAT(1X,10I6)
511	  continue

	else if (nbit.eq.32) then 
c  read integer*4 data
	  NROWS=IFIX(FLOAT(NNY)/720.+1.)
	  WRITE(6,*) 'Total pixel',NNY,NROWS
	  if (abs(bzero).gt.0.0001) then
	    DO 54 N=0,NROWS-1
	      CALL READF(CHANNEL,RECBL,2880,II)
C  Convert to "real" INTEGERS	
	      IF (IOSB(2).NE.2880) THEN
	        WRITE(6,5002) N,IOSB(2),IYSTOP
	        IOSB(2)=2880
	      END IF
	        DO 55 I=1,720
	        IK=N*720+I
	        IF (IK.LE.IYSTOP) THEN
	          IY(IK)=nint(bscale*na(I)+bzero)
	        ELSE
	          WRITE(6,456) N+1
	          WRITE(6,*) IK,I,IYSTOP,IOSB(2)
	          WRITE(6,*) na(I)  
	          GO TO 513
	        END IF
 55           CONTINUE
 54 	    CONTINUE
513	    continue
	  else
c  no scaling
	    DO 56 N=0,NROWS-1
	      CALL READF(CHANNEL,RECBL,2880,II)
C  Convert to "real" INTEGERS	
	      IF (IOSB(2).NE.2880) THEN
	        WRITE(6,5002) N,IOSB(2),IYSTOP
	        IOSB(2)=2880
	      END IF
	        DO 57 I=1,720
	        IK=N*720+I
	        IF (IK.LE.IYSTOP) THEN
	          IY(IK)=na(I)
	        ELSE
	          WRITE(6,456) N+1
	          WRITE(6,*) IK,I,IYSTOP,IOSB(2)
	          WRITE(6,*) na(I)  
	          GO TO 514
	        END IF
 57           CONTINUE
 56 	    CONTINUE
514	    continue
	  end if
	else 
	  write(6,*)  '  **** file not 16 or 32 bits, cannot read **'
	  go to 98
	end if
	IERR=0
C     IERR=0 MEANS NORMAL RETURN, NO ERRORS
	GO TO 99
98    WRITE(6,*) ' ** Not  FITS  format!!!!'
      GO TO 89
90    WRITE(6,*) ' **CHECK TAPE ASSIGNMENT PRIVILEGE**'
      GO TO 82
91    WRITE(6,*) ' TAPE ERROR (RECORDSIZE?)'
89    IERR=-2
      GO TO 99
80    IERR=99
      GO TO 99
81    IERR=98
      GO TO 99
82    IERR=-1
99    RETURN
      END
C

	SUBROUTINE FTSPS(CHANNEL,II,NHEAD,NNY,NPAX,IHB,NFITF,OBJNAM,FILEN
     *                   ,nbit,bzero,bscale,idevf)
C
C PROGRAM TO FIND GIVEN MAGTAPE FILE, AND 
C POSITION TAPE AT BEGINNING OF FIRST RECORD OF DESIRED FILE
C
	INTEGER*2 FILEN
	INTEGER*4 NNY,NFITF,IHB,NHEAD
	INTEGER*4 CHANNEL
	INTEGER*2  II(*),NPAX(4)
	CHARACTER*2880 REKRD
	CHARACTER*3 ITEST,ITEST1
	CHARACTER*20 OBJNAM ,hdr*80
	CHARACTER*1 IANS 
	COMMON/QTPIE2/IOSB(4)
	IHB=1
	NFTEM=0
	IX=0
	IFILE=0
	IF (FILEN.NE.0) GO TO 1234
97	WRITE(6,52) 
 52	format(' Enter tape file number: ',$)
	READ(5,*,ERR=97,end=298) FILEN
1234  	IF(FILEN.NE.999) THEN
           IFILE=FILEN-NFITF-1
	   CALL TRWAD(CHANNEL,IFILE)
	   NFITF=FILEN-1
	END IF
	CALL READF(CHANNEL,REKRD,2880,II)
	IFILE=IFILE+1
	IF (II(1).EQ.1.) GO TO 17

C  Check first card image to see if this is a valid FITS format.
	IF (FILEN.NE.999) WRITE(8,621) NFITF+1
	WRITE(6,621) NFITF+1
	IF (FILEN.EQ.999) THEN
		NFTEM=NFTEM+1
		WRITE(8,621) NFTEM
		WRITE(6,621) NFTEM
	END IF
621	FORMAT(//'  ---- File number',I3,' -----')
	NHEAD=1
	N1=1
	N2=80
	IANS=REKRD(30:30)
	hdr=rekrd(n1:n2)
	WRITE(8,612) HDR
	WRITE(6,612) HDR
	IF (IANS.NE.'T') GO TO 198
	NHEAD=NHEAD+1
	N1=N1+80
	N2=N2+80

C  Get "Number-of-bits-per-data-point"
	READ (REKRD(N1:N2),502) NBIT
c  change header card to 16 for output to disk
	hdr=rekrd(n1:n2)
c	if (nbit.eq.32) rekrd(109:110)='16'
502	FORMAT (10X,I20)
	WRITE(8,612) HDR
	WRITE(6,612) HDR
	NHEAD=NHEAD+1
	N1=N1+80
	N2=N2+80

C  Get number of axes
	READ (REKRD(N1:N2),502) NAXIS
	hdr=rekrd(n1:n2)
	WRITE(8,612) HDR
	WRITE(6,612) HDR
	NHEAD=NHEAD+1
	N1=N1+80
	N2=N2+80
	NNY=1

C  Get number of data points along first axis, etc.
	DO 8 I=1,NAXIS
		READ (REKRD(N1:N2),502) NPAX(I)
		NNY=NNY*NPAX(I)
	        hdr=rekrd(n1:n2)
		WRITE(8,612) HDR
		WRITE(6,612) HDR
		NHEAD=NHEAD+1
		N1=N1+80
		N2=N2+80
		N3=N1+2
8	CONTINUE

	KNH=36-NHEAD
 20	IF (IHB.gt.1) KNH=36
	DO 610 I=1,KNH
	        hdr=rekrd(n1:n2)
		ITEST1=REKRD(N1:N3)
		IF (ITEST1.EQ.'OBJ') READ(REKRD(N1+11:N1+31),677) OBJNAM
		IF (ITEST1.EQ.'BZE') then
	           READ(REKRD(N1+11:N1+31),*) bzero 
	           write(6,*) '  bzero ', bzero
	        end if
		IF (ITEST1.EQ.'BSC') then
	           READ(REKRD(N1+11:N1+31),*) bscale
	           write(6,*) '  bscale ', bscale
	        end if
		NHEAD=NHEAD+1
		N1=N1+80
		N2=N2+80
		N3=N1+2
		N4=N1+11
		WRITE(8,612) HDR
		ITEST=REKRD(N1:N3)
 		IF (ITEST1.EQ.'OBJ'.OR.ITEST1.EQ.'HIS'.OR.ITEST1.EQ.'F1P')
     *			WRITE(6,612) HDR
677		FORMAT(A20)
612		FORMAT(1X,A79)
653		IF(ITEST.eq.'END') then
	          write(idevf,rec=ihb) rekrd
	          return 
	        end if
C     If last card of header information is met, and a catalog is
C     desired, the data array is read and the program goes on to
C     the next file, printing out headers.
610	CONTINUE
c write out temporary header block
	write(idevf,rec=ihb) rekrd
	IHB=IHB+1
18	CALL READF(CHANNEL,REKRD,2880,II)
	write(idevf,rec=ihb) rekrd
	N1=1
	N2=80
	GO TO 20
17	WRITE(6,*) '  HIT END OF TAPE --- REWINDING!'
10	CALL TRWAD(CHANNEL,999)
	IF (IOSB(4).EQ.9) WRITE(6,*) '  AT "BOT"'
	RETURN
198	WRITE(6,*) '  *** Not  FITS  format!!!!'
298	II(1)=-1
	RETURN
	END
C

	SUBROUTINE FTSND(CHANNEL,II)
C
C PROGRAM TO FIND END OF DATA ON A TAPE (DOUBLE EOF)
C POSITIONS TAPE IN FRONT OF LAST EOF
C
	INTEGER*4 CHANNEL,IOSB,II(4)
	INTEGER*2 HEAD(1440)
	COMMON/QTPIE2/IOSB(4)
	CHANNEL=3
	WRITE(6,*) ' TAPE POSITIONING'
	CALL TASSIGN(CHANNEL,*99)
C  Back up two files to ensure that the tape is not beyond the double EO
	CALL TRWAD(CHANNEL,-2)
C  Move forward 1 file mark and read
1	CALL TRWAD(CHANNEL,1)
	CALL READF(CHANNEL,HEAD,2880,II)
	IF (II(1).EQ.1) GO TO 17
	GO TO 1
C  Read a file mark. Therefore must be at end of data.  Back up over the
C    file mark.
17	CALL TRWAD(CHANNEL,-1)
	RETURN
99	II(1)=100
	RETURN
	END
C

C      SUBROUTINE FTSWR(CHANNEL,II,LABEL)
C
C  ROUTINE TO COPY A "FITS" DISK FILE TO TAPE
C
C	INTEGER*4 CHANNEL
C      INTEGER*2 II(1),IOSB
C      BYTE LABEL(1),FILN(10),DTUM(2880)
C	COMMON/QTPIE2/IOSB(4)
C	EXTERNAL IO$_WRITEOF,IO$_WRITELBLK,SS$_ENDOFTAPE
C	EQUIVALENCE (TYPE,FILN(6))
C	DATA TYPE/'.FTS'/,NBYT/2880/
CC  Open disk file
C	FILN(10)=0
C      DO 1 I=1,5
C1     FILN(I)=LABEL(I)
C      OPEN(NAME=FILN,UNIT=20,FORM='UNFORMATTED',STATUS='OLD',
C     * RECORDSIZE=NBYT,ERR=99)
C      NR=0
C      J=%LOC(IO$_WRITELBLK)
C      K=%LOC(SS$_ENDOFTAPE)
CC  Read a disk record and write to tape
C2     READ (20,END=80) DTUM
C      NR=NR+1
C      RETCODE=SYS$QIOW(,%VAL(CHANNEL),%VAL(J),IOSB,,,
C     * %LOC(DTUM(1)),%VAL(NBYT),,,,)
C      IF (RETCODE.NE.1) GO TO 93
CC  Check for end-of-tape
C      IF (IOSB(1).EQ.K) GO TO 90
C      GO TO 2
CC  Disk file has been copied.  Display the number of records copied and
CC    put 2 EOF marks on tape
C80    IF (NR.EQ.0) GO TO 91
C      II(1)=0
C      WRITE(6,101) NR
C101   FORMAT ('  WROTE ',I4,' RECORDS TO TAPE')
C      DELETE(UNIT=20)
C81    J=%LOC(IO$_WRITEOF)
C      RETCODE=SYS$QIOW(,%VAL(CHANNEL),%VAL(J),IOSB,,,,,,,,)
C      RETCODE=SYS$QIOW(,%VAL(CHANNEL),%VAL(J),IOSB,,,,,,,,)
C      RETURN
CC  In case the end-of-tape is encountered either during the data
CC    transfer back up to the last valid file and put 2 EOF marks
CC    on the tape again.  Set error flag.
C90    CALL TRWAD(CHANNEL,-1)
C      II(1)=-1
C      GO TO 81
C91    WRITE(6,*) '  DISK TRANSFER ERROR.  NO DATA?'
C      GO TO 92
C99    WRITE(6,*) '  DISK TRANSFER ERROR.  NO FILE?'
C92    II(1)=-2
C      RETURN
C93    II(1)=-3
C      RETURN
C      END
C

	SUBROUTINE READF(CHANNEL,IBLOCK,NB,IUFT)
	INTEGER*4 IOSB,IUFT(8)
	INTEGER*4 CHANNEL, NCHAR, TREAD
	CHARACTER*(*) IBLOCK
	COMMON/QTPIE2/IOSB(4)
C  IOSB(2) IS # OF BYTES IN THE RECORD
C  IOSB(1) GIVES THE STATUS OF THE END PT---EOF EOR DOUBLE FILE
	NCHAR= TREAD(CHANNEL, IBLOCK)
	IOSB(2)=NCHAR
	IF (NCHAR.LT.0) GOTO 9
	IUFT(1)=0
	IUFT(2)=NCHAR
	IF (NCHAR.EQ.0) IUFT(1)=1
	RETURN
9	WRITE(6,*) ' CHECK TAPE ASSIGNMENT PRIVILEGE'
	RETURN
	END
C

        SUBROUTINE TRWAD(CHANNEL,NF)
C     IF NF=0 RETURNS
C           999 REWINDS TO BEGINNING, LEAVING TAPE LOADED
C           SOME POSITIVE NUMBER, ADVANCES THAT NUMBER
c
	INTEGER*4 IOSB
	INTEGER*4 CHANNEL
	INTEGER TSKIPF, TSTATE, NF, FILENO, RECNO, TCSR
	LOGICAL ERRF, EOFF, EOTF
	COMMON/QTPIE2/IOSB(4)
	IF (NF.EQ.0) RETURN
	IOSB(1)=0
	ISTATUS=TSKIPF(CHANNEL,NF,0)
	IF (ISTATUS.LT.0) THEN
		ISTATUS=TSTATE(CHANNEL,FILENO,RECNO,ERRF,EOFF,EOTF,TCSR)
		IF (EOTF.EQV..TRUE.) STOP ' END OF TAPE !!'
	ENDIF
	RETURN
	END

C
C
C
	SUBROUTINE TASSIGN(TLU,*)
	INTEGER TLU,TOPEN
	CHARACTER*32 DEVNAM,ERRSTRING
	LOGICAL LABEL
C
	TLU=1
	LABEL=.TRUE.
	CALL GETENV('TAPE',DEVNAM)
	ISTATUS=TOPEN(TLU,DEVNAM(1:lnblnk(DEVNAM)),LABEL)
	CALL gerror(ERRSTRING)
	IF (ISTATUS.NE.0) THEN
		WRITE(6,*) '*** Can''t open TAPE device ***'
		WRITE(6,*) 'TAPE = ', DEVNAM
		WRITE(6,*) 'ISTATUS = ',ISTATUS
		WRITE(6,*) 'MESSAGE = ',ERRSTRING
		RETURN1
	ENDIF
	RETURN
	END
