C
C   Subroutine to read pictures in FITS format on disk to the core
C     modified from rdvista.f on March 3, 1990
C****************************************************************************
C
C
        SUBROUTINE RFITSDK(*,NFR,FITSNAM,IX,NU,NV,KF)
c       INTEGER*2 IX(NU,NV,KF),ixy(1440)
        INTEGER IX(NU,NV,KF)
	integer*2 ixy(1440)
        INTEGER NPAX(2),bitpix
        REAL*8 BSCALE,BZERO
        CHARACTER*20 FITSNAM,ITEST1
        CHARACTER*35 NCOM,NCOMC
        CHARACTER HEADBLK*2880,IANS*1,HDR*80
        COMMON/PICC/NCOMC(15)
        INCLUDE 'picdir.inc'
        CALL QUERYNFR(NFR,KF,0,*999,*20001)
C   get fits file name, default extension=fits
20001     IF (FITSNAM.EQ.' ') THEN
 600      WRITE(6,1)
 1      FORMAT('   Enter FITS file name: ',$)
          READ(5,2,END=999,ERR=600) FITSNAM
 2      FORMAT(A20)
        END IF
	krec=1
        DO 100 I=1,20
          IF (FITSNAM(I:I).EQ.'.') GO TO 101
          IF (FITSNAM(I:I).EQ.' ') GO TO 102
 100    CONTINUE
 102    IF (I.EQ.1) GO TO 600
        FITSNAM=FITSNAM(1:I-1)//'.fits'
101       OPEN(UNIT=20,FILE=FITSNAM,FORM='UNFORMATTED',STATUS='OLD'
     *        ,access='direct',recl=2880,ERR=998)
c         READ (unit=20,rec=krec,ERR=987,END=986) HEADBLK
          READ (unit=20,rec=krec,ERR=987) HEADBLK
C  go through header block and extract needed info
          NHEAD=1
          IHB=0
          N1=1
          N2=80
          IANS=HEADBLK(30:30)
          IF (IANS.NE.'T') GO TO 987
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get "Number-of-bits-per-data-point"
          READ (HEADBLK(N1:N2),502) bitpix
	  if (bitpix.ne.16) then
	    write(6,*) '  *** cannot read fits not in short integer ***'
	    return1
	  end if	
502     FORMAT (10X,I20)
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get number of axes
          READ (HEADBLK(N1:N2),502) NAXIS
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get number of data points along first axis, etc.
          DO 108 I=1,NAXIS
            READ (HEADBLK(N1:N2),502) NPAX(I)
          WRITE(6,612) headblk(n1:n2) 
            WRITE(6,612) HDR
            NHEAD=NHEAD+1
            N1=N1+80
            N2=N2+80
            N3=N1+2
 108      CONTINUE
          IF (NPAX(1).GT.NU.OR.NPAX(2).GT.NV) THEN
            CLOSE(UNIT=20)
            WRITE(6,*)' +++ Picture size too large for configuration'
            RETURN1
          END IF
          NII(NFR)=NPAX(1)
          NJJ(NFR)=NPAX(2)
c  read remaining header
C  get bscale and bzero
C  find objectname and put it in the comment field
          KNH=36-NHEAD
 150      IF (IHB.GE.1) KNH=36
          DO 110 I=1,KNH
            IF (headblk(n1:n2).EQ.' ') GO TO 110
            ITEST1=HEADBLK(N1:N3)
            IF (ITEST1.EQ.'OBJ')  then
	        READ(HEADBLK(N1+11:N1+30),677) NCOMC(NFR)
                WRITE(6,612) headblk(n1:n2)
	    else if (ITEST1.EQ.'BSC') then
	      READ(HEADBLK(N1+11:N1+30),*) BSCALE
            else if (ITEST1.EQ.'BZE') then
	      READ(HEADBLK(N1+11:N1+30),*) BZERO
            else IF(ITEST1.EQ.'END') then
	      GO TO 111
	    end if
c            NHEAD=NHEAD+1
            N1=N1+80
            N2=N2+80
            N3=N1+2
c            N4=N1+11
 611   FORMAT(A80)
677     FORMAT(A20)
612     FORMAT(1X,A79)
622     FORMAT(1X,A80)
110      CONTINUE
C   "END" is not reached, read another header block
	 krec=krec+1
c        READ (20,rec=krec,ERR=986,END=986) HEADBLK
         READ (20,rec=krec,ERR=986) HEADBLK
         IHB=IHB+1
	 n1=1
	 n2=80
	 n3=3
c	 n4=n1+11
         GO TO 150
111       CONTINUE
C
C  read data
        write(6,*) 'BSCALE ',BSCALE,'    BZERO ',BZERO
	i=1
	j=1	
	if (abs(1.-bscale).lt.0.0001.and.abs(bzero).lt.0.01) then
 124	  krec=krec+1
c	  read(20,rec=krec,err=985,end=984) ixy
	  read(20,rec=krec,err=985) ixy
           do 122 k=1,1440
	     if (i.gt.nii(nfr)) then
	       j=j+1
	       if (j.gt.njj(nfr)) go to 123
	       i=1
	     end if
	     ix(i,j,nfr)=ixy(k)
	     i=i+1
 122	   continue
	  go to 124
	else
 125	  krec=krec+1
c	  read(20,rec=krec,err=985,end=984) ixy
	  read(20,rec=krec,err=985) ixy
           do 126 k=1,1440
	     if (i.gt.nii(nfr)) then
	       j=j+1
	       if (j.gt.njj(nfr)) go to 123
	       i=1
	     end if
	     ix(i,j,nfr)=nint(ixy(k)*bscale+bzero)
	     i=i+1
 126	   continue
	  go to 125
	end if
 123	CLOSE(UNIT=20)
 999    RETURN1
 998    WRITE(6,*) '  **** NO SUCH FILE ***'
        RETURN1
 986    WRITE(6,*) '  **** CAN''T READ HEADER *** ',IHB+1
        CLOSE(UNIT=20)
        RETURN1
 987    WRITE(6,*) '  **** NOT SIMPLE FITS ***'
        CLOSE(UNIT=20)
        RETURN1
 985    WRITE(6,*) '  **** ERR READING DATA *** at ',I,J
        CLOSE(UNIT=20)
        RETURN1
 984    WRITE(6,*) '  +++ DATA ENDED PREMATURELY +++ at ',I,J
        CLOSE(UNIT=20)
        RETURN1
        END
