C////////////////////////////////////////////////////////////////
C
c           programs to create sky mask to mask out stars (only for
c                 stars, assume ~circular psf shape)
c
c   procedure 1:
c       read in existing .phm file
c          set up radius for individual objects by examining
c          the growth curve and IDS
c          create a crbp input file
c
c   procedure 2:  (not implemented)
c       create a master high S/N psf profile to a large radius
c       scale master profile with individual object
c       determine radius at which the profile of the object is less 
c          than a threshold in units of sky sigma
c       create crbp input file using the radius
c
	SUBROUTINE skymask(*,NFR,ipar,IX,NU,NV,KF)
c maximum objects
	parameter(nmax=56000)
c	INTEGER*2 IX(NU,NV,KF),ICL(nmax)
	INTEGER IX(NU,NV,KF),ICL(nmax)
	integer nx,ny,ids(nmax)
	DIMENSION  RMAG(nmax),cntr(nmax),
     *   SKY(nmax),ZSIG(nmax),err(nmax),rad(nmax)
	CHARACTER COMMENT*60,filout*24,filroot*18
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=2 FOR POSITION FILE'
	  RETURN1
	END IF
c  read object information from .phm file
c    error here is really S/N, rad is really radius
	call mordaper(nfr,rad,rmag,err,sky,zsig,icl,ids,nmax,
     *       comment,filroot,*999)
c  search for max aperture
	napmax=0
	radmax=0.
	do 150 i=1,nob(nfr)
	  if (ids(i).gt.napmax) then
	    napmax=ids(i)
	    radmax=rad(i)
	  end if
 150	continue
	idsatlim=nint(0.67*napmax)
	filout=filroot(1:lnblnk(filroot))//'bp.macro'
	write(6,2) filout
 2	format('  ...Output macro file name: ',a20/
     *      '   ... macro automatically created for mask in frame 2')
c make macro file
	call opennew(28,1,20,filout,*999)
	write(28,3) filroot(1:lnblnk(filroot))//'.phm',nii(nfr),njj(nfr)
 3	format('# star mask pixel map macro created from ',a22,
     *        /'crbp'/,' 2'/2i6)
	do 100 i=1,nob(nfr)
	  if (icl(i).eq.4) then
	    if (ids(i).lt.idsatlim) then
c	      irad=radmax*2.4
	      irad=radmax*2.2
	    else
c	      irad=rad(i)*2.4
	      irad=rad(i)*2.0
	    end if
	  else 
	    if (ids(i).le.2) then
	      goto 100
	    else if (err(i).lt.5..or.ids(i).lt.5) then
c	      irad=nint(rad(i)*1.5)
	      irad=rad(i)*1.5
	    else
c	      irad=nint(rad(i)*2.)
	      irad=rad(i)*2.
	    end if
	  end if
	  write(28,4) ijoi(i,nfr),ijoj(i,nfr),irad  
 4	format('p',i6,1x,i6,1x,i4,f10.0,i5)
 100	CONTINUE
	write(28,*)
	write(28,*) 'end'
 	CLOSE(UNIT=28)
 999	RETURN1
	END
c//////////////////////////////////////////////////////////////////
c
c   subroutine to compute sky using a mask to block out objects
c
c     the mask map is passed through in imask (0=good, 1=masked)
C      IRC=1: RING,  IRC=0: CIRCLE
C      IO,JO = CO-ORINATE (INTEGER*2)
C      RADIUS: IAP2=OUTER RADIUS, IAP(NAPP)=INNER RADIUS : IN COMMON BLOCK
C         ** must call APARRY to set IT's and IROW's before calling RINGSKY
C      SKY, ZSIG = RETURNED VALUE
C      SKYRAY, MSKY= ARRAY TO HOLD SKY VALUES, UP TO MSKY PIXELS
C
	subroutine masky(IRC,SKY,ZSIG,NNAP,IO,JO,NI,NJ,IX,NU,NV,imask,
     *                      SKARAY,MSKY,N3,IW,IPR)
c	INTEGER*2 IX(NU,NV),imask(nu,nv)
	INTEGER IX(NU,NV),imask(nu,nv)
	character ians*1
	REAL SKARAY(MSKY)
	include 'apert.inc'
	INCLUDE 'ppparm.inc'
	K=0
	NSK=0
	IPR=0
	JR1=JO-IROW1(NNAP)
	JR2=JO+IROW1(NNAP)
C  filling the  array for sky determination
	IF (IRC.EQ.1) THEN
	  DO 100 J=MAX0(1,JO-IROW2),MIN0(NJ,JO+IROW2)
	    K=K+1
	    DO 101 I=MAX0(1,IO-IT2(K)/2), MIN0(NI,IO+IT2(K)/2)
	      IF (J.LT.JR1.OR.J.GT.JR2) GO TO 102
	      KK=IT1(K+IROW1(NNAP)-IROW2,NNAP)/2
	      IR1=IO-KK
	      IR2=IO+KK
	      IF (I.LT.IR1.OR.I.GT.IR2) GO TO 102
	      GO TO 101
 102	      continue
	      if (imask(i,j).eq.0) then
	        NSK=NSK+1
	        IF (NSK.GT.MSKY) GO TO 700
	        SKARAY(NSK)=FLOAT(IX(I,J))
	      end if
 101	    CONTINUE
 100	  CONTINUE
	ELSE
C Filing array for circle sky
	  DO 200 J=MAX0(1,JO-IROW2),MIN0(NJ,JO+IROW2)
	    K=K+1
	    DO 201 I=MAX0(1,IO-IT2(K)/2), MIN0(NI,IO+IT2(K)/2)
	      if (imask(i,j).eq.0) then
	        NSK=NSK+1
	        IF (NSK.GT.MSKY) GO TO 700
	        SKARAY(NSK)=FLOAT(IX(I,J))
	      end if
 201	    CONTINUE
 200	  CONTINUE
	END IF
    	IF (NSK.LE.0) THEN
	  WRITE(6,*) ' **** Sky pixel number <= 0 ****'
	  IPR=999
	  RETURN
	END IF
 700	IF (NSK.GT.MSKY) THEN
    	  WRITE(6,*) ' +++sky pixel num >',MSKY,' pixels' 
	  WRITE(6,*) ' ...SKY DETERMINED FROM INCOMPLETE APERTURE'
	  NSK=MSKY
	END IF
	CALL MMM(SKARAY,NSK,N3,ZMEAN,ZMED,ZMODE,ZSIG,ZSK,ZREJ,NIT,1.,
     *             ZM1)
	IF (ZSK.GT.1.E08) THEN
	  SKY=ZM1
	ELSE
	  SKY=SKCMED*ZMED-SKCMEAN*ZMEAN
C	  SKY=ZMODE
C	  SKY=0.5*(ZMODE +ZMOD)
C	  IF (ZMEAN.LT.ZMED) SKY=ZMED
	END IF
	IF (IW.EQ.1) WRITE(6,12) N3,ZMEAN,ZMED,ZMODE,SKY,zsig
 12	FORMAT(' pix#',I5,1x,'mean,med,mod,sky:',4F9.2,' sig',f9.2)
 999	RETURN
	END 
