C////////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE FOR SURFACE PHOTOMETRY
C       IPAR=0 CIRCULAR APERTURES (SEBOK APERTURE)
C       IPAR=1 SECTOR OF CIRCULAR APERTURE
C              (FOR IPAR=1, NFR<=3 ONLY)
C
	SUBROUTINE SURPHO(*,NFR,STRF,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INTEGER IAP(150),TIAP(3),IT(294),ITP(294),INITD(10),IDD(10)
	REAL*4 AAR(350,350),SKYRAY(70000),SP(150),RR(150),TSP(3)
     *        , TLSP(3),TRR(3),AART(2,2),ER(150),TER(3)
	CHARACTER STRF*60,FILEN*24,STR*8,string*10,fstr31*50,fstr49*120
     *          ,comment*60
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	EQUIVALENCE (SKYRAY(1),iscr(800001)),(AAR(1,1),iscr(1))
     *        ,(iap(1),iscr(700001)),(it(1),iscr(701001)),
     *        (itp(1),iscr(702001)),(sp(1),iscr(703001)),
     *        (rr(1),iscr(704001)),(er(1),iscr(705001))
	CALL QUERYNFR(NFR,KF,0,*999,*20010)
20010	NI=NII(NFR)
	NJ=NJJ(NFR)
	KF1=KF-1
	IF (IPAR.EQ.1.AND.NFR.GE.KF-1) THEN
	  WRITE(6,10) KF-1
 10	FORMAT(' ****CANNOT DO SSPHO FOR FRAME >=',I1,'****')
	  RETURN1
	END IF
	IF (IPAR.EQ.1) 	WRITE(6,*) '  +++++ WARNING: SSPHO WILL'
     *               ,  ' OVERWRITE FRAME',KF1
	FILEN=STRF(1:18)
 610	IF (FILEN.EQ.' ') WRITE(6,11)
11	FORMAT( '   Enter output file name, n for NO save: ',$)
	CALL RDFILN(FILEN,NCC,IFP)
	IF (IFP.EQ.-999) RETURN1
	IF (IFP.EQ.-1) THEN
	  filen=' '
	  GO TO 610
	END IF
 2	FORMAT(A8)
	IF (FILEN.EQ.'q') RETURN1
	if (filen.ne.'n'.and.filen.ne.' ') then
	  write(6,'(''  Enter comment: '',$)')
	  read(5,3,end=999) comment
	  IF (IFP.EQ.0) FILEN=FILEN(1:NCC)//'.sfp'
	  call opennew(28,1,18,filen,*610)
 3	format(a60)
	end if
 600	WRITE(6,12) XC,YC
 12	FORMAT('   Enter centroid X,Y, (Default=',2F8.3,'): ',$)
	CALL READ2R(XC,YC,*900,*600)
	IXC=NINT(XC)
	IYC=NINT(YC)
 603	WRITE(6,13) IDIA
 13	FORMAT('   Enter max diameter (odd int pixel, defualt=',I4,
     *        '): ',$)
	CALL READ1I(IDIA,*900,*603)
	IF (IDIA.LE.0) GO TO 603
	DO 171 I=1,10
	  IF (IDD(I).EQ.0) THEN
	    LR=I-1
	    IF (LR.EQ.0) THEN
	      INITD(1)=1
	      IDD(1)=2
	      LR=1
	    END IF
	    GO TO 6201
	  END IF
 171	CONTINUE
	LR=LR-1
 6201	istatus=encode(string,float(max0(1,lr)),1,0,idum)
	fstr49='(''   Enter a series of starting dia. and delta dia.,'' 
&	     ,'' 0 0 to end''/''   Current default: '','
&	       //string(1:lnblnk(string))//'(I4,I5,'',''))'
 620	WRITE(6,fstr49) (INITD(I),IDD(I),I=1,LR)
c 49	FORMAT('   Enter a series of starting dia. and detla dia., to'
c     *      ' end enter 0 0.'/'   Current default:',<MAX0(1,LR)>(I4,I5
c     *       ,','))
 	DO LRT=1,10
	  GO TO 605
 621	  WRITE(6,*) ' *** INPUT ERROR IN LAST ENTRY, TRY AGAIN***'
 605	  WRITE(6,14)  
 14	FORMAT('     Enter starting diameter and increment: ',$)
	  CALL READ2I(INITDT,IDELDT,*900,*621)
	  if (lrt.eq.1.and.ideldt.eq.0) go to 173
	  INITD(LRT)=INITDT
	  IDD(LRT)=IDELDT
	  IF (INITDT.EQ.0) GO TO 172
	END DO
 172	LRT=LRT-1
	IF (LRT.NE.0) LR=LRT
 173 	CALL CSKY(*60,NFR,NINT(XC),NINT(YC),SKY,SKYSIG,nsky,IX,NU,NV,KF,' ')
 60	if (nsky.ne.0) then
	  skyerr=skysig/sqrt(float(nsky-1))
	  write(6,*) '  Default sky uncertainty = rms of the mean,'
	else
	  write(6,*) ' Sky entered by user, uncertainty not computed'
	end if
 6011	write(6,5) skyerr
  5	format('  Enter uncertainty of sky value in ADU [dflt:',f8.4,
     *         ']: ',$)
	call read1r(skyerr,*900,*6011)
c	SRSKY=SQRT(AMAX1(0.,SKY))
	SSKYSIG=SKYSIG*SKYSIG
	IFR=0
 611	WRITE(6,*) '  Total CCD gain: ', ccdgain 
c 612	WRITE(6,15) 
c 15	FORMAT('   Enter an/sn for data averaged/sum from n frame,'/
c     *       '         c if you want to change the read noise     : ',$)
c	call readstr(8,str,*900,*612)
c	IF (STR(1:1).EQ.'c') THEN
c 613	  WRITE(6,16) SIGREAD
c 16	FORMAT(   '   ENTER new readout noise (df:',f7.2,'): ',$)
c	  call read1r(sigread,*900,*613)
c	  GO TO	611
c	ELSE
c	  DO K=2,8
c	    IF (STR(K:K).EQ.' ') GO TO 160
c	  END DO
c	  IF (K.LE.2) GO TO 611
c 160	  istatus=encode(string,float(k-2),1,0,idum)
c	  fstr31='(I'//string(1:lnblnk(string))//')'
c 	  READ(STR(2:K-1),fstr31,ERR=611,END=611) IFR
c 31	FORMAT(I<K-2>)
c	  IF (STR(1:1).EQ.'a') THEN
c	    SIGREAD=SIGREAD/SQRT(FLOAT(IFR))
c	  ELSE IF (STR(1:1).EQ.'s') THEN
c	    SIGREAD=SQRT(FLOAT(IFR))*SIGREAD
c	  ELSE
c	    GO TO 611
c	  END IF
c	END IF
 	IF (IPAR.EQ.1) THEN
C   sector
 601	  WRITE(6,17) PAD,SWIDD
 17	FORMAT('   ENTER position angle of sector (+REAL DEG)'
     *             ,' AND half-width of sector,'/'   Default:',2F7.2,
     *	  '    (CCW from 12 O''C position=+ive, + ONLY): ',$)
	  CALL READ2R(PAD,SWIDD,*900,*601)
	  PA=(360.-PAD)*.01745329
	  SWID=SWIDD*.01745329+.00001
	  IRAD=IDIA/2
	  IYT=IYC-IRAD
	  IYB=IYC+IRAD
	  IXL=IXC-IRAD
	  IXR=IXC+IRAD	
C
C   CALCULATE ANGLE ARRAY
C
C
C   SET INTERPOLATION WEIGHT
C
	  THEMAX=PA+SWID
	  THEMIN=PA-SWID
	  KC=0
	  IF (THEMAX.GT.6.283185.OR.THEMIN.GT.6.283185) THEN 
	    KC=1
	    THEMAX=THEMAX-6.283185
	    THEMIN=THEMIN-6.283185
	  END IF
	  DO 100 J=1,IDIA+1
	    YY=IYC-IRAD+J-1.5
	    DO 100 I=1,IDIA+1
	      XX=IXC-IRAD+I-1.5
 	      AAR(I,J)=ATAN2(YC-YY,XC-XX)
	      IF (KC.EQ.1) GO TO 100
	      IF (AAR(I,J).LT.0.00) AAR(I,J)=AAR(I,J)+6.283185
 100	  CONTINUE
C
C   SET INTERPOLATION WEIGHT
C
	  DO 101 J=1,NJ
	    DO 101 I=1,NI
 101	      IX(I,J,KF1)=0
	  K1=0
	  DO 102 J=IYT,IYB	
	    K2=0
	    K1=K1+1
	    DO 102 I=IXL,IXR
	      K2=K2+1
	      DO 81 K=1,2
	        DO 81 KK=1,2
  81	          AART(KK,K)=AAR(K2+KK-1,K1+K-1)
C
C   TO ENSURE CONTINUITY OF ANGLE
C
	      DO 82 K=1,2
	        IF (ABS(AART(K,1)-AART(K,2)).LT.3.142) GO TO 82 
	        IF (AART(K,1)-AART(K,2)) 85,82,86
 85	        AART(K,1)=AART(K,1)+6.283185
	        GO TO 82
 86	        AART(K,2)=AART(K,2)+6.283185
 82	      CONTINUE
	      DO 103 K=1,2
	        AT=AMOD((AART(1,K)+AART(2,K))*.5,6.283185)
	        IF (ABS(AART(1,K)-AART(2,K)).GT.3.14159) 
     *              AT=(AMOD(AART(1,K)+AART(2,K),6.283185))*.5
	        IF (AT.GE.THEMIN.AND.AT.LE.THEMAX) 
     *              IX(I,J,KF1)=IX(I,J,KF1)+2
	        DO 103 KK=1,2
	          AT=AMOD((AART(KK,1)+AART(KK,2))*.5,6.283185)
	          IF (ABS(AART(KK,1)-AART(KK,2)).GT.3.14159)
     *	               AT=(AMOD(AART(KK,1)+AART(KK,2),6.283185))*.5
	          IF (AT.GE.THEMIN.AND.AT.LE.THEMAX) 
     *                 IX(I,J,KF1)=IX(I,J,KF1)+1
	          AT2=AMOD(AART(KK,K),6.283185)
	          IF (AT2.GE.THEMIN.AND.AT2.LE.THEMAX) 
     *                 IX(I,J,KF1)=IX(I,J,KF1)+1
 103	      CONTINUE
 102	  CONTINUE
C  angle for complete circle
	ELSE
	  PAD=0.
	  SWIDD=180.
	END IF
C
C   CALCULATE SURFACE PROFILE
C
C  FORM APERTURES
c  ! aperture limit
	INITD(LR+1)=IDIA+1 
C  NUMBER OF APERTURES
	NAP=0
	DO 202 LL=1,LR
	  NR=0
 211	  NAP=NAP+1
	  IF (NAP.GT.150) GO TO 202
 	  IAP(NAP)=INITD(LL)+NR*IDD(LL)
	  NR=NR+1
	  IF (IAP(NAP).GE.INITD(LL+1)) GO TO 202
	  GO TO 211
 202	  NAP=NAP-1
	DO 290 M=1,MIN(150,NAP+2)
	  SP(M)=0.
	  RR(M)=0.
 290	ER(M)=0.
C  SURFACE PROFILE FOR EACH APERTURE
C
C   FIRST APERTURE
	AWT=0.
	CALL APARAYB(IAP(1),ITP,IROWP,NPIX,0,400)
	K=0	
	DO 190 J=MAX0(1,IYC-IROWP),MIN0(NJ,IYC+IROWP)
	  K=K+1
	  DO 190 I=MAX0(1,IXC-ITP(K)/2),MIN0(NI,IXC+ITP(K)/2)
	    IF (IPAR.EQ.0) THEN
	      AWT=AWT+1.
	      SP(1)=SP(1)+IX(I,J,NFR)-SKY
	    ELSE
 	      AWT=AWT+FLOAT(IX(I,J,KF1))/12.
	     SP(1)=SP(1)+(FLOAT(IX(I,J,NFR))-SKY)*FLOAT(IX(I,J,KF1))/12.
	    END IF
 190	CONTINUE
	IF (AWT.EQ.0.) THEN
	  SP(1)=FLOAT(IX(IXC,IYC,NFR))-SKY
	  AWT=1.
	END IF
 	SP(1)=SP(1)/AWT 
	IF (SP(1).GT.0.00001) THEN
C	  ER(1)=SKYSIG/(SP(1)*SQRT(AWT))
c	  ER(1)=(SKYSIG-SIGREAD)*SQRT(SP(1)+SKY)/SRSKY+SIGREAD
c	  ER(1)=SQRT(ER(1)*ER(1)+SSKYSIG/AWT)/(SP(1)*SQRT(AWT))
	    er(1)=(skyerr*skyerr*awt+sskysig+sp(1)/ccdgain)*awt
	    er(1)=sqrt(er(1))/(sp(1)*awt)
	ELSE
	  ER(1)=99.
	END IF 
	RR(1)=IAP(1)*.25
C    BEGIN OF BIG LOOP
C
	DO 210 M=2, NAP
	  CALL APARAYB(IAP(M),IT,IROW,NPIX,0,400)	
	  JR1=IYC-IROWP
	  JR2=IYC+IROWP
	  IROWDIF=IROW-IROWP
	  K=0
	  AWT=0.
	  IF (IPAR.EQ.0) THEN
C  full circular aperture
	    DO 230 J=MAX0(1,IYC-IROW),MIN0(NJ,IYC+IROW)
	      K=K+1
 	      DO 231 I=MAX0(1,IXC-IT(K)/2),MIN0(NI,IXC+IT(K)/2)
	        IF (J.LT.JR1.OR.J.GT.JR2) GO TO 232
	        KK=ITP(K-IROWDIF)/2
	        IR1=IXC-KK
	        IR2=IXC+KK
	        IF (I.GE.IR1.AND.I.LE.IR2) GO TO 231
 232	        AWT=AWT+1.
	        SP(M)=SP(M)+FLOAT(IX(I,J,NFR))-SKY
 231	      CONTINUE
 230	    CONTINUE
	  ELSE
C sectored profile, use weights in IX(KF1)  full pixel = weight of 12
 	    DO 250 J=MAX0(1,IYC-IROW),MIN0(NJ,IYC+IROW)
	      K=K+1
 	      DO 251 I=MAX0(1,IXC-IT(K)/2),MIN0(NI,IXC+IT(K)/2)
	        IF (IX(I,J,KF1).EQ.0) GO TO 251
	        IF (J.LT.JR1.OR.J.GT.JR2) GO TO 252
	        KK=ITP(K-IROWDIF)/2
	        IR1=IXC-KK
	        IR2=IXC+KK
	        IF (I.GE.IR1.AND.I.LE.IR2) GO TO 251
 252	        AWT=AWT+IX(I,J,KF1)
	        SKYRAY(NAPIX)=IX(I,J,NFR)
	        SP(M)=SP(M)+(SKYRAY(NAPIX)-SKY)*FLOAT(IX(I,J,KF1))
 251	      CONTINUE
 250	    CONTINUE
	  END IF
	  IF (AWT.NE.0.) THEN
	    SP(M)=SP(M)/AWT
	  ELSE
	    SP(M)=0.
	  END IF
c ! rescale AWT to number of pixels
	  IF (IPAR.EQ.1) AWT=AWT/12.  
C  calculate uncertainty
	  IF (SP(M).GE.0.0001) THEN
C	    ER(M)=SKYSIG/(SP(M)*SQRT(AWT))
c	    ER(M)=(SKYSIG-SIGREAD)*SQRT(SP(M)+SKY)/SRSKY+SIGREAD
c	    ER(M)=SQRT(ER(M)*ER(M)+SSKYSIG/AWT)/(SP(M)*SQRT(AWT))
c uncertainty: sum in quardrature of: uncertainty of sky value, sky flutuation
c               within the aperture, and photon noise within the aperture
	    er(m)=(skyerr*skyerr*awt+sskysig+sp(m)/ccdgain)*awt
	    er(m)=sqrt(er(m))/(sp(m)*awt)
	  ELSE
	    ER(M)=99.
	  END IF
 	  RR(M)=(IAP(M)+IAP(M-1))*.25
C
C  SET (M-1) TH APERTURE PARAMTERS TO M TH APERTURE PARAMETER	
C
	  DO 270 NN=1,2*IROW+1
 270	    ITP(NN)=IT(NN)
 	  IROWP=IROW
c !  end of big loop
 210	CONTINUE 
	NPROW=(NAP+1)/2
	write(28,'(1x,a60)') comment
	WRITE(28,51) NAP,PAD,SWIDD,SKY,SKYSIG
 51	FORMAT(1X,I3,1X,'POSITION ANGLE:',F7.2,5X,'HALF-WIDTH',F7.2
     *          ,5X,'SKY= ',F9.3,'+-',F7.3)
	write(6,45)
 45	format(1x,2('Apert  Rad   ct/pix   mag/pix +/-frac  '))
	DO 280 K=1,NPROW
	  DO 281 KK=1,2
	    TIAP(KK)=IAP(K+(KK-1)*NPROW)
	    TRR(KK)=RR(K+(KK-1)*NPROW)
	    TSP(KK)=SP(K+(KK-1)*NPROW)
	    TER(KK)=ER(K+(KK-1)*NPROW)
	    TLSP(KK)=99.
 281	  IF (TSP(KK).GT.0.) TLSP(KK)=-2.5*ALOG10(TSP(KK))
 280	WRITE(6,50) (TIAP(KK),TRR(KK),TSP(KK),TLSP(KK),
     *            TER(KK),KK=1,2)
 50	FORMAT(1X,2(I3,F7.2,F10.3,1X,F7.3,F8.3,3X))
c write data to file
	if (filen.ne.'n') then
	  DO 282 K=1,nap   
 	    IF (SP(K).GT.0.) then
	      rlsp=-2.5*ALOG10(SP(K))
	    else
	      rlsp=99.
	    end if 
	    WRITE(28,59) IAP(K),RR(K),rlsp,ER(K)
 282	  continue
	  CLOSE(UNIT=28)
	end if
 59	FORMAT(1X,I3,1X,F7.2,2X,F7.3,1X,F8.3,3X)
 900	if (filen.ne.'n'.and.filen.ne.' ') close(unit=28,err=999)
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CREATE CIRCULAR APERTURE AND CALCULATE OTH,
C    2ND AND 4TH MOMENTS OF APERTURE WITH INTENSITY OF 1
C
	SUBROUTINE APARAYB(IA,IT,IROW,N,IW,NMAX)
	INTEGER IT(*)
	IF (IA.GT.NMAX) THEN
	  WRITE(6,*) '  **** aperture too large, max: ',NMAX
	  N=-1
	  RETURN
	END IF
	N=0
	IAA=IA*IA+1
	IROW=IA/2
	KI=IROW+2
	DO 100 J=1, IROW+1
	  KI=KI-1
	  KK=J-1
	  IT(KI)=2*(INT(.5*SQRT(FLOAT(IAA-4*KK*KK))))+1
 100	CONTINUE
	KI=2*IROW+2
	DO 101 J=1, IROW
	  KI=KI-1
	  IT(KI)=IT(J)
 101	CONTINUE
	IJ=IROW+1
	DO 200 I=1, 2*IROW+1
	  N=N+IT(I)
 200	CONTINUE
	IF (IW.EQ.1) WRITE(6,*) IA,N
	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MAKE MAP OF CONNECTED PIXEL AREA WITH VALUE>=IXLIM
C    STARTING FROM SEEDS WITH VALUE>ISEED, WITH MIMUM SIZE OF NCON PIXELS
C      
	SUBROUTINE ISOPHOT(*,NFRA,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ITC(100000),JTC(100000)
	INTEGER IX(NU,NV,KF),ITC(100000),JTC(100000)
C            ,ICONC(0:49999)
	INTEGER NFRA(5),ICTL(40)
	DIMENSION XCEN(40),YCEN(40),RAD(40),ARAD(40),BRAD(40),ELL(40),
     *         THETA(40)
c	REAL*4 SKYRAY(62500),SP(150),RR(150),TSP(3)
c    *        , TLSP(3),TRR(3),AART(2,2),ER(150),TER(3)
	CHARACTER FILEN*24,STR*8,ian*1,ian1*1,comment*60
	INCLUDE 'pppcore.inc'
C	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	EQUIVALENCE (ITC(1),iscr(1)),(JTC(1),iscr(300001))
	NFR=NFRA(1)
	NFISO=NFRA(2)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
C	WRITE(6,*) '  --- A scratch frame is needed for area connection'
C6001	CALL QUERYNFR(NRES,KF,5,*999,)
C	IF (NRES.EQ.NFR) THEN 
C	  WRITE(6,*) '  **** OVER-WRITING original frame not allowed'
C	  NRES=0
C	  GO TO 6001
C	END IF
20001	IF (NFISO.EQ.0) THEN
 6002	  WRITE (6,8)
 8	FORMAT('  Optional: Enter frame number for storing isophot map:'
     *        /'        <cr> for not saving isophot map: ',$)
	  NFISO=0
	  CALL READ1I(NFISO,*6002,*999)
	  IF (NFISO.EQ.NFR) THEN
	    WRITE(6,*) '  **** OVER-WRITING original frame not allowed'
	    GO TO 6002
	  ELSE IF (NFISO.NE.0) THEN
	    CALL QUERYNFR(NFISO,KF,0,*999,*20003)
20003	    NII(NFISO)=NII(NFR)
	    NJJ(NFISO)=NJJ(NFR)
	    DO 106 J=1,NJJ(NFR)
	      DO 106 I=1,NII(NFR)
 106	        IX(I,J,NFISO)=0
	  END IF
	END IF
 600	WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter center of object [',2I5,']: ',$)
	CALL READ2I(ICEN,JCEN,*999,*600)
	IF (ICEN.GT.NII(NFR).OR.JCEN.GT.NJJ(NFR).OR.
     *            ICEN.LT.0.OR.JCEN.LE.0) THEN
	  WRITE(6,*)  '  **** CO-ORD TOO LARGE OR TOO SMALL ****'
	  GO TO 600
	END IF
 	CALL CSKY(*60,NFR,ICEN,JCEN,SKY,SKYSIG,nsky,IX,NU,NV,KF,' ')
 60	if (nsky.ne.0) then
	  skyerr=skysig/sqrt(float(nsky-1))
	  write(6,*) '  Default sky uncertainty = rms of the mean,'
	else
	  write(6,*) ' Sky entered by user, uncertainty not computed'
	end if
 601	write(6,5) skyerr
  5	format('  Enter uncertainty of sky value in ADU [dflt:',f8.4,
     *         ']: ',$)
	call read1r(skyerr,*999,*601)
c	SRSKY=SQRT(AMAX1(0.00001,SKY))
	SSKYSIG=SKYSIG*SKYSIG
        MAX=IX(ICEN,JCEN,NFR)
	IF (NC.LE.0) NC=20
 602	WRITE(6,13) SKY,SKYSIG,MAX,NC
 13	FORMAT(2X,' Mode =',F10.2,6x,'sigma =',F9.3,6X,'MAX = ',I6,/,
     *     '   Enter number of levels (MAX=40) [',I3,']: ',$)
	CALL READ1I(NC,*999,*602)
	IF (IAN.EQ.' ') IAN='m'
 6021	WRITE(6,14) IAN
 14	FORMAT('  Enter level types: p=previous, u=user input'/
     *    '         l=linear, m=log  [dflt: ',A1,']: ',$)
	call readstr(1,ian1,*999,*6021)
	IF (IAN1.NE.' ') IAN=IAN1
1	FORMAT(A1)
	IF (IAN.EQ.'p') THEN
	  NL=0
	  DO 108 I=1,NC
	    IF (ICTL(I).NE.0.) NL=NL+1
 108	  CONTINUE
	ELSE IF (IAN.EQ.'m') THEN
 609	  WRITE(6,16) CPLEVEL
 16	FORMAT( '   Levels are factor of ',F6.4,' apart (set cplevel)')
	    DLEVEL=MAX-SKY
	    DO 1111 I=1,NC
	      ICTL(I)=NINT(SKY+DLEVEL)
	      IF (DLEVEL.LT.CPLX*SKYSIG) GO TO 1117
C   lowest level must be larger than 1 sigma
 1111	      DLEVEL=DLEVEL*CPLEVEL
 1117	    NL=I
	ELSE IF (IAN.EQ.'l') THEN
	    DLEVEL=(MAX-SKY)/FLOAT(NC)
	    DO 1110 I=1,NC
 	      ICTL(I)=MAX+NINT((1-I)*DLEVEL)
 1110         IF (ICTL(I).LT.1) GO TO 1211
 1211	    NL=I-1
	ELSE IF (IAN.EQ.'u') THEN
	  DO 110 I=1,NC
 603	    WRITE(6,15) I,ICTL(I)
 15	FORMAT('    Enter level ',I2,' [',I6,'] (Ctr d to stop): ',$)
	    CALL READ1I(ICTL(I),*603,*1113)
	    IF (ICTL(I).LT.1) GO TO 1122
 110	  CONTINUE
 1122	  NL=I-1
	END IF
 18	FORMAT(5x,'----',I4,' levels will be computed ...')
 1113	WRITE(6,18) NC
 6994	  WRITE(6,21) SKY,SKYSIG
 21	FORMAT(' Isophot levels: background=',F9.2,'  sigma=',F9.3)
	IF (NC.LE.0) THEN
	  STR=' '
	  GO TO 602
	END IF
	DO 1431 M=NL+1,NC
 1431	  ICTL(M)=0
 	NCL=(NL+3)/4
	DO 143 M=1,NCL
	    M1=(M-1)*4+1
	    M2=M1+3
 143	  WRITE(6,144) (L,ICTL(L),L=M1,M2)
 144	FORMAT(4(4X,I2,1X,I6))
 6099	WRITE(6,22)
 22	FORMAT('  Are isophot levels OK? y=<cr>/n :',$)
	call readstr(1,ian1,*999,*6099)
	IF (IAN1.EQ.'n') GO TO 602
	FILEN=' '
 610	IF (FILEN.EQ.' ') WRITE(6,11)
 11	FORMAT( '   Enter profile output file name, n for NO save: ',$)
	CALL RDFILN(FILEN,NCC,IFP)
	IF (IFP.EQ.-999) RETURN1
	IF (IFP.EQ.-1) THEN
	  FILEN=' '
	  GO TO 610
	END IF
 2	FORMAT(A8)
	IF (FILEN.EQ.'q') RETURN1
	if (filen.ne.'n'.and.filen.ne.' ') then
	  IF (IFP.EQ.0) FILEN=FILEN(1:NCC)//'.sfp'
	  call opennew(28,1,18,filen,*610)
	  write(6,'(''  Enter comment: '',$)')
	  read(5,3,end=900) comment
 3	format(a60)
	end if
	WRITE(6,25)
	IF (FILEN.NE.'n') THEN
	  write(28,'(1x,60a)') comment
 	  WRITE(28,21) SKY,SKYSIG
	  WRITE(28,25)
	END IF
 25	FORMAT('  #  ADU  mag/sq pix  area wt. centroid   radius  angle'
     *        ,'      a      b      e')
	SUM1=0.
	IPT1=0
	DO 101 I=1,NL
	  SUM=0.
	  CALL SEGCON(ICEN,JCEN,ICTL(I),ITC,JTC,IPT,NII(NFR),NJJ(NFR),
     *                 IX(1,1,NFR),NU,NV)
C  make isophot map)
	  IF (NFISO.NE.0) THEN
	    NCT=NL-I+1
	    DO 114 N=1,IPT
	      IF (IX(ITC(N),JTC(N),NFISO).EQ.0) 
     *             IX(ITC(N),JTC(N),NFISO)=NCT
 114	    CONTINUE
	  END IF
C  compute profile parameters
C  1:  centroid 
	  ICX=0
	  ICY=0
	  PT=FLOAT(IPT)
	  DO 111 N=1,IPT
	    ICX=ICX+ITC(N)
 111	    ICY=ICY+JTC(N)
	  XCEN(I)=FLOAT(ICX)/PT
	  YCEN(I)=FLOAT(ICY)/PT
C  2:  equivalent radius
	  RAD(I)=SQRT(PT/3.1416)
C  3:  best fitting ellipse (see Dodd and MacGillivray, 1986 A.J., 92, 706)
C    compute moments	  
	  RMXX=0.
	  RMXY=0.
	  RMYY=0.
	  DO 112 N=1,IPT
	    SUM=SUM+IX(ITC(N),JTC(N),NFR)
	    TT=ITC(N)-XCEN(I)
	    TT1=JTC(N)-YCEN(I)
	    RMXX=RMXX+TT*TT
	    RMXY=RMXY+TT1*TT
 112	    RMYY=RMYY+TT1*TT1
	  RMXX=RMXX/PT
	  RMXY=RMXY/PT
	  RMYY=RMYY/PT
	  RMXSY=RMXX-RMYY
	  IF (ABS(RMXSY).LT.0.0000001) RMXSY=.0000001
	  THETA(I)=57.2958*0.5*ATAN2(2.*RMXY,RMXSY)
	  TT=2.*(RMXX+RMYY) 
	  TT1=2.*SQRT(AMAX1(0.00001,RMXSY*RMXSY+4*RMXY*RMXY))
	  ARAD(I)=SQRT(AMAX1(.000001,TT+TT1))
	  BRAD(I)=SQRT(AMAX1(.000001,TT-TT1))
	  ELL(I)=1-BRAD(I)/AMAX1(.00001,ARAD(I))
	  SUM=SUM-SKY*IPT
C  compute uncertainty in flux
c	  SIGSUR=sqrt(float(IPT-IPT1))*SKYSIG/(SUM-SUM1)
c	  sigsur=sqrt((skyerr/(float(ictl(i))-sky))**2+sigsur*sigsur)
c
c  new noise calculation: uncertainty=skyerr+photon noise
c         photon noise=sqrt(sky noise^2+object noise^2)
c following values are squared already
	  skynoise=float(ipt-ipt1)*skysig*skysig
	  objnoise=(sum-sum1)/ccdgain
c skyerr, skynoise, objnoise are all in ADUs
c  skyerr gives the uncertainty in the level due to sky, the
c   sum of the noise divided by the number of pixel gives the
c   uncertainy of the level due to the noise.
c    this is done in this curious way because the level is fixed,
c   and it is the radius that is being fitted.
c
c  linear sum
c	  sigsur=skyerr+sqrt(skynoise+objnoise)/float(ipt-ipt1)
c  quadrature sum as fraction
	  sigsur=sqrt(skyerr*skyerr+(skynoise+objnoise)/
     *          float((ipt-ipt1)*(ipt-ipt1)))
c sigsur as mag error
	  sigsur=2.5*alog10(amax1(.00001,1.+sigsur/(float(ictl(i))-sky)))
c              
c total error^2= N*sig^2+gain*sum/(gain*sum)^2
	  SIGTOT=SQRT(IPT*SSKYSIG+sum/ccdgain)/SUM
	  IPT1=IPT
	  SUM1=SUM
C  output
	IF (FILEN.NE.'n') THEN
	  WRITE(28,23) I,ICTL(I)-NINT(SKY),-2.5*ALOG10(AMAX1(.00001,
     *               FLOAT(ICTL(I))-SKY)),SIGSUR,XCEN(I),YCEN(I),
     *         RAD(I),THETA(I),ARAD(I),BRAD(I),ELL(I)
	  WRITE(28,31) IPT,SUM,-2.5*ALOG10(AMAX1(1.,SUM)),SIGTOT
	END IF
	  WRITE(6,23) I,ICTL(I)-nint(SKY),-2.5*ALOG10(AMAX1(.00001,
     *               FLOAT(ICTL(I))-SKY)),SIGSUR,XCEN(I),YCEN(I),
     *         RAD(I),THETA(I),ARAD(I),BRAD(I),ELL(I)
	  WRITE(6,31) IPT,SUM,-2.5*ALOG10(AMAX1(1.,SUM)),SIGTOT
 31	FORMAT(5X,'# of pix:',I7,'  total net cts:',F10.1,' mag:',F8.3
     *          ,F7.3)
 23	FORMAT(1X,I2,I6,F8.3,F6.3,2F9.3,F8.3,F8.2,1X,2F7.2,F7.3)
 101	CONTINUE
 900	IF (FILEN.NE.'n') CLOSE(UNIT=28)
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////
C
C  SUBROUTINE FOR CONNECTED AREA USING SEGMENTS
C
C
	SUBROUTINE SEGCON(ICEN,JCEN,ILIM,ISEG,JSEG,NPX,NI,NJ,
     *                 IX,NU,NV)
c	INTEGER*2 IX(NU,NV),ISEG(1),JSEG(1),KSEG1(5000),KSEG2(5000)
	INTEGER IX(NU,NV),ISEG(*),JSEG(*),KSEG1(5000),KSEG2(5000)
     	INTEGER NSEG(5000)
	include 'pppcore.inc'
c	equivalence (iscr(60001),kseg1(1)),(iscr(65001),kseg2(1))
c    *             , (iscr(67001),nseg(1))
c    NSEG(k) is the number of pixels in the kth segment
c    KSEG1(i) is the I pixel co-ordinate of the segment (temp storage)
c
C  search 1st segment which will be used as seeds
	do 220 i=1,1000
	 nseg(i)=0
 220	continue
	do 221 i=1,3000
	  kseg1(i)=0
	  kseg2(i)=0
 221	continue
c	NSEG(1)=0
c searching forward, fixed J, running I
	DO 100 I=ICEN,NI
	  IF (IX(I,JCEN).LT.ILIM) GO TO 200
	  NSEG(1)=NSEG(1)+1
	  KSEG1(NSEG(1))=I
 100	CONTINUE
c searching backward, fixed J, running I
 200	DO 101 I=ICEN-1,1,-1
	  IF (IX(I,JCEN).LT.ILIM) GO TO 201
	  NSEG(1)=NSEG(1)+1
	  KSEG1(NSEG(1))=I
 101	CONTINUE
C  sort the segment I co-ordinate from small to large
 201	IF (NSEG(1).GT.1) CALL N2SORT(NSEG(1),KSEG1)
C Store array
	DO 110 I=1,NSEG(1)
	  ISEG(I)=KSEG1(I)
 110	  JSEG(I)=JCEN
C
C  first search J co-ordinate less than center
C   KSEG1 contains I co-ordinate of seed segment
C   KSEG2 contains retruned new  segment
C
	K=0
	NPX=NSEG(1)
	DO 102 J=JCEN-1,1,-1
	  K=K+1
	  CALL CONSEG(KSEG1,KSEG2,NSEG(K),NSEG(K+1),ILIM,IX(1,J),NI)
C  store data 
c  ! exit search if the next segment has no pixel:
	  IF (NSEG(K+1).EQ.0) GO TO 202 
c  otherwise sort the new segment
	  IF (NSEG(K+1).GT.1) CALL N2SORT(NSEG(K+1),KSEG2)
c  store the new segment
	  DO 103 L=1,NSEG(K+1)
	    KSEG1(L)=KSEG2(L)
 	    ISEG(NPX+L)=KSEG2(L)
 103	    JSEG(NPX+L)=J
	  NPX=NPX+NSEG(K+1)
 102	CONTINUE
C
C search the other J direction
C   restore initial segment (around ICEN)
 202	DO 111 I=1,NSEG(1)
 111	  KSEG1(I)=ISEG(I)
	NSEG(K)=NSEG(1)
	K=K-1
	DO 104 J=JCEN+1,NJ
	  K=K+1
	  CALL CONSEG(KSEG1,KSEG2,NSEG(K),NSEG(K+1),ILIM,IX(1,J),NI)
C  store data 
c  ! exit search
	  IF (NSEG(K+1).EQ.0) GO TO 203 
	  IF (NSEG(K+1).GT.1) CALL N2SORT(NSEG(K+1),KSEG2)
	  DO 105 L=1,NSEG(K+1)
	    KSEG1(L)=KSEG2(L)
 	    ISEG(NPX+L)=KSEG2(L)
 105	    JSEG(NPX+L)=J
	  NPX=NPX+NSEG(K+1)
 104	CONTINUE
 203	RETURN
	END
C
C/////////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE OF CONNECTING A SINGLE SEGMENT GIVEN A SEED SEGMENT IN
C   ASCENDING I CO-ORDINATE (stored in kseg1)
c   the new segment is stored in kseg2
C
	SUBROUTINE CONSEG(KSEG1,KSEG2,NSEG1,NSEG2,ILIM,IX,NI)
c	INTEGER*2 KSEG1(1),KSEG2(1),IX(NI)
	INTEGER KSEG1(*),KSEG2(*),IX(NI)
C  start search from the smallest i
 	NSEG2=0
	DO 100 I=KSEG1(1),1,-1
	  IF (IX(I).LT.ILIM) GO TO 200
	  NSEG2=NSEG2+1
	  KSEG2(NSEG2)=I
 100	CONTINUE
c LARGE is the previous larges I co-ordinate checked
 200	LARGE=KSEG1(1)
C comes to an end, now look for additional segments connected with seed
C  at i co-ordinate larger than I=kseg1(1), 
	L=2
c ! do while loop
 150    CONTINUE   
	  DO 102 I=L,NSEG1
	    IF (KSEG1(I).GT.LARGE) THEN
	      LBACK=LARGE
	      LARGE=KSEG1(I)
c ! new seed
	      GO TO 202 
	    END IF
 102	  CONTINUE
C  no more seed, done (ie kseg1(nseg1) is not larger than LARGE)
	  GO TO 151
C  new seed, go forward
 202	  L=I+1
 	  DO 104 I=LARGE,NI
	    IF (IX(I).LT.ILIM) GO TO 201
	    NSEG2=NSEG2+1
	    KSEG2(NSEG2)=I
 104	  CONTINUE
C  check backward to LBACK
 201	  DO 105 II=LARGE-1,LBACK,-1
	    IF (IX(II).LT.ILIM) GO TO 203
	    NSEG2=NSEG2+1
 105	    KSEG2(NSEG2)=II
 203	  LARGE=I
	GO TO 150
 151	RETURN
	END
c//////////////////////////////////////////////////////////
c
c  subroutine to generate a file of neighbours and the masking
c    radius from an object, based on a position file
c
c      written May 9, 2000
c
	subroutine nmaskfile(nfr,ix,nu,nv,kf,*)
c	integer*2 nnei,nng(200),ix(nu,nv,kf)
	integer nnei,nng(200),ix(nu,nv,kf)
	dimension skaray(50000),iminr(200)
	character filenam*20
	include 'objcat.inc'
	include 'picdir.inc'
	include 'pppcore.inc'
	include 'apert.inc'
	equivalence (iscr(1900001),skaray(1))
	call querynfr(nfr,kf,0,*999,*600)
 600	write(6,1) ii,jj
 1	format('  Enter integer IJ co-ord of obj [',2i5,']: ',$)
	call read2i(ii,jj,*999,*600)
 501	write(6,3) maxr
 3	format('  Enter maximum radius in pixels [',i4,']: ',$)
	call read1i(maxr,*999,*600)
 602	write(6,2)
 2	format('  Enter output file name: ',$)
	read(5,'(a20)',end=999) filenam
c    !Max radius
	IRMAX=maxr
	IRMAXSQ=IRMAX*IRMAX
c locate the object (or nearest) in the pos file
	call locobj(ii,jj,icen,3,nob(nfr),ijoi(1,nfr),ijoj(1,nfr))
	if (icen.eq.0) then
	   write(6,5) 
	   return1
 5	format(' warning: no object found in posfil at position')
	else
	  write(6,6) icen
 6	format(' ppp obj#',i5,' at position...')
	end if
	ni=nii(nfr)
	nj=njj(nfr)
	call nneigh(nnei,nng,ii,jj,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),
     *           icen,irmax,irmaxsq)
c determine sky
	write(6,*) nnei, ' neighbours found'
	iap1(1)=irmax/2
	iap2=125
	IAP1(2)=MAX0(IAP1(1),IAP2-MAX0(6,IAP2/6))
	CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),PP(1),NA(1)
     *               ,IPRT)
	CALL APARAY(IAP1(2),IT1(1,2),IROW1(2),QQ(2),RR(2),PP(2),NA(2)
     *               ,IPRT)
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
	CALL RCSKY(1,SKY,ZSIG,2,II,JJ,NI,NJ,IX(1,1,NFR)
     *            ,NU,NV,SKARAY,50000,nsky,1,IPR)
	write(6,*) ' sky value: ',sky
	call makemask2(nnei,nng,ijoi(1,nfr),ijoj(1,nfr),ii,jj,
     *     sky,irmax,ix(1,1,nfr),nu,nv,ni,nj,iminr)
c out put
	call opennew(28,1,20,filenam,*999)
	do 100 i=1,nnei
	  write(28,10) i,ijoi(nng(i),nfr),ijoj(nng(i),nfr),iminr(i)
 100	continue
 10	format(i3,2x,2I6,2x,I5)
	close(unit=29)
 999	return1
	end
