C///////////////////////////////////////////////////////////////////////
c        subroutines to write fits to disk
c       *copied from ppplt, modified for ppp8k, Jan 29, 2004*
c
c  current set up will readout header block of the last fits image
c    read *** need to fix.
c
c           standard ppp input and output is fits file (.fits files)
c          with block lenght 2880 one or more fits header blocks are allowed.
c           When data are read in, they are recorded in a PPPDIR.DAT file
c           For reading data, if the file does not exist in PPPDIR, a search
c           of the disk is made and PPPDIR is automatically updated.
c           
c           if a .fits file does not exist for a PPPDIR image, the second
c           default format is the old .PIC file (unformatted direct acess
c           record length=1 line of the image), and it will automatically
c           read such a file if it exists.
c
c           When an image is read into PPP core, a pointer to its file name
c           is established so that the header information is available.
c           Writing a file into the disk involves creating a fits header
c           using, in order of over-ride, the following information:
c                  (1) a new OBJ line to be input from the terminal
c                  (2) the current picture size
c                  (3) the header file of the parent fits image if exist.
c
C///////////////////////////////////////////////////////////////////////
c/////////////////////////////////////////////
c
c      subroutine to write core picture to disk
C
	SUBROUTINE wdkfits(*,nfr,FILENC,irep,IX,NU,NV,kf,IR)
	INTEGER IX(NU,NV,kf)
	CHARACTER*24 NFILEN,FILEN
	CHARACTER*24 FILENC,FILENF,filenh,objnam*18,fitsname*24
	character headblk*2880,hdr(360)*80,size*20,fdate*24
     *         ,itest1*3,blank*20,axistr*20,imdir*55,nyes*1,
     *        ncomc*36,ncom*36
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	common/header/bzero,bscale,headblk(20),nhb
	common/headerst/bzest(15),bscst(15),headbst(20,15),nhbst(15)
	equivalence (headblk(1)(1:1),hdr(1)(1:1))
	common/imagedir/imdir
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254)
C decode filename
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IR=0
	blank='                   '
	IF (FILENC.EQ.' ') WRITE(6,1)
 1	FORMAT('  Enter output .fits file name: ',$)
	CALL RDFILND(FILENC,NC,IPF)
	IF (IPF.LE.-1) THEN
C  name too long or aborted
	  IR=-1
	  RETURN1
	END IF              
	FILEN=FILENC(1:NC)
C  get name for OPEN statement
	IF (IPF.EQ.0) THEN
C  no qualifier, append 
	  FILENF=FILENC(1:NC)//'.fits'
	ELSE                           
C	  qualifier exits
	  FILENF=FILENC
	END IF
 79	CALL DIREC(FILEN,FILENF,NFR,IP,2,IDF)
C a duplicate name is found in DIR
        IF (IP.EQ.1) THEN
 600      WRITE(6,2) FILEN
 2      FORMAT(' --- ',A12,' --- Already EXIST, Do you want to'
     *         ,' DELETE? (y/[n]): ',$)
          call readstr(1,nyes,*999,*600)
          IF (NYES.EQ.'y') THEN
C             delete original
            CALL DIREC(FILEN,FILENF,NFR,IP,0,IDF)
            GO TO 79
          ELSE
            WRITE(6,*) ' ...NO FILE WRITTEN.'
            RETURN1
          END IF
C   directory full
        ELSE  IF (IP.EQ.2) THEN
          WRITE(6,*) ' *** NO FILE WRITTEN *** '
          IR=-1
          RETURN1
        ELSE IF (IP.EQ.-1) THEN
          RETURN1
        END IF
C
C  start write:
C
 71	NI=NII(nfr)
	NJ=NJJ(nfr)
	call stthead(nfr)
	write(6,*) 'bzero ', bzero,' bscale ',bscale
c  writing fits
	open(unit=20,file=imdir(1:lnblnk(imdir))//filenf
     *        ,status='new',access='direct',recl=2880,err=9001)
 777	format(1x,a18)
c  write header
c  copy header block headblk, (this version copies nhb header blocks)
	if (nhb.gt.0) then
	ihb=1
	ihistory=0
	if (headblk(ihb).ne.' ') then
c  replace size information on hb#1
          DO 1181 I=1,36
            IF (hdr(i)(1:6).eq.'NAXIS1') then
	      istatus=encode(axistr,float(ni),1,0,idum)
	      hdr(i)(11:30)=axistr
	    end if
            IF (hdr(i)(1:6).eq.'NAXIS2') then
	      istatus=encode(axistr,float(nj),1,0,idum)
	      hdr(i)(11:30)=axistr
	    end if
c replace "object" field
            IF (hdr(i)(1:3).eq.'OBJ') then
	      objnam=ncom(nof)(1:18)
	      hdr(i)(1:30)='OBJECT  = '''//objnam//''''
	    end if
c  add a card before end card to indicate the file was created by ppp
            if (hdr(i)(1:3).eq.'    ') then
	      if (ihistory.eq.0) then
                hdr(i)='HISTORY = Saved from PPP '//fdate()
	        ihistory=1
	      end if
	    end if
	    if (hdr(i)(1:3).eq.'END') goto 1182
 1181  	  continue
   	  write(20,rec=1) headblk(1)
c  the more than one card
	  do 1081 n=2,nhb
            do 1183 i=36*(n-1)+1,36*n
              if (hdr(i)(1:3).eq.'    ') then
	        if (ihistory.eq.0) then
                  hdr(i)='HISTORY = Saved from PPP '//fdate()
	          ihistory=1
	        end if
	      end if
              if (hdr(i)(1:3).eq.'END') then
	        ihb=n
                goto 1182
              end if
 1183       continue
   	    write(20,rec=n) headblk(n)
 1081     continue
c  in this case, no end card was found!
	  ihb=nhb
	  hdr(i-1)='END'
c  write last header card
 1182 	  write(20,rec=ihb) headblk(ihb)
	end if
	else
c   if there is no data in header block, create simple header
c     and use default bscale and bzero (1 and 0)
	  write(6,10)
c10	format('  No default fits header.  Enter Object name : ',$)
 10	format('  No default fits header.  simple header used: ',$)
c	  read(5,'(a20)',end=998) objname
	  objnam=ncom(nof)(1:18)
	  call makefhd(ni,nj,objnam)
	  ihb=1
 	  write(20,rec=ihb) headblk(ihb)
	end if
	write(6,*) ' bscale ',bscale,' bzero ',bzero, 'nfr ',nfr
	call fitsdataout(20,ihb,ix(1,1,nfr),
     *         nu,nv,ni,nj,ibyte,bscale,bzero)
 998	close(unit=20)
 999	return1
 9001	write(5,*) ' *** no such file *** '
	return1
	end
c//////////////////////////////////////////////////
c
c  subroutine to write out fits data (data only)
c  ihb is the number of header blks already written
c
	subroutine fitsdataout(idev,ihb,ix,nu,nv,ni,nj,ibyte,
     *          bscale,bzero)
	integer ix(nu,nv)
	integer*2 ixt(1440)
	i=1
	j=1
	nblk=ihb
 201	nblk=nblk+1
	do 202 k=1,1440
	  if (i.gt.ni) then
c  go to next line
	    j=j+1
	    if (j.gt.nj) then
c  pad with zeros
	      do 203, l=k,1440
	        ixt(l)=0
 203	      continue
	      if (ibyte.eq.1) call byte_swap(ixt,2880)
	      write(idev,rec=nblk) ixt
	      return
	    end if
	    i=1
	  end if
	  ixt(k)=nint((float(ix(i,j))-bzero)/bscale)
c do byte switching if needed
	  i=i+1
 202	continue
	if (ibyte.eq.1) call byte_swap(ixt,2880)
	write(idev,rec=nblk) ixt
	go to 201
	end
c
c//////////////////////////////////////////////////////////////
c
c  subroutine to make a simple .fits header, returning 1 2880 byte
c     block as the first blk in the common headblk
c
	subroutine makefhd(ni,nj,objnam)
	character objnam*35,fdate*24,headblk*2880,hdr(360)*80
     *          ,size*5,blank*20,bzstr*20
	common/header/bzero,bscale,headblk(20),nhb
	equivalence (headblk(1)(1:1),hdr(1)(1:1))
	blank='                    '
	hdr(1)='SIMPLE  =                    T  /  FITS STANDARD'
	hdr(2)='BITPIX  =                   16  /  FITS BITS/PIXEL'
	hdr(3)='NAXIS   =                    2  /  NUMBER OF AXES'
	istatus=encode(size,float(ni),1,0,idum)
	hdr(4)='NAXIS1  ='//BLANK(1:21-lnblnk(size))//size(1:
     *         lnblnk(size))//'  /'
	istatus=encode(size,float(nj),1,0,idum)
	hdr(5)='NAXIS2  ='//BLANK(1:21-lnblnk(size))//size(1:
     *         lnblnk(size))//'  /'
	istatus=encode(bzstr,bscale,1,6,idum)
	hdr(6)='BSCALE  =    '//bzstr//' / PIX= FITS*BS + BZ'
c	hdr(6)='BSCALE  =       1.0000000000E0  /  PIX= FITS*BS + BZ'
c *** fix bzero
	istatus=encode(bzstr,bzero,1,6,idum)
	hdr(7)='BZERO   =    '//bzstr//' / PIX= FITS*BS + BZ'
	write(6,*) bzero,bzstr
	hdr(8)='OBJECT  = '''//objnam//''''
	hdr(9)='HISTORY = Saved from PPP '//fdate()
	hdr(10)='END'
	do 100 i=11,36
	  hdr(i)=' '
 100	continue
	return
	end
